# phpMyAdmin SQL Dump
# version 2.5.4
# http://www.phpmyadmin.net
#
# Host: lims-dbm.bcgsc.bc.ca
# Generation Time: Aug 17, 2004 at 11:53 AM
# Server version: 4.0.16
# PHP Version: 4.2.2
# 
# Database : `RHA1backup`
# 

# --------------------------------------------------------

#
# Table structure for table `Assembled`
#

CREATE TABLE `Assembled` (
  `Assembled_ID` int(10) unsigned NOT NULL auto_increment,
  `FK_Contig__ID` int(10) unsigned NOT NULL default '0',
  `FK_Trace__ID` int(10) unsigned NOT NULL default '0',
  `Assembled_Read_Start` int(11) NOT NULL default '0',
  `Assembled_Read_Stop` int(11) NOT NULL default '0',
  `Assembled_Direction` tinyint(1) default NULL,
  PRIMARY KEY  (`Assembled_ID`),
  KEY `FK_Contig__ID` (`FK_Contig__ID`),
  KEY `FK_Trace__ID` (`FK_Trace__ID`)
) TYPE=MyISAM AUTO_INCREMENT=3804827 ;

# --------------------------------------------------------

#
# Table structure for table `Assembler`
#

CREATE TABLE `Assembler` (
  `Assembler_ID` smallint(5) unsigned NOT NULL auto_increment,
  `Assembler_Name` varchar(25) NOT NULL default '',
  `Assembler_Version` varchar(10) default NULL,
  `Assembler_Description` mediumtext,
  PRIMARY KEY  (`Assembler_ID`)
) TYPE=MyISAM AUTO_INCREMENT=4 ;

# --------------------------------------------------------

#
# Table structure for table `Assembly`
#

CREATE TABLE `Assembly` (
  `Assembly_ID` int(11) NOT NULL auto_increment,
  `FK_Project__ID` smallint(5) unsigned NOT NULL default '0',
  `FK_Assembler__ID` smallint(5) unsigned NOT NULL default '0',
  `FK_Job_Queue__ID` smallint(5) unsigned NOT NULL default '0',
  `Assembly_Build_ID` decimal(10,2) unsigned NOT NULL default '0.00',
  `Assembly_Type` text NOT NULL,
  `Assembly_DateStart` datetime NOT NULL default '0000-00-00 00:00:00',
  `Assembly_DateEnd` datetime default NULL,
  `Assembly_Status` enum('initiated','completed','failed','hidden') NOT NULL default 'initiated',
  PRIMARY KEY  (`Assembly_ID`),
  KEY `FK_Project__ID` (`FK_Project__ID`),
  KEY `FK_Assembler__ID` (`FK_Assembler__ID`),
  KEY `FK_Job_Queue__ID` (`FK_Job_Queue__ID`)
) TYPE=MyISAM AUTO_INCREMENT=56 ;

# --------------------------------------------------------

#
# Table structure for table `Blast`
#

CREATE TABLE `Blast` (
  `Blast_ID` int(10) unsigned NOT NULL auto_increment,
  `FK_Orf__ID` int(10) unsigned NOT NULL default '0',
  `FK_Blast_Config__ID` int(10) unsigned NOT NULL default '0',
  `Blast_Accession` varchar(16) default NULL,
  `Blast_Protein_Name` text,
  `Blast_Organism` mediumtext,
  `Blast_Orf_Similarity` float unsigned default NULL,
  `Blast_Score` mediumint(8) unsigned default NULL,
  `Blast_Bits` float unsigned default NULL,
  `Blast_Match` int(10) unsigned default NULL,
  `Blast_EValue` float unsigned default NULL,
  `Blast_Hit_Start` int(10) unsigned default NULL,
  `Blast_Hit_Stop` int(10) unsigned default NULL,
  `Blast_Hit_Length` int(10) unsigned default NULL,
  `Blast_Hit_Protein_Length` int(10) unsigned NOT NULL default '0',
  `Blast_Hit_Similarity` float unsigned NOT NULL default '0',
  `Blast_Hit_Identity` float unsigned NOT NULL default '0',
  `Blast_Query_Start` int(10) unsigned default NULL,
  `Blast_Query_Stop` int(10) unsigned default NULL,
  `Blast_Positive_Residues` int(10) unsigned default NULL,
  `Blast_Query_Sequence` text,
  `Blast_Hit_Sequence` text,
  PRIMARY KEY  (`Blast_ID`),
  KEY `FK_Orf__ID` (`FK_Orf__ID`),
  KEY `FK_Blast_Config__ID` (`FK_Blast_Config__ID`)
) TYPE=MyISAM AUTO_INCREMENT=30984 ;

# --------------------------------------------------------

#
# Table structure for table `Blast_Config`
#

CREATE TABLE `Blast_Config` (
  `Blast_Config_ID` smallint(5) unsigned NOT NULL auto_increment,
  `Blast_Config_Program` mediumtext NOT NULL,
  `Blast_Config_Blastall` text NOT NULL,
  `Blast_Config_Exec` mediumtext NOT NULL,
  `Blast_Config_Dir` mediumtext NOT NULL,
  `Blast_Config_Database` text NOT NULL,
  `Blast_Config_Processor` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`Blast_Config_ID`)
) TYPE=MyISAM AUTO_INCREMENT=2 ;

# --------------------------------------------------------

#
# Table structure for table `Blastable_DB`
#

CREATE TABLE `Blastable_DB` (
  `Blastable_DB_ID` smallint(5) unsigned NOT NULL auto_increment,
  `Blastable_DB_Exec` varchar(30) NOT NULL default '',
  `Blastable_DB_Exec_Dir` mediumtext NOT NULL,
  `Blastable_DB_Location` mediumtext NOT NULL,
  `Blastable_DB_Node` varchar(20) NOT NULL default '',
  `Blastable_DB_Wrapper` varchar(30) NOT NULL default '',
  `Blastable_DB_Wrapper_Dir` mediumtext NOT NULL,
  PRIMARY KEY  (`Blastable_DB_ID`)
) TYPE=MyISAM AUTO_INCREMENT=3 ;

# --------------------------------------------------------

#
# Table structure for table `Center`
#

CREATE TABLE `Center` (
  `Center_ID` smallint(5) unsigned NOT NULL auto_increment,
  `Center_Name` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`Center_ID`),
  UNIQUE KEY `Center_Name` (`Center_Name`)
) TYPE=MyISAM AUTO_INCREMENT=2 ;

# --------------------------------------------------------

#
# Table structure for table `Clone`
#

CREATE TABLE `Clone` (
  `Clone_ID` int(10) unsigned NOT NULL auto_increment,
  `Clone_Name` varchar(100) NOT NULL default '',
  `FK_Library__ID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`Clone_ID`),
  KEY `FK_Library__ID` (`FK_Library__ID`)
) TYPE=MyISAM AUTO_INCREMENT=94045 ;

# --------------------------------------------------------

#
# Table structure for table `Config`
#

CREATE TABLE `Config` (
  `Config_ID` smallint(5) unsigned NOT NULL auto_increment,
  `FK_Assembler__ID` smallint(5) unsigned NOT NULL default '0',
  `Config_Data_Dir` mediumtext,
  `Config_Exec_Dir` mediumtext,
  `Config_Xml_Dir` mediumtext,
  `Config_Read_File` varchar(40) default NULL,
  `Config_Qual_File` varchar(40) default NULL,
  `Config_Xml_File` varchar(40) default NULL,
  `Config_Exec_Cmd` varchar(40) default NULL,
  `Config_Assembler_Exec` varchar(40) default NULL,
  `Config_Assembler_Dir` mediumtext,
  `Config_Analysis_File` varchar(40) default NULL,
  `Config_AssemblyXml_File` varchar(40) default NULL,
  `Config_SummaryXml_File` varchar(40) default NULL,
  `Config_Tig_Fasta_File` varchar(40) default NULL,
  `Config_Tig_Qual_File` varchar(40) default NULL,
  `Config_Output_Dir` mediumtext,
  `Config_Web_Dir` tinytext NOT NULL,
  `Config_Assembler_Node` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`Config_ID`),
  KEY `FK_Assembler__ID` (`FK_Assembler__ID`)
) TYPE=MyISAM AUTO_INCREMENT=4 ;

# --------------------------------------------------------

#
# Table structure for table `Contig`
#

CREATE TABLE `Contig` (
  `Contig_ID` int(10) unsigned NOT NULL auto_increment,
  `FK_Assembly__ID` int(10) unsigned NOT NULL default '0',
  `FK_Supercontig__ID` int(10) unsigned default NULL,
  `Contig_Number` int(10) unsigned NOT NULL default '0',
  `Contig_Error` mediumint(8) unsigned NOT NULL default '0',
  `Contig_Size` int(10) unsigned NOT NULL default '0',
  `Contig_Order` mediumint(8) unsigned default NULL,
  `Contig_PrecedingGap_Size` int(11) default NULL,
  `Contig_CompA` tinyint(3) unsigned NOT NULL default '0',
  `Contig_CompT` tinyint(3) unsigned NOT NULL default '0',
  `Contig_CompG` tinyint(3) unsigned NOT NULL default '0',
  `Contig_CompC` tinyint(3) unsigned NOT NULL default '0',
  `Contig_Phred20` int(10) unsigned NOT NULL default '0',
  `Contig_Phred30` int(10) unsigned NOT NULL default '0',
  `Contig_Phred40` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`Contig_ID`),
  KEY `FK_Assembly__ID` (`FK_Assembly__ID`),
  KEY `FK_Supercontig__ID` (`FK_Supercontig__ID`)
) TYPE=MyISAM AUTO_INCREMENT=70859 ;

# --------------------------------------------------------

#
# Table structure for table `Contig_Coord`
#

CREATE TABLE `Contig_Coord` (
  `Contig_Coord_ID` int(10) unsigned NOT NULL auto_increment,
  `FK_Contig__ID` int(10) unsigned NOT NULL default '0',
  `Contig_Coord_Number` int(10) unsigned NOT NULL default '0',
  `Contig_Coord_Start` int(10) unsigned NOT NULL default '0',
  `Contig_Coord_Stop` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`Contig_Coord_ID`),
  KEY `FK_Contig__ID` (`FK_Contig__ID`)
) TYPE=MyISAM AUTO_INCREMENT=29146 ;

# --------------------------------------------------------

#
# Table structure for table `Contig_Layout`
#

CREATE TABLE `Contig_Layout` (
  `Contig_Layout_ID` int(10) unsigned NOT NULL auto_increment,
  `FK_Ultracontig__ID` int(10) unsigned NOT NULL default '0',
  `FK_Contig_Coord__ID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`Contig_Layout_ID`),
  KEY `FK_Ultracontig__ID` (`FK_Ultracontig__ID`),
  KEY `FK_Contig_Coord__ID` (`FK_Contig_Coord__ID`)
) TYPE=MyISAM AUTO_INCREMENT=29842 ;

# --------------------------------------------------------

#
# Table structure for table `Enzyme`
#

CREATE TABLE `Enzyme` (
  `Enzyme_ID` int(10) unsigned NOT NULL auto_increment,
  `Enzyme_Name` char(40) NOT NULL default '',
  `Enzyme_Type` enum('cohesive','blunt') default NULL,
  `Enzyme_Recognition_Sequence` char(50) NOT NULL default '',
  `Enzyme_Cut_Site` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`Enzyme_ID`)
) TYPE=MyISAM AUTO_INCREMENT=2 ;

# --------------------------------------------------------

#
# Table structure for table `Executable`
#

CREATE TABLE `Executable` (
  `Executable_ID` smallint(5) unsigned NOT NULL auto_increment,
  `Executable_Name` varchar(20) NOT NULL default '',
  `Executable_Description` mediumtext NOT NULL,
  `Executable_Directory` mediumtext NOT NULL,
  PRIMARY KEY  (`Executable_ID`)
) TYPE=MyISAM AUTO_INCREMENT=6 ;

# --------------------------------------------------------

#
# Table structure for table `Gap`
#

CREATE TABLE `Gap` (
  `Gap_ID` int(10) unsigned NOT NULL auto_increment,
  `FK_Clone__ID` int(10) unsigned NOT NULL default '0',
  `FK_Assembly__ID` int(10) unsigned NOT NULL default '0',
  `Gap_Left_Contig_Number` decimal(10,2) unsigned NOT NULL default '0.00',
  `Gap_Left_Contig_Size` int(10) unsigned NOT NULL default '0',
  `Gap_Right_Contig_Number` decimal(10,2) unsigned NOT NULL default '0.00',
  `Gap_Right_Contig_Size` int(10) unsigned NOT NULL default '0',
  `Gap_Left_Read_Name` text NOT NULL,
  `Gap_Left_Read_Start` int(10) unsigned NOT NULL default '0',
  `Gap_Left_Read_Stop` int(10) unsigned NOT NULL default '0',
  `Gap_Left_Read_Direction` tinyint(1) default NULL,
  `Gap_Right_Read_Name` text NOT NULL,
  `Gap_Right_Read_Start` int(10) unsigned NOT NULL default '0',
  `Gap_Right_Read_Stop` int(10) unsigned NOT NULL default '0',
  `Gap_Right_Read_Direction` tinyint(1) default NULL,
  `Gap_Left_Contig_Inversion` tinyint(1) default NULL,
  `Gap_Right_Contig_Inversion` tinyint(1) default NULL,
  `Gap_Size` int(11) NOT NULL default '0',
  `Gap_Select` tinyint(1) default NULL,
  `Gap_Clone_Misassembly` tinyint(1) default NULL,
  PRIMARY KEY  (`Gap_ID`),
  KEY `FK_Clone__ID` (`FK_Clone__ID`),
  KEY `FK_Assembly__ID` (`FK_Assembly__ID`)
) TYPE=MyISAM AUTO_INCREMENT=269700 ;

# --------------------------------------------------------

#
# Table structure for table `Gene_Finder`
#

CREATE TABLE `Gene_Finder` (
  `Gene_Finder_ID` smallint(5) unsigned NOT NULL auto_increment,
  `Gene_Finder_Name` varchar(40) default NULL,
  `Gene_Finder_Wrapper` varchar(40) default NULL,
  `Gene_Finder_Wrapper_Dir` tinytext,
  `Gene_Finder_CDS_File` varchar(40) default NULL,
  `Gene_Finder_Protein_File` varchar(40) default NULL,
  `Gene_Finder_EveryGene_File` varchar(40) default NULL,
  `Gene_Finder_Dir` tinytext,
  `Gene_Finder_LowQual_Threshold` float unsigned NOT NULL default '0',
  `Gene_Finder_MaxPhred_Threshold` smallint(5) unsigned NOT NULL default '0',
  `Gene_Finder_Genome_Topology` enum('linear','circular') NOT NULL default 'linear',
  `Gene_Finder_Smallest_Gene` smallint(5) unsigned NOT NULL default '0',
  `Gene_Finder_Overlap_Percent` float unsigned NOT NULL default '0',
  `Gene_Finder_Training_Set` tinyint(1) unsigned default NULL,
  `Gene_Finder_Train_FullPath` tinytext,
  PRIMARY KEY  (`Gene_Finder_ID`)
) TYPE=MyISAM AUTO_INCREMENT=7 ;

# --------------------------------------------------------

#
# Table structure for table `InSilico_Digest`
#

CREATE TABLE `InSilico_Digest` (
  `InSilico_Digest_ID` smallint(5) unsigned NOT NULL auto_increment,
  `FK_Map_Layout__ID` int(10) unsigned NOT NULL default '0',
  `FK_Contig__ID` int(10) unsigned NOT NULL default '0',
  `InSilico_Digest_Fragment_Size` text,
  `InSilico_Digest_Fragment_Position` text,
  `InSilico_Digest_Fosmid_Start` int(10) unsigned default NULL,
  `InSilico_Digest_Fosmid_Stop` int(10) unsigned default NULL,
  `InSilico_Digest_Comment` text,
  `InSilico_Digest_Image_Name` tinytext,
  PRIMARY KEY  (`InSilico_Digest_ID`),
  KEY `FK_Map_Layout__ID` (`FK_Map_Layout__ID`),
  KEY `FK_Contig__ID` (`FK_Contig__ID`)
) TYPE=MyISAM AUTO_INCREMENT=3641 ;

# --------------------------------------------------------

#
# Table structure for table `Job_Queue`
#

CREATE TABLE `Job_Queue` (
  `Job_Queue_ID` int(10) unsigned NOT NULL auto_increment,
  `FK_Executable__ID` int(10) unsigned NOT NULL default '0',
  `FK_Node__ID` int(10) unsigned default NULL,
  `Job_Queue_FileCdt` mediumtext,
  `Job_Queue_AssemblerCdt` varchar(20) default NULL,
  `Job_Queue_StartDateCdt` date default NULL,
  `Job_Queue_EndDateCdt` date default NULL,
  `Job_Queue_LibraryCdt` mediumtext,
  `Job_Queue_Username` varchar(20) NOT NULL default '',
  `Job_Queue_Email` varchar(50) default NULL,
  `Job_Queue_DateStart` datetime NOT NULL default '0000-00-00 00:00:00',
  `Job_Queue_DateEnd` datetime default NULL,
  `Job_Queue_New_Build` tinyint(1) NOT NULL default '0',
  `Job_Queue_Gene_Finder` smallint(5) default '0',
  `Job_Queue_AssemblyCdt` int(10) unsigned NOT NULL default '0',
  `Job_Queue_Map_ID` int(10) unsigned NOT NULL default '0',
  `Job_Queue_Status` enum('waiting','initiated','completed','failed') NOT NULL default 'waiting',
  PRIMARY KEY  (`Job_Queue_ID`),
  KEY `FK_Executable__ID` (`FK_Executable__ID`),
  KEY `FK_Node__ID` (`FK_Node__ID`)
) TYPE=MyISAM AUTO_INCREMENT=79 ;

# --------------------------------------------------------

#
# Table structure for table `Library`
#

CREATE TABLE `Library` (
  `Library_ID` int(10) unsigned NOT NULL auto_increment,
  `Library_Name` varchar(20) NOT NULL default '',
  `Library_Insert_Size` mediumint(10) unsigned NOT NULL default '0',
  `Library_Insert_StdDev` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`Library_ID`),
  UNIQUE KEY `Library_Name` (`Library_Name`)
) TYPE=MyISAM AUTO_INCREMENT=19 ;

# --------------------------------------------------------

#
# Table structure for table `Library_Analysis`
#

CREATE TABLE `Library_Analysis` (
  `Library_Analysis_ID` int(10) unsigned NOT NULL auto_increment,
  `FK_Library__ID` int(10) unsigned NOT NULL default '0',
  `FK_Assembly__ID` int(10) unsigned NOT NULL default '0',
  `Library_Analysis_Insert_Range` text NOT NULL,
  `Library_Analysis_Insert_Value` text NOT NULL,
  `Library_Analysis_Insert_Clone` mediumint(8) unsigned NOT NULL default '0',
  `Library_Analysis_Insert_Mean` float unsigned NOT NULL default '0',
  `Library_Analysis_Insert_StdDev` float unsigned NOT NULL default '0',
  `Library_Analysis_Insert_Max` mediumint(8) unsigned NOT NULL default '0',
  `Library_Analysis_Insert_Min` mediumint(8) unsigned NOT NULL default '0',
  `Library_Analysis_Contig_Range` text NOT NULL,
  `Library_Analysis_Contig_Value` text NOT NULL,
  `Library_Analysis_Paired_Same` int(10) unsigned NOT NULL default '0',
  `Library_Analysis_Paired_Different` int(10) unsigned NOT NULL default '0',
  `Library_Analysis_Unpaired` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`Library_Analysis_ID`),
  KEY `FK_Library__ID` (`FK_Library__ID`),
  KEY `FK_Assembly__ID` (`FK_Assembly__ID`)
) TYPE=MyISAM AUTO_INCREMENT=496 ;

# --------------------------------------------------------

#
# Table structure for table `Map`
#

CREATE TABLE `Map` (
  `Map_ID` smallint(5) unsigned NOT NULL auto_increment,
  `Map_Version` varchar(50) default NULL,
  `Map_Date` datetime NOT NULL default '0000-00-00 00:00:00',
  `Map_Comment` tinytext,
  PRIMARY KEY  (`Map_ID`)
) TYPE=MyISAM AUTO_INCREMENT=4 ;

# --------------------------------------------------------

#
# Table structure for table `Map_Contig`
#

CREATE TABLE `Map_Contig` (
  `Map_Contig_ID` smallint(5) unsigned NOT NULL auto_increment,
  `FK_Map__ID` smallint(5) unsigned NOT NULL default '0',
  `Map_Contig_Number` mediumint(8) unsigned NOT NULL default '0',
  `Map_Contig_Size` int(10) unsigned default NULL,
  PRIMARY KEY  (`Map_Contig_ID`),
  KEY `FK_Map__ID` (`FK_Map__ID`)
) TYPE=MyISAM AUTO_INCREMENT=56 ;

# --------------------------------------------------------

#
# Table structure for table `Map_Layout`
#

CREATE TABLE `Map_Layout` (
  `Map_Layout_ID` int(10) unsigned NOT NULL auto_increment,
  `FK_Map_Contig__ID` int(10) unsigned NOT NULL default '0',
  `FK_Clone__ID` int(10) unsigned NOT NULL default '0',
  `FK_Enzyme__ID` int(10) unsigned NOT NULL default '0',
  `Map_Layout_AltCloneName` tinytext NOT NULL,
  `Map_Layout_Buried` tinyint(1) unsigned NOT NULL default '0',
  `Map_Layout_Order` int(10) unsigned NOT NULL default '0',
  `Map_Layout_Overlap` int(11) NOT NULL default '0',
  `Map_Layout_Experimental_Digest` text NOT NULL,
  PRIMARY KEY  (`Map_Layout_ID`),
  KEY `FK_Map_Contig__ID` (`FK_Map_Contig__ID`),
  KEY `FK_Clone__ID` (`FK_Clone__ID`)
) TYPE=MyISAM AUTO_INCREMENT=13820 ;

# --------------------------------------------------------

#
# Table structure for table `Node`
#

CREATE TABLE `Node` (
  `Node_ID` smallint(5) unsigned NOT NULL auto_increment,
  `Node_Name` varchar(20) NOT NULL default '',
  `Node_Specification` mediumtext,
  PRIMARY KEY  (`Node_ID`)
) TYPE=MyISAM AUTO_INCREMENT=3 ;

# --------------------------------------------------------

#
# Table structure for table `Old_Orf`
#

CREATE TABLE `Old_Orf` (
  `Old_Orf_ID` int(10) unsigned NOT NULL auto_increment,
  `Old_Orf_Number` int(10) unsigned NOT NULL default '0',
  `FK_Orf__ID` int(10) unsigned NOT NULL default '0',
  `Old_Orf_CDS_Sequence` text NOT NULL,
  PRIMARY KEY  (`Old_Orf_ID`),
  KEY `FK_Orf__ID` (`FK_Orf__ID`)
) TYPE=MyISAM AUTO_INCREMENT=4061 ;

# --------------------------------------------------------

#
# Table structure for table `Orf`
#

CREATE TABLE `Orf` (
  `Orf_ID` int(10) unsigned NOT NULL auto_increment,
  `Orf_CDS_Sequence` text NOT NULL,
  `Orf_CDS_Length` int(10) unsigned NOT NULL default '0',
  `Orf_Protein_Sequence` text NOT NULL,
  `Orf_Protein_Length` int(10) unsigned NOT NULL default '0',
  `Orf_Initiation_Codon` char(3) NOT NULL default '',
  `Orf_PercentA` float unsigned NOT NULL default '0',
  `Orf_PercentT` float unsigned NOT NULL default '0',
  `Orf_PercentC` float unsigned NOT NULL default '0',
  `Orf_PercentG` float unsigned NOT NULL default '0',
  `Orf_PercentGC` float unsigned NOT NULL default '0',
  `Orf_Position_A1` float unsigned NOT NULL default '0',
  `Orf_Position_A2` float unsigned NOT NULL default '0',
  `Orf_Position_A3` float unsigned NOT NULL default '0',
  `Orf_Position_T1` float unsigned NOT NULL default '0',
  `Orf_Position_T2` float unsigned NOT NULL default '0',
  `Orf_Position_T3` float unsigned NOT NULL default '0',
  `Orf_Position_C1` float unsigned NOT NULL default '0',
  `Orf_Position_C2` float unsigned NOT NULL default '0',
  `Orf_Position_C3` float unsigned NOT NULL default '0',
  `Orf_Position_G1` float unsigned NOT NULL default '0',
  `Orf_Position_G2` float unsigned NOT NULL default '0',
  `Orf_Position_G3` float unsigned NOT NULL default '0',
  PRIMARY KEY  (`Orf_ID`)
) TYPE=MyISAM AUTO_INCREMENT=30984 ;

# --------------------------------------------------------

#
# Table structure for table `Orf_Context`
#

CREATE TABLE `Orf_Context` (
  `Orf_Context_ID` int(10) unsigned NOT NULL auto_increment,
  `FK_Orf__ID` int(10) unsigned NOT NULL default '0',
  `FK_Gene_Finder__ID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`Orf_Context_ID`),
  KEY `FK_Orf__ID` (`FK_Orf__ID`),
  KEY `FK_Gene_Finder__ID` (`FK_Gene_Finder__ID`)
) TYPE=MyISAM AUTO_INCREMENT=69237 ;

# --------------------------------------------------------

#
# Table structure for table `Orf_Origin`
#

CREATE TABLE `Orf_Origin` (
  `Orf_Origin_ID` int(10) unsigned NOT NULL auto_increment,
  `FK_Contig__ID` int(10) unsigned NOT NULL default '0',
  `FK_Orf_Context__ID` int(10) unsigned NOT NULL default '0',
  `Orf_Origin_Strand` tinyint(4) NOT NULL default '0',
  `Orf_Origin_Start` int(10) unsigned NOT NULL default '0',
  `Orf_Origin_Stop` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`Orf_Origin_ID`),
  KEY `FK_Contig__ID` (`FK_Contig__ID`),
  KEY `FK_Orf_Context__ID` (`FK_Orf_Context__ID`)
) TYPE=MyISAM AUTO_INCREMENT=272085 ;

# --------------------------------------------------------

#
# Table structure for table `Overlap`
#

CREATE TABLE `Overlap` (
  `Overlap_ID` int(10) unsigned NOT NULL auto_increment,
  `FK_Clone__ID` int(10) unsigned NOT NULL default '0',
  `FK_Assembly__ID` int(10) unsigned NOT NULL default '0',
  `Overlap_Contig_Number` decimal(10,2) unsigned NOT NULL default '0.00',
  `Overlap_Contig_Size` int(10) unsigned NOT NULL default '0',
  `Overlap_Left_Read_Name` text NOT NULL,
  `Overlap_Left_Read_Start` int(10) unsigned NOT NULL default '0',
  `Overlap_Left_Read_Stop` int(10) unsigned NOT NULL default '0',
  `Overlap_Left_Read_Direction` tinyint(1) default NULL,
  `Overlap_Right_Read_Name` text NOT NULL,
  `Overlap_Right_Read_Start` int(10) unsigned NOT NULL default '0',
  `Overlap_Right_Read_Stop` int(10) unsigned NOT NULL default '0',
  `Overlap_Right_Read_Direction` tinyint(1) default NULL,
  `Overlap_Size` int(10) unsigned default NULL,
  `Overlap_Read_Inclusion` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`Overlap_ID`),
  KEY `FK_Clone__ID` (`FK_Clone__ID`),
  KEY `FK_Assembly__ID` (`FK_Assembly__ID`)
) TYPE=MyISAM AUTO_INCREMENT=297039 ;

# --------------------------------------------------------

#
# Table structure for table `Project`
#

CREATE TABLE `Project` (
  `Project_ID` smallint(5) unsigned NOT NULL auto_increment,
  `Project_Organization` varchar(40) NOT NULL default '',
  `Project_Name` varchar(20) NOT NULL default '',
  `Project_Organism` varchar(100) NOT NULL default '',
  `Project_Description` text,
  `Project_Genome_Size` int(10) unsigned default NULL,
  `Project_Type` enum('genome','est','clone','other','test') NOT NULL default 'genome',
  `Project_Web_Image` varchar(40) NOT NULL default '',
  `Project_Initiated` date NOT NULL default '0000-00-00',
  `Project_Completed` date default NULL,
  `Project_Contact_Name` varchar(30) NOT NULL default '',
  `Project_Contact_Mail` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`Project_ID`)
) TYPE=MyISAM AUTO_INCREMENT=2 ;

# --------------------------------------------------------

#
# Table structure for table `Read_Coord`
#

CREATE TABLE `Read_Coord` (
  `Read_Coord_ID` int(10) unsigned NOT NULL auto_increment,
  `FK_Trace__ID` int(10) unsigned NOT NULL default '0',
  `Read_Coord_CloneName` tinytext NOT NULL,
  `Read_Coord_AltCloneName` tinytext NOT NULL,
  `Read_Coord_Direction` tinytext NOT NULL,
  `Read_Coord_Buried` tinyint(1) default NULL,
  `Read_Coord_Start` int(10) unsigned NOT NULL default '0',
  `Read_Coord_Stop` int(10) unsigned NOT NULL default '0',
  `Read_Coord_Orientation` tinyint(1) NOT NULL default '0',
  `Read_Coord_Order` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`Read_Coord_ID`),
  KEY `FK_Trace__ID` (`FK_Trace__ID`)
) TYPE=MyISAM AUTO_INCREMENT=205700 ;

# --------------------------------------------------------

#
# Table structure for table `Read_Layout`
#

CREATE TABLE `Read_Layout` (
  `Read_Layout_ID` int(10) unsigned NOT NULL auto_increment,
  `FK_Ultracontig__ID` int(10) unsigned NOT NULL default '0',
  `FK_Read_Coord__ID` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`Read_Layout_ID`),
  KEY `FK_Ultracontig__ID` (`FK_Ultracontig__ID`),
  KEY `FK_Read_Coord__ID` (`FK_Read_Coord__ID`)
) TYPE=MyISAM AUTO_INCREMENT=208607 ;

# --------------------------------------------------------

#
# Table structure for table `Summary`
#

CREATE TABLE `Summary` (
  `Summary_ID` int(10) unsigned NOT NULL auto_increment,
  `FK_Assembly__ID` int(10) unsigned NOT NULL default '0',
  `Summary_Analyzed_Read` int(10) unsigned NOT NULL default '0',
  `Summary_Contig_Number` smallint(5) unsigned NOT NULL default '0',
  `Summary_Supertig_Number` smallint(5) unsigned NOT NULL default '0',
  `Summary_Supertig_Size` int(10) unsigned NOT NULL default '0',
  `Summary_Singleton_Read` smallint(5) unsigned default NULL,
  `Summary_Bad_Quality_Read` smallint(5) unsigned default NULL,
  `Summary_Masked_Read` smallint(5) unsigned default NULL,
  `Summary_Contig_Coverage` float unsigned NOT NULL default '0',
  `Summary_Genome_Coverage` float unsigned NOT NULL default '0',
  `Summary_Genome_Coverage2` float unsigned NOT NULL default '0',
  `Summary_Poisson_Genome_Size` int(10) unsigned NOT NULL default '0',
  `Summary_Poisson_Genome_Coverage` float unsigned NOT NULL default '0',
  `Summary_Poisson_Genome_Coverage2` float unsigned NOT NULL default '0',
  `Summary_Poisson_Contig` smallint(5) unsigned NOT NULL default '0',
  `Summary_Error` float unsigned NOT NULL default '0',
  `Summary_Largest_Tig` int(10) unsigned NOT NULL default '0',
  `Summary_Smallest_Tig` int(10) unsigned NOT NULL default '0',
  `Summary_Mean_Tig` float unsigned NOT NULL default '0',
  `Summary_Mean_Super` float unsigned NOT NULL default '0',
  `Summary_Total_Bases` int(10) unsigned NOT NULL default '0',
  `Summary_Consensus` int(10) unsigned NOT NULL default '0',
  `Summary_Phred30` int(10) unsigned NOT NULL default '0',
  `Summary_Phred40` int(10) unsigned NOT NULL default '0',
  `Summary_Above1K_Tigsize` int(10) unsigned NOT NULL default '0',
  `Summary_N50` int(10) unsigned NOT NULL default '0',
  `Summary_Percent_A` float unsigned NOT NULL default '0',
  `Summary_Percent_T` float unsigned NOT NULL default '0',
  `Summary_Percent_C` float unsigned NOT NULL default '0',
  `Summary_Percent_G` float unsigned NOT NULL default '0',
  `Summary_Assembled_Read` int(10) unsigned NOT NULL default '0',
  `Summary_Singleton_Contig` mediumint(8) unsigned NOT NULL default '0',
  `Summary_2Read_Contig` mediumint(8) unsigned NOT NULL default '0',
  `Summary_3Read_Contig` mediumint(8) unsigned NOT NULL default '0',
  `Summary_4Read_Contig` mediumint(8) unsigned NOT NULL default '0',
  `Summary_5Read_Contig` mediumint(8) unsigned NOT NULL default '0',
  `Summary_6Read_Contig` mediumint(8) unsigned NOT NULL default '0',
  `Summary_10Read_Contig` mediumint(8) unsigned NOT NULL default '0',
  `Summary_20Read_Contig` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`Summary_ID`),
  KEY `FK_Assembly__ID` (`FK_Assembly__ID`)
) TYPE=MyISAM AUTO_INCREMENT=55 ;

# --------------------------------------------------------

#
# Table structure for table `Supercontig`
#

CREATE TABLE `Supercontig` (
  `Supercontig_ID` int(10) unsigned NOT NULL auto_increment,
  `FK_Assembly__ID` int(10) unsigned NOT NULL default '0',
  `Supercontig_Number` smallint(5) unsigned NOT NULL default '0',
  `Supercontig_Size` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`Supercontig_ID`),
  KEY `FK_Assembly__ID` (`FK_Assembly__ID`)
) TYPE=MyISAM AUTO_INCREMENT=16943 ;

# --------------------------------------------------------

#
# Table structure for table `Trace`
#

CREATE TABLE `Trace` (
  `Trace_ID` int(10) unsigned NOT NULL auto_increment,
  `Trace_Name` varchar(30) NOT NULL default '',
  `FK_Clone__ID` int(10) unsigned NOT NULL default '0',
  `Trace_Directory` varchar(200) NOT NULL default '',
  `Trace_Direction` enum('F','R','U') NOT NULL default 'F',
  `Trace_Well` char(3) NOT NULL default '',
  `Trace_Plate_Number` smallint(5) unsigned default NULL,
  `Trace_Plate_Quadrant` enum('a','b','c','d') default NULL,
  `Trace_Template` varchar(30) NOT NULL default '',
  `Trace_Type` enum('paired_production','unpaired_production') NOT NULL default 'paired_production',
  `Trace_Sequence` text NOT NULL,
  `Trace_Quality` blob NOT NULL,
  `Trace_Length` mediumint(8) unsigned NOT NULL default '0',
  `Trace_Quality_Length` mediumint(8) unsigned default NULL,
  `Trace_Vector_Quality` mediumint(8) unsigned default NULL,
  `Trace_Date_Sequenced` datetime default NULL,
  PRIMARY KEY  (`Trace_ID`),
  UNIQUE KEY `Trace_Name` (`Trace_Name`),
  KEY `FK_Clone__ID` (`FK_Clone__ID`)
) TYPE=MyISAM AUTO_INCREMENT=187803 ;

# --------------------------------------------------------

#
# Table structure for table `Ultracontig`
#

CREATE TABLE `Ultracontig` (
  `Ultracontig_ID` int(10) unsigned NOT NULL auto_increment,
  `FK_Supercontig__ID` int(10) unsigned NOT NULL default '0',
  `FK_Map_Contig__ID` int(10) unsigned NOT NULL default '0',
  `Ultracontig_Scaffold_Order` smallint(5) unsigned NOT NULL default '0',
  `Ultracontig_Scaffold_Orientation` tinyint(3) unsigned NOT NULL default '0',
  `Ultracontig_Scaffold_PrecedingGap` int(10) unsigned NOT NULL default '0',
  `Ultracontig_Scaffold_Size` int(10) unsigned NOT NULL default '0',
  `Ultracontig_Scaffold_Buried` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`Ultracontig_ID`),
  KEY `FK_Supercontig__ID` (`FK_Supercontig__ID`),
  KEY `FK_Map_Contig__ID` (`FK_Map_Contig__ID`)
) TYPE=MyISAM AUTO_INCREMENT=1632 ;
