#!/usr/local/bin/perl
##############################
# perldoc_header             #
##############################

=head1 NAME <UPLINK>

BlastlessRemedy.pl -

=head1 SYNOPSIS <UPLINK>

	<<SYNOPSIS>>

=head1 DESCRIPTION <UPLINK>

=for html
<BR>Author:Rene Warren<BR>Script:BlastlessRemedy.pl<BR>Purpose:This script will attempt to identify a match in specified public database<BR>November 2002<BR>

=cut

##############################
# superclasses               #
##############################

=head2 SUPERCLASSES <UPLINK>

=over

=back

=cut

##############################
# system_variables           #
##############################
##############################
# standard_modules_ref       #
##############################

=head2 STANDARD MODULES REFERENCE <UPLINK>

=over

=item FindBin

=item lib "$FindBin::Bin/../lib"

=item strict

=item SQLdb

=back

=cut

#Author:Rene Warren
#Script:BlastlessRemedy.pl
#Purpose:This script will attempt to identify a match in specified public database
#November 2002
use FindBin;
use lib "$FindBin::Bin/../lib";
use strict;
use SQLdb;

##############################
# custom_modules_ref         #
##############################

=head2 CUSTOM MODULES REFERENCE <UPLINK>

=over

=back

=cut

##############################
# global_vars                #
##############################

=head2 GLOBAL VARIABLES <UPLINK>

=over

=item $opt_p

=item $opt_u

=item $opt_d

=item $opt_o

=back

=cut

use vars qw($opt_p $opt_u $opt_d $opt_o);
##############################
# modular_vars               #
##############################
##############################
# constants                  #
##############################
##############################
# main_header                #
##############################
require "getopts.pl";
&Getopts('p:u:d:o:');
####Arguments
if (! $opt_p || ! $opt_u || ! $opt_d || ! $opt_o){
   die "Usage: BlastlessRemedy.pl -u username -p password -d database -o host name\n";
}
my %user_info;
$user_info{'username'}=$opt_u;
$user_info{'password'}=$opt_p;
$user_info{'host_name'}=$opt_o;
$user_info{'database'}=$opt_d;
my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'database'}, $user_info{'host_name'});
###Get Orfs
my @field=("FK_Orf__ID");
my @table=("Blast");
my @condition=();
my $special="Order by FK_Orf__ID";
my $select=SQLdb::GetRecord(\@field, \@table, \@condition, $special);
my $tmp_orflist=SQLdb::ExecuteMany($dbh, $select);
###Rearrange List
my %blastorf;
my @refblastorf=@$tmp_orflist;
foreach my $ref(@refblastorf){
   my @record=@$ref;
   $blastorf{$record[0]}++
}
###Identify blastless
#get amount of blast searches total
@field=("count(Orf_ID)");
@table=("Orf");
@condition=();
$select=SQLdb::GetRecord(\@field, \@table, \@condition);
my $tmp_orfcnt=SQLdb::ExecuteUnique($dbh, $select);
my @orf_count=@$tmp_orfcnt;
my @orf=(1..$orf_count[0]);
my %new_orf;
foreach my $orf(@orf){
   if (!defined $blastorf{$orf}){
      my @field=("Orf_Protein_Sequence");
      my @table=("Orf");
      my @condition=("Orf_ID=$orf");
      my $select=SQLdb::GetRecord(\@field, \@table, \@condition);
      my $tmp_orflist=SQLdb::ExecuteUnique($dbh, $select);
      my @orf_list=@$tmp_orflist;
      $new_orf{$orf}=$orf_list[0];
   }
}
foreach my $orf (sort {$a<=>$b} keys %new_orf){
   print "$orf\n$new_orf{$orf}\n\n";
}
###Blast What was never blasted
#******************** temporary measures/refer to the database SAMdb model
my $blast_config_id=1;
#####################
####Get Blast Configuration
####Get Assembly Information
my @field=("Blast_Config_Program", "Blast_Config_Exec", "Blast_Config_Dir", "Blast_Config_Database", "Blast_Config_Processor", "Blast_Config_Blastall");
my @table=("Blast_Config");
my @condition=("Blast_Config_ID=$blast_config_id");####1 for blastp
my $select_blast_config=SQLdb::GetRecord(\@field, \@table, \@condition);
my $tmp_config=SQLdb::ExecuteUnique($dbh, $select_blast_config);
SQLdb::Disconnect($dbh);
my @blast_config=@$tmp_config;
my $blast_parser="$blast_config[2]/$blast_config[1]";
####Start Blasting
foreach my $orf_id (sort {$a<=>$b} keys %new_orf){
   print "Starting $orf_id...\n";#temporary
   my $blastall="| $blast_config[5] -a $blast_config[4] -p $blast_config[0] -d $blast_config[3] | $blast_parser $orf_id $blast_config_id $user_info{'username'} $user_info{'password'} $user_info{'database'} $user_info{'host_name'}";
   open (BLAST, $blastall) or die "Can't open $blastall\n";
   print BLAST $new_orf{$orf_id};
   close BLAST;
   print "Blast of ORF#$orf_id completed.\n"; 
}
exit;

##############################
# constructor                #
##############################
##############################
# public_methods             #
##############################
##############################
# public_functions           #
##############################
##############################
# private_methods            #
##############################
##############################
# private_functions          #
##############################
##############################
# main_footer                #
##############################
##############################
# perldoc_footer             #
##############################

=head1 KNOWN ISSUES <UPLINK>

<<KNOWN ISSUES>>

=head1 FUTURE IMPROVEMENTS <UPLINK>

<<FUTURE IMPROVEMENTS>>

=head1 AUTHORS <UPLINK>

<<AUTHORS>>

=head1 CREATED <UPLINK>

2004-08-18

=head1 REVISION <UPLINK>

=cut

