#!/usr/local/bin/perl
##############################
# perldoc_header             #
##############################

=head1 NAME <UPLINK>

ExecuteTask.pl - 

=head1 SYNOPSIS <UPLINK>

	<<SYNOPSIS>>

=head1 DESCRIPTION <UPLINK>

=for html
<BR>Author:Rene Warren<BR>Script:ExecuteTask.pl<BR>Purpose:Grabs information located in Job Queue table and execute prgms<BR>February 11th, 2003<BR>

=cut

##############################
# superclasses               #
##############################

=head2 SUPERCLASSES <UPLINK>

=over

=back

=cut

##############################
# system_variables           #
##############################
##############################
# standard_modules_ref       #
##############################

=head2 STANDARD MODULES REFERENCE <UPLINK>

=over

=item FindBin

=item lib "$FindBin::Bin/../lib"

=item SQLdb

=item strict

=item Date::Manip

=item Data::Dumper

=back

=cut

#Author:Rene Warren
#Script:ExecuteTask.pl
#Purpose:Grabs information located in Job Queue table and execute prgms
#February 11th, 2003
use FindBin;
use lib "$FindBin::Bin/../lib";
use SQLdb;
use strict;
use Date::Manip;
use Data::Dumper;

##############################
# custom_modules_ref         #
##############################

=head2 CUSTOM MODULES REFERENCE <UPLINK>

=over

=back

=cut

##############################
# global_vars                #
##############################

=head2 GLOBAL VARIABLES <UPLINK>

=over

=item $opt_u

=item $opt_p

=item $opt_d

=item $opt_o

=back

=cut

use vars qw($opt_u $opt_p $opt_d $opt_o);
##############################
# modular_vars               #
##############################
##############################
# constants                  #
##############################
##############################
# main_header                #
##############################
require "getopts.pl";
&Getopts('u:p:d:o:');
if (! $opt_u || ! $opt_p || ! $opt_d || ! $opt_o){
   print "Usage: ExecuteTask.pl\n";
   print "\t-u username\n";
   print "\t-p password\n";
   print "\t-d database\n";
   print "\t-o host name\n";
   exit;
}
my ($joblist_reference, $node_reference, $node_id, $user_info);
$user_info->{'username'}=$opt_u;
$user_info->{'password'}=$opt_p;
$user_info->{'database'}=$opt_d;
$user_info->{'host_name'}=$opt_o;
($joblist_reference, $node_reference, $node_id)=&getInfoFromDatabase($user_info);       ####Read Job Queue Table and the Executable;
&launchJob($joblist_reference,$node_reference, $user_info, $node_id);

##############################
# constructor                #
##############################
##############################
# public_methods             #
##############################
##############################
# public_functions           #
##############################

=head2 PUBLIC FUNCTIONS <UPLINK>

=for html <font size='-1'><strong><A href='#getInfoFromDatabase'>getInfoFromDatabase; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#launchJob'>launchJob; </A></strong></font><BR>

=over

=for html <A NAME='getInfoFromDatabase'>

=item getInfoFromDatabase

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#---------------------------------------------------
sub getInfoFromDatabase{

   my $user_info=shift;

   my $job_reference;
   my @node_record;
   my %node_id;

   eval{
      ###initialize connection
      my $dbh=SQLdb::Initialize($user_info->{'password'}, $user_info->{'username'}, $user_info->{'database'}, $user_info->{'host_name'});

      ###Inquisite about the jobs waiting in the Queue
      my @jobwaiting_field=("Job_Queue_ID", "Executable_ID", "Executable_Name", "Executable_Directory", "Job_Queue_FileCdt", "Job_Queue_AssemblerCdt", "Job_Queue_StartDateCdt", "Job_Queue_EndDateCdt", "Job_Queue_LibraryCdt", "Job_Queue_Email", "Job_Queue_New_Build", "Job_Queue_Gene_Finder", "Job_Queue_Map_ID", "Job_Queue_AssemblyCdt");
      my @jobwaiting_table=("Job_Queue", "Executable");
      my @jobwaiting_condition=("Executable_ID=FK_Executable__ID", "Job_Queue_Status='waiting'");
      my $special_instruction="ORDER BY Job_Queue_ID limit 1";
      my $select_jobwaiting=SQLdb::GetRecord(\@jobwaiting_field, \@jobwaiting_table, \@jobwaiting_condition, $special_instruction);
      $job_reference=SQLdb::ExecuteUnique($dbh, $select_jobwaiting);
       
      ###Get Single Node where to launch SAM
      my @node_field=("Node_Name", "Node_ID");
      my @node_table=("Node");
      my @node_condition=();
      my $node_instruction="Order By Node_ID limit 1";
      my $select_node=SQLdb::GetRecord(\@node_field, \@node_table, \@node_condition, $node_instruction);
      my $node_reference=SQLdb::ExecuteUnique($dbh, $select_node);
      my @node_array=@$node_reference;

      ####Some data structure rearrangement to allow sorting
      push @node_record, $node_array[0];
      $node_id{$node_array[0]}=$node_array[1];
      
      SQLdb::Disconnect($dbh);

   };
   if($@){print "Query failed:$@\n";}

   return $job_reference, \@node_record, \%node_id;   
}

=for html <A NAME='launchJob'>

=item launchJob

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$joblist_reference</B>():  [Default = <B>shift</B>]<BR>
- <B>$node_reference</B>():  [Default = <B>shift</B>]<BR>
- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$node_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#---------------------------------------------------
sub launchJob{

   my $joblist_reference=shift;
   my @record=@$joblist_reference;
   my $node_reference=shift;
   my @node_record=@$node_reference;
   my $user_info=shift;
   my $node_id=shift;
   my %node_id=%$node_id;

   my @date_format=("%Y-%m-%d %H:%M:%S");
 
   if (defined $record[0] && defined $node_record[0]){#if there's no job or no nodes to run the jobs on, just end  

      eval{

         ###initialize connection
         my $dbh=SQLdb::Initialize($user_info->{'password'}, $user_info->{'username'}, $user_info->{'database'}, $user_info->{'host_name'});
         
         my $node_name=$node_record[0]; #get node name
         my $node_table_id=$node_id{$node_name};   #Get the idea for that node (same order below)

         ###Update Status to initiated only for the job read above
         my $uniquetable="Job_Queue";
         my @field=("Job_Queue_Status", "FK_Node__ID");
         my @value=("initiated", "$node_table_id");
         my @condition=("Job_Queue_ID=$record[0]","Job_Queue_Status='waiting'");
         SQLdb::UpdateRecord($dbh, $uniquetable, \@field, \@value, \@condition);

         SQLdb::Disconnect($dbh);

         #run  1 job on 1 node at a time

         my $unixdate=`date`;
         chomp($unixdate);
         my $startdate=&UnixDate($unixdate,@date_format);

         my $argument="-u $user_info->{'username'} -p $user_info->{'password'} -d $user_info->{'database'} -o $user_info->{'host_name'} -i \'$record[0]\' ";

         if ($record[1]==1 || $record[1]==3){#this references the program to run .. file parsing (import map or import trace archive
            $argument.="-f \'$record[4]\' -m \'$record[9]\'";
         }elsif($record[1]==2){#run assembler
            $argument.="-a $record[5] -s \'$record[6]\' -e \'$record[7]\' -l \'$record[8]\' -v \'$record[10]\' -g \'$record[11]\' -m \'$record[9]\'";
         }elsif($record[1]==4){#run tiemapNassembly.pl
            $argument.="-a \'$record[13]\' -f \'$record[12]\' -m \'$record[9]\'";
         }elsif($record[1]==5){#run wrapper to coordinate the annotation of selected assembly
            $argument.="-a \'$record[13]\' -g \'$record[11]\' -m \'$record[9]\'";
         }

         #my $cmd = "ssh $node_record[0] $record[3]/$record[2] $argument &";#No need to run these on <>machines, the assemblers need to //& run in background (don't wait for end of execution to loop)
         my $cmd = "$record[3]/$record[2] $argument &";#No need to run these on <>machines, the assemblers need to //& run in background (don't wait for end of execution to loop)

         print "Starting remote script as $cmd\n";
         system("$cmd")==0 or die "Problem Executing $cmd!\n";
      };
      if($@){print "$@\nProgram failed.\n";}else{print "Your Job was Launched normally\n";}

   }else{
      print "No jobs to launch.\n";
      #write to log
   }

}

=back

=cut

##############################
# private_methods            #
##############################
##############################
# private_functions          #
##############################
##############################
# main_footer                #
##############################
##############################
# perldoc_footer             #
##############################

=head1 KNOWN ISSUES <UPLINK>

<<KNOWN ISSUES>>

=head1 FUTURE IMPROVEMENTS <UPLINK>

<<FUTURE IMPROVEMENTS>>

=head1 AUTHORS <UPLINK>

<<AUTHORS>>

=head1 CREATED <UPLINK>

2004-08-18

=head1 REVISION <UPLINK>

=cut

