#!/usr/local/bin/perl
##############################
# perldoc_header             #
##############################

=head1 NAME <UPLINK>

run_phrap.pl - 

=head1 SYNOPSIS <UPLINK>

	<<SYNOPSIS>>

=head1 DESCRIPTION <UPLINK>

=for html
<BR>Author:Rene Warren<BR>Script:run_phrap.pl<BR>Purpose:wrapper for running Phrap<BR>Jan 17th, 2003<BR>

=cut

##############################
# superclasses               #
##############################

=head2 SUPERCLASSES <UPLINK>

=over

=back

=cut

##############################
# system_variables           #
##############################
##############################
# standard_modules_ref       #
##############################

=head2 STANDARD MODULES REFERENCE <UPLINK>

=over

=item FindBin

=item lib "$FindBin::Bin/../lib"

=item strict

=item SQLdb

=item DBI

=back

=cut

#Author:Rene Warren
#Script:run_phrap.pl
#Purpose:wrapper for running Phrap
#Jan 17th, 2003
use FindBin;
use lib "$FindBin::Bin/../lib";
use strict;
use SQLdb;
use DBI;

##############################
# custom_modules_ref         #
##############################

=head2 CUSTOM MODULES REFERENCE <UPLINK>

=over

=back

=cut

##############################
# global_vars                #
##############################

=head2 GLOBAL VARIABLES <UPLINK>

=over

=back

=cut

##############################
# modular_vars               #
##############################
##############################
# constants                  #
##############################
##############################
# main_header                #
##############################
my $exec_dir=$ARGV[0];
my $project=$ARGV[1];
my $run=$ARGV[2];
my $data_dir=$ARGV[3];
my $exec=$ARGV[4];
my $password=$ARGV[5];
my $username=$ARGV[6];
my $database=$ARGV[7];
my $hostname=$ARGV[8];
my $date_start=$ARGV[9];
my $date_end=$ARGV[10];
my $library_list=$ARGV[11];
my $count=0;
####Build date condition
my $date_condition="Trace_Date_Sequenced>=\'$date_start\' AND Trace_Date_Sequenced<=\'$date_end 23:59:59\'";
####Build library condition
my @chosen_library=split (/,/, $library_list);
my $library_count=0;
my $library_condition;
foreach my $lib (sort @chosen_library){
    $library_condition.=" OR " if ($library_count>0);
    $library_condition.="Library_Name=\'$lib\'";
    $library_count++;
}
####Create Phrap directory structure 
`mkdir $data_dir/$project/$run` if (! -d  "$data_dir/$project/$run");                        #create a run directory 
`mkdir $data_dir/$project/$run/edit_dir` if (! -d "$data_dir/$project/$run/edit_dir");
`mkdir $data_dir/$project/$run/chromat_dir` if (! -d "$data_dir/$project/$run/chromat_dir");
`mkdir $data_dir/$project/$run/phd_dir` if (! -d "$data_dir/$project/$run/phd_dir");
####Get Trace name and origin (trace directory)
my $dbh=SQLdb::Initialize($password, $username, $database, $hostname);
my @trace_field=("Trace_Name", "Trace_Directory");
my @trace_table=("Trace", "Clone", "Library"); 
my @trace_condition=("Clone_ID=FK_Clone__ID", "Library_ID=FK_Library__ID", "$date_condition", "$library_condition");
my $select_trace=SQLdb::GetRecord(\@trace_field, \@trace_table, \@trace_condition);
my $ref_array=SQLdb::ExecuteMany($dbh, $select_trace);
my @traceref_array=@$ref_array;
SQLdb::Disconnect($dbh);
####Copying traces to current assembly dir
print "Creating links to trace files in  $data_dir/$project/$run/chromat_dir/\n";
foreach my $record_ref (@traceref_array){
   my @record=@$record_ref;
   `ln -s $record[1]/chromat_dir/$record[0] $data_dir/$project/$run/chromat_dir/$record[0]`;#creating soft link
   `ln -s $record[1]/phd_dir/$record[0].phd.1 $data_dir/$project/$run/phd_dir/$record[0].phd.1`;#creating soft link
    $count++;
}
####Running assembler
print "Running $exec_dir/$exec -please be patient\n";
chdir "$data_dir/$project/$run/edit_dir";                  #Will run phrap from this directory
eval{
   system("$exec_dir/$exec")==1 or die "problem running phredPhrap...\n";
};
####Changing files, makes it easier to manage later
`cp "$data_dir/$project/$run/edit_dir/$run.fasta.screen.contigs" "$data_dir/$project/$run/edit_dir/fasta.screen.contigs"`;
`cp "$data_dir/$project/$run/edit_dir/$run.fasta.screen.contigs.qual" "$data_dir/$project/$run/edit_dir/fasta.screen.contigs.qual"`;

##############################
# constructor                #
##############################
##############################
# public_methods             #
##############################
##############################
# public_functions           #
##############################
##############################
# private_methods            #
##############################
##############################
# private_functions          #
##############################
##############################
# main_footer                #
##############################
##############################
# perldoc_footer             #
##############################

=head1 KNOWN ISSUES <UPLINK>

<<KNOWN ISSUES>>

=head1 FUTURE IMPROVEMENTS <UPLINK>

<<FUTURE IMPROVEMENTS>>

=head1 AUTHORS <UPLINK>

<<AUTHORS>>

=head1 CREATED <UPLINK>

2004-08-18

=head1 REVISION <UPLINK>


=cut

