#!/usr/local/bin/perl56
##############################
# perldoc_header             #
##############################

=head1 NAME <UPLINK>

sequencedb2xml.pl - 

=head1 SYNOPSIS <UPLINK>

	<<SYNOPSIS>>

=head1 DESCRIPTION <UPLINK>

=for html
<BR>Author:Rene Warren<BR>Script:sequencedb2xml.pl<BR>Purpose:#Creates an xml file (model file) for inputing sequence data in SAMdb, used in conjunction with BCGSC LIMS<BR>October 2002<BR>

=cut

##############################
# superclasses               #
##############################

=head2 SUPERCLASSES <UPLINK>

=over

=back

=cut

##############################
# system_variables           #
##############################
##############################
# standard_modules_ref       #
##############################

=head2 STANDARD MODULES REFERENCE <UPLINK>

=over

=item FindBin

=item lib "$FindBin::Bin/../lib"

=item strict

=item lib "/usr/local/lib/perl5/site_perl/5.005"

=item Date::Manip

=item SQLdb

=item Data::Dumper

=item lib "/usr/local/ulib/prod/alDente/lib/perl"

=item Sequencing::Sequencing_API

=item Data::Dumper

=item SDB::DBIO

=back

=cut

#Author:Rene Warren
#Script:sequencedb2xml.pl
#Purpose:#Creates an xml file (model file) for inputing sequence data in SAMdb, used in conjunction with BCGSC LIMS
#October 2002
use FindBin;
use lib "$FindBin::Bin/../lib";
use strict;
use lib "/usr/local/lib/perl5/site_perl/5.005";
use Date::Manip;
use SQLdb;
use Data::Dumper;
use Data::Dumper;
use lib "/usr/local/ulib/prod/alDente/lib/perl";
use Sequencing::Sequencing_API;
use Data::Dumper;
use Data::Dumper;
use SDB::DBIO;

##############################
# custom_modules_ref         #
##############################

=head2 CUSTOM MODULES REFERENCE <UPLINK>

=over

=back

=cut

##############################
# global_vars                #
##############################

=head2 GLOBAL VARIABLES <UPLINK>

=over

=item $opt_j

=item $opt_f

=item $opt_i

=item $opt_p

=item $opt_u

=item $opt_d

=item $opt_a

=item $opt_t

=item $opt_c

=item $opt_h

=item $opt_r

=item $opt_w

=back

=cut

use vars qw($opt_j $opt_f $opt_i $opt_p $opt_u $opt_d $opt_a $opt_t $opt_c $opt_h $opt_r $opt_w);
##############################
# modular_vars               #
##############################
##############################
# constants                  #
##############################
##############################
# main_header                #
##############################
require "getopts.pl";
&Getopts('j:f:i:p:u:d:a:t:c:h:r:w:');
#####TRAP ERRORS#####
#INVALID OPTION
if (! $opt_j || ! $opt_f || ! $opt_i || ! $opt_p || ! $opt_u || ! $opt_d || ! $opt_a || ! $opt_t || !$opt_c || ! $opt_h || ! $opt_r || ! $opt_w){
   die "Usage: sequencedb2xml.pl -u username -p password -d database -h hostname -j project_id (RHA1=23, WM276=39) -f xmlfilename -i insertfile -c chemistry file -a date -t /fullpath/trace repository -r directory to store xml -w base name for walks (e.g.RZ888)\n";
}elsif (! -d $opt_r){
   die "$opt_r invalid.\n";
}elsif (! -e "$opt_r/$opt_i"){
   print "$opt_r/$opt_i\n";
   die "Please Enter a valid file.\n";
}elsif (! -e "$opt_r/$opt_c"){
   print "$opt_r/$opt_c\n";
   die "Please Enter a valid file.\n";
}elsif (-e "$opt_r/$opt_f"){
   `rm -f $opt_r/$opt_f`;
   `rm -f $opt_r/$opt_f.log`;
}
my $study_id=$opt_j;
my $file=$opt_f;
my $insertfile=$opt_i;
my $chemistryfile=$opt_c;
my $trace_dir=$opt_t;
my $date=`date`;
my $filedir=$opt_r;
chomp ($date);
####Initialize database connection
#my $connection = DBIO->new();
#$connection->connect(-dbase=>$opt_d,-host=>$opt_h,-user=>$opt_u,-password=>$opt_p);
my $API = Sequencing_API->new(-dbase=>$opt_d,-host=>$opt_h,-DB_user=>$opt_u,-DB_password=>$opt_p,-connect=>1);
print "$file\n";
&initializeXml($file, $filedir, $date);
my $assembly_data=&getInfoAssembly();
my ($insert_size, $insert_stdev)=&getInfoLib($insertfile, $filedir);
my $primer=&getInfo($chemistryfile, $filedir);
my $sequence_data=&getInfoSequence($assembly_data, $insert_size, $insert_stdev, $study_id, $file, $filedir, $opt_a, $API, $trace_dir, $primer, $opt_w);
&endXml($file, $filedir);
exit;

##############################
# constructor                #
##############################
##############################
# public_methods             #
##############################
##############################
# public_functions           #
##############################

=head2 PUBLIC FUNCTIONS <UPLINK>

=for html <font size='-1'><strong><A href='#test'>test; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getInfoLib'>getInfoLib; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getInfo'>getInfo; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#endXml'>endXml; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#initializeXml'>initializeXml; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#addRecord'>addRecord; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getInfoAssembly'>getInfoAssembly; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getInfoSequence'>getInfoSequence; </A></strong></font><BR>

=over

=for html <A NAME='test'>

=item test

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$sequence_data</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------------
sub test{

   my $sequence_data=shift;
   my %sequence_data=%$sequence_data;

   my $ct=0;

   foreach my $id (sort %sequence_data){
      $ct++;
   }
   print "$ct\n";

}

=for html <A NAME='getInfoLib'>

=item getInfoLib

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$file</B>():  [Default = <B>shift</B>]<BR>
- <B>$filedir</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------------
sub getInfoLib{

   my $file=shift;
   my $filedir=shift;

   my %hash;
    my %stdev;

   open (OUT, "$filedir/$file") or die "Can't open $file!\n";
   while (<OUT>){
      chomp;
      my ($x, $y, $z);
      ($x, $y, $z)=split(';',$_);      
      $hash{$x}=$y;
      $stdev{$x}=$z;
      print "$x..$z\n";
   }
   close OUT;

   return \%hash, \%stdev;
}

=for html <A NAME='getInfo'>

=item getInfo

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$file</B>():  [Default = <B>shift</B>]<BR>
- <B>$filedir</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------------
sub getInfo{

   my $file=shift;
   my $filedir=shift;

   my %hash;

   open (OUT, "$filedir/$file") or die "Can't open $file!\n";
   while (<OUT>){
      chomp;
      my ($x, $y);
      ($x, $y)=split(';',$_);
      $hash{$x}=$y;
   }
   close OUT;

   return \%hash;
}

=for html <A NAME='endXml'>

=item endXml

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$file</B>():  [Default = <B>shift</B>]<BR>
- <B>$filedir</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------------
sub endXml{

   my $file=shift;
   my $filedir=shift;

   open (IN, ">>$filedir/$file") or die "Can't open $file\n";

   print IN "\t</trace_volume>";   

   close IN;

}

=for html <A NAME='initializeXml'>

=item initializeXml

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$file</B>():  [Default = <B>shift</B>]<BR>
- <B>$filedir</B>():  [Default = <B>shift</B>]<BR>
- <B>$date</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------------
sub initializeXml{

   my $file=shift;
   my $filedir=shift;
   my $date=shift;

   open (IN, ">$filedir/$file") or die "Can't open $file\n";

   #Create XML according to the NCBI's trace archive RFC
   print IN "<?xml version=\"1.0\"?>\n";   
   print IN "\t<trace_volume>\n";
   print IN "\t\t<volume_name>trace archive</volume_name>\n";
   print IN "\t\t<volume_date>$date</volume_date>\n";
   print IN "\t\t<volume_version>        </volume_version>\n";

   close IN;

} #end sub

=for html <A NAME='addRecord'>

=item addRecord

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$record</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_data</B>():  [Default = <B>shift</B>]<BR>
- <B>$insert_size</B>():  [Default = <B>shift</B>]<BR>
- <B>$insert_stdev</B>():  [Default = <B>shift</B>]<BR>
- <B>$file</B>():  [Default = <B>shift</B>]<BR>
- <B>$filedir</B>():  [Default = <B>shift</B>]<BR>
- <B>$trace_dir</B>():  [Default = <B>shift</B>]<BR>
- <B>$primer</B>():  [Default = <B>shift</B>]<BR>
- <B>$fileno</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------------
sub addRecord{

   my $record=shift;
   my %record=%$record;
   my $assembly_data=shift;
   my @assembly_data=@$assembly_data;
   my $insert_size=shift;
   my %insert_size=%$insert_size;
   my $insert_stdev=shift;
   my %insert_stdev=%$insert_stdev;
   my $file=shift;
   my $filedir=shift;
   my $trace_dir=shift;
   my $primer=shift;
   my %primer=%$primer;
   my $fileno=shift;

  my $seq_length=length($record{'Sequence'});
   
  my $percent_qual=0;
  if ($seq_length==0){ 
    #
  }else{
    $percent_qual=($record{'Quality_Length'}/$seq_length*100) if ($seq_length>0);
  }

  #print "$percent_qual :: $seq_length\n";

  if($percent_qual != 0 && $seq_length >0){###Will not import bad (very bad!) reads in SAMdb

   open (IN, ">>$filedir/$file") or die "Can't open $file\n";

   ####has been commented out on Apr5,03.  Reason: there's a discrepency between seq db capillary id and trance name on the file system.
   ####Deals with short < 3digits capillary id (integral part of trace name);
   #my $capillary;   
   #if (int($record{'Capillary'})<10){
   #   $capillary="00".int($record{'Capillary'});
   #}
   #elsif(int($record{'Capillary'})<100){
   #   $capillary="0".int($record{'Capillary'});
   #} 
   #elsif(int($record{'Capillary'})>=100){
   #   $capillary=int($record{'Capillary'});
   #}

   my $quadrant;
   if (! $record{'Parent_Quadrant'}){
      $quadrant='';
   }else{
      $quadrant=$record{'Parent_Quadrant'};
   }

   print IN "\t\t<trace>\n";    
   print IN "\t\t\t<trace_name>$fileno</trace_name>\n";
   print IN "\t\t\t<trace_directory>$trace_dir</trace_directory>\n";                                                 #temporary centralized location
   print IN "\t\t\t<center_name>$assembly_data[0]</center_name>\n";
   print IN "\t\t\t<center_project>$record{'project'}</center_project>\n"; 
   print IN "\t\t\t<library_id>$record{'Library_Name'}</library_id>\n";
   print IN "\t\t\t<plate_number>$record{'Plate_Number'}</plate_number>\n";
   print IN "\t\t\t<plate_quadrant>$quadrant</plate_quadrant>\n";
   print IN "\t\t\t<clone_id>$record{'OriginalClone'}</clone_id>\n";                  
   print IN "\t\t\t<template_id>$record{'Template'}</template_id>\n";
   print IN "\t\t\t<insert_size>$insert_size{$record{'Library_Name'}}</insert_size>\n";
   
   print IN "\t\t\t<quality_length>$record{'Quality_Length'}</quality_length>\n";
   print IN "\t\t\t<vector_quality>$record{'Vector_Quality'}</vector_quality>\n";

   #STD DEV (10% INSERT LENGTH) NOOOO!!!!!
   #my $stdev=0.1*$insert_size{$record{'Library_Name'}};
   print IN "\t\t\t<insert_stddev>$insert_stdev{$record{'Library_Name'}}</insert_stddev>\n";   
   print IN "\t\t\t<well_id>$record{'Well'}</well_id>\n";
   print IN "\t\t\t<trace_sequence>$record{'Sequence'}</trace_sequence>\n";
   
   my @quality=unpack ("C*", $record{'Sequence_Scores'});

   print IN "\t\t\t<trace_quality>@quality</trace_quality>\n";

   #TRACE TYPE
   my $type;
   if ($primer{$record{'Chemistry_Code'}} eq 'F' || $primer{$record{'Chemistry_Code'}} eq 'R'){
       $type="paired_production";
   }
   else{
       $type="unpaired_production";
   }

   print "$record{'Chemistry_Code'}...$primer{$record{'Chemistry_Code'}}...$record{'Vector_Quality'}\n";

   print IN "\t\t\t<trace_end>$primer{$record{'Chemistry_Code'}}</trace_end>\n";
   print IN "\t\t\t<run_date>$record{'Sequence_DateTime'}</run_date>\n";
   print IN "\t\t\t<type>$type</type>\n";

   #LENGTH
   my $length=length($record{'Sequence'});
   print IN "\t\t\t<trace_length>$length</trace_length>\n";
   print IN "\t\t</trace>\n";
     
   close IN;

 }else{
   open (INFO, ">>$filedir/$file.log") or die "Can't open $file.log\n";
   print INFO "$record{'Sequence_Subdirectory'}_$record{'Well'} * $record{'Quality_Length'} * $seq_length * $percent_qual\n";
   close INFO;
 }

}

=for html <A NAME='getInfoAssembly'>

=item getInfoAssembly

=for html
for now, only gets the center name from the assembly database<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
- None<BR>
<BR>

=cut

#-------------------------------------------
#for now, only gets the center name from the assembly database
sub getInfoAssembly{

   my @assembly_data;

   my $password="viewer";
   my $username="viewer";
   my $database="RHA1backup";
   my $host="lims-dbm";

   my $dbh=SQLdb::Initialize($password,$username,$database, $host);

   my @field=("Center_Name");
   my @table=("Center");
   my @condition=();
   my $select=SQLdb::GetRecord(\@field, \@table, \@condition);
   my $tmp_rec=SQLdb::ExecuteUnique($dbh, $select);

   SQLdb::Disconnect($dbh); 

   return $tmp_rec;
}

=for html <A NAME='getInfoSequence'>

=item getInfoSequence

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$assembly_data</B>():  [Default = <B>shift</B>]<BR>
- <B>$insert_size</B>():  [Default = <B>shift</B>]<BR>
- <B>$insert_stdev</B>():  [Default = <B>shift</B>]<BR>
- <B>$study_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$file</B>():  [Default = <B>shift</B>]<BR>
- <B>$filedir</B>():  [Default = <B>shift</B>]<BR>
- <B>$date_condition</B>():  [Default = <B>shift</B>]<BR>
- <B>$API</B>():  [Default = <B>shift</B>]<BR>
- <B>$trace_dir</B>():  [Default = <B>shift</B>]<BR>
- <B>$primer</B>():  [Default = <B>shift</B>]<BR>
- <B>$walks</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------------
sub getInfoSequence{

   my $assembly_data=shift;
   my $insert_size=shift;
   my $insert_stdev=shift;
   my $study_id=shift;      
   my $file=shift;  
   my $filedir=shift;
   my $date_condition=shift;
   my $API=shift;
   my $trace_dir=shift;
   my $primer=shift;
   my $walks=shift;

   my @record;
   
   ##################Get Plates INFO ######################################################
   ######get plate ID only, will need it for unused wells
   my @plate_fields=("Plate_ID");
   #my $plate_reference=$API->get_Read_data(-study_id=>$study_id, -since=>$date_condition,-fields=>\@plate_fields,-include=>'production,approved', -format=>'array', -group_by=>'Plate_ID');
   my $plate_reference=$API->get_Read_data(-project_id=>$study_id, -since=>$date_condition,-fields=>\@plate_fields,-include=>'production,approved', -format=>'array', -group_by=>'Plate_ID');

   my $no_seq;
   foreach my $ref (@$plate_reference){
      #########check whether a specific well has been used or not
      #my $unused_wells=&get_Plate_data(-connection=>$connection,-fields=>['unused_wells'],-plate_id=>$ref->{'Plate_ID'});
      my $unused_wells=$API->get_Plate_data(-fields=>['unused_wells'],-plate_id=>$ref->{'Plate_ID'});
      print Dumper($unused_wells);
      my $tmp_array=$unused_wells->{unused_wells};

      ####convert unused well in a user-friendly format
      my $all_wells=$tmp_array->[0];
      my @well_array=split(',', $all_wells);
      foreach my $well(@well_array){
       #print "well $well\n";
       my $formatted_well;
       if($well=~/(\D{1})(\d+)/){
          my $char=$1;
          my $num=$2;
          my $id;
          if($num=~/\d{2}/){#two digits
             $id=$num;
          }else{            #only one digit
             $id="0".$num;
          }

          $formatted_well=$char.$id;
       }
       $no_seq->{$ref->{'Plate_ID'}}{$formatted_well}++;
       print "UNUSED WELL:$formatted_well\n";
     }
   }

   ###################Get Reads INFO ######################################################
   ###### get raw sequence data (nucleotide sequence and phred scores for each base pair ##
   my @fields=("Library_Name", "Plate_Number", "Parent_Quadrant", "chemistry_code", "Clone_Sequence.Well", "Sequence", "Sequence_Scores", "Sequence_DateTime", "Sequence_Subdirectory", "Capillary", "Quality_Length", "Vector_Quality", "project", "Plate_ID");
   my $read_reference=$API->get_Read_data(-project_id=>$study_id, -since=>$date_condition,-fields=>\@fields,-include=>'production,approved', -format=>'array', -group_by=>'run_id,Clone_Sequence.Well');

   my $ct=0;
   my $ct2=0;
   foreach my $ref(@$read_reference){                ####all traces
      my $fileno;
      my $flag=1;
      my $library=$ref->{'Library_Name'};
      $ct++;
      print "****$ct library $ref->{'Plate_Number'}**$ref->{'Plate_ID'}**$ref->{'Well'}****\n";

      if(! defined $no_seq->{$ref->{'Plate_ID'}}{$ref->{'Well'}}){       ####Defined Wells are unusued wells
   
         $ct2++;
         print "$ct2 good sequences $ref->{'Well'} is ok:  processing $ref->{'Sequence_Subdirectory'}_$ref->{'Well'}\n";
 
         if($library eq $walks){###special condition if dealing with walks
            my %ancestry=%{$API->get_plate_lineage(-plate_id=>$ref->{'Plate_ID'},-well=>$ref->{'Well'})};### Clone_Sequence.Well?
            my ($new_library, $new_plate, $new_quadrant, $new_well)=($ref->{'Library_Name'}, $ref->{'Plate_Number'}, $ref->{'Parent_Quadrant'}, $ref->{'Well'});
            my ($orig_library, $orig_plate_all, $orig_well)=($1, $2, $3) if ($ancestry{sample_name}=~/^(\w{5})\-(\d+[abcd]?)\_(\D\d{2})/);
            my ($orig_plate_number, $orig_quadrant);

            $flag=0 if (! $orig_library);

            if($orig_plate_all=~/(\d+)([abcd])?/){
               ($orig_plate_number, $orig_quadrant)=($1,$2);
            }
 
            $new_quadrant='' if (!$new_quadrant);
            $orig_quadrant='' if (!$orig_quadrant);
            my $new_chemistry=$1 if ($ref->{'Sequence_Subdirectory'}=~/\w+\.(\w+\.?\d?)$/);

            $new_chemistry=~s/CBO/CB/i;

            print "$ref->{'Sequence_Subdirectory'} $new_chemistry $new_library, $new_plate\n";

            $fileno=$orig_library.$orig_plate_all.".".$new_chemistry.".".$new_plate.$new_quadrant.$new_well."_".$orig_well;

            ####Reassigned values for the Original clone
            $ref->{'Library_Name'}=$orig_library;
            $ref->{'Plate_Number'}=$new_plate;
            $ref->{'Plate_Quadrant'}=$orig_quadrant;
            $ref->{'Well'}=$orig_well;
            $ref->{'OriginalClone'}=$orig_library.$orig_plate_all.$orig_well;        
            $ref->{'Chemistry_Code'}=$1 if ($new_chemistry=~/(\w+)(\.\d+)?/);
            $ref->{'Template'}=$new_library.$new_plate.$new_quadrant.$new_well;

         }else{                 ###no walks
            $fileno=$ref->{'Sequence_Subdirectory'}."_".$ref->{'Well'};
            ####Reassigned values for the Original clone
            my $chemistry_code_only=$1 if ($ref->{'Sequence_Subdirectory'}=~/\w+\.(\w+)(\.\d+)?$/);

            $ref->{'OriginalClone'}=$ref->{'Library_Name'}.$ref->{'Plate_Number'}.$ref->{'Parent_Quadrant'}.$ref->{'Well'};
            $ref->{'Template'}=$ref->{'OriginalClone'};
            $ref->{'Plate_Quadrant'}=$ref->{'Parent_Quadrant'};
            $ref->{'Chemistry_Code'}=$chemistry_code_only;
            $ref->{'Well'}=$ref->{'Well'};
         }

         #build xml file
         if($flag){###if something not normal with parental filename
            &addRecord($ref, $assembly_data, $insert_size, $insert_stdev, $file, $filedir, $trace_dir, $primer, $fileno);
         }
       }
    }
   #$connection->disconnect();
   $API->disconnect;
}#end sub

=back

=cut

##############################
# private_methods            #
##############################
##############################
# private_functions          #
##############################
##############################
# main_footer                #
##############################
##############################
# perldoc_footer             #
##############################

=head1 KNOWN ISSUES <UPLINK>

<<KNOWN ISSUES>>

=head1 FUTURE IMPROVEMENTS <UPLINK>

<<FUTURE IMPROVEMENTS>>

=head1 AUTHORS <UPLINK>

<<AUTHORS>>

=head1 CREATED <UPLINK>

2004-08-18

=head1 REVISION <UPLINK>


=cut

