#!/usr/local/bin/perl
##############################
# perldoc_header             #
##############################

=head1 NAME <UPLINK>

xmlmap_parser.pl -

=head1 SYNOPSIS <UPLINK>

	<<SYNOPSIS>>

=head1 DESCRIPTION <UPLINK>

=for html
<BR>Author:Rene Warren<BR>Script:xmlmap_parser.pl<BR>Purpose:Parses map xml file and fills SAMdb<BR>Takes advantage of XML::Simple's power (good for smaller xml files) Vs. XML::Parser (currently in used for xmltrace_parser.pl)<BR>June 2003<BR>

=cut

##############################
# superclasses               #
##############################

=head2 SUPERCLASSES <UPLINK>

=over

=back

=cut

##############################
# system_variables           #
##############################
##############################
# standard_modules_ref       #
##############################

=head2 STANDARD MODULES REFERENCE <UPLINK>

=over

=item FindBin

=item lib "$FindBin::Bin/../lib"

=item strict

=item CommonTask

=item XMLparser

=back

=cut

#Author:Rene Warren
#Script:xmlmap_parser.pl
#Purpose:Parses map xml file and fills SAMdb
#Takes advantage of XML::Simple's power (good for smaller xml files) Vs. XML::Parser (currently in used for xmltrace_parser.pl)
#June 2003
use FindBin;
use lib "$FindBin::Bin/../lib";
use strict;
use CommonTask;
use XMLparser;

##############################
# custom_modules_ref         #
##############################

=head2 CUSTOM MODULES REFERENCE <UPLINK>

=over

=back

=cut

##############################
# global_vars                #
##############################

=head2 GLOBAL VARIABLES <UPLINK>

=over

=item $opt_p

=item $opt_f

=item $opt_u

=item $opt_d

=item $opt_o

=item $opt_m

=item $opt_i

=back

=cut

use vars qw($opt_p $opt_f $opt_u $opt_d $opt_o $opt_m $opt_i);
##############################
# modular_vars               #
##############################
##############################
# constants                  #
##############################
##############################
# main_header                #
##############################
require "getopts.pl";
&Getopts('p:f:u:d:o:m:i:');
my @date_format=("%Y-%m-%d %H:%M:%S");
my %user_info;
####Arguments (allow to proceed without email or job_queue id
if (! $opt_p || ! $opt_f || ! $opt_u || ! $opt_d || !$opt_o){die "Usage: xmlmap_parser.pl -u username -p password -d database -o host name -f /fullpath/mapXMLarchive -i job_queue id  -m email \n";}elsif(! -e "$opt_f"){die "$opt_f doesn't exist...Please Enter a valid file.\n";}
$user_info{'username'}=$opt_u;
$user_info{'password'}=$opt_p;
$user_info{'database'}=$opt_d;
$user_info{'host_name'}=$opt_o;
my $xml_file=$opt_f;
my $email=$opt_m;
my $jobqueue_id=$opt_i;
my $fosmidboundary_size=10000; ####change this value if plasmid lib>10k or fosmid lib for fingerprint map (unlikely) <10k
###$fosmidboundary_size is ONLY used to speed up data retrieval from SAMdb, since only large clones are fingerprinted.
my ($status, $message)=XMLparser::readMapData(\%user_info, $xml_file, $fosmidboundary_size);
CommonTask::updateJobStatus(\%user_info, $jobqueue_id, $status, \@date_format);
&sendEmail($email, $status, $message, $jobqueue_id, $xml_file, \%user_info) if ($opt_m);  ###Only send email id address supplied
exit;

##############################
# constructor                #
##############################
##############################
# public_methods             #
##############################
##############################
# public_functions           #
##############################

=head2 PUBLIC FUNCTIONS <UPLINK>

=for html <font size='-1'><strong><A href='#sendEmail'>sendEmail; </A></strong></font><BR>

=over

=for html <A NAME='sendEmail'>

=item sendEmail

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$email</B>():  [Default = <B>shift</B>]<BR>
- <B>$status</B>():  [Default = <B>shift</B>]<BR>
- <B>$message</B>():  [Default = <B>shift</B>]<BR>
- <B>$jobqueue_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$xml_file</B>():  [Default = <B>shift</B>]<BR>
- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-----------------------------
sub sendEmail{

   my $email=shift;
   my $status=shift;
   my $message=shift;
   my $jobqueue_id=shift;
   my $xml_file=shift;
   my $user_info=shift;
   my %user_info=%$user_info;

   print "email sent to $email\n";

   ###must send the Job_Queue to the user
   my $comment="Job#$jobqueue_id:\nParsing xml file $xml_file into $user_info{'database'} Status:$status.\n$message\n";
   CommonTask::sendMail($email, $comment, $jobqueue_id) if ($email ne ''); ###make sure don't send the email even if option is there

}

=back

=cut

##############################
# private_methods            #
##############################
##############################
# private_functions          #
##############################
##############################
# main_footer                #
##############################
##############################
# perldoc_footer             #
##############################

=head1 KNOWN ISSUES <UPLINK>

<<KNOWN ISSUES>>

=head1 FUTURE IMPROVEMENTS <UPLINK>

<<FUTURE IMPROVEMENTS>>

=head1 AUTHORS <UPLINK>

<<AUTHORS>>

=head1 CREATED <UPLINK>

2004-08-18

=head1 REVISION <UPLINK>


=cut

