#!/usr/local/bin/perl
##############################
# perldoc_header             #
##############################

=head1 NAME <UPLINK>

xmltrace_parser.pl  

=head1 SYNOPSIS <UPLINK>

	<<SYNOPSIS>>

=head1 DESCRIPTION <UPLINK>

=for html
<BR>Author:Rene Warren<BR>Script:xmltrace_parser.pl<BR>Purpose:Parses sequence xml file and fills SAMdb<BR>October 2002<BR>

=cut

##############################
# superclasses               #
##############################

=head2 SUPERCLASSES <UPLINK>

=over

=back

=cut

##############################
# system_variables           #
##############################
##############################
# standard_modules_ref       #
##############################

=head2 STANDARD MODULES REFERENCE <UPLINK>

=over

=item FindBin

=item lib "$FindBin::Bin/../lib"

=item strict

=item Date::Manip

=item XML::Parser

=item SQLdb

=item Data::Dumper

=item CommonTask

=back

=cut

#Author:Rene Warren
#Script:xmltrace_parser.pl
#Purpose:Parses sequence xml file and fills SAMdb
#October 2002
use FindBin;
use lib "$FindBin::Bin/../lib";
use strict;
use Date::Manip;
use XML::Parser;
use SQLdb;
use Data::Dumper;
use CommonTask;

##############################
# custom_modules_ref         #
##############################

=head2 CUSTOM MODULES REFERENCE <UPLINK>

=over

=back

=cut

##############################
# global_vars                #
##############################

=head2 GLOBAL VARIABLES <UPLINK>

=over

=item $opt_p

=item $opt_f

=item $opt_u

=item $opt_d

=item $opt_o

=item $opt_m

=item $opt_i

=back

=cut

use vars qw($opt_p $opt_f $opt_u $opt_d $opt_o $opt_m $opt_i);
##############################
# modular_vars               #
##############################
##############################
# constants                  #
##############################
##############################
# main_header                #
##############################
require "getopts.pl";
&Getopts('p:f:u:d:o:m:i:');
####All these are global---This is because of the oddness of the xmlparser
my ($tag, $data, $endtag);
my %record;
my $library_record;
my $dbh;#make global 
my ($library_insert_ct, $library_update_ct,  $read_insert_ct, $read_update_ct, $clone_insert_ct, $clone_update_ct);
my $library_record;
my $clone_record;
my @date_format=("%Y-%m-%d %H:%M:%S");
my %user_info;
####Arguments (allow to proceed without email or job_queue id
if (! $opt_p || ! $opt_f || ! $opt_u || ! $opt_d || !$opt_o){die "Usage: xmltrace_parser.pl -u username -p password -d database -o host name -f /fullpath/TraceArchiveXml -i job_queue id -m email \n";}elsif(! -e "$opt_f"){die "$opt_f doesn't exist...Please Enter a valid file.\n";}
$user_info{'username'}=$opt_u;
$user_info{'password'}=$opt_p;
$user_info{'database'}=$opt_d;
my $xml_file=$opt_f;
$user_info{'host_name'}=$opt_o;
my $email=$opt_m;
my $jobqueue_id=$opt_i;
my ($status, $message)=&readData(\%user_info, $xml_file);
CommonTask::updateJobStatus(\%user_info, $jobqueue_id, $status, \@date_format);
&sendEmail($email, $status, $message, $jobqueue_id, $xml_file, \%user_info) if ($opt_m);  ###only sends email if there seem to be an address
exit;

##############################
# constructor                #
##############################
##############################
# public_methods             #
##############################
##############################
# public_functions           #
##############################

=head2 PUBLIC FUNCTIONS <UPLINK>

=for html <font size='-1'><strong><A href='#sendEmail'>sendEmail; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#readData'>readData; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getDate'>getDate; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getInitialValue'>getInitialValue; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#checkExistence'>checkExistence; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#insertData'>insertData; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#StartTag'>StartTag; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#Text'>Text; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#EndTag'>EndTag; </A></strong></font><BR>

=over

=for html <A NAME='sendEmail'>

=item sendEmail

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$email</B>():  [Default = <B>shift</B>]<BR>
- <B>$status</B>():  [Default = <B>shift</B>]<BR>
- <B>$message</B>():  [Default = <B>shift</B>]<BR>
- <B>$jobqueue_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$xml_file</B>():  [Default = <B>shift</B>]<BR>
- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-----------------------------
sub sendEmail{

   my $email=shift;
   my $status=shift;
   my $message=shift;
   my $jobqueue_id=shift;
   my $xml_file=shift;
   my $user_info=shift;
   my %user_info=%$user_info;

   print "email sent to $email\n";

   ###must send the Job_Queue to the user
   my $comment="Your Job#$jobqueue_id:\nParsing xml file $xml_file into $user_info{'database'} Status:$status.\n$message";
   CommonTask::sendMail($email, $comment, $jobqueue_id) if ($email ne '');

}

=for html <A NAME='readData'>

=item readData

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$xml_file</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub readData{ 

   my $user_info=shift;
   my %user_info=%$user_info;
   my $xml_file=shift;
   
   my ($status, $message);

   eval{

      ####Initialize Timer
      my $start_date=&getDate();
   
      ####Initialize the XML parser
      my $xmlparser=new XML::Parser(Style =>'Stream', ErrorContext => 2);

      ####Initialize database connection
      print "Connecting to $user_info{'database'} database...\n";
      $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'database'}, $user_info{'host_name'});

      ####Get initial values
      print "Getting Initial db values...\n";
      ($library_record, $clone_record)=&getInitialValue();

      ####Parse XML and Fill assembly database as the file being parsed
      print "Populating $user_info{'database'} database...\n";

      $xmlparser->parsefile("$xml_file");#this can't be put in an eval block

      ####End Time
      my $end_date=&getDate();

      ####Time Elapsed
      my $time_elapsed=&DateCalc($start_date,$end_date);

      print "*started at    :$start_date\n";
      print "*Finished at   :$end_date\n";
      print "*Time Elapsed  :$time_elapsed\n";

      print "Read inserted:$read_insert_ct\nRead updated:$read_update_ct\nClone inserted:$clone_insert_ct\nClone updated:$clone_update_ct\nLibrary inserted:$library_insert_ct\nLibrary updated:$library_update_ct\n";

      $dbh->disconnect();

   };
   if($@){$status="failed";$message="$@";print "$@ Failed!\n";}else{$status="completed";print "Success!\n";}

   return $status, $message;

}

=for html <A NAME='getDate'>

=item getDate

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
- None<BR>
<BR>

=cut

#-------------------------------------

sub getDate{

   my $date=`date`;
   chomp($date);
   return $date;

}

=for html <A NAME='getInitialValue'>

=item getInitialValue

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
- None<BR>
<BR>

=cut

#-------------------------------------
sub getInitialValue{

   my @field=("max(Library_ID)");
   my @table=("Library");
   my @condition=();
   my $select_library=SQLdb::GetRecord(\@field, \@table, \@condition);
   my $library_record=SQLdb::ExecuteUnique($dbh, $select_library);

   @field=("max(Clone_ID)");
   @table=("Clone");
   @condition=();
   my $select_clone=SQLdb::GetRecord(\@field, \@table, \@condition);
   my $clone_record=SQLdb::ExecuteUnique($dbh, $select_clone);

   return $library_record, $clone_record;
}

=for html <A NAME='checkExistence'>

=item checkExistence

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$record</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub checkExistence{

    my $record=shift;
    my %record=%$record;

    #CHECK EXISTENCE OF LIBRARY #invoke SQLassembly.pm module see module definition
    my @field=("Library_ID");
    my @table=("Library");
    my @condition=("Library_Name='$record{'library_id'}'");
    my $select_library=SQLdb::GetRecord(\@field, \@table, \@condition);
    my $tmp_library=SQLdb::ExecuteUnique($dbh, $select_library);

    #CHECK EXISTENCE OF CLONE
    @field=("Clone_ID");
    @table=("Clone");
    @condition=("Clone_Name='$record{'clone_id'}'");
    my $select_clone=SQLdb::GetRecord(\@field, \@table, \@condition);
    my $tmp_clone=SQLdb::ExecuteUnique($dbh, $select_clone);

    #CHECK EXISTENCE OF READ
    @field=("Trace_ID");
    @table=("Trace");
    @condition=("Trace_Name='$record{'trace_name'}'");
    my $select_read=SQLdb::GetRecord(\@field, \@table, \@condition);
    my $tmp_read=SQLdb::ExecuteUnique($dbh, $select_read);

    return $tmp_library, $tmp_read, $tmp_clone;

}

=for html <A NAME='insertData'>

=item insertData

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$library_record</B>():  [Default = <B>shift</B>]<BR>
- <B>$clone_record</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_library</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_read</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_clone</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#---------------------------
sub insertData{

      my $library_record=shift;
      my @library_record=@$library_record;
      my $clone_record=shift;
      my @clone_record=@$clone_record;
      my $tmp_library=shift;
      my @library_existence=@$tmp_library;
      my $tmp_read=shift;
      my @read_existence=@$tmp_read;
      my $tmp_clone=shift;
      my @clone_existence=@$tmp_clone;

      my ($library_id, $library_name);
     ($library_id, $library_name)=@library_existence;
     my $read_name=$read_existence[0];
     my ($clone_id, $clone_name);
     ($clone_id, $clone_name)=@clone_existence;

     $dbh->{RaiseError}=1;

     if (! defined $library_id){#LIBRARY DOESN'T EXIST IN DATABASE, INSERT DATA FOR THAT LIBRARY
           #LIBRARY TABLE
           my $uniquetable="Library";
           my @field=("Library_ID", "Library_Name", "Library_Insert_Size", "Library_Insert_StdDev");
           my @value=("", "$record{'library_id'}", "$record{'insert_size'}", "$record{'insert_stddev'}");

           SQLdb::InsertRecord($dbh, $uniquetable, \@field, \@value);

           $library_record[0]++;#increment the library record (essential to link accurate Library_ID to Trace when Inserting new record)
           $library_id=$library_record[0];
           $library_insert_ct++;
       }

       if (! defined $clone_id){#CLONE DOESN'T EXIST IN DATABASE, INSERT DATA FOR THAT CLONE
           
           my $uniquetable="Clone";
           my @field=("Clone_ID", "Clone_Name", "FK_Library__ID");
           my @value=("", "$record{'clone_id'}", "$library_id");

           SQLdb::InsertRecord($dbh, $uniquetable, \@field, \@value);

           $clone_record[0]++;#increment the library record (essential to link accurate Library_ID to Trace when Inserting new record)
           $clone_id=$clone_record[0];
           $clone_insert_ct++;
       }

        #READ TABLE
        #CONVERT QUALITY INTO BINARY AND INSERT IT
        my @quality=split (' ',$record{'trace_quality'});
        my $quality_blob=pack("C*", @quality);
        my @binary=($quality_blob);

        if (! defined $read_existence[0]){#INSERT

           my $uniquetable="Trace";
           my @field=("Trace_ID", "FK_Clone__ID", "Trace_Name", "Trace_Directory", "Trace_Direction", "Trace_Template", "Trace_Well", "Trace_Plate_Number", "Trace_Plate_Quadrant", "Trace_Type", "Trace_sequence", "Trace_quality", "Trace_Length", "Trace_Date_Sequenced", "Trace_Quality_Length", "Trace_Vector_Quality");
           my @value=("", "$clone_id", "$record{'trace_name'}", "$record{'trace_directory'}", "$record{'trace_end'}", "$record{'template_id'}", "$record{'well_id'}", "$record{'plate_number'}", "$record{'plate_quadrant'}", "$record{'type'}", "$record{'trace_sequence'}","?","$record{'trace_length'}", "$record{'run_date'}", "$record{'quality_length'}", "$record{'vector_quality'}");
           SQLdb::InsertRecord($dbh, $uniquetable, \@field, \@value, \@binary);
           $read_insert_ct++;

        }
        else{#UPDATE

           print "$read_name\t$record{'trace_name'} updated.\n";
           my $uniquetable="Trace";
           my @field=("FK_Clone__ID", "Trace_Name", "Trace_Directory", "Trace_Direction", "Trace_Well","Trace_Plate_Number", "Trace_Plate_Quadrant", "Trace_Type", "Trace_Sequence", "Trace_Quality", "Trace_Length","Trace_Date_Sequenced", "Trace_Quality_Length", "Trace_Vector_Quality");
           my @value=("$clone_id", "$record{'trace_name'}", "$record{'trace_directory'}", "$record{'trace_end'}", "$record{'well_id'}", "$record{'plate_number'}", "$record{'plate_quadrant'}", "$record{'type'}", "$record{'trace_sequence'}", "?", "$record{'trace_length'}","$record{'run_date'}", "$record{'quality_length'}", "$record{'vector_quality'}");
           my @condition=("Trace_Name like '%$record{'trace_name'}%'");#don't want to use the table id here, because if name change, the whole process of analysis changes.
           SQLdb::UpdateRecord($dbh, $uniquetable, \@field, \@value, \@condition, \@binary);
           $read_update_ct++;
        }

        return \@library_record, \@clone_record;  #keep update of library # for new insertions

}#end sub

=for html <A NAME='StartTag'>

=item StartTag

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$p</B>(): the $expat  [Default = <B>shift</B>]<BR>
- <B>$el</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#---------------------------
sub StartTag{

  my $p  = shift; #the $expat
  my $el=shift;
   
  $tag=$el;

}#end sub

=for html <A NAME='Text'>

=item Text

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
- None<BR>
<BR>

=cut

#---------------------------
sub Text{

  $data=$_; 

}#end sub

=for html <A NAME='EndTag'>

=item EndTag

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$p</B>():  [Default = <B>shift</B>]<BR>
- <B>$el</B>():  [Default = <B>shift</B>]<BR>
<FONT color=red>## parameters are also passed on to <A Href=#checkExistence>checkExistence</A> ##</Font><BR>
</Font><BR>

=cut

#---------------------------
sub EndTag{

  my $p=shift;
  my $el=shift;

  $endtag=$el;

  if ($tag eq $endtag){#ALL THE DATA BETWEEN RFC TRACE ARCHIVE XML

     if (! defined $data){#if no data between tag, just put a null value
        $record{$endtag}='';
     }
     else{
        $record{$endtag}="$data";  #for all the data (non-markup separated by start/end tags)
     } 

  }
  if ($endtag =~ /trace$/i){    #need to specify which tag specify a record (trace IS in this case)
      my ($tmp_library, $tmp_read, $tmp_clone);
      ($tmp_library, $tmp_read, $tmp_clone)=checkExistence(\%record);
      ($library_record, $clone_record)=insertData($library_record, $clone_record, $tmp_library, $tmp_read, $tmp_clone);
      %record=();
  }

}#end sub

=back

=cut

##############################
# private_methods            #
##############################
##############################
# private_functions          #
##############################
##############################
# main_footer                #
##############################
##############################
# perldoc_footer             #
##############################

=head1 KNOWN ISSUES <UPLINK>

<<KNOWN ISSUES>>

=head1 FUTURE IMPROVEMENTS <UPLINK>

<<FUTURE IMPROVEMENTS>>

=head1 AUTHORS <UPLINK>

<<AUTHORS>>

=head1 CREATED <UPLINK>

2004-08-18

=head1 REVISION <UPLINK>

=cut

