#Encrypts and encodes any kind of data.  Used with sam.pl to pass user information as parameters
#Rene Warren
#November 2003
package Cipher;

##############################
# perldoc_header             #
##############################

=head1 NAME <UPLINK>

Cipher.pm - Encrypts and encodes any kind of data.  Used with sam.pl to pass user information as parameters

=head1 SYNOPSIS <UPLINK>

	<<SYNOPSIS>>

=head1 DESCRIPTION <UPLINK>

=for html
Encrypts and encodes any kind of data.  Used with sam.pl to pass user information as parameters<BR>Rene Warren<BR>November 2003<BR>

=cut

##############################
# superclasses               #
##############################

=head2 SUPERCLASSES <UPLINK>

=over

=back

=cut

##############################
# system_variables           #
##############################
##############################
# standard_modules_ref       #
##############################

=head2 STANDARD MODULES REFERENCE <UPLINK>

=over

=item strict

=item Storable qw(freeze thaw)

=item Crypt::CBC

=item MIME::Base64

=item Compress::LZV1

=item Data::Dumper

=item URI::Escape;1

=back

=cut

use strict;
use Storable qw(freeze thaw);
use Crypt::CBC;
use MIME::Base64;
use Compress::LZV1;
use Data::Dumper;
use URI::Escape;1;

##############################
# custom_modules_ref         #
##############################

=head2 CUSTOM MODULES REFERENCE <UPLINK>

=over

=back

=cut

##############################
# global_vars                #
##############################

=head2 GLOBAL VARIABLES <UPLINK>

=over

=back

=cut

##############################
# modular_vars               #
##############################
##############################
# constants                  #
##############################
##############################
# main_header                #
##############################
##############################
# constructor                #
##############################
##############################
# public_methods             #
##############################
##############################
# public_functions           #
##############################

=head2 PUBLIC FUNCTIONS <UPLINK>

=for html <font size='-1'><strong><A href='#wrapData'>wrapData; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#unwrapData'>unwrapData; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#encodeData'>encodeData; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#decodeData'>decodeData; </A></strong></font><BR>

=over

=for html <A NAME='wrapData'>

=item wrapData

=for html
Will encode the data and escape the string (best suited to pass as an argument thru web pages)<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$hash_ref</B>():  [Default = <B>shift</B>]<BR>
- <B>$key</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#----------------------------------
sub wrapData{

   #Will encode the data and escape the string (best suited to pass as an argument thru web pages)
   my $hash_ref=shift;
   my $key=shift;

   my $compress=1;

   my $unesc_data_ecz=&encodeData($hash_ref, $compress, $key);
   my $data_ecz=uri_escape($unesc_data_ecz, "^A-Za-z");#string must be escaped
   
   return $data_ecz;

}

=for html <A NAME='unwrapData'>

=item unwrapData

=for html
Will restore the escape and decode the string back to the original reference<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmpdata_ecz</B>():  [Default = <B>shift</B>]<BR>
- <B>$key</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub unwrapData{

   #Will restore the escape and decode the string back to the original reference
   my $tmpdata_ecz=shift;
   my $key=shift;
 
   my $compress=1;

   my $data_ecz=uri_unescape($tmpdata_ecz, "^A-Za-z");           #unescape data allcharacters other than letters
   my $hash_ref=&decodeData($data_ecz, $compress, $key);       #thaw, decompress, decode

   return $hash_ref;
}

=for html <A NAME='encodeData'>

=item encodeData

=for html
heart of the encryption: freeze, compress, encrypt & encode)<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$data</B>():  [Default = <B>shift</B>]<BR>
- <B>$compress</B>():  [Default = <B>shift</B>]<BR>
- <B>$key</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------
sub encodeData{

   #heart of the encryption: freeze, compress, encrypt & encode)
   my $data=shift;
   my $compress=shift;
   my $key=shift;

   if(! $data) {
        return undef;
   }

   my $data_pipeline = $data;

   eval {

   ### Freeze

   $data_pipeline = freeze($data_pipeline);

   ### Compress (if requested)

   if($compress) {
        $data_pipeline = compress($data_pipeline);
   }

   ### Encrypt (if requested)

   if($key) {
        my $cipher = Crypt::CBC->new({key=>$key,cipher=>'Blowfish'});
        $data_pipeline = $cipher->encrypt($data_pipeline);
   }

   ### Encode

   $data_pipeline = encode_base64($data_pipeline,"");

   };

   if($@) {
       # error!
       return undef;
   } else {
       return $data_pipeline;
   }
}

=for html <A NAME='decodeData'>

=item decodeData

=for html
heart of the decryption: Decode, decrypt, decompress and thaw<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$data</B>():  [Default = <B>shift</B>]<BR>
- <B>$compress</B>():  [Default = <B>shift</B>]<BR>
- <B>$key</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------
sub decodeData{

   #heart of the decryption: Decode, decrypt, decompress and thaw
   my $data=shift;
   my $compress=shift; 
   my $key=shift;

   if(! $data) {
        return undef;
   }

   my $data_pipeline = $data;

   eval {

   ### Decode

   $data_pipeline = decode_base64($data_pipeline);

   ### Decrypt (if requested)
   #my $cipher_name="Blowfish";

   if($key){
        my $cipher = Crypt::CBC->new({key=>$key,cipher=>'Blowfish'});
        $data_pipeline = $cipher->decrypt($data_pipeline);
   }

   ### Decompress (if requested)

   if($compress) {
        $data_pipeline = decompress($data_pipeline);
   }

   ### Thaw

   $data_pipeline = thaw($data_pipeline);

   };

   if($@) {
           return undef;
   } else {
           return $data_pipeline;
   }

}

=back

=cut

##############################
# private_methods            #
##############################
##############################
# private_functions          #
##############################
##############################
# main_footer                #
##############################
##############################
# perldoc_footer             #
##############################

=head1 KNOWN ISSUES <UPLINK>

<<KNOWN ISSUES>>

=head1 FUTURE IMPROVEMENTS <UPLINK>

<<FUTURE IMPROVEMENTS>>

=head1 AUTHORS <UPLINK>

<<AUTHORS>>

=head1 CREATED <UPLINK>

2004-08-18

=head1 REVISION <UPLINK>


=cut


return 1;
