#CreateAssemblyXML.pm module
#Creates a data structure in a format compatible with  XML::Simple. 
#Rene Warren
#January 2003
package CreateAssemblyXML;

##############################
# perldoc_header             #
##############################

=head1 NAME <UPLINK>

CreateAssemblyXML.pm - CreateAssemblyXML.pm module

=head1 SYNOPSIS <UPLINK>

	<<SYNOPSIS>>

=head1 DESCRIPTION <UPLINK>

=for html
CreateAssemblyXML.pm module<BR>Creates a data structure in a format compatible with  XML::Simple. <BR>Rene Warren<BR>January 2003<BR>

=cut

##############################
# superclasses               #
##############################

=head2 SUPERCLASSES <UPLINK>

=over

=back

=cut

##############################
# system_variables           #
##############################
##############################
# standard_modules_ref       #
##############################

=head2 STANDARD MODULES REFERENCE <UPLINK>

=over

=item strict

=item Data::Dumper

=item XML::Simple

=back

=cut

use strict;
use Data::Dumper;
use XML::Simple;

##############################
# custom_modules_ref         #
##############################

=head2 CUSTOM MODULES REFERENCE <UPLINK>

=over

=back

=cut

##############################
# global_vars                #
##############################

=head2 GLOBAL VARIABLES <UPLINK>

=over

=back

=cut

##############################
# modular_vars               #
##############################
##############################
# constants                  #
##############################
##############################
# main_header                #
##############################
#--------------------------------------------
1;

##############################
# constructor                #
##############################
##############################
# public_methods             #
##############################
##############################
# public_functions           #
##############################

=head2 PUBLIC FUNCTIONS <UPLINK>

=for html <font size='-1'><strong><A href='#assemblySummary'>assemblySummary; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#startRecord'>startRecord; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#endRecord'>endRecord; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#writeRecord'>writeRecord; </A></strong></font><BR>

=over

=for html <A NAME='assemblySummary'>

=item assemblySummary

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$date</B>():  [Default = <B>shift</B>]<BR>
- <B>$stats</B>():  [Default = <B>shift</B>]<BR>
- <B>$data_config</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#--------------------------------------------
sub assemblySummary{

   my $date=shift;
   my $stats=shift;
   my %stats=%$stats;
   my $data_config=shift;
   my @data_config=@$data_config;

   my %summary_xml;
   
   ####Calculations
   my $avgErrorRate = ($stats{'error_rate'}/$stats{'contigs'}) if ($stats{'contigs'} != 0);
   $avgErrorRate = sprintf "%0.2f", $avgErrorRate;

   my $perca=($stats{'all_a'}/$stats{'totalbp'})*100 if ($stats{'totalbp'} !=0);
   $perca = sprintf "%0.2f", $perca;

   my $perct=($stats{'all_t'}/$stats{'totalbp'})*100 if ($stats{'totalbp'} !=0);
   $perct = sprintf "%0.2f", $perct;

   my $percc=($stats{'all_c'}/$stats{'totalbp'})*100 if ($stats{'totalbp'} !=0);
   $percc = sprintf "%0.2f", $percc;

   my $percg=($stats{'all_g'}/$stats{'totalbp'})*100 if ($stats{'totalbp'} !=0);
   $percg = sprintf "%0.2f", $percg;

   ####Open file for writing
   open (IN, ">$data_config[0]/$data_config[1]/$data_config[2]/$data_config[4]") or die "can't open $data_config[0]/$data_config[1]/$data_config[2]/$data_config[4]\n";

   print IN "<?xml version=\"1.0\"?>\n";
   print IN "\t<assembly_volume>\n";
   print IN "\t\t<volume_name>Assembly Data Archive $data_config[0]</volume_name>\n";
   print IN "\t\t<volume_date>$date</volume_date>\n";
   print IN "\t\t<volume_version>$data_config[2]</volume_version>\n";
 
   print IN "\t\t<assembly_summary>\n";
   print IN "\t\t\t<read_assembled>$stats{'assembled_reads'}</read_assembled>\n";
   print IN "\t\t\t<read_analyzed>$stats{'read_analyzed'}</read_analyzed>\n";
   print IN "\t\t\t<contig_number>$stats{'contigs'}</contig_number>\n";
   print IN "\t\t\t<supertig_number>$stats{'supertig'}</supertig_number>\n";
   print IN "\t\t\t<supertig_size>$stats{'supertig_size'}</supertig_size>\n";

   print IN "\t\t\t<badquality_read>$stats{'bad_quality'}</badquality_read>\n";
   print IN "\t\t\t<singleton_read>$stats{'read_singleton'}</singleton_read>\n";
   print IN "\t\t\t<masked_read>$stats{'masked_read'}</masked_read>\n";

   print IN "\t\t\t<genome_coverage>$stats{'genome_coverage'}</genome_coverage>\n";
   print IN "\t\t\t<genome_coverage2>$stats{'genome_coverage2'}</genome_coverage2>\n";###using analyzed reads
   print IN "\t\t\t<contig_coverage>$stats{'contig_coverage'}</contig_coverage>\n";
   print IN "\t\t\t<poisson_genome>$stats{'poisson_genome_size'}</poisson_genome>\n";
   print IN "\t\t\t<poisson_coverage>$stats{'poisson_genome_coverage'}</poisson_coverage>\n";
   print IN "\t\t\t<poisson_coverage2>$stats{'poisson_genome_coverage2'}</poisson_coverage2>\n";###using analyzed reads
   print IN "\t\t\t<poisson_contig>$stats{'poisson_contig'}</poisson_contig>\n";

   print IN "\t\t\t<average_error>$avgErrorRate</average_error>\n";
   print IN "\t\t\t<biggest_contig>$stats{'biggest_tig'}</biggest_contig>\n";
   print IN "\t\t\t<smallest_contig>$stats{'smallest_tig'}</smallest_contig>\n";
   print IN "\t\t\t<mean_tigsize>$stats{'mean_tig'}</mean_tigsize>\n";
   print IN "\t\t\t<mean_supersize>$stats{'mean_supertig'}</mean_supersize>\n";
   print IN "\t\t\t<percent_a>$perca</percent_a>\n";
   print IN "\t\t\t<percent_t>$perct</percent_t>\n";
   print IN "\t\t\t<percent_c>$percc</percent_c>\n";
   print IN "\t\t\t<percent_g>$percg</percent_g>\n";
   print IN "\t\t\t<N50_length>$stats{'N50_length'}</N50_length>\n";
   print IN "\t\t\t<total_bp>$stats{'totalbp'}</total_bp>\n";
   print IN "\t\t\t<consensus>$stats{'consensus'}</consensus>\n";
   print IN "\t\t\t<above1kcontig_size>$stats{'tigsize'}</above1kcontig_size>\n";
  #print IN "\t\t\t<phred20>$stats{'phred20'}</phred20>\n";
   print IN "\t\t\t<phred30>$stats{'phred30'}</phred30>\n";
   print IN "\t\t\t<phred40>$stats{'phred40'}</phred40>\n";
  #print IN "\t\t\t<conditional_tigsize>$stats{'tigsize'}</conditional_tigsize>\n";
   print IN "\t\t\t<contig_singleton>$stats{'1'}</contig_singleton>\n";
   print IN "\t\t\t<two_read>$stats{'2'}</two_read>\n";
   print IN "\t\t\t<three_read>$stats{'3'}</three_read>\n";
   print IN "\t\t\t<four_read>$stats{'4'}</four_read>\n";
   print IN "\t\t\t<five_read>$stats{'5'}</five_read>\n";
   print IN "\t\t\t<six_read>$stats{'6+'}</six_read>\n";
   print IN "\t\t\t<ten_read>$stats{'10+'}</ten_read>\n";
   print IN "\t\t\t<twenty_read>$stats{'20+'}</twenty_read>\n";

   print IN "\t\t</assembly_summary>\n";
   print IN "\t</assembly_volume>\n";

   close IN;

}

=for html <A NAME='startRecord'>

=item startRecord

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$date</B>():  [Default = <B>shift</B>]<BR>
- <B>$data_config</B>():  [Default = <B>shift</B>]<BR>
- <B>$file</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#--------------------------------------------
sub startRecord{

   my $date=shift;
   my $data_config=shift;
   my @data_config=@$data_config;
   my $file=shift;

   open (IN, ">$data_config[0]/$data_config[1]/$data_config[2]/$file") or die "can't open $data_config[0]/$data_config[1]/$data_config[2]/$file\n";

   print IN "<?xml version=\"1.0\"?>\n";
   print IN "\t<assembly_volume>\n";
   print IN "\t\t<volume_name>Assembly Data Archive $data_config[0]</volume_name>\n";
   print IN "\t\t<volume_date>$date</volume_date>\n";
   print IN "\t\t<volume_version>$data_config[2]</volume_version>\n";

   close IN;
}

=for html <A NAME='endRecord'>

=item endRecord

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$data_config</B>():  [Default = <B>shift</B>]<BR>
- <B>$file</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#--------------------------------------------
sub endRecord{

   my $data_config=shift;
   my @data_config=@$data_config;
   my $file=shift;

   open (IN, ">>$data_config[0]/$data_config[1]/$data_config[2]/$file") or die "can't open $data_config[0]/$data_config[1]/$data_config[2]/$file\n";

   print IN "\t</assembly_volume>\n";
  
   close IN;
}

=for html <A NAME='writeRecord'>

=item writeRecord

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$contig</B>():  [Default = <B>shift</B>]<BR>
- <B>$data_config</B>():  [Default = <B>shift</B>]<BR>
- <B>$read_per_tig</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#--------------------------------------------
sub writeRecord{

   my $contig=shift;
   my %contig=%$contig;
   my $data_config=shift;
   my @data_config=@$data_config;
   my $read_per_tig=shift;
   my %read_per_tig=%$read_per_tig;

   my $perca = sprintf "%0.2f", $contig{'perca'};
   my $perct = sprintf "%0.2f", $contig{'perct'};
   my $percc = sprintf "%0.2f", $contig{'percc'};
   my $percg = sprintf "%0.2f", $contig{'percg'};
   my $percgc = sprintf "%0.2f", $contig{'percgc'};

   open (IN, ">>$data_config[0]/$data_config[1]/$data_config[2]/$data_config[3]") or die "can't open $data_config[0]/$data_config[1]/$data_config[2]/$data_config[3]\n";

   print IN "\t\t<contig number=\"$contig{'number'}\">\n";
   print IN "\t\t\t<contig_number>$contig{'number'}</contig_number>\n";
   print IN "\t\t\t<contig_size>$contig{'size'}</contig_size>\n";
   print IN "\t\t\t<contig_consensus>$contig{'consensus'}</contig_consensus>\n";
   print IN "\t\t\t<contig_error>$contig{'error_rate'}</contig_error>\n";
   print IN "\t\t\t<contig_phred20>$contig{'phred20'}</contig_phred20>\n";
   print IN "\t\t\t<contig_phred30>$contig{'phred30'}</contig_phred30>\n";
   print IN "\t\t\t<contig_phred40>$contig{'phred40'}</contig_phred40>\n";
   #print IN "\t\t\t<contig_sequence>$contig{'sequence'}</contig_sequence>\n";
   #print IN "\t\t\t<contig_quality>$contig{'qual'}</contig_quality>\n";
   print IN "\t\t\t<contig_compa>$perca</contig_compa>\n";
   print IN "\t\t\t<contig_compt>$perct</contig_compt>\n";
   print IN "\t\t\t<contig_compc>$percc</contig_compc>\n";
   print IN "\t\t\t<contig_compg>$percg</contig_compg>\n";
   print IN "\t\t\t<contig_percgc>$percgc</contig_percgc>\n";
   print IN "\t\t\t<supertig_number>$contig{'supertig_number'}</supertig_number>\n";
   print IN "\t\t\t<contig_order>$contig{'contig_order'}</contig_order>\n";
   print IN "\t\t\t<contig_preceding_gap>$contig{'contig_gap'}</contig_preceding_gap>\n";
   print IN "\t\t\t<supertig_size>$contig{'supertig_size'}</supertig_size>\n";

   #my $read=$contig{'read_name'};
   #my @read=@$read;

   my $read_set=$read_per_tig{$contig{'number'}};
   my %read_set=%$read_set;

   foreach my $read_name(sort keys %read_set){
       my $start=$read_set{$read_name}{'start'};
       my $stop=$read_set{$read_name}{'stop'};
       my $direction=$read_set{$read_name}{'direction'};
       print IN "\t\t\t<read_name start=\"$start\" stop=\"$stop\" direction=\"$direction\">$read_name</read_name>\n";
   }
   print IN "\t\t</contig>\n";

   close IN;
}

=back

=cut

##############################
# private_methods            #
##############################
##############################
# private_functions          #
##############################
##############################
# main_footer                #
##############################
##############################
# perldoc_footer             #
##############################

=head1 KNOWN ISSUES <UPLINK>

<<KNOWN ISSUES>>

=head1 FUTURE IMPROVEMENTS <UPLINK>

<<FUTURE IMPROVEMENTS>>

=head1 AUTHORS <UPLINK>

<<AUTHORS>>

=head1 CREATED <UPLINK>

2004-08-18

=head1 REVISION <UPLINK>


=cut


return 1;
