#Orf2Database.pm -Populates SAMdb with ORFs and their putative function.
#Rene Warren
#January 2003
package Orf2Database;

##############################
# perldoc_header             #
##############################

=head1 NAME <UPLINK>

Orf2Database.pm - Orf2Database.pm -Populates SAMdb with ORFs and their putative function.

=head1 SYNOPSIS <UPLINK>

	<<SYNOPSIS>>

=head1 DESCRIPTION <UPLINK>

=for html
Orf2Database.pm -Populates SAMdb with ORFs and their putative function.<BR>Rene Warren<BR>January 2003<BR>

=cut

##############################
# superclasses               #
##############################

=head2 SUPERCLASSES <UPLINK>

=over

=back

=cut

##############################
# system_variables           #
##############################
##############################
# standard_modules_ref       #
##############################

=head2 STANDARD MODULES REFERENCE <UPLINK>

=over

=item strict

=item FindBin

=item lib "$FindBin::Bin/"

=item SQLdb;1

=back

=cut

use strict;
use FindBin;
use lib "$FindBin::Bin/";
use SQLdb;1;

##############################
# custom_modules_ref         #
##############################

=head2 CUSTOM MODULES REFERENCE <UPLINK>

=over

=back

=cut

##############################
# global_vars                #
##############################

=head2 GLOBAL VARIABLES <UPLINK>

=over

=back

=cut

##############################
# modular_vars               #
##############################
##############################
# constants                  #
##############################
##############################
# main_header                #
##############################
##############################
# constructor                #
##############################
##############################
# public_methods             #
##############################
##############################
# public_functions           #
##############################

=head2 PUBLIC FUNCTIONS <UPLINK>

=for html <font size='-1'><strong><A href='#updateOrf'>updateOrf; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getGeneFinderConfiguration'>getGeneFinderConfiguration; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#retrieveExistingOrf'>retrieveExistingOrf; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getContigID'>getContigID; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#updateOrfTable'>updateOrfTable; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#checkContextExistence'>checkContextExistence; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#checkOriginExistence'>checkOriginExistence; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#addRecordContext'>addRecordContext; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#addRecordOrigin'>addRecordOrigin; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#addRecordOrf'>addRecordOrf; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#addBlastRecord'>addBlastRecord; </A></strong></font><BR>

=over

=for html <A NAME='updateOrf'>

=item updateOrf

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$quality_orf</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
## <Font color=blue>####Get Contig</Font><BR>
</Font><BR>

=cut

#--------------------------------
sub updateOrf{

   my $user_info=shift;
   my $assembly_id=shift;
   my $quality_orf=shift;
   my $gene_finder_id=shift;

   ####Get Contig
   my $existing_tig=&getContigID($user_info, $assembly_id);
   ####Put Orf in Mo
   my $existing_orf=&retrieveExistingOrf($user_info);
   ####Update Orf and Orf_Origin
   my $tmp_new_orf=&updateOrfTable($user_info, $quality_orf, $existing_orf, $existing_tig, $gene_finder_id);

   return $tmp_new_orf;
}

=for html <A NAME='getGeneFinderConfiguration'>

=item getGeneFinderConfiguration

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#--------------------------------
sub getGeneFinderConfiguration{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $gene_finder_id=shift;

   my %gene_finder_config;

   ####Connecting to Database
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'database'}, $user_info{'host_name'});

   ####Get all existing orf
   my @gf_field=("Gene_Finder_Dir", "Gene_Finder_LowQual_Threshold", "Gene_Finder_MaxPhred_Threshold", "Gene_Finder_Genome_Topology", "Gene_Finder_Smallest_Gene", "Gene_Finder_Wrapper", "Gene_Finder_Wrapper_Dir", "Gene_Finder_CDS_File", "Gene_Finder_Protein_File", "Gene_Finder_EveryGene_File", "Gene_Finder_Overlap_Percent", "Gene_Finder_Train_FullPath");
   my @gf_table=("Gene_Finder");
   my @gf_condition=("Gene_Finder_ID=$gene_finder_id");
   my $select_gf=SQLdb::GetRecord(\@gf_field, \@gf_table, \@gf_condition);
   my $gf_reference=SQLdb::ExecuteUnique($dbh, $select_gf);

   SQLdb::Disconnect($dbh);

   my @gene_finder_array=@$gf_reference;

   $gene_finder_config{'directory'}=$gene_finder_array[0];
   $gene_finder_config{'lowqual'}=$gene_finder_array[1];
   $gene_finder_config{'maxphred'}=$gene_finder_array[2];
   $gene_finder_config{'topology'}=$gene_finder_array[3];
   $gene_finder_config{'smallest_gene'}=$gene_finder_array[4];
   $gene_finder_config{'wrapper'}=$gene_finder_array[5];
   $gene_finder_config{'wrapper_dir'}=$gene_finder_array[6];
   $gene_finder_config{'cds_file'}=$gene_finder_array[7];
   $gene_finder_config{'protein_file'}=$gene_finder_array[8];
   $gene_finder_config{'everygene_file'}=$gene_finder_array[9];
   $gene_finder_config{'overlap'}=$gene_finder_array[10];
   $gene_finder_config{'training_set'}=$gene_finder_array[11];

   return \%gene_finder_config;
}

=for html <A NAME='retrieveExistingOrf'>

=item retrieveExistingOrf

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#--------------------------------
sub retrieveExistingOrf{

   my $user_info=shift;
   my %user_info=%$user_info;

   my %existing_orf;

   ####Connecting to Database
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'database'}, $user_info{'host_name'});

   ####Get all existing orf
   my @orf_field=("Orf_ID", "Orf_CDS_Sequence");
   my @orf_table=("Orf");
   my @orf_condition=();
   my $select_orf=SQLdb::GetRecord(\@orf_field, \@orf_table, \@orf_condition);
   my $orf_reference=SQLdb::ExecuteMany($dbh, $select_orf);

   SQLdb::Disconnect($dbh);

   my @orf_ref=@$orf_reference;

   foreach my $reference (@orf_ref){
      my @orf_arr=@$reference;
      $existing_orf{$orf_arr[1]}=$orf_arr[0];
   }

   return \%existing_orf;
}

=for html <A NAME='getContigID'>

=item getContigID

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#--------------------------------
sub getContigID{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;

   my %existing_tig;   

   ####Connecting to Database
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'database'}, $user_info{'host_name'});

   ####Get all contig id and number for a specific assembly
   my @tig_field=("Contig_ID", "Contig_Number");
   my @tig_table=("Contig", "Assembly");
   my @tig_condition=("Assembly_ID=FK_Assembly__ID", "Assembly_ID=$assembly_id");
   my $select_tig=SQLdb::GetRecord(\@tig_field, \@tig_table, \@tig_condition);
   my $tig_reference=SQLdb::ExecuteMany($dbh, $select_tig);
   
   SQLdb::Disconnect($dbh);

   my @tig_ref=@$tig_reference;

   foreach my $reference (@tig_ref){
      my @tig_arr=@$reference;
      $existing_tig{$tig_arr[1]}=$tig_arr[0];
   }

   return \%existing_tig;
}

=for html <A NAME='updateOrfTable'>

=item updateOrfTable

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$quality_orf</B>():  [Default = <B>shift</B>]<BR>
- <B>$existing_orf</B>():  [Default = <B>shift</B>]<BR>
- <B>$existing_tig</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#--------------------------------
sub updateOrfTable{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $quality_orf=shift;
   my %quality_orf=%$quality_orf;
   my $existing_orf=shift;
   my %existing_orf=%$existing_orf;
   my $existing_tig=shift;
   my %existing_tig=%$existing_tig; 
   my $gene_finder_id=shift; 

   my %new_orf;

   ####Connecting to Database
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'database'}, $user_info{'host_name'});

   ####Get The current Orf table ID
   my @orf_field=("max(Orf_ID)");
   my @orf_table=("Orf");
   my @orf_condition=();
   my $select_orf=SQLdb::GetRecord(\@orf_field, \@orf_table, \@orf_condition);
   my $orf_reference=SQLdb::ExecuteUnique($dbh, $select_orf);

   my @orf_reference=@$orf_reference;
   my $orf_id=$orf_reference[0];

   ####Get Initial Orf_Context ID
   my @context_field=("max(Orf_Context_ID)");
   my @context_table=("Orf_Context");
   my @context_condition=();
   my $select_context=SQLdb::GetRecord(\@context_field, \@context_table, \@context_condition);
   my $context_reference=SQLdb::ExecuteUnique($dbh, $select_context);

   my @context_reference=@$context_reference;
   my $context_id=$context_reference[0];

   my ($ct, $ex, $new)=(0,0,0);
   ####Cycle through New Orfs
   foreach my $tig (keys %quality_orf){
      my $tmp_orf=$quality_orf{$tig};
      my %orf_list=%$tmp_orf;
      my $contig_id=$existing_tig{$tig};#get the id
      $ct++;
      print "$ct- (quality ORFs) **$tig**\n";
      foreach my $orf_cds (keys %orf_list){
         my $tmp_spec=$orf_list{$orf_cds};
         ####cds exist
         if (defined $existing_orf{$orf_cds}){
            $ex++;
            print "exists $ex\n";
            my $existing_id=$existing_orf{$orf_cds};
            my $current_context_id=&checkContextExistence($existing_id, $gene_finder_id, $dbh);

            if (! $current_context_id){
               $context_id=&addRecordContext($context_id, $existing_id, $gene_finder_id, $dbh);#keep track of context_id
               $current_context_id=$context_id;
            }         
            my $tmp_origin_id=&checkOriginExistence($contig_id, $current_context_id, $dbh); 
            &addRecordOrigin($current_context_id, $tmp_spec, $contig_id, $dbh) if (! $tmp_origin_id); ####only store record if data doesn't exist
         }else{####orf doesn't exist
            $new++;
            print "new $new\n";
            $orf_id=&addRecordOrf($orf_id, $tmp_spec, $orf_cds, $dbh);
            $context_id=&addRecordContext($context_id, $orf_id, $gene_finder_id, $dbh);    
            &addRecordOrigin($context_id, $tmp_spec, $contig_id, $dbh);  ####no need to check existence...new orf
            $new_orf{$orf_id}=$orf_list{$orf_cds}{'protein'};            ####keep orf in memory for blasting
         }
      }
   }

   SQLdb::Disconnect($dbh);

   return \%new_orf;
}

=for html <A NAME='checkContextExistence'>

=item checkContextExistence

=for html
Orf_Context is a transition table allowing a M-M realationship between Orf and Gene_Finder Table<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$existing_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$dbh</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#--------------------------------
#Orf_Context is a transition table allowing a M-M realationship between Orf and Gene_Finder Table
sub checkContextExistence{

   my $existing_id=shift;
   my $gene_finder_id=shift;
   my $dbh=shift;

   my @field=("Orf_Context_ID");
   my @table=("Orf_Context");
   my @condition=("FK_Orf__ID=$existing_id", "FK_Gene_Finder__ID=$gene_finder_id");
   my $select=SQLdb::GetRecord(\@field, \@table, \@condition);
   my $tmp_reference=SQLdb::ExecuteUnique($dbh, $select);
   my @reference=@$tmp_reference;

   return $reference[0];#return the id if it exists
}

=for html <A NAME='checkOriginExistence'>

=item checkOriginExistence

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$contig_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$context_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$dbh</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#--------------------------------
sub checkOriginExistence{

   my $contig_id=shift;
   my $context_id=shift;
   my $dbh=shift;

   my @field=("Orf_Origin_ID");
   my @table=("Orf_Origin");
   my @condition=("FK_Orf_Context__ID=$context_id", "FK_Contig__ID=$contig_id");
   my $select=SQLdb::GetRecord(\@field, \@table, \@condition);
   my $tmp_reference=SQLdb::ExecuteUnique($dbh, $select);
   my @reference=@$tmp_reference;

   return $reference[0];#return the id if it exists
}

=for html <A NAME='addRecordContext'>

=item addRecordContext

=for html
Orf_Context is a transition table allowing a M-M realationship between Orf and Gene_Finder Table<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$context_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$orf_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$dbh</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#--------------------------------
#Orf_Context is a transition table allowing a M-M realationship between Orf and Gene_Finder Table
sub addRecordContext{
 
   my $context_id=shift;
   my $orf_id=shift;
   my $gene_finder_id=shift;
   my $dbh=shift;

   $context_id++;

   my $uniquetable="Orf_Context";
   my @field=("Orf_Context_ID", "FK_Orf__ID", "FK_Gene_Finder__ID");
   my @value=("$context_id", "$orf_id","$gene_finder_id");
   SQLdb::InsertRecord($dbh, $uniquetable, \@field, \@value);

   return $context_id;
}

=for html <A NAME='addRecordOrigin'>

=item addRecordOrigin

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$context_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_spec</B>():  [Default = <B>shift</B>]<BR>
- <B>$contig_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$dbh</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#--------------------------------
sub addRecordOrigin{

   my $context_id=shift;
   my $tmp_spec=shift;
   my %orf_info=%$tmp_spec;
   my $contig_id=shift;
   my $dbh=shift;

   my $uniquetable="Orf_Origin";
   my @field=("Orf_Origin_ID", "FK_Contig__ID", "FK_Orf_Context__ID", "Orf_Origin_Strand", "Orf_Origin_Start", "Orf_Origin_Stop");
   my @value=("", "$contig_id", "$context_id","$orf_info{'strand'}","$orf_info{'start'}", "$orf_info{'stop'}"); 
   SQLdb::InsertRecord($dbh, $uniquetable, \@field, \@value);

   #will need to modify here if don't want to overwrite more record origin

}

=for html <A NAME='addRecordOrf'>

=item addRecordOrf

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$orf_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_spec</B>():  [Default = <B>shift</B>]<BR>
- <B>$orf_cds</B>():  [Default = <B>shift</B>]<BR>
- <B>$dbh</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#--------------------------------
sub addRecordOrf{

   my $orf_id=shift;
   my $tmp_spec=shift;
   my %orf_info=%$tmp_spec;
   my $orf_cds=shift;
   my $dbh=shift;

   ####Update some values
   my $cds_length=length($orf_cds);
   my $protein_length=length($orf_info{'protein'});
   $orf_id++;
   ####

   my $uniquetable="Orf";
   my @field=("Orf_ID", "Orf_CDS_Sequence", "Orf_CDS_Length", "Orf_Protein_Sequence", "Orf_Protein_Length", "Orf_Initiation_Codon", "Orf_PercentA", "Orf_PercentT","Orf_PercentC","Orf_PercentG", "Orf_PercentGC", "Orf_Position_A1", "Orf_Position_A2", "Orf_Position_A3", "Orf_Position_T1", "Orf_Position_T2", "Orf_Position_T3", "Orf_Position_C1", "Orf_Position_C2", "Orf_Position_C3", "Orf_Position_G1", "Orf_Position_G2", "Orf_Position_G3");
   my @value=("$orf_id", "$orf_cds", "$cds_length", "$orf_info{'protein'}", "$protein_length", "$orf_info{'initiation_codon'}", "$orf_info{'percent_a'}", "$orf_info{'percent_t'}", "$orf_info{'percent_c'}", "$orf_info{'percent_g'}", "$orf_info{'percent_gc'}", "$orf_info{'a1'}", "$orf_info{'a2'}", "$orf_info{'a3'}","$orf_info{'t1'}", "$orf_info{'t2'}", "$orf_info{'t3'}","$orf_info{'c1'}", "$orf_info{'c2'}", "$orf_info{'c3'}", "$orf_info{'g1'}", "$orf_info{'g2'}", "$orf_info{'g3'}");
   SQLdb::InsertRecord($dbh, $uniquetable, \@field, \@value);

   return $orf_id;
}

=for html <A NAME='addBlastRecord'>

=item addBlastRecord

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$orf_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$blast</B>():  [Default = <B>shift</B>]<BR>
- <B>$blast_config_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#--------------------------------
sub addBlastRecord{
  
   my $orf_id=shift; 
   my $user_info=shift;
   my %user_info=%$user_info;
   my $blast=shift;
   my %blast=%$blast;
   my $blast_config_id=shift;

   ####Connecting to Database
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'database'}, $user_info{'host_name'});

   my $uniquetable="Blast";
   my @field=("Blast_ID", "FK_Orf__ID", "FK_Blast_Config__ID", "Blast_Accession", "Blast_Protein_Name", "Blast_Organism", "Blast_Orf_Similarity", "Blast_Score", "Blast_EValue","Blast_Hit_Length", "Blast_Hit_Start", "Blast_Hit_Stop", "Blast_Query_Start", "Blast_Query_Stop", "Blast_Positive_Residues", "Blast_Query_Sequence", "Blast_Hit_Sequence", "Blast_Bits", "Blast_Match", "Blast_Hit_Protein_Length", "Blast_Hit_Similarity", "Blast_Hit_Identity");
   my @value=("", "$orf_id", "$blast_config_id","$blast{'accession'}", "$blast{'protein'}", "$blast{'organism'}", "$blast{'orf_similarity'}","$blast{'score'}","$blast{'evalue'}","$blast{'hit_length'}","$blast{'hit_start'}","$blast{'hit_stop'}","$blast{'query_start'}","$blast{'query_stop'}", "$blast{'positive'}", "$blast{'query_sequence'}", "$blast{'hit_sequence'}", "$blast{'bits'}", "$blast{'match'}", "$blast{'hit_protein_length'}", "$blast{'hit_similarity'}", "$blast{'hit_identity'}");
   SQLdb::InsertRecord($dbh, $uniquetable, \@field, \@value);
   
   SQLdb::Disconnect($dbh);

}

=back

=cut

##############################
# private_methods            #
##############################
##############################
# private_functions          #
##############################
##############################
# main_footer                #
##############################
##############################
# perldoc_footer             #
##############################

=head1 KNOWN ISSUES <UPLINK>

<<KNOWN ISSUES>>

=head1 FUTURE IMPROVEMENTS <UPLINK>

<<FUTURE IMPROVEMENTS>>

=head1 AUTHORS <UPLINK>

<<AUTHORS>>

=head1 CREATED <UPLINK>

2004-08-18

=head1 REVISION <UPLINK>


=cut


return 1;
