#wgsDATA - A module for data retrieval (from SAMdb) and processing
#wgsDATA is the ultimate link between SAMdb and users
#It is responsible for querying SAMdb, producing lists and process the data before it is displayed 
#Rene Warren April 2003
package wgsDATA;

##############################
# perldoc_header             #
##############################

=head1 NAME <UPLINK>

wgsDATA.pm - wgsDATA - A module for data retrieval (from SAMdb) and processing

=head1 SYNOPSIS <UPLINK>

	<<SYNOPSIS>>

=head1 DESCRIPTION <UPLINK>

=for html
wgsDATA - A module for data retrieval (from SAMdb) and processing<BR>wgsDATA is the ultimate link between SAMdb and users<BR>It is responsible for querying SAMdb, producing lists and process the data before it is displayed <BR>Rene Warren April 2003<BR>

=cut

##############################
# superclasses               #
##############################

=head2 SUPERCLASSES <UPLINK>

=over

=back

=cut

##############################
# system_variables           #
##############################
##############################
# standard_modules_ref       #
##############################

=head2 STANDARD MODULES REFERENCE <UPLINK>

=over

=item CGI qw/:all/

=item strict

=item SQLdb

=item Number::Format

=item Cache::FileCache

=item Date::Manip

=item GD::Graph::mixed

=item GD

=item Statistics::Descriptive

=item SequenceAnalysis

=item Data::Dumper

=back

=cut

use CGI qw/:all/;
use strict;
use SQLdb;
use Number::Format;
use Cache::FileCache;
use Date::Manip;
use GD::Graph::mixed;
use GD;
use Statistics::Descriptive;
use SequenceAnalysis;
use Data::Dumper;

##############################
# custom_modules_ref         #
##############################

=head2 CUSTOM MODULES REFERENCE <UPLINK>

=over

=back

=cut

##############################
# global_vars                #
##############################

=head2 GLOBAL VARIABLES <UPLINK>

=over

=back

=cut

##############################
# modular_vars               #
##############################
##############################
# constants                  #
##############################
##############################
# main_header                #
##############################
####Making the cache
my %cache_options = (namespace=>"wgs",
                     cache_root=>"/home/tmp/rwarren",
                     default_expires_in=>1000);
my $cache = new Cache::FileCache(\%cache_options);
my $format= new Number::Format(-thousands_sep => ',');
#$cache->clear();
################### File #############################
#----------------------------------
####Obtain htdocs, cgi-bin and script information
1;

##############################
# constructor                #
##############################
##############################
# public_methods             #
##############################
##############################
# public_functions           #
##############################

=head2 PUBLIC FUNCTIONS <UPLINK>

=for html <font size='-1'><strong><A href='#getScriptLocation'>getScriptLocation; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getUserInfo'>getUserInfo; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#checkDatabaseConnection'>checkDatabaseConnection; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#retrieveTasks'>retrieveTasks; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#deleteJob'>deleteJob; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#addAnnotationTask'>addAnnotationTask; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#addTieMapTask'>addTieMapTask; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#checkXMLFileExistence'>checkXMLFileExistence; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#addJobToQueue'>addJobToQueue; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getGeneFinderList'>getGeneFinderList; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getAssemblerTraceNLibrary'>getAssemblerTraceNLibrary; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#writeTask'>writeTask; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#processBuild'>processBuild; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getAssemblyList'>getAssemblyList; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getAssemblerNBuild'>getAssemblerNBuild; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getAssemblerList'>getAssemblerList; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getGeneFinderUsed'>getGeneFinderUsed; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getMapVersionUsed'>getMapVersionUsed; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getLibraryList'>getLibraryList; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#extractAssembly'>extractAssembly; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getGapCache'>getGapCache; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getOverlapCache'>getOverlapCache; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getProject'>getProject; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getDefaultAssembly'>getDefaultAssembly; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getDefaultGeneFinder'>getDefaultGeneFinder; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getDefaultMapVersion'>getDefaultMapVersion; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getMapList'>getMapList; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getHashAssembly'>getHashAssembly; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getHashOrf'>getHashOrf; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getAssemblyInfo'>getAssemblyInfo; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getOrfInfo'>getOrfInfo; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getStatInitCodon'>getStatInitCodon; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getComparisonData'>getComparisonData; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#calculateDifference'>calculateDifference; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getProgress'>getProgress; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#recordArray2Element'>recordArray2Element; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#createProgressGraph'>createProgressGraph; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getDistribution'>getDistribution; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#createDistributionGraph'>createDistributionGraph; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#cumulateBarGraph'>cumulateBarGraph; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#lineGraph'>lineGraph; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getInsertSizeData'>getInsertSizeData; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#createInsertGraph'>createInsertGraph; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#barGraph'>barGraph; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getBlastConfig'>getBlastConfig; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getDownloadConfig'>getDownloadConfig; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getOrfContigFileConfig'>getOrfContigFileConfig; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getGapData'>getGapData; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#createGapDistribution'>createGapDistribution; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getOverlapData'>getOverlapData; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getMapScrollBoxInfo'>getMapScrollBoxInfo; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#initializeMapViewerData'>initializeMapViewerData; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getSupertigIntrinsicData'>getSupertigIntrinsicData; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getContigCoord'>getContigCoord; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getReadCoord'>getReadCoord; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#rearrangeMapCoord'>rearrangeMapCoord; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#computeMapImage'>computeMapImage; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#drawRectangle'>drawRectangle; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#initializeDrawing'>initializeDrawing; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#initializeColor'>initializeColor; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getTigScrollBoxInfo'>getTigScrollBoxInfo; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getSpecificOrfInfo'>getSpecificOrfInfo; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#processOrfInfo'>processOrfInfo; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#processListInfo'>processListInfo; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getSpecifics'>getSpecifics; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#computeTigImage'>computeTigImage; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#initializeTigViewerData'>initializeTigViewerData; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getOneOrfInfo'>getOneOrfInfo; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#getOrfList'>getOrfList; </A></strong></font><BR>

=over

=for html <A NAME='getScriptLocation'>

=item getScriptLocation

=for html
File #############################<BR>Obtain htdocs, cgi-bin and script information<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$config_file</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#$cache->clear();

################### File #############################

#----------------------------------
####Obtain htdocs, cgi-bin and script information
sub getScriptLocation{

   my $scriptname=shift;
   my $config_file=shift;

   my $cgipath=$1 if ($scriptname =~ /(.*)\/.*\.pl/);
   open (OUT, "$config_file") or die "Can't open $config_file";
   my $htdocpath=<OUT>; #reads the first line of the file
   chomp($htdocpath);
   close OUT;

   return $cgipath, $htdocpath;

}

=for html <A NAME='getUserInfo'>

=item getUserInfo

=for html
Get user info<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$config_file</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#----------------------------------
####Get user info
sub getUserInfo{

   my $config_file=shift;

   my %user_info;

   open (OUT, "$config_file") or die "Can't open $config_file";
   my $line=<OUT>;
   my ($username, $password, $assembly_db, $assembly_host)=split(';', $line);

   $user_info{'password'}=$password;
   $user_info{'username'}=$username;
   $user_info{'assembly_database'}=$assembly_db;
   $user_info{'assembly_host'}=$assembly_host;

   return \%user_info;
}

=for html <A NAME='checkDatabaseConnection'>

=item checkDatabaseConnection

=for html
SAM ############################<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$sam_login</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

##################### SAM ############################

#----------------------------------
sub checkDatabaseConnection{

   my $sam_login=shift;
   my %sam_login=%$sam_login;

   my @project_data;

   if ($sam_login{'username'} && $sam_login{'password'}){
      my $dbh;

      eval{
         ####Initialize the database
         $dbh=SQLdb::Initialize($sam_login{'password'}, $sam_login{'username'}, $sam_login{'database'}, $sam_login{'host_name'});
         my @field=("Project_Organism", "Project_Description");
         my @table=("Project");
         my @condition=();
         my $select=SQLdb::GetRecord(\@field, \@table, \@condition);
         my $tmp_record=SQLdb::ExecuteUnique($dbh, $select);
         @project_data=@$tmp_record;
         SQLdb::Disconnect($dbh);
      };
      if($@){
         $sam_login{'password'}=$sam_login{'database'}=$sam_login{'username'}='';
         $sam_login{'pass'}=0;
      }else{
         SQLdb::Disconnect($dbh);
         $sam_login{'pass'}=1;
         $sam_login{'project'}=$project_data[0];
         $sam_login{'description'}=$project_data[1];
      }
   }

   return \%sam_login;
}

=for html <A NAME='retrieveTasks'>

=item retrieveTasks

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$sam_login</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#----------------------------------
sub retrieveTasks{

   my $sam_login=shift;
   my %sam_login=%$sam_login;

   my $dbh=SQLdb::Initialize($sam_login{'password'}, $sam_login{'username'}, $sam_login{'database'}, $sam_login{'host_name'});

   ####Get General Assembler Info
   my @task_field=("Job_Queue_ID","Executable_Description", "Job_Queue_FileCdt", "Job_Queue_AssemblerCdt", "Job_Queue_StartDateCdt", "Job_Queue_EndDateCdt", "Job_Queue_LibraryCdt", "Job_Queue_Username", "Job_Queue_DateStart", "Job_Queue_Status", "Executable_ID", "Job_Queue_Gene_Finder", "Job_Queue_AssemblyCdt", "Job_Queue_Map_ID");
   my @task_table=("Job_Queue", "Executable");
   my @task_condition=("Executable_ID=FK_Executable__ID");
   my $special="Order By Job_Queue_ID DESC";
   my $select_task=SQLdb::GetRecord(\@task_field, \@task_table, \@task_condition, $special);
   my $task_reference=SQLdb::ExecuteMany($dbh, $select_task);

   SQLdb::Disconnect($dbh);
   
   return $task_reference;

}

=for html <A NAME='deleteJob'>

=item deleteJob

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$sam_login</B>():  [Default = <B>shift</B>]<BR>
- <B>$delete_job</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub deleteJob{
   
   my $sam_login=shift;
   my %sam_login=%$sam_login;
   my $delete_job=shift;
   my @delete_job=@$delete_job;
  
   my ($deletion_message, $delete_condition);
   my $flag=0;

   my $dbh=SQLdb::Initialize($sam_login{'password'}, $sam_login{'username'}, $sam_login{'database'}, $sam_login{'host_name'});

   my $unique_table="Job_Queue";
   my @condition=("Job_Queue_Status='waiting'");

   ####Build condition
   foreach my $record_id (sort @delete_job){

      if ($flag){
         $delete_condition.=" OR Job_Queue_ID=$record_id";
      }else{
         $delete_condition="(Job_Queue_ID=$record_id";
      }
      $flag++;

   }
   $delete_condition.=")";

   push @condition, $delete_condition;

   if (@delete_job){###something to delete
      SQLdb::deleteRecord($dbh, $unique_table, \@condition);
   }

   SQLdb::Disconnect($dbh);
}

=for html <A NAME='addAnnotationTask'>

=item addAnnotationTask

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_select</B>():  [Default = <B>shift</B>]<BR>
- <B>$email</B>():  [Default = <B>shift</B>]<BR>
- <B>$command_id</B>(): same as $sam_selection var  [Default = <B>shift</B>]<BR>
- <B>$sam_login</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub addAnnotationTask{

   my $assembly_id=shift;
   my $gene_finder_select=shift;
   my $email=shift;
   my $command_id=shift; ###same as $sam_selection var
   my $sam_login=shift;

   &addJobToQueue($sam_login, $command_id, '', '', $gene_finder_select, $assembly_id, '', '', '', $email, '', '');  #gene finder, but no other condition
   my $comment="The program has successfully been added to the queue.  You will be notified by e-mail once the annotation is completed.";
   my $color="000066";
   wgsHTML::displayMessage($comment, $color);

}

=for html <A NAME='addTieMapTask'>

=item addTieMapTask

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$map_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$email</B>():  [Default = <B>shift</B>]<BR>
- <B>$command_id</B>(): same as $sam_selection var  [Default = <B>shift</B>]<BR>
- <B>$sam_login</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub addTieMapTask{ 
   my $assembly_id=shift;
   my $map_id=shift;
   my $email=shift;
   my $command_id=shift; ###same as $sam_selection var
   my $sam_login=shift;

   &addJobToQueue($sam_login, $command_id, '', '', '', $assembly_id, '', '', '', $email, '', $map_id); 
   my $comment="The program has successfully been added to the queue.  You will be notified by e-mail once the process is over.";
   my $color="000066";
   wgsHTML::displayMessage($comment, $color);
}

=for html <A NAME='checkXMLFileExistence'>

=item checkXMLFileExistence

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$file</B>():  [Default = <B>shift</B>]<BR>
- <B>$email</B>():  [Default = <B>shift</B>]<BR>
- <B>$sam_login</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$htdocpath</B>():  [Default = <B>shift</B>]<BR>
- <B>$sam_selection</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub checkXMLFileExistence{

   my $file=shift;
   my $email=shift;
   my $sam_login=shift;
   my $scriptname=shift;
   my $htdocpath=shift;
   my $sam_selection=shift;
   my $menu=shift;
   my $fuzzykey=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $compressed_userinfo=shift;

 
   if (! -e $file){
      wgsHTML::filePrompt($scriptname, $htdocpath, $sam_selection, $menu,  $fuzzykey, $assembly_id, $gene_finder_id, $compressed_userinfo);
      my $comment="File $file Not Found!";
      my $color="FF0000";
      wgsHTML::displayMessage($comment, $color);
   }
   else{#put request in Job_Queued table

      ####it's easier to build an argument string since different programs take on different arguments
      &addJobToQueue($sam_login, $sam_selection,'', '', '', '', '', '', '', $email, $file,'');  #file, but no other condition 
      my $comment="The program has successfully been added to the queue.  You will be notified by e-mail once the parsing is over.";
      my $color="000066";
      wgsHTML::displayMessage($comment, $color);
   }

}

=for html <A NAME='addJobToQueue'>

=item addJobToQueue

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$sam_login</B>():  [Default = <B>shift</B>]<BR>
- <B>$command_id</B>(): same as $sam_selection var  [Default = <B>shift</B>]<BR>
- <B>$assembler_name</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_type</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_select</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_condition</B>():  [Default = <B>shift</B>]<BR>
- <B>$sequence_start</B>():  [Default = <B>shift</B>]<BR>
- <B>$sequence_end</B>():  [Default = <B>shift</B>]<BR>
- <B>$library_condition</B>():  [Default = <B>shift</B>]<BR>
- <B>$email</B>():  [Default = <B>shift</B>]<BR>
- <B>$file</B>():  [Default = <B>shift</B>]<BR>
- <B>$map_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub addJobToQueue{

   my $sam_login=shift;
   my %sam_login=%$sam_login;
   my $command_id=shift;      #######same as $sam_selection var
   my $assembler_name=shift;
   my $assembly_type=shift;
   my $gene_finder_select=shift;
   my $assembly_condition=shift;
   my $sequence_start=shift;
   my $sequence_end=shift;
   my $library_condition=shift;
   my $email=shift;
   my $file=shift;
   my $map_id=shift;

   ####Get Unix Date

   my $unixdate=`date`;
   chomp($unixdate);
   my @format=("%Y-%m-%d %H:%M:%S");
   my $start_date=&UnixDate($unixdate,@format);

   ####Initialize Database Connection

   my $dbh=SQLdb::Initialize($sam_login{'password'}, $sam_login{'username'}, $sam_login{'database'}, $sam_login{'host_name'});

   ####Check existence of Executable ID

   my @field=("Executable_ID");
   my @table=("Executable");
   my @condition=("Executable_ID=$command_id");
   my $select_executable=SQLdb::GetRecord(\@field, \@table, \@condition);
   my $tmp_executable=SQLdb::ExecuteUnique($dbh, $select_executable);
   my @executable_arr=@$tmp_executable;
   my $executable_id=$executable_arr[0];

   ####Add New job in Job_Queue only if there's a executable id associated with id

   if ($executable_id){
     my $uniquetable="Job_Queue";
     my @field=("Job_Queue_ID", "FK_Executable__ID", "Job_Queue_FileCdt", "Job_Queue_AssemblerCdt", "Job_Queue_StartDateCdt", "Job_Queue_EndDateCdt", "Job_Queue_LibraryCdt", "Job_Queue_Username", "Job_Queue_Email", "Job_Queue_DateStart", "Job_Queue_New_Build", "Job_Queue_Gene_Finder", "Job_Queue_AssemblyCdt", "Job_Queue_Map_ID", "Job_Queue_Status");
     my @value=("", "$executable_id", "$file", "$assembler_name", "$sequence_start", "$sequence_end",  "$library_condition","$sam_login{'username'}", "$email", "$start_date", "$assembly_type","$gene_finder_select", $assembly_condition, $map_id, "waiting");
     SQLdb::InsertRecord($dbh, $uniquetable, \@field, \@value);
   }

   SQLdb::Disconnect($dbh);
}

=for html <A NAME='getGeneFinderList'>

=item getGeneFinderList

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$sam_login</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub getGeneFinderList{###gene finder available

   my $sam_login=shift;
   my %sam_login=%$sam_login;

   my $dbh=SQLdb::Initialize($sam_login{'password'}, $sam_login{'username'}, $sam_login{'database'}, $sam_login{'host_name'});
   ####Get Assembler
   my @field=("Gene_Finder_ID", "Gene_Finder_Name", "Gene_Finder_Training_Set", "Gene_Finder_Train_FullPath");
   my @table=("Gene_Finder");
   my @condition=();
   my $select=SQLdb::GetRecord(\@field, \@table, \@condition);
   my $tmp_gf_list=SQLdb::ExecuteMany($dbh, $select);

   my @list=@$tmp_gf_list;
   my @gf_list;

   foreach my $reference (@list){
      my @record=@$reference;
      my @temp_gf=($record[0], $record[1]);
      if($record[2]){###expects a file as training set
         if(-e $record[3]){###only makes a list of existing files
            push @gf_list, \@temp_gf;
         }
      }else{###don't expect anything so, don't have to check file
         push @gf_list, \@temp_gf;
      }
   }
   return \@gf_list;
}

=for html <A NAME='getAssemblerTraceNLibrary'>

=item getAssemblerTraceNLibrary

=for html
Gather all current sequence information (available for assembly)<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$sam_login</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
#Gather all current sequence information (available for assembly)
sub getAssemblerTraceNLibrary{

   my $sam_login=shift;
   my %sam_login=%$sam_login;

   my %sequence_date;
   my ($most_recent_date, $least_recent_date)=('1900-01-01 00:00:00', '2100-01-01 00:00:00');

   my $dbh=SQLdb::Initialize($sam_login{'password'}, $sam_login{'username'}, $sam_login{'database'}, $sam_login{'host_name'});
   ####Get Assembler
   my @assembler_field=("Assembler_Name");
   my @assembler_table=("Assembler");
   my @assembler_condition=();
   my $select_assembler=SQLdb::GetRecord(\@assembler_field, \@assembler_table, \@assembler_condition);
   my $tmp_assembler_list=SQLdb::ExecuteMany($dbh, $select_assembler);

   ####Get Libraries
   my @library_field=("Library_Name");
   my @library_table=("Library");
   my @library_condition=();
   my $select_library=SQLdb::GetRecord(\@library_field, \@library_table, \@library_condition);
   my $tmp_library_list=SQLdb::ExecuteMany($dbh, $select_library);

   ####Get Date
   my @trace_field=("Trace_Date_Sequenced");
   my @trace_table=("Trace");
   my @trace_condition=();
   my $special_instruction="GROUP BY Trace_Date_Sequenced";
   my $select_trace=SQLdb::GetRecord(\@trace_field, \@trace_table, \@trace_condition, $special_instruction);
   my $tmp_trace=SQLdb::ExecuteMany($dbh, $select_trace);
   my @trace_ref=@$tmp_trace;

   SQLdb::Disconnect($dbh);

   ####Reorganize dates
   foreach my $reference(@trace_ref){
       my @trace_arr=@$reference;
       #only get the date, not the time (I don't think we are so keen into assembling traces to the minute)
       my $date_only=$1 if ($trace_arr[0]=~/(\S+)\s+\S+/);

       $sequence_date{$date_only}++;
       $most_recent_date=$date_only if ($date_only gt $most_recent_date);
       $least_recent_date=$date_only if ($date_only lt $least_recent_date);
   }

   return $tmp_assembler_list, $tmp_library_list, \%sequence_date, $most_recent_date, $least_recent_date;
}

=for html <A NAME='writeTask'>

=item writeTask

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$sequence_start</B>():  [Default = <B>shift</B>]<BR>
- <B>$sequence_end</B>():  [Default = <B>shift</B>]<BR>
- <B>$library_ref</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembler_name</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_type</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_select</B>():  [Default = <B>shift</B>]<BR>
- <B>$email</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$command_id</B>(): same as $sam_selection var  [Default = <B>shift</B>]<BR>
- <B>$sam_login</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub writeTask{

   my $sequence_start=shift;
   my $sequence_end=shift;
   my $library_ref=shift;
   my @library=@$library_ref;
   my $assembler_name=shift;
   my $assembly_type=shift;
   my $gene_finder_select=shift;
   my $email=shift;
   my $scriptname=shift;
   my $command_id=shift; ###same as $sam_selection var
   my $sam_login=shift;

   ####it's easier to build an argument string since different programs take on different arguments
   ####Build Library condition
   my $library_count=0;
   my $library_condition;

   foreach my $library(sort @library){
      $library_condition.="," if ($library_count>0); #will build a condition for all libraries
      $library_condition.="$library";
      $library_count++;
   }

   &addJobToQueue($sam_login, $command_id, $assembler_name, $assembly_type, $gene_finder_select,'', $sequence_start, $sequence_end, $library_condition, $email,'','');#no file, but library+date cdt
   my $comment="The program has successfully been added to the queue.  You will be notified by e-mail once the assembly and analysis is over.";
   my $color="000066";
   wgsHTML::displayMessage($comment, $color);

}

=for html <A NAME='processBuild'>

=item processBuild

=for html
Core Program ######################<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_build</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#################### Core Program ######################

#-------------------------------------
sub processBuild{

   my $tmp_build=shift;
   my @build_ref=@$tmp_build;

   my @update_build;

   foreach my $ref(@build_ref){
      my @record=@$ref;
      my $build=$format->format_number($record[1]);
      my @new_record=($record[0], $build, $record[2], $record[3]);
      push @update_build, \@new_record;
   }

   return \@update_build;

}

=for html <A NAME='getAssemblyList'>

=item getAssemblyList

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub getAssemblyList{

   my $user_info=shift;
   my %user_info=%$user_info;

   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   #####Get Assembler
   my @field=("Assembler_Name", "Assembly_Build_ID", "Assembly_ID", "Assembly_Type");
   my @table=("Assembler", "Assembly");
   my @condition=("Assembler_ID=FK_Assembler__ID", "Assembly_Status='completed'");
   my $special_instruction="ORDER BY Assembly_ID DESC";
   my $select_build=SQLdb::GetRecord(\@field, \@table, \@condition, $special_instruction);
   my $tmp_build=SQLdb::ExecuteMany($dbh, $select_build);

   SQLdb::Disconnect($dbh);

   my $update_build=&processBuild($tmp_build);   

   return $update_build;
}

=for html <A NAME='getAssemblerNBuild'>

=item getAssemblerNBuild

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub getAssemblerNBuild{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;

   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   #####Get Assembler
   my @field=("Assembler_Name", "Assembly_Build_ID", "Assembly_Type");
   my @table=("Assembler", "Assembly");
   my @condition=("Assembler_ID=FK_Assembler__ID", "Assembly_ID=$assembly_id");
   my $select_build=SQLdb::GetRecord(\@field, \@table, \@condition);
   my $tmp_build=SQLdb::ExecuteUnique($dbh, $select_build);
   SQLdb::Disconnect($dbh);

   my @build=@$tmp_build;
   my $assembler=$build[0];
   my $build=$format->format_number($build[1]);
   $build.=" ".$build[2]; 

   return $assembler, $build;
}

=for html <A NAME='getAssemblerList'>

=item getAssemblerList

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub getAssemblerList{

   my $user_info=shift;
   my %user_info=%$user_info;

   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   #####Get Assembler List
   my @field=("Assembler_Name");
   my @table=("Assembler", "Assembly");
   my @condition=("Assembler_ID=FK_Assembler__ID", "Assembly_Status='completed'");#ensures that doesn't display for inexistent builds or unsuccessful assemblies
   my $instruction="GROUP BY Assembler_Name";
   my $select_assembler=SQLdb::GetRecord(\@field, \@table, \@condition, $instruction);
   my $tmp_assembler=SQLdb::ExecuteMany($dbh, $select_assembler);
   SQLdb::Disconnect($dbh);

   return $tmp_assembler;

}

=for html <A NAME='getGeneFinderUsed'>

=item getGeneFinderUsed

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub getGeneFinderUsed{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;

   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   #####Get The Gene Finders Used with this assembly
   my @field=("Gene_Finder_ID", "Gene_Finder_Name");
   my @table=("Gene_Finder", "Contig", "Assembly", "Orf_Origin", "Orf_Context");
   my @condition=("Assembly_ID=FK_Assembly__ID", "Contig_ID=FK_Contig__ID", "Orf_Context_ID=FK_Orf_Context__ID", "Gene_Finder_ID=FK_Gene_Finder__ID", "Assembly_ID=$assembly_id");
   my $instruction="GROUP BY Gene_Finder_ID";
   my $select_genefinder=SQLdb::GetRecord(\@field, \@table, \@condition, $instruction);
   my $tmp_genefinder=SQLdb::ExecuteMany($dbh, $select_genefinder);
   SQLdb::Disconnect($dbh);

   my @ref=@$tmp_genefinder;

   my $gene_finder_used;
   foreach my $ref(@ref){
      my @record=@$ref;
      $gene_finder_used->{$record[0]}=$record[1];
   } 

   return $gene_finder_used;
}

=for html <A NAME='getMapVersionUsed'>

=item getMapVersionUsed

=for html
Get the Map Versions used with this assembly  <BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub getMapVersionUsed{
   ####Get the Map Versions used with this assembly  
   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;

   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   my @field=("Map_ID", "Map_Version");
   my @table=("Map", "Map_Contig", "Ultracontig", "Supercontig", "Assembly");
   my @condition=("Assembly_ID=FK_Assembly__ID", "Supercontig_ID=FK_Supercontig__ID", "Map_Contig_ID=FK_Map_Contig__ID", "Map_ID=FK_Map__ID", "Assembly_ID=$assembly_id");
   my $instruction="GROUP BY Map_ID";
   my $select_mapversion=SQLdb::GetRecord(\@field, \@table, \@condition, $instruction);  
   my $tmp_mapversion=SQLdb::ExecuteMany($dbh, $select_mapversion);
   SQLdb::Disconnect($dbh);
   
   my @ref=@$tmp_mapversion;

   my $map_version_used;
   foreach my $ref(@ref){
      my @record=@$ref;
      $map_version_used->{$record[0]}=$record[1];
   }
   return $map_version_used;
}

=for html <A NAME='getLibraryList'>

=item getLibraryList

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub getLibraryList{

   my $user_info=shift;
   my %user_info=%$user_info;

   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   ####Get Libraries
   my @library_field=("Library_Name");
   my @library_table=("Library");
   my @library_condition=();
   my $select_library=SQLdb::GetRecord(\@library_field, \@library_table, \@library_condition);
   my $tmp_library=SQLdb::ExecuteMany($dbh, $select_library);

   SQLdb::Disconnect($dbh);

   return $tmp_library;
}

=for html <A NAME='extractAssembly'>

=item extractAssembly

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tag</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub extractAssembly{

   my $tag=shift;

   my ($assembler, $build);

   if ($tag=~/(\w+)\s+\D+(\d+)/){
      $assembler=$1;
      $build=$2;
   }

   return $assembler, $build;
}

=for html <A NAME='getGapCache'>

=item getGapCache

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$cache_key</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-----------------------------
sub getGapCache{

   my $cache_key=shift;
   my %cache_key=%$cache_key;

   my $span_clone=$cache_key{'key'}."spanning_clone";
   my $stat_key=$cache_key{'key'}."clone_stats";

   my $tmp_gap_list=$cache->get($span_clone);
   my $tmp_gap_stat=$cache->get($stat_key);

   return $tmp_gap_list, $tmp_gap_stat;
}

=for html <A NAME='getOverlapCache'>

=item getOverlapCache

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$cache_key</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-----------------------------
sub getOverlapCache{

   my $cache_key=shift;
   my %cache_key=%$cache_key;

   my $overlap_clone=$cache_key{'key'}."overlap";
   my $tmp_overlap_list=$cache->get($overlap_clone);

   return $tmp_overlap_list;
}

=for html <A NAME='getProject'>

=item getProject

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-----------------------------
sub getProject{

   my $user_info=shift;
   my %user_info=%$user_info;

   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   my @field=("Project_Organism", "Project_Description", "Project_Genome_Size", "Project_Web_Image");
   my @table=("Project");
   my @condition=();
   my $select_project=SQLdb::GetRecord(\@field, \@table, \@condition);
   my $tmp_project=SQLdb::ExecuteUnique($dbh, $select_project);
   SQLdb::Disconnect($dbh);

   $tmp_project->[2]=$format->format_number($tmp_project->[2]);###make sure you have a nicely formatted number

   return $tmp_project;
}

=for html <A NAME='getDefaultAssembly'>

=item getDefaultAssembly

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-----------------------------
sub getDefaultAssembly{

   my $user_info=shift;
   my %user_info=%$user_info;

   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   my @field=("Assembly_ID");
   my @table=("Assembler", "Assembly");
   my @condition=("Assembler_ID=FK_Assembler__ID", "Assembly_Status='completed'");
   my $instruction="ORDER BY Assembly_ID DESC limit 1";
   my $select_assembly=SQLdb::GetRecord(\@field, \@table, \@condition, $instruction);
   my $tmp_assembly=SQLdb::ExecuteUnique($dbh, $select_assembly);
   SQLdb::Disconnect($dbh);

   my @assembly=@$tmp_assembly;
   
   return $assembly[0]; #assembler, build

}

=for html <A NAME='getDefaultGeneFinder'>

=item getDefaultGeneFinder

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-----------------------------
sub getDefaultGeneFinder{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;

   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   #####Get The Gene Finders Used with this assembly
   my @field=("Gene_Finder_ID");
   my @table=("Gene_Finder", "Contig", "Assembly", "Orf_Origin", "Orf_Context");
   my @condition=("Assembly_ID=FK_Assembly__ID", "Contig_ID=FK_Contig__ID", "Orf_Context_ID=FK_Orf_Context__ID", "Gene_Finder_ID=FK_Gene_Finder__ID", "Assembly_ID=$assembly_id");
   my $instruction="GROUP BY Gene_Finder_ID limit 1";
   my $select_genefinder=SQLdb::GetRecord(\@field, \@table, \@condition, $instruction);
   my $tmp_genefinder=SQLdb::ExecuteUnique($dbh, $select_genefinder);
   SQLdb::Disconnect($dbh);

   my @genefinder=@$tmp_genefinder;
  
   return $genefinder[0]; 

}

=for html <A NAME='getDefaultMapVersion'>

=item getDefaultMapVersion

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-----------------------------
sub getDefaultMapVersion{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;

   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   #####Get The Map ID Used with this assembly
   my @field=("Map_ID");
   my @table=("Map", "Map_Contig", "Ultracontig", "Supercontig", "Assembly");
   my @condition=("Assembly_ID=FK_Assembly__ID", "Supercontig_ID=FK_Supercontig__ID", "Map_Contig_ID=FK_Map_Contig__ID", "Map_ID=FK_Map__ID", "Assembly_ID=$assembly_id");
   my $instruction="GROUP BY Map_ID limit 1";
   my $select_mapid=SQLdb::GetRecord(\@field, \@table, \@condition, $instruction);
   my $tmp_mapid=SQLdb::ExecuteUnique($dbh, $select_mapid);
   SQLdb::Disconnect($dbh);
   
   my @mapid=@$tmp_mapid;

   return $mapid[0]; 
}

=for html <A NAME='getMapList'>

=item getMapList

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-----------------------------
sub getMapList{

   my $user_info=shift;
   my %user_info=%$user_info;

   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   #####Get A List of all the Map IDs imported
   my @field=("Map_ID", "Map_Version", "Map_Date");
   my @table=("Map");
   my @condition=();
   my $instruction="ORDER BY Map_Version DESC";
   my $select_map=SQLdb::GetRecord(\@field, \@table, \@condition, $instruction);
   my $tmp_map=SQLdb::ExecuteMany($dbh, $select_map);
   SQLdb::Disconnect($dbh);

   return $tmp_map;
}

=for html <A NAME='getHashAssembly'>

=item getHashAssembly

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_summary</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-----------------------------
sub getHashAssembly{

   my $tmp_summary=shift;
   my @record=@$tmp_summary;
 
   my %assembly;

   $assembly{'contig'}=$format->format_number($record[0]);
   $assembly{'supertig'}=$format->format_number($record[1]);
   $assembly{'supertig_size'}=$format->format_number($record[2]);
   $assembly{'singleton_read'}=$format->format_number($record[3]);
   $assembly{'error'}=$format->format_number($record[4],1,1);
   $assembly{'largest_contig'}=$format->format_number($record[5]);
   $assembly{'smallest_contig'}=$format->format_number($record[6]);
   $assembly{'mean_tig'}=$format->format_number($record[7],1,1);
   $assembly{'mean_super'}=$format->format_number($record[8],1,1);
   $assembly{'base'}=$format->format_number($record[9]);
   $assembly{'consensus'}=$format->format_number($record[10]);
   $assembly{'phred40'}=$format->format_number($record[11]);
   $assembly{'N50'}=$format->format_number($record[12]);
   $assembly{'percentA'}=$format->format_number($record[13],1,1);
   $assembly{'percentT'}=$format->format_number($record[14],1,1);
   $assembly{'percentC'}=$format->format_number($record[15],1,1);
   $assembly{'percentG'}=$format->format_number($record[16],1,1);
   $assembly{'analyzed_read'}=$format->format_number($record[17]);
   $assembly{'assembled_read'}=$format->format_number($record[18]);
   $assembly{'singleton_contig'}=$format->format_number($record[19]);
   $assembly{'2read'}=$format->format_number($record[20]);
   $assembly{'3read'}=$format->format_number($record[21]);
   $assembly{'4read'}=$format->format_number($record[22]);
   $assembly{'5read'}=$format->format_number($record[23]);
   $assembly{'6read'}=$format->format_number($record[24]);
   $assembly{'10read'}=$format->format_number($record[25]);
   $assembly{'20read'}=$format->format_number($record[26]);
   $assembly{'bad_read'}=$format->format_number($record[27]);
   $assembly{'masked_read'}=$format->format_number($record[28]);
   $assembly{'tig_coverage'}=$format->format_number($record[29],2,1);
   $assembly{'genome_coverage'}=$format->format_number($record[30],2,1);
   $assembly{'poisson_size'}=$format->format_number($record[31]);
   $assembly{'poisson_coverage'}=$format->format_number($record[32],2,1);
   $assembly{'poisson_contig'}=$format->format_number($record[33]);
   $assembly{'date_assembled'}=$record[34];

   return \%assembly;
}

=for html <A NAME='getHashOrf'>

=item getHashOrf

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_orf</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-----------------------------
sub getHashOrf{

   my $tmp_orf=shift;
   my @record=@$tmp_orf;

   my %orf;

   $orf{'count'}=$format->format_number($record[0]);
   $orf{'max'}=$format->format_number($record[1]);
   $orf{'min'}=$format->format_number($record[2]);
   $orf{'mean'}=$format->format_number($record[3],1,1);

   return \%orf;
}

=for html <A NAME='getAssemblyInfo'>

=item getAssemblyInfo

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-----------------------------
sub getAssemblyInfo{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;

   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   ####Assembly Summary Info
   my @summary_field=("Summary_Contig_Number", "Summary_Supertig_Number", "Summary_Supertig_Size", "Summary_Singleton_Read", "Summary_Error", "Summary_Largest_Tig", "Summary_Smallest_Tig", "Summary_Mean_Tig", "Summary_Mean_Super", "Summary_Total_Bases", "Summary_Consensus", "Summary_Phred40", "Summary_N50", "Summary_Percent_A", "Summary_Percent_T", "Summary_Percent_C", "Summary_Percent_G", "Summary_Analyzed_Read", "Summary_Assembled_Read", "Summary_Singleton_Contig", "Summary_2Read_Contig", "Summary_3Read_Contig", "Summary_4Read_Contig", "Summary_5Read_Contig", "Summary_6Read_Contig", "Summary_10Read_Contig", "Summary_20Read_Contig", "Summary_Bad_Quality_Read", "Summary_Masked_Read", "Summary_Contig_Coverage", "Summary_Genome_Coverage", "Summary_Poisson_Genome_Size", "Summary_Poisson_Genome_Coverage", "Summary_Poisson_Contig", "Assembly_DateStart");
   
   my @summary_table=("Summary", "Assembly");
   my @summary_condition=("Assembly_ID=FK_Assembly__ID", "Assembly_ID=$assembly_id");
   my $select_summary=SQLdb::GetRecord(\@summary_field, \@summary_table, \@summary_condition);  
   my $tmp_summary=SQLdb::ExecuteUnique($dbh, $select_summary);
   SQLdb::Disconnect($dbh);

   my $assembly_list=&getHashAssembly($tmp_summary);

   return $assembly_list;
}

=for html <A NAME='getOrfInfo'>

=item getOrfInfo

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-----------------------------
sub getOrfInfo{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;
   my $gene_finder_id=shift;

   ####Connect to the Database
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   ####Simple Stats
   my @orf_field=("count(Orf_ID)", "max(Orf_CDS_Length)", "min(Orf_CDS_Length)", "AVG(Orf_CDS_Length)");
   my @orf_table=("Blast", "Contig", "Orf", "Orf_Origin", "Assembly", "Orf_Context", "Gene_Finder");
   my @orf_condition=("Orf_Context_ID=FK_Orf_Context__ID","Orf_ID=Orf_Context.FK_Orf__ID", "Contig_ID=FK_Contig__ID","Assembly_ID=FK_Assembly__ID", "Assembly_ID='$assembly_id'", "Orf_ID=Blast.FK_Orf__ID", "Gene_Finder_ID=FK_Gene_Finder__ID", "Gene_Finder_ID=$gene_finder_id");
   my $select_orf=SQLdb::GetRecord(\@orf_field, \@orf_table, \@orf_condition);
#   print "$select_orf";
   my $tmp_orf=SQLdb::ExecuteUnique($dbh, $select_orf);
 
   ####Retrieve Initiation Codon
   my @cod_field=("Orf_Initiation_Codon");
   my @cod_table=("Contig", "Orf", "Orf_Origin", "Assembly", "Orf_Context", "Gene_Finder");
   my @cod_condition=("Orf_Context_ID=FK_Orf_Context__ID","Orf_ID=FK_Orf__ID", "Contig_ID=FK_Contig__ID","Assembly_ID=FK_Assembly__ID", "Assembly_ID='$assembly_id'", "Gene_Finder_ID=FK_Gene_Finder__ID", "Gene_Finder_ID=$gene_finder_id");
   my $select_cod=SQLdb::GetRecord(\@cod_field, \@cod_table, \@cod_condition);
   my $tmp_cod=SQLdb::ExecuteMany($dbh, $select_cod);
   SQLdb::Disconnect($dbh);

   my $init_codon=&getStatInitCodon($tmp_cod);
   my $orf_info=&getHashOrf($tmp_orf);

   return $orf_info, $init_codon;
}

=for html <A NAME='getStatInitCodon'>

=item getStatInitCodon

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_cod</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-----------------------------
sub getStatInitCodon{####get % for every initiation codon

   my $tmp_cod=shift;
   my @codon_reference=@$tmp_cod;

   my (%codon_type, %initiation_codon);
   my $total_record=0;

   ###sum up the number of each type
   foreach my $reference(@codon_reference){
      my @record=@$reference;
      $codon_type{$record[0]}++;
      $total_record++;
   }
 
   ###calculate percentages  
   foreach my $type (sort keys %codon_type){
      my $percent=($codon_type{$type}/$total_record)*100 if ($total_record>0);;
      $initiation_codon{$type}=$format->format_number($percent,1,1);
   }
   return \%initiation_codon;
}

=for html <A NAME='getComparisonData'>

=item getComparisonData

=for html
LIBRARY STATS<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$compare_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#####LIBRARY STATS

#-----------------------------
sub getComparisonData{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;
   my $compare_id=shift;

   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   #Assembly Summary Info
   my @summary_field=("Assembly_DateStart", "Summary_Contig_Number", "Summary_Supertig_Number", "Summary_Supertig_Size", "Summary_Singleton_Read", "Summary_Error", "Summary_Largest_Tig", "Summary_Smallest_Tig", "Summary_Mean_Tig", "Summary_Mean_Super", "Summary_Total_Bases", "Summary_Consensus", "Summary_Phred40", "Summary_N50", "Summary_Percent_A", "Summary_Percent_T", "Summary_Percent_C", "Summary_Percent_G", "Summary_Analyzed_Read", "Summary_Assembled_Read", "Summary_Singleton_Contig", "Summary_2Read_Contig", "Summary_3Read_Contig", "Summary_4Read_Contig", "Summary_5Read_Contig", "Summary_6Read_Contig", "Summary_10Read_Contig", "Summary_20Read_Contig", "Summary_Bad_Quality_Read", "Summary_Masked_Read", "Summary_Contig_Coverage", "Summary_Genome_Coverage", "Summary_Poisson_Genome_Size", "Summary_Poisson_Genome_Coverage", "Summary_Poisson_Contig");
   my @summary_table=("Summary", "Assembly");
   my @summary_condition=("Assembly_ID=FK_Assembly__ID", "FK_Assembly__ID=$assembly_id OR FK_Assembly__ID=$compare_id");
   my $special_instruction;
   if ($compare_id>$assembly_id){$special_instruction="GROUP BY FK_Assembly__ID";}else{$special_instruction="GROUP BY FK_Assembly__ID DESC";}
   my $select_summary=SQLdb::GetRecord(\@summary_field, \@summary_table, \@summary_condition, $special_instruction);
   my $tmp_summary=SQLdb::ExecuteMany($dbh, $select_summary);

   SQLdb::Disconnect($dbh);

   my $compare_list=&calculateDifference(\@summary_field, $tmp_summary);

   return $compare_list;
}

=for html <A NAME='calculateDifference'>

=item calculateDifference

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_field</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_summary</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub calculateDifference{

   my $tmp_field=shift;
   my @field_summary=@$tmp_field;
   my $tmp_summary=shift;
   my @array_reference=@$tmp_summary;

   my $tmp_first=$array_reference[0];
   my @first_record=@$tmp_first;

   my %compare_list; 

   for(my $position=1;$position<=$#first_record;$position++){

      if (! defined $array_reference[1][$position]){                   #if compare to the exact same assembly
         $array_reference[1][$position]=$array_reference[0][$position];
      }

      my $value=($array_reference[0][$position]-$array_reference[1][$position]);
      my $delta;

      if($value<0){
         $value=$format->format_number(abs($value),1);
         $delta="(".$value.")";
      }elsif($value>0){
         $value=$format->format_number($value,1);
         $delta="+".$value;
      }else{
         $delta="-";
      }

      my $element_title=$1 if ($field_summary[$position]=~ /^[^_]*\_(.*)$/ );#Removes the field table tag
      $element_title=~s/\_/ /g;
      
      $compare_list{$element_title}{'one'}=$format->format_number($array_reference[0][$position],1);
      $compare_list{$element_title}{'two'}=$format->format_number($array_reference[1][$position],1);###make sure numbers are nicely formatted
      $compare_list{$element_title}{'delta'}=$delta;

   }
   $compare_list{'Date Assembled'}{'one'}=$array_reference[0][0];
   if (! defined $array_reference[1][0]){                   #if compare to the exact same assembly
         $array_reference[1][0]=$array_reference[0][0];
   }
   $compare_list{'Date Assembled'}{'two'}=$array_reference[1][0];
   $compare_list{'Date Assembled'}{'delta'}=&DateCalc($compare_list{'Date Assembled'}{'one'}, $compare_list{'Date Assembled'}{'two'});
   
   return \%compare_list;
}

=for html <A NAME='getProgress'>

=item getProgress

=for html
Assembly Progress ####################<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$summary_list</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembler_name</B>():  [Default = <B>shift</B>]<BR>
- <B>$cache_key</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#################### Assembly Progress ####################

#-------------------------------------
sub getProgress{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $summary_list=shift;
   my @summary_list=@$summary_list;
   my $assembler_name=shift;
   my $cache_key=shift;
   my %cache_key=%$cache_key;

   ####Initialize connection 
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   #####Get Summary Stats
   my @summary_field=("concat(Assembly_Build_ID, Assembly_Type)", @summary_list);
   my @summary_table=("Summary", "Assembly", "Assembler");
   my @summary_condition=("Assembler_ID=FK_Assembler__ID", "Assembly_ID=FK_Assembly__ID", "Assembly_Status='completed'", "Assembler_Name='$assembler_name'");
   my $special_instruction="ORDER BY Summary_Analyzed_Read";#regardless of the build, always nice progression
   my $select_summary=SQLdb::GetRecord(\@summary_field, \@summary_table, \@summary_condition, $special_instruction);
   my $tmp_summary=SQLdb::ExecuteMany($dbh, $select_summary);
   SQLdb::Disconnect($dbh);

   my ($progress_title, $graph_data, $reformated_summary)=&recordArray2Element($tmp_summary, \@summary_field);
   my @title=@$progress_title;
   my $max_option=$#title;
   $max_option+=2;

   my ($x_label, @legend)=@title;
  
   ####create unique keys for specific sessions
   my $key_pro=$cache_key{'key'}."progress";
   my $key_ass=$cache_key{'key'}."assembler";
   my $key_leg=$cache_key{'key'}."legend";

   $cache->set($key_pro, $graph_data, 200);
   $cache->set($key_ass, $assembler_name, 200);
   $cache->set($key_leg, \@legend, 200);

   return $reformated_summary, \@title, $max_option;
}

=for html <A NAME='recordArray2Element'>

=item recordArray2Element

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$array_of_reference</B>():  [Default = <B>shift</B>]<BR>
- <B>$field_label</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub recordArray2Element{

   my $array_of_reference=shift;
   my @array_of_reference=@$array_of_reference;
   my $field_label=shift;
   my @field_label=@$field_label;

   my ($record_count, $element_count)= (0,0);
   my (@graph_data, @reformated_summary);
   my @progress_title;

   my $max_record=$#array_of_reference;
   my $first_reference=$array_of_reference[0];
   my @first_record=@$first_reference;
   my $max_element=$#first_record;

   for ($element_count=0;$element_count<=$max_element;$element_count++){
         for($record_count=0;$record_count<=$max_record;$record_count++){
             if ($element_count == 0){###this is the build id
                $graph_data[$element_count][$record_count]=$array_of_reference[$record_count][$element_count];
                $reformated_summary[$record_count][$element_count]=$array_of_reference[$record_count][$element_count];##no formatting:::text
             }else{
                $graph_data[$element_count][$record_count]=$array_of_reference[$record_count][$element_count];
                $reformated_summary[$record_count][$element_count]=$format->format_number($array_of_reference[$record_count][$element_count],2);
             }
      }
      my $element_title=$1 if ($field_label[$element_count]=~ /^[^_]*\_(.*)$/);#Removes the field table tag
      $element_title=~s/[\_\(\)]/ /g;
      push @progress_title, $element_title;
   }
   return \@progress_title, \@graph_data, \@reformated_summary;
   
}

=for html <A NAME='createProgressGraph'>

=item createProgressGraph

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$cache_key</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub createProgressGraph{

    my $cache_key=shift;
    my %cache_key=%$cache_key;

    my $key_pro=$cache_key{'key'}."progress";
    my $key_ass=$cache_key{'key'}."assembler";
    my $key_leg=$cache_key{'key'}."legend";
 
    ####Get the cached data
    my $progress_data=$cache->get($key_pro);
    my $assembler=$cache->get($key_ass);
    my $legend=$cache->get($key_leg);

    ####Define Titles
    my $title="$assembler Assembly Progression";
    my $x_label="Assembly Build Number";
    my $y_label="Value";
    my $x_orient=1;

    &lineGraph($progress_data, $title, $x_label, $y_label, $x_orient, $legend);
}

=for html <A NAME='getDistribution'>

=item getDistribution

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_library</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembler_name</B>():  [Default = <B>shift</B>]<BR>
- <B>$build</B>():  [Default = <B>shift</B>]<BR>
- <B>$cache_key</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub getDistribution{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $tmp_library=shift;
   my @library=@$tmp_library;
   my $assembly_id=shift;
   my $assembler_name=shift;
   my $build=shift;
   my $cache_key=shift;
   my %cache_key=%$cache_key;

   my (@legend, @data);
   my ($missing_library, $library_condition);
   my (%all_account, %library_list);
   my $library_count=0;

   ####Library condition
   foreach my $lib (sort @library){
    $library_condition.=" OR " if ($library_count>0);
    $library_condition.="Library_Name=\'$lib\'";
    $library_count++;
   }

   ####Connect
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   ####Get Contig Value
   my @field=("Library_Name", "Library_Analysis_Contig_Range", "Library_Analysis_Contig_Value");
   my @table=("Library_Analysis", "Assembly", "Library");
   my @condition=("Assembly_ID=FK_Assembly__ID", "Library_ID=FK_Library__ID", "Assembly_ID=$assembly_id", "$library_condition");
   my $select=SQLdb::GetRecord(\@field, \@table, \@condition);
   my $tmp_distribution=SQLdb::ExecuteMany($dbh, $select);
   my @distribution_ref=@$tmp_distribution;

   SQLdb::Disconnect($dbh);
 
   my $flag=1;
   if (!defined $distribution_ref[0]){
      $flag=0;
   }

   my @contig_list=split('\s+', $distribution_ref[0][1]);#only put x value once
   my @data=\@contig_list;

   foreach my $reference(@distribution_ref){
      my @distribution_record=@$reference;
      my @value=split('\s+', $distribution_record[2]);

      ###Reorganizes data for table below
      for(my $arr_pos=0;$arr_pos<=$#contig_list;$arr_pos++){
         $all_account{$value[$arr_pos]}{$contig_list[$arr_pos]}=$distribution_record[0];   #read count=value[1] tig=$value[0]
      }
      push @data, \@value;
      push @legend, $distribution_record[0];
      $library_list{$distribution_record[0]}++;

   }
   foreach my $lib(sort @library){if (!defined $library_list{$lib}){$missing_library.="$lib ";}}###keep track of libraries missing from chosen assembly

   my $assembly_text=$assembler_name." build".$build;

   ###cache value for graph
   my $distr_dat=$cache_key{'key'}."distr_data";
   my $distr_ass=$cache_key{'key'}."distr_assembly";
   my $distr_leg=$cache_key{'key'}."distr_legend";

   $cache->set($distr_dat, \@data, 200);
   $cache->set($distr_ass, $assembly_text, 200);
   $cache->set($distr_leg, \@legend, 200);

   return \%all_account, $missing_library, $flag;

}

=for html <A NAME='createDistributionGraph'>

=item createDistributionGraph

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$cache_key</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub createDistributionGraph{

    my $cache_key=shift;
    my %cache_key=%$cache_key;

    ####Get the cached data
    my $distr_dat=$cache_key{'key'}."distr_data";
    my $distr_ass=$cache_key{'key'}."distr_assembly";
    my $distr_leg=$cache_key{'key'}."distr_legend";

    my $distribution_data=$cache->get($distr_dat);
    my $assembly_name=$cache->get($distr_ass);
    my $legend=$cache->get($distr_leg);

    ####Define Titles
    my $x_label="Contig Number";
    my $y_label="Number of reads";
    my $title="Position of Reads in $assembly_name";

    ####Define Graph Specifics
    my $x_tick=10;
    my @distribution_data=@$distribution_data;
    my $xdata=$distribution_data[0];
    my @xdata=@$xdata;
    my $last_index=$#xdata;
    my $x_integer=int($xdata[$last_index]/$x_tick);
    my $x_max=($x_tick*$x_integer)+$x_tick;

    my $cumulate=2;
    my $x_orient=1;

    &cumulateBarGraph($distribution_data, $title, $x_label, $y_label, $x_max, $x_tick, $legend, $cumulate, $x_orient);
}

=for html <A NAME='cumulateBarGraph'>

=item cumulateBarGraph

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$data</B>():  [Default = <B>shift</B>]<BR>
- <B>$title</B>():  [Default = <B>shift</B>]<BR>
- <B>$x_label</B>():  [Default = <B>shift</B>]<BR>
- <B>$y_label</B>():  [Default = <B>shift</B>]<BR>
- <B>$x_max</B>():  [Default = <B>shift</B>]<BR>
- <B>$x_tick</B>():  [Default = <B>shift</B>]<BR>
- <B>$legend</B>():  [Default = <B>shift</B>]<BR>
- <B>$cumulate</B>():  [Default = <B>shift</B>]<BR>
- <B>$x_orient</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub cumulateBarGraph{

    my $data=shift;
    my $title=shift;
    my $x_label=shift;
    my $y_label=shift;
    my $x_max=shift;
    my $x_tick=shift;
    my $legend=shift;
    my @legend=@$legend;
    my $cumulate=shift;
    my $x_orient=shift;

    my $graph = GD::Graph::bars->new(500, 400);

     $graph->set(
      x_label           =>  $x_label,
      y_label           =>  $y_label,
      title             =>  $title,
      x_tick_number     =>  $x_tick,
      y_min_value       =>  0,
      x_max_value       =>  $x_max,
      x_labels_vertical =>  $x_orient,
#      x_plot_values     => 1,
#     cumulate          => 1,
      overwrite         => $cumulate,         #makes cumulated bars
      tick_length       => -3
      );

   $graph->set_legend(@legend);

   my $format = $graph->export_format;
   print header("image/$format");
   binmode STDOUT;                        #to standard output
   print $graph->plot($data)->$format(); #note: there's no GIF created

}

=for html <A NAME='lineGraph'>

=item lineGraph

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$data</B>():  [Default = <B>shift</B>]<BR>
- <B>$title</B>():  [Default = <B>shift</B>]<BR>
- <B>$x_label</B>():  [Default = <B>shift</B>]<BR>
- <B>$y_label</B>():  [Default = <B>shift</B>]<BR>
- <B>$x_orient</B>():  [Default = <B>shift</B>]<BR>
- <B>$legend</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub lineGraph{

    my $data=shift;
    my $title=shift;
    my $x_label=shift;
    my $y_label=shift;
    my $x_orient=shift;
    my $legend=shift;
    my @legend=@$legend;

    my $graph = GD::Graph::linespoints->new(500, 400);

     $graph->set(
      x_label           =>  $x_label,
      y_label           =>  $y_label,
      title             =>  $title,
      x_labels_vertical =>  0,
      tick_length       => -3,
      x_labels_vertical =>  $x_orient,
      line_width        =>  2
      );

   $graph->set_legend(@legend);

   my $format_graph = $graph->export_format;
   print header("image/$format_graph");
   binmode STDOUT;                        #to standard output
   print $graph->plot($data)->$format_graph(); #note: there's no GIF created
}

=for html <A NAME='getInsertSizeData'>

=item getInsertSizeData

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembler_name</B>():  [Default = <B>shift</B>]<BR>
- <B>$build</B>():  [Default = <B>shift</B>]<BR>
- <B>$cache_key</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub getInsertSizeData{

   my $user_info=shift;
   my %user_info=%$user_info; 
   my $assembly_id=shift;
   my $assembler_name=shift;
   my $build=shift;
   my $cache_key=shift;
   my %cache_key=%$cache_key;

   ####Connect
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

    ####Get Insert Size
   my @field=("Library_Name", "Library_Analysis_Insert_Range", "Library_Analysis_Insert_Value", "Library_Analysis_Insert_Clone", "Library_Analysis_Insert_Mean", "Library_Analysis_Insert_StdDev", "Library_Analysis_Insert_Max", "Library_Analysis_Insert_Min");
   my @table=("Library_Analysis", "Assembly", "Library");
   my @condition=("Assembly_ID=FK_Assembly__ID", "Library_ID=FK_Library__ID", "Assembly_ID=$assembly_id");
   my $special_instruction="ORDER BY Library_Name";
   my $select=SQLdb::GetRecord(\@field, \@table, \@condition, $special_instruction);
   my $tmp_insert=SQLdb::ExecuteMany($dbh, $select);
   my @insert_ref=@$tmp_insert;

   ####Stats
   my %insert_list;
   my $assembly_txt=$assembler_name." Build".$build;

   foreach my $reference (@insert_ref){
      my @summary;
      my @lib_record=@$reference;

      my $insert="insert".$lib_record[0];
      my @range=split('\s+',$lib_record[1]);#this is because values are stored as a string in the database
      my @value=split('\s+',$lib_record[2]);#same here
      my @data=([@range], [@value]);

      my $cache_data=$cache_key{'key'}.$insert;
      my $cache_text=$cache_key{'key'}."insert_assembly";

      $cache->set($cache_data, \@data, 200);
      $cache->set($cache_text, $assembly_txt, 200);

      my @stats=splice(@lib_record, 3, 5);
      foreach my $element(@stats){
         $element=$format->format_number($element,1,1);
         push @summary, $element;
      }
      $insert_list{$lib_record[0]}=\@summary;
   }
   return \%insert_list;  
}

=for html <A NAME='createInsertGraph'>

=item createInsertGraph

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$insert_library</B>():  [Default = <B>shift</B>]<BR>
- <B>$cache_key</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub createInsertGraph{

   my $insert_library=shift;
   my $cache_key=shift;
   my %cache_key=%$cache_key;

   ####Get the cached data
   my $insert="insert".$insert_library;
   my $cache_data=$cache_key{'key'}.$insert;
   my $cache_text=$cache_key{'key'}."insert_assembly";

   my $insert_data=$cache->get($cache_data);
   my $assembly_info=$cache->get($cache_text);

   ####Define Titles
   my $title="Insert Size Distribution $assembly_info";
   my $y_label="Number of Clones";
   my $x_label="Insert Length (bp)";
   my @legend=($insert_library);

   my $cumulate=1;
   my $x_max=0;
   my $x_tick=0;
   my $x_orient=1;
   my $show_values=0;

   &barGraph($insert_data, $title, $x_label, $y_label, \@legend, $x_orient, $show_values);
}

####Start Addition
#-------------------------------------
sub getContigSizeData{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;

   ####Connect
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   ####Get Contig Size
   my @field=("Contig_Size");
   my @table=("Contig", "Assembly");
   my @condition=("Assembly_ID=FK_Assembly__ID", "Assembly_ID=$assembly_id");
   my $select=SQLdb::GetRecord(\@field, \@table, \@condition);
   my $tmp_size=SQLdb::ExecuteMany($dbh, $select);

   return $tmp_size;
}

#-------------------------------------
sub getSupercontigSizeData{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;

   ####Connect
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   ####Get Contig Size
   my @field=("Supercontig_Size");
   my @table=("Supercontig", "Assembly");
   my @condition=("Assembly_ID=FK_Assembly__ID", "Assembly_ID=$assembly_id");
   my $select=SQLdb::GetRecord(\@field, \@table, \@condition);
   my $tmp_size=SQLdb::ExecuteMany($dbh, $select);

   return $tmp_size;
}

#-------------------------------------
sub calculateSequenceDistribution{

   my $assembler_name=shift;
   my $build=shift;
   my $cache_key=shift;
   my %cache_key=%$cache_key;
   my $tmp_size=shift;
   my @size_ref=@$tmp_size;
   my $REDUCTION_RATIO=shift;

   ####Stats

   my $assembly_txt=$assembler_name." Build".$build;

   my ($hun, $tho, $ten, $hth, $mil)=(0,0,0,0,0);
   my ($b_hun, $b_tho, $b_ten, $b_hth, $b_mil)=(0,0,0,0,0);
   my ($total_size, $total_count)=(0,0);

   foreach my $reference (@size_ref){
    
     my @size=@$reference;
  
     $total_size+=$size[0];
     $total_count++;
  
     if($size[0]>0 && $size[0]<1000){
        $hun++;
        $b_hun+=$size[0];
     }elsif($size[0]>=1000 && $size[0]<10000){
        $tho++;
        $b_tho+=$size[0];
     }elsif($size[0]>=10000 && $size[0]<100000){
        $ten++;
        $b_ten+=$size[0];
     }elsif($size[0]>=100000 && $size[0]<1000000){
        $hth++;
        $b_hth+=$size[0];
     }elsif($size[0]>=1000000){
        $mil++;
        $b_mil+=$size[0];
     }
   }
   my @r1=("<1kb", $format->format_number($hun), $format->format_number($b_hun));
   my @r2=("1-10kb", $format->format_number($tho), $format->format_number($b_tho));
   my @r3=("10-100kb", $format->format_number($ten), $format->format_number($b_ten));
   my @r4=("100kb-1Mb", $format->format_number($hth), $format->format_number($b_hth));
   my @r5=(">1Mb", $format->format_number($mil), $format->format_number($b_mil));
   my @r6=("TOTAL", $format->format_number($total_count), $format->format_number($total_size));

   my @data_orig=(\@r1, \@r2, \@r3, \@r4, \@r5, \@r6);

   $b_hun/=$REDUCTION_RATIO;##this is because the data doesn't 'fit' in the graph with y1
   $b_tho/=$REDUCTION_RATIO;
   $b_ten/=$REDUCTION_RATIO;
   $b_hth/=$REDUCTION_RATIO;
   $b_mil/=$REDUCTION_RATIO;

   my @x_sc=("<1kb", "1-10kb", "10-100kb", "100kb-1M", ">1M");
   my @y_sc=($hun, $tho, $ten, $hth, $mil);
   my @y_sc_fit=($b_hun, $b_tho, $b_ten, $b_hth, $b_mil);

   my @data_graph=(\@x_sc, \@y_sc, \@y_sc_fit);

   my $cache_data=$cache_key{'key'}."sequence_distribution_data";
   my $cache_text=$cache_key{'key'}."sequence_distribution_text";

   $cache->set($cache_data, \@data_graph, 200);
   $cache->set($cache_text, $assembly_txt, 200);

   return \@data_orig;
}

#-------------------------------------
sub createContigDistributionGraph{

   my $REDUCTION_RATIO=shift;
   my $sequence_type=shift;
   my $cache_key=shift;
   my %cache_key=%$cache_key;

   ####Get the cached data
   my $cache_data=$cache_key{'key'}."sequence_distribution_data";
   my $cache_text=$cache_key{'key'}."sequence_distribution_text";

   my $sequence_distribution_data=$cache->get($cache_data);
   my $assembly_info=$cache->get($cache_text);

   ####Define Titles
   my $title="$sequence_type Size Distribution $assembly_info";
   my $y_label="Amount";
   my $x_label="Insert Length (bp)";
   $sequence_type.="s";
   my @legend=("Number of $sequence_type","Number of Bases X $REDUCTION_RATIO");

   my $cumulate=1;
   my $x_max=0;
   my $x_tick=0;
   my $x_orient=1;
   my $show_values=0;

   &barGraph($sequence_distribution_data, $title, $x_label, $y_label, \@legend, $x_orient, $show_values);
}

#####End Additions





=for html <A NAME='barGraph'>

=item barGraph

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$data</B>():  [Default = <B>shift</B>]<BR>
- <B>$title</B>():  [Default = <B>shift</B>]<BR>
- <B>$x_label</B>():  [Default = <B>shift</B>]<BR>
- <B>$y_label</B>():  [Default = <B>shift</B>]<BR>
- <B>$legend</B>():  [Default = <B>shift</B>]<BR>
- <B>$x_orient</B>():  [Default = <B>shift</B>]<BR>
- <B>$show_values</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub barGraph{

    my $data=shift;
    my $title=shift;
    my $x_label=shift;
    my $y_label=shift;
    my $legend=shift;
    my @legend=@$legend;
    my $x_orient=shift;
    my $show_values=shift;

    my $graph = GD::Graph::bars->new(500, 400);

     $graph->set(
      x_label           =>  $x_label,
      y_label           =>  $y_label,
      title             =>  $title,
      y_min_value       =>  0,
      x_labels_vertical =>  $x_orient,
      tick_length       => -3,
      long_ticks        =>  1,
      x_ticks           =>  0
      #show_values	=>  $show_values
      );

   $graph->set_legend(@legend);

   my $format = $graph->export_format;
   print header("image/$format");
   binmode STDOUT;                        #to standard output
   
   print $graph->plot($data)->$format(); #note: there's no GIF created

}

=for html <A NAME='getBlastConfig'>

=item getBlastConfig

=for html
Blast #######################<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$blastable_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

################### Blast #######################

#-------------------------------------
sub getBlastConfig{

   my $user_info=shift;
   my $assembly_id=shift;
   my $blastable_id=shift;
   my $gene_finder_id=shift;

   my %blast_config;

   my ($tmp_blast, $tmp_tig, $tmp_orf)=&getOrfContigFileConfig($user_info, $assembly_id, $blastable_id, $gene_finder_id);
   my @blast_dir=@$tmp_blast;
   my @contig_file=@$tmp_tig;
   my @orf_file=@$tmp_orf;

   $blast_config{'contig'}="/$blast_dir[0]/$assembly_id/$contig_file[0]";
   $blast_config{'orf'}="/$blast_dir[0]/$assembly_id/$orf_file[0]"; 
   $blast_config{'orf_cds'}="/$blast_dir[0]/$assembly_id/$orf_file[1]";
   $blast_config{'everygene'}="/$blast_dir[0]/$orf_file[2]";

   return \%blast_config;
}

=for html <A NAME='getDownloadConfig'>

=item getDownloadConfig

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$blastable_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$htdocpath</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub getDownloadConfig{

   my $user_info=shift;
   my $assembly_id=shift;
   my $blastable_id=shift;
   my $gene_finder_id=shift;
   my $htdocpath=shift;

   my %download_config;

   my ($tmp_blast, $tmp_tig, $tmp_orf)=&getOrfContigFileConfig($user_info, $assembly_id, $blastable_id, $gene_finder_id);
   my @blast_dir=@$tmp_blast;
   my @contig_file=@$tmp_tig;
   my @orf_file=@$tmp_orf;

   $download_config{'contig'}="$htdocpath/$assembly_id/$contig_file[0]";
   $download_config{'orf'}="$htdocpath/$assembly_id/$orf_file[0]";
   $download_config{'orf_cds'}="$htdocpath/$assembly_id/$orf_file[1]";

   return \%download_config;
}

=for html <A NAME='getOrfContigFileConfig'>

=item getOrfContigFileConfig

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$blastable_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub getOrfContigFileConfig{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;
   my $blastable_id=shift;
   my $gene_finder_id=shift;

   ####Connect
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   ####Get Orf file name
   my @field=("Gene_Finder_Protein_File", "Gene_Finder_CDS_File", "Gene_Finder_EveryGene_File");
   my @table=("Gene_Finder");
   my @condition=("Gene_Finder_ID=$gene_finder_id");
   my $select=SQLdb::GetRecord(\@field, \@table, \@condition);
   my $tmp_orf=SQLdb::ExecuteUnique($dbh, $select);

   ####Get Contig file name
   my @tigfield=("Config_Tig_Fasta_File");
   my @tigtable=("Config", "Assembler", "Assembly");
   my @tigcondition=("Assembler_ID=Assembly.FK_Assembler__ID", "Assembler_ID=Config.FK_Assembler__ID", "Assembly_ID=$assembly_id");
   my $tigselect=SQLdb::GetRecord(\@tigfield, \@tigtable, \@tigcondition);
   my $tmp_tig=SQLdb::ExecuteUnique($dbh, $tigselect);

   ####Get Location of blast files
   my @blastfield=("Blastable_DB_Location");
   my @blasttable=("Blastable_DB");
   my @blastcondition=("Blastable_DB_ID=$blastable_id");
   my $blastselect=SQLdb::GetRecord(\@blastfield, \@blasttable, \@blastcondition);
   my $tmp_blast=SQLdb::ExecuteUnique($dbh, $blastselect);
   SQLdb::Disconnect($dbh);

   return $tmp_blast, $tmp_tig, $tmp_orf;
}

=for html <A NAME='getGapData'>

=item getGapData

=for html
GAP #######################<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembler</B>():  [Default = <B>shift</B>]<BR>
- <B>$build</B>():  [Default = <B>shift</B>]<BR>
- <B>$cache_key</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

################### GAP #######################

#-------------------------------------
sub getGapData{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;
   my $assembler=shift;
   my $build=shift;
   my $cache_key=shift;
   my %cache_key=%$cache_key;

   my %image;

   ####Connect to db
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   my @gap_field=("Clone_Name", "Gap_Left_Contig_Number", "Gap_Right_Contig_Number", "Gap_Size", "Gap_Clone_Misassembly", "Gap_Left_Contig_Inversion", "Gap_Right_Contig_Inversion");
   my @gap_table=("Gap", "Clone", "Assembly");
   my @gap_condition=("Clone_ID=FK_Clone__ID", "Assembly_ID=FK_Assembly__ID", "Assembly_ID=$assembly_id");
   my $instruction="ORDER BY Gap_Left_Contig_Number, Gap_Right_Contig_Number, Clone_Name";
   my $select_gap=SQLdb::GetRecord(\@gap_field, \@gap_table, \@gap_condition, $instruction);
   #print "$select_gap";
   my $tmp_gap=SQLdb::ExecuteMany($dbh, $select_gap);
   SQLdb::Disconnect($dbh);

   ####Images related to gap info
   $image{1}{1}="rArB.PNG";
   $image{1}{0}="rAB.PNG";
   $image{0}{1}="ArB.PNG";
   $image{0}{0}="AB.PNG";

   my @gap=@$tmp_gap;
   my (%gap_list, %gap_count);

   ####Prepare ALL the Gap data for that assembly
   foreach my $ref(@gap){
      my @record=@$ref;
      my $gap=$record[1]."-".$record[2];
      $gap_list{$gap}{$record[0]}{'size'}=$record[3];
      if ($record[4]){
         $gap_list{$gap}{$record[0]}{'misassembly'}="misassembly?";
      }else{
         if ($record[3]<0){
            $gap_list{$gap}{$record[0]}{'misassembly'}="potential overlap";
         }else{
            $gap_list{$gap}{$record[0]}{'misassembly'}="-";
         }
      }
      $gap_list{$gap}{$record[0]}{'image'}=$image{$record[5]}{$record[6]};
      $gap_count{$gap}++;
   }

   my (%classify_count, %clone_count, %gap_stats);
   my @positive_gap=();
   my @negative_gap=();
   my @gap_sizes=();
   my ($less_zero, $hundred_kb, $thousand_kb, $fivethousand_kb, $tenthousand_kb)=(0,0,0,0,0);
   my ($less_zero_single, $hundred_kb_single, $thousand_kb_single, $fivethousand_kb_single, $tenthousand_kb_single)=(0,0,0,0,0);

   foreach my $gap (keys %gap_list){
      my $count=$gap_count{$gap};
      $classify_count{$count}++;
      my $tmp_clone_list=$gap_list{$gap};
      my %clone_list=%$tmp_clone_list;

      foreach my $clone(keys %clone_list){
         if ($clone_list{$clone}{'size'} >= 0){
            push @positive_gap, $clone_list{$clone}{'size'};
         }else{
            push @negative_gap, $clone_list{$clone}{'size'};
         }
         $clone_count{$count}{$gap}{$clone}{'size'}=$format->format_number($clone_list{$clone}{'size'});
         $clone_count{$count}{$gap}{$clone}{'misassembly'}=$clone_list{$clone}{'misassembly'};
         $clone_count{$count}{$gap}{$clone}{'image'}=$clone_list{$clone}{'image'};
      }

      my $count_negative=$#negative_gap+1;
      if($count_negative==$count){###all gaps are negative
         @gap_sizes=@negative_gap;
         $gap_stats{$count}{$gap}{'type'}="Potential Overlap";
      }else{###mix of positive and negative
         @gap_sizes=@positive_gap;
         $gap_stats{$count}{$gap}{'type'}="Potential Gap";
      }

      ####Stats on Average gap size
      my $stat=Statistics::Descriptive::Full->new();
      $stat->add_data(@gap_sizes);

      if ($stat->mean()<0){
          $less_zero++ if ($count>1);
          $less_zero_single++ if ($count>=1);
      }elsif ($stat->mean()>=0 && $stat->mean()<1000){
          $hundred_kb++  if ($count>1);
          $hundred_kb_single++  if ($count>=1);
      }elsif ($stat->mean()>=1000 && $stat->mean()<5000){
          $thousand_kb++  if ($count>1);
          $thousand_kb_single++  if ($count>=1);
      }elsif ($stat->mean()>=5000 && $stat->mean()<10000){
          $fivethousand_kb++  if ($count>1);
          $fivethousand_kb_single++  if ($count>=1);
      }elsif ($stat->mean()>=10000){
          $tenthousand_kb++  if ($count>1);
          $tenthousand_kb_single++  if ($count>=1);
      }

      $gap_stats{$count}{$gap}{'mean'}=$format->format_number($stat->mean(),1,1);
      $gap_stats{$count}{$gap}{'max'}=$format->format_number($stat->max());
      $gap_stats{$count}{$gap}{'min'}=$format->format_number($stat->min());
      $gap_stats{$count}{$gap}{'count'}=$format->format_number($stat->count());
      $gap_stats{$count}{$gap}{'stdev'}=$format->format_number($stat->standard_deviation(),1,1);
      @positive_gap=();
      @negative_gap=();
      @gap_sizes=();
   }
   my @gapstat_x=("<0kb", "0-1kb", "1-5kb", "5-10kb", ">10kb");
   my @gapstat_y=($less_zero, $hundred_kb, $thousand_kb, $fivethousand_kb, $tenthousand_kb);
   my @gapstat_all=($less_zero_single, $hundred_kb_single, $thousand_kb_single, $fivethousand_kb_single, $tenthousand_kb_single);

   my @data=([@gapstat_x], [@gapstat_y], [@gapstat_all]);

   my $concat="$assembler"." Build".$build;

   ####Specific Session id as key
   my $span_key=$cache_key{'key'}."spanning_clone";
   my $stat_key=$cache_key{'key'}."clone_stats";
   my $stat_data_key=$cache_key{'key'}."gapstatdata";
   my $assembly_key=$cache_key{'key'}."gap_current_assembly";

   $cache->set($span_key, \%clone_count, "10 minutes");
   $cache->set($stat_key, \%gap_stats, "10 minutes");
   $cache->set($stat_data_key, \@data, "10 minutes");
   $cache->set($assembly_key, $concat, "10 minutes");

   return \%classify_count;
}

=for html <A NAME='createGapDistribution'>

=item createGapDistribution

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$cache_key</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub createGapDistribution{

   my $cache_key=shift;
   my %cache_key=%$cache_key;

   ####Get Cache Data
   my $stat_data_key=$cache_key{'key'}."gapstatdata";
   my $assembly_key=$cache_key{'key'}."gap_current_assembly";

   my $gap_data=$cache->get($stat_data_key);
   my $gap_assembly=$cache->get($assembly_key);

   ####Define Titles
   my $title="Gap Size Distribution $gap_assembly";
   my $y_label="Amount of Gaps";
   my $x_label="Gap Sizes (bp)";
   my @legend=("Gap Spanned by 2+ clones","Gap Spanned by 1+ clones");

   my $cumulate=1;
   my $x_max=0;
   my $x_tick=0;
   my $x_orient=0;
   my $show_values=1;

   &barGraph($gap_data, $title, $x_label, $y_label, \@legend, $x_orient, $show_values);

}

=for html <A NAME='getOverlapData'>

=item getOverlapData

=for html
Overlap #######################<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$cache_key</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

################### Overlap #######################

#-------------------------------------
sub getOverlapData{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;
   my $cache_key=shift;
   my %cache_key=%$cache_key;

   ####Connect to database
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   my @gap_field=("Clone_Name", "Overlap_Contig_Number", "Overlap_Size");
   my @gap_table=("Overlap", "Clone", "Assembly");
   my @gap_condition=("Clone_ID=FK_Clone__ID", "Assembly_ID=FK_Assembly__ID", "Assembly_ID=$assembly_id");
   my $instruction="ORDER BY Overlap_Contig_Number, Clone_Name";
   my $select_overlap=SQLdb::GetRecord(\@gap_field, \@gap_table, \@gap_condition, $instruction);
   my $tmp_overlap=SQLdb::ExecuteMany($dbh, $select_overlap);
   SQLdb::Disconnect($dbh);

   my @overlap=@$tmp_overlap;
   my (%overlap_count, %overlap_list);

   foreach my $ref(@overlap){
      my @record=@$ref;
      $overlap_list{$record[1]}{$record[0]}{'size'}=$format->format_number($record[2]);
      $overlap_count{$record[1]}++;
   }

   ####cache key
   my $overlap_key=$cache_key{'key'}."overlap";
   $cache->set($overlap_key, \%overlap_list, "10 minutes");

   return \%overlap_count;
}

=for html <A NAME='getMapScrollBoxInfo'>

=item getMapScrollBoxInfo

=for html
MAP VIEWER #######################<BR>Retrieve all map contigs associated with a specific map_id<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$map_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

################### MAP VIEWER #######################

#-------------------------------------
sub getMapScrollBoxInfo{

   ###Retrieve all map contigs associated with a specific map_id
   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;
   my $map_id=shift;

   ####Connect to database
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   ####all map contig
   my @tig_field=("Map_Contig_Number", "Map_Contig_Size");
   my @tig_table=("Map_Contig", "Map");
   my @tig_condition=("Map_ID=FK_Map__ID", "Map_ID=$map_id");
   my $tig_instruction="ORDER BY Map_Contig_Number";
   my $select_tig=SQLdb::GetRecord(\@tig_field, \@tig_table, \@tig_condition, $tig_instruction);
   my $tmp_tig=SQLdb::ExecuteMany($dbh, $select_tig);

   SQLdb::Disconnect($dbh);

   my ($maptig_scroll, $contig_size)=processListInfo($tmp_tig);

   return $maptig_scroll;
}

=for html <A NAME='initializeMapViewerData'>

=item initializeMapViewerData

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
- None<BR>
<BR>

=cut

#-------------------------------------
sub initializeMapViewerData{

   my $ycenter=10;    #0
   my $ytop=5;
   my $ybot=15;
   my $xleft_1=5;
   my $xleft_2=15;
   my $xleft_3=25;    #5
   my $xmiddle_l=335;
   my $xmiddle_r=345;
   my $xright_1=655;
   my $xright_2=665;
   my $xright_3=675;  #10
   my $xmid=340;
   my $width=680;
   my $length=3000;
   my $x_all=20;
   my $sc_y=65;       #15
   my $tig_y=85;
   my $rd_y=105;
   my $thick_sc_y=8;
   my $thick_tig_y=5;
   my $thick_rd_y=1;  #20
   my $x_fix=20;
   my $x_legend1=280;
   my $x_legend2=380;
   my $x_legend3=480;
   my $x_legend4=580; #25
   my $y_legend1=20;   
   my $y_legend2=30;
   my $y_legend3=40;  

   my @graph_value=($ycenter, $ytop, $ybot, $xleft_1, $xleft_2, $xleft_3, $xmiddle_l, $xmiddle_r, $xright_1, $xright_2, $xright_3, $xmid, $width, $length, $x_all, $sc_y, $tig_y, $rd_y, $thick_sc_y, $thick_tig_y, $thick_rd_y, $x_fix, $x_legend1, $x_legend2, $x_legend3, $x_legend4, $y_legend1, $y_legend2, $y_legend3);
   return \@graph_value;
}

=for html <A NAME='getSupertigIntrinsicData'>

=item getSupertigIntrinsicData

=for html
gather supercontig coordinates from SAMdb<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
- None<BR>
<BR>

=cut

#-------------------------------------
sub getSupertigIntrinsicData{

   #gather supercontig coordinates from SAMdb
   my ($user_info, $assembly_id, $map_id, $maptig_selection, $buried)=@_;

   ####Connect to database
   my $dbh=SQLdb::Initialize($user_info->{'password'}, $user_info->{'username'}, $user_info->{'assembly_database'}, $user_info->{'assembly_host'});

   ####Get Supercontig Order, Size and Gap
   my @field=("Supercontig_Number", "Ultracontig_Scaffold_PrecedingGap", "Ultracontig_Scaffold_Size", "Ultracontig_Scaffold_Orientation");
   my @table=("Supercontig", "Ultracontig", "Map", "Map_Contig", "Assembly");
   my @condition=("Assembly_ID=FK_Assembly__ID", "Map_ID=FK_Map__ID", "Supercontig_ID=FK_Supercontig__ID", "Map_Contig_ID=FK_Map_Contig__ID", "Map_Contig_Number=$maptig_selection", "Assembly_ID=$assembly_id", "Map_ID=$map_id", "Ultracontig_Scaffold_Buried=$buried");
   my $instruction="ORDER BY Ultracontig_Scaffold_Order";
   my $select=SQLdb::GetRecord(\@field, \@table, \@condition, $instruction);
   my $supertig_arr=SQLdb::ExecuteMany($dbh, $select);

   SQLdb::Disconnect($dbh);

   return $supertig_arr;
}

=for html <A NAME='getContigCoord'>

=item getContigCoord

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
- None<BR>
<BR>

=cut

#-------------------------------------
sub getContigCoord{

   my ($user_info, $assembly_id, $map_id, $maptig_selection, $buried)=@_;

   my $dbh=SQLdb::Initialize($user_info->{'password'}, $user_info->{'username'}, $user_info->{'assembly_database'}, $user_info->{'assembly_host'});

   ####Get Contig Data
   my @field=("Supercontig_Number", "Contig_Coord_Number", "Contig_Coord_Start", "Contig_Coord_Stop"); 
   my @table=("Assembly", "Map", "Map_Contig", "Ultracontig", "Supercontig", "Contig_Layout", "Contig_Coord");
   my @condition=("Assembly_ID=FK_Assembly__ID", "Map_ID=FK_Map__ID", "Supercontig_ID=FK_Supercontig__ID", "Map_Contig_ID=FK_Map_Contig__ID", "Ultracontig_ID=FK_Ultracontig__ID", "Contig_Coord_ID=FK_Contig_Coord__ID", "Map_Contig_Number=$maptig_selection", "Assembly_ID=$assembly_id", "Map_ID=$map_id", "Ultracontig_Scaffold_Buried=$buried");
   my $instruction="ORDER BY Ultracontig_Scaffold_Order";
   my $select=SQLdb::GetRecord(\@field, \@table, \@condition, $instruction);
   my $contig_arr=SQLdb::ExecuteMany($dbh, $select);

   SQLdb::Disconnect($dbh);

   return $contig_arr;
}

=for html <A NAME='getReadCoord'>

=item getReadCoord

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
- None<BR>
<BR>

=cut

#-------------------------------------
sub getReadCoord{

   my ($user_info, $assembly_id, $map_id, $maptig_selection, $buried)=@_;

   my $dbh=SQLdb::Initialize($user_info->{'password'}, $user_info->{'username'}, $user_info->{'assembly_database'}, $user_info->{'assembly_host'});
   
   ####Get Read Data
   my @field=("Supercontig_Number", "Read_Coord_CloneName", "Read_Coord_AltCloneName", "Read_Coord_Direction", "Read_Coord_Start", "Read_Coord_Stop", "Read_Coord_Orientation", "Read_Coord_Order");
   my @table=("Assembly", "Map", "Map_Contig", "Ultracontig", "Supercontig", "Read_Layout", "Read_Coord");
   my @condition;

   if ($buried){#includes buried clone
      @condition=("Assembly_ID=FK_Assembly__ID", "Map_ID=FK_Map__ID", "Supercontig_ID=FK_Supercontig__ID", "Map_Contig_ID=FK_Map_Contig__ID", "Ultracontig_ID=FK_Ultracontig__ID", "Read_Coord_ID=FK_Read_Coord__ID", "Map_Contig_Number=$maptig_selection", "Assembly_ID=$assembly_id", "Map_ID=$map_id", "Ultracontig_Scaffold_Buried=$buried");
   }else{       #does not include buried clone
      @condition=("Assembly_ID=FK_Assembly__ID", "Map_ID=FK_Map__ID", "Supercontig_ID=FK_Supercontig__ID", "Map_Contig_ID=FK_Map_Contig__ID", "Ultracontig_ID=FK_Ultracontig__ID", "Read_Coord_ID=FK_Read_Coord__ID", "Map_Contig_Number=$maptig_selection", "Assembly_ID=$assembly_id", "Map_ID=$map_id", "Ultracontig_Scaffold_Buried=$buried", "Read_Coord_Buried=$buried");
   }

   my $instruction="ORDER BY Ultracontig_Scaffold_Order, Read_Coord_Order";
   my $select=SQLdb::GetRecord(\@field, \@table, \@condition, $instruction);
   my $read_arr=SQLdb::ExecuteMany($dbh, $select);

   #print "$select";
   SQLdb::Disconnect($dbh);

   return $read_arr;
}

=for html <A NAME='rearrangeMapCoord'>

=item rearrangeMapCoord

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
- None<BR>
<BR>

=cut

#-------------------------------------
sub rearrangeMapCoord{
   
   my ($supertig_arr, $contig_arr, $read_arr)=@_;
   my @supertig_arr=@$supertig_arr;
   my @contig_arr=@$contig_arr;
   my @read_arr=@$read_arr;

   my $sc_start_coord=0;
   my $sc_end_coord=1;
   my ($supertig_coord, $contig_coord, $read_coord);

   #########Supercontig
   foreach my $record (@supertig_arr){
      $sc_start_coord=$sc_end_coord+$record->[1];    #preceeding gap
      $sc_end_coord=$sc_start_coord+$record->[2];    #sc size

      $supertig_coord->{$record->[0]}{'start'}=$sc_start_coord;
      $supertig_coord->{$record->[0]}{'stop'}=$sc_end_coord;
      $supertig_coord->{$record->[0]}{'orientation'}=$record->[3];
      $supertig_coord->{$record->[0]}{'order'}=$record->[4];
   }
   my $ultracontig_size=$format->format_number($sc_end_coord);

   ##########Contig
   foreach my $record (@contig_arr){

      if (! $supertig_coord->{$record->[0]}{'orientation'}){###reverse complement
         $contig_coord->{$record->[0]}{$record->[1]}{'stop'}=($supertig_coord->{$record->[0]}{'stop'})-($record->[2]);###essential for GD (start must always be smaller than stop)
         $contig_coord->{$record->[0]}{$record->[1]}{'start'}=($supertig_coord->{$record->[0]}{'stop'})-($record->[3]);
      }else{
         $contig_coord->{$record->[0]}{$record->[1]}{'start'}=($supertig_coord->{$record->[0]}{'start'})+($record->[2]);
         $contig_coord->{$record->[0]}{$record->[1]}{'stop'}=($supertig_coord->{$record->[0]}{'start'})+($record->[3]);
      }
   }

   ############Read(1st step:treat as separate entity i.e. read as finish object)
   foreach my $record (@read_arr){
     
      if (! $supertig_coord->{$record->[0]}{'orientation'}){#sc is flipped
         $read_coord->{$record->[7]}{$record->[1]}{$record->[3]}{'stop'}=($supertig_coord->{$record->[0]}{'stop'})-($record->[4]);
         $read_coord->{$record->[7]}{$record->[1]}{$record->[3]}{'start'}=($supertig_coord->{$record->[0]}{'stop'})-($record->[5]);
         if ($record->[6]){ #change the read orientation
            $record->[6]=0 
         }else{
            $record->[6]=1;
         }
      }else{
        $read_coord->{$record->[7]}{$record->[1]}{$record->[3]}{'start'}=($supertig_coord->{$record->[0]}{'start'})+($record->[4]);
        $read_coord->{$record->[7]}{$record->[1]}{$record->[3]}{'stop'}=($supertig_coord->{$record->[0]}{'start'})+($record->[5]);         
      }
      $read_coord->{$record->[7]}{$record->[1]}{$record->[3]}{'orientation'}=$record->[6];
      $read_coord->{$record->[7]}{$record->[1]}{'alternate_name'}=$record->[2];
      $read_coord->{$record->[7]}{$record->[1]}{$record->[3]}{'supercontig'}=$record->[0];
   }

   return $supertig_coord, $contig_coord, $read_coord, $ultracontig_size;   
}

=for html <A NAME='computeMapImage'>

=item computeMapImage

=for html
Will generate the map image<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
- None<BR>
<BR>

=cut

#-------------------------------------
sub computeMapImage{

   ###Will generate the map image
   my ($maptig_selection, $zoom, $horizmove, $ultracontig_size, $supertig_coord, $contig_coord, $read_coord, $clone_name, $graph_value)=@_;
 
   my $image=&initializeDrawing($graph_value->[12], $graph_value->[13]); #Define Drawing Object
   my $color=&initializeColor($image);

   $image->interlaced('true');

   ####GRID
   for(my $xpos;$xpos<$graph_value->[12];$xpos+=10){
       $image->line($xpos,0,$xpos,$graph_value->[13],$color->{lightgrey});#makes grid
   }

   my $x_pos=$graph_value->[14]+$horizmove;
   my $fingerprint_size=0;

   ###BAR
   &drawRectangle($image, 0, $graph_value->[12]-1, $graph_value->[21],30,$color->{lightgrey});

   ###DRAW FRAME
   $image->rectangle(0,0,$graph_value->[12]-1,$graph_value->[13]-1,$color->{black});

   ####TEXT
   my $contig_name_text="Map Contig ".$maptig_selection." (based on fingerprint)";   $image->string(gdSmallFont,$graph_value->[21], $graph_value->[26], $contig_name_text,$color->{black});
   my $fingermap_text="Approx Contig Size: ".$ultracontig_size." bp";
   $image->string(gdSmallFont,$graph_value->[21], $graph_value->[27], $fingermap_text,$color->{black});

   ####LEGEND
   ###Supercontig
   $image->string(gdSmallFont,$graph_value->[22], $graph_value->[26], "Supercontig",$color->{black});
   &drawRectangle($image, $graph_value->[22], $graph_value->[22]+5, $graph_value->[27],$graph_value->[18],$color->{navy});
   $image->string(gdSmallFont,$graph_value->[22]+7, $graph_value->[27], " 5'->3'",$color->{black});

   &drawRectangle($image, $graph_value->[22], $graph_value->[22]+5, $graph_value->[28],$graph_value->[18], $color->{blue});
   $image->string(gdSmallFont,$graph_value->[22]+7, $graph_value->[28], " 3'->5'",$color->{black});

   ###Contig
   $image->string(gdSmallFont,$graph_value->[23], $graph_value->[26], "Contig",$color->{black});
   &drawRectangle($image, $graph_value->[23], $graph_value->[23]+5, $graph_value->[27],$graph_value->[19],$color->{navy});
   $image->string(gdSmallFont,$graph_value->[23]+7, $graph_value->[27], " 5'->3'",$color->{black});

   &drawRectangle($image, $graph_value->[23], $graph_value->[23]+5, $graph_value->[28],$graph_value->[19], $color->{blue});
   $image->string(gdSmallFont,$graph_value->[23]+7, $graph_value->[28], " 3'->5'",$color->{black});

   ###Read
   $image->string(gdSmallFont,$graph_value->[24], $graph_value->[26], "Seq. Read",$color->{black});
   &drawRectangle($image, $graph_value->[24], $graph_value->[24]+2, $graph_value->[27]+5,$graph_value->[20], $color->{forrest});
   &drawRectangle($image, $graph_value->[24]+20, $graph_value->[24]+22, $graph_value->[27]+5,$graph_value->[20], $color->{forrest});

   ###Clone
   $image->string(gdSmallFont,$graph_value->[25], $graph_value->[26], "Clones",$color->{black});
   &drawRectangle($image, $graph_value->[25], $graph_value->[25]+15, $graph_value->[27]+5,$graph_value->[20], $color->{salmon});
   $image->string(gdSmallFont,$graph_value->[25]+10, $graph_value->[27], " normal",$color->{black});
   &drawRectangle($image, $graph_value->[25], $graph_value->[25]+15, $graph_value->[28]+5,$graph_value->[20], $color->{purple});
   $image->string(gdSmallFont,$graph_value->[25]+10, $graph_value->[28], " illogical",$color->{black});

   ###DRAW NAVIGATION BUTTON
   ###DRAW ARROWS

   # make left first triangle
   my $toptri = new GD::Polygon;
   $toptri->addPt($graph_value->[3],$graph_value->[0]);
   $toptri->addPt($graph_value->[4],$graph_value->[1]);
   $toptri->addPt($graph_value->[4],$graph_value->[2]);
   # draw the polygon, filling it with a color
   $image->filledPolygon($toptri,$color->{grey});

   #make left second triangle
   my $sectoptri = new GD::Polygon;
   $sectoptri->addPt($graph_value->[4],$graph_value->[0]);
   $sectoptri->addPt($graph_value->[5],$graph_value->[1]);
   $sectoptri->addPt($graph_value->[5],$graph_value->[2]);
   # draw the polygon, filling it with a color
   $image->filledPolygon($sectoptri,$color->{grey});

   # make right first triangle
   my $bottri = new GD::Polygon;
   $bottri->addPt($graph_value->[10],$graph_value->[0]);
   $bottri->addPt($graph_value->[9],$graph_value->[1]);
   $bottri->addPt($graph_value->[9],$graph_value->[2]);
   # draw the polygon, filling it with a color
   $image->filledPolygon($bottri,$color->{grey});

   #make right second triangle
   my $secbottri = new GD::Polygon;
   $secbottri->addPt($graph_value->[9],$graph_value->[0]);
   $secbottri->addPt($graph_value->[8],$graph_value->[1]);
   $secbottri->addPt($graph_value->[8],$graph_value->[2]);
   # draw the polygon, filling it with a color
   $image->filledPolygon($secbottri,$color->{grey});

   #make center diamond
   my $diamond = new GD::Polygon;
   $diamond->addPt($graph_value->[11],$graph_value->[1]);
   $diamond->addPt($graph_value->[7],$graph_value->[0]);
   $diamond->addPt($graph_value->[11],$graph_value->[2]);
   $diamond->addPt($graph_value->[6],$graph_value->[0]);

   # draw the polygon, filling it with a color
   $image->filledPolygon($diamond,$color->{grey});

   ###Draw Supercontig
   if (defined  %$supertig_coord && defined %$read_coord){

    my %supertig_coord=%$supertig_coord;
    my %read_coord=%$read_coord;
    my $ultracontig_size;

    foreach my $sc (sort {$supertig_coord{$a}{'start'}<=>$supertig_coord{$b}{'start'}} keys %supertig_coord){
      my $sc_start=($supertig_coord{$sc}{'start'}/$zoom)+$x_pos;
      my $sc_end=($supertig_coord{$sc}{'stop'}/$zoom)+$x_pos;
      my $tmp_color;
      if($supertig_coord{$sc}{'orientation'}==1){$tmp_color=$color->{navy};}else{$tmp_color=$color->{blue}};
      &drawRectangle($image, $sc_start, $sc_end, $graph_value->[15], $graph_value->[18], $tmp_color, $sc, $color->{black});

      my $tmp_contig=$contig_coord->{$sc};
      my %contig=%$tmp_contig;
      my $count_tig;

      foreach my $tig (sort {$contig{$a}{'start'}<=>$contig{$b}{'start'}} keys %contig){
         $count_tig++;
         my $tig_start=($contig{$tig}{'start'}/$zoom)+$x_pos;
         my $tig_end=($contig{$tig}{'stop'}/$zoom)+$x_pos;
         
         &drawRectangle($image, $tig_start, $tig_end, $graph_value->[16], $graph_value->[19], $tmp_color);

         my $odd=$count_tig%2;
         if($odd){
            $image->string(gdTinyFont,$tig_start, $graph_value->[16]-10, $tig,$color->{black});
         }else{
           $image->string(gdTinyFont,$tig_start, $graph_value->[16]+8, $tig,$color->{black});
         }
      }          
   }

   ###Draw Reads
   ###assess whether reads span different supercontigs
   ###and whether pairs are illogical

   my $rdypos=$graph_value->[17];
   my $type_color=$color->{'salmon'};
   my $name;
   foreach my $order (sort {$a<=>$b} keys %read_coord){

    my $tmp_clone=$read_coord{$order};
    my %clone=%$tmp_clone;
    foreach my $clone(keys %clone){ 

      ####both pairs represented for a clone
      if(defined $clone{$clone}{'F'} && defined $clone{$clone}{'R'}){
         ####naming
         if ($clone_name){
            $name=$read_coord{$order}{$clone}{'alternate_name'};
         }else{
            $name=$clone;
         }

         ####on different supercontigs
         if ($read_coord{$order}{$clone}{'F'}{'supercontig'} != $read_coord{$order}{$clone}{'R'}{'supercontig'}){
            $read_coord{$order}{$clone}{'span'}==1;
         }else{
            $read_coord{$order}{$clone}{'span'}==0;
         }

         ####Determine the identity of the 1st read
         my $forward=$read_coord{$order}{$clone}{'F'}{'start'};
         my $reverse=$read_coord{$order}{$clone}{'R'}{'start'};
         my ($left_read_orientation, $right_read_orientation, $left_start, $left_stop, $right_start, $right_stop, $layout);

         if($forward<$reverse){
            $left_read_orientation=$read_coord{$order}{$clone}{'F'}{'orientation'};
            $right_read_orientation=$read_coord{$order}{$clone}{'R'}{'orientation'};
            $left_start=$read_coord{$order}{$clone}{'F'}{'start'};
            $left_stop=$read_coord{$order}{$clone}{'F'}{'stop'};
            $right_start=$read_coord{$order}{$clone}{'R'}{'start'};
            $right_stop=$read_coord{$order}{$clone}{'R'}{'stop'}; 
            $layout="rd:F-R sc:$read_coord{$order}{$clone}{'F'}{'supercontig'}-$read_coord{$order}{$clone}{'R'}{'supercontig'}";
         }else{
            $left_read_orientation=$read_coord{$order}{$clone}{'R'}{'orientation'};
            $right_read_orientation=$read_coord{$order}{$clone}{'F'}{'orientation'};
            $left_start=$read_coord{$order}{$clone}{'R'}{'start'};
            $left_stop=$read_coord{$order}{$clone}{'R'}{'stop'};
            $right_start=$read_coord{$order}{$clone}{'F'}{'start'};
            $right_stop=$read_coord{$order}{$clone}{'F'}{'stop'};
            $layout="rd:R-F sc:$read_coord{$order}{$clone}{'R'}{'supercontig'}-$read_coord{$order}{$clone}{'F'}{'supercontig'}";
         }

         if (! $left_read_orientation){
             #$read_coord{$order}{$clone}{'illogical'}=1;
             $type_color=$color->{'purple'};
         }else{
             if ($right_read_orientation){
                #$read_coord{$order}{$clone}{'illogical'}=1;
                $type_color=$color->{'purple'};
             }else{
                #$read_coord{$order}{$clone}{'illogical'}=0;
                $type_color=$color->{'salmon'};
             }
         }

         my $scaled_lstart=($left_start/$zoom)+$x_pos;
         my $scaled_lstop=($left_stop/$zoom)+$x_pos;
         my $scaled_rstart=($right_start/$zoom)+$x_pos;
         my $scaled_rstop=($right_stop/$zoom)+$x_pos;
         my $insert_size=$right_stop-$left_start;

         $image->string(gdTinyFont, $scaled_rstop+3, $rdypos-2, "$name ($insert_size) $layout", $color->{black});
         &drawRectangle($image, $scaled_lstop, $scaled_rstart, $rdypos, $graph_value->[20], $type_color);

         &drawRectangle($image, $scaled_lstart, $scaled_lstop, $rdypos, $graph_value->[20], $color->{forrest});
         &drawRectangle($image, $scaled_rstart, $scaled_rstop,  $rdypos, $graph_value->[20], $color->{forrest});

      }else{#only one pair present
         if ($clone_name){
            $name=$read_coord{$order}{$clone}{'alternate_name'};
         }else{
            $name=$clone;
         }
         my ($start, $stop, $scaled_start, $scaled_stop, $direction);
         if(defined $clone{$clone}{'F'}){
            $start=$read_coord{$order}{$clone}{'F'}{'start'};
            $stop=$read_coord{$order}{$clone}{'F'}{'stop'};
            $scaled_start=($start/$zoom)+$x_pos;
            $scaled_stop=($stop/$zoom)+$x_pos;
            $direction="F";
         }else{
            $start=$read_coord{$order}{$clone}{'R'}{'start'};
            $stop=$read_coord{$order}{$clone}{'R'}{'stop'};
            $scaled_start=($start/$zoom)+$x_pos;
            $scaled_stop=($stop/$zoom)+$x_pos;
            $direction="R";
         }    
         $image->string(gdTinyFont, $scaled_stop+3, $rdypos-2, "$name$direction", $color->{swamp});
         &drawRectangle($image, $scaled_start, $scaled_stop, $rdypos, $graph_value->[20], $color->{forrest});         

      }
     }
     $rdypos+=6
    }
   }

   # Output the GIF (to STDOUT) with the correct HTTP header:
   print "Content-type: image/gif\n\n";
   print $image->gif;
}

=for html <A NAME='drawRectangle'>

=item drawRectangle

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$image</B>():  [Default = <B>shift</B>]<BR>
- <B>$start</B>():  [Default = <B>shift</B>]<BR>
- <B>$end</B>():  [Default = <B>shift</B>]<BR>
- <B>$y</B>():  [Default = <B>shift</B>]<BR>
- <B>$thickness</B>():  [Default = <B>shift</B>]<BR>
- <B>$bar_color</B>():  [Default = <B>shift</B>]<BR>
- <B>$text</B>():  [Default = <B>shift</B>]<BR>
- <B>$text_color</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------------------------------------------------
sub drawRectangle{

        my $image=shift;
        my $start=shift;
        my $end=shift;
        my $y=shift;
        my $thickness=shift;
        my $bar_color=shift;
        my $text=shift;
        my $text_color=shift;
   
        my $text_ypos=$y-10;
        $image->filledRectangle($start,$y,$end,$y+$thickness,$bar_color);
        $image->string(gdTinyFont,$start, $text_ypos, $text,$text_color);
}

=for html <A NAME='initializeDrawing'>

=item initializeDrawing

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
- None<BR>
<BR>

=cut

#-------------------------------------
sub initializeDrawing{

   my ($width, $length)=@_;
   
   my $image = new GD::Image($width,$length);

   return $image;
}

=for html <A NAME='initializeColor'>

=item initializeColor

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$image</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub initializeColor{

   my $image=shift;
   my $color;

   # allocate some colors
   $color->{white} = $image->colorAllocate(255,255,255);
   $color->{black} = $image->colorAllocate(0,0,0);
   $color->{swamp} = $image->colorAllocate(150,150,30);
   $color->{blue} = $image->colorAllocate(0,102,204);
   $color->{yellow}= $image->colorAllocate(255,255,0);
   $color->{cyan}=$image->colorAllocate(0,255,255);
   $color->{purple}=$image->colorAllocate(255,0,255);
   $color->{green}=$image->colorAllocate(100,250,25);
   $color->{red}=$image->colorAllocate(250,25,75);
   $color->{forrest}= $image->colorAllocate(25,175,0);
   $color->{color2}=$image->colorAllocate(180,200,180);
   $color->{dirtyred}=$image->colorAllocate(200,0,120);
   $color->{navy}=$image->colorAllocate(0,0,150);
   $color->{dirtyyellow}=$image->colorAllocate(200,200,75);
   $color->{grey}=$image->colorAllocate(153, 153, 153);
   $color->{lightgrey}=$image->colorAllocate(220, 220, 220);
   $color->{salmon}=$image->colorAllocate(255,153,153);
   $color->{lightblue}=$image->colorAllocate(153,204,255);
   $color->{orange}=$image->colorAllocate(255,153,51);

   return $color;
}

=for html <A NAME='getTigScrollBoxInfo'>

=item getTigScrollBoxInfo

=for html
TIG VIEWER #######################<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

################### TIG VIEWER #######################

#-------------------------------------
sub getTigScrollBoxInfo{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;
   my $gene_finder_id=shift;

   ####Connect to database
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   ####all contig
   my @tig_field=("Contig_Number", "Contig_Size");
   my @tig_table=("Contig", "Assembly");
   my @tig_condition=("Assembly_ID=FK_Assembly__ID", "Assembly_ID=$assembly_id");
   my $tig_instruction="ORDER BY Contig_Number";
   my $select_tig=SQLdb::GetRecord(\@tig_field, \@tig_table, \@tig_condition, $tig_instruction);
   my $tmp_tig=SQLdb::ExecuteMany($dbh, $select_tig);

   ####all orfs
   my @orf_field=("Orf_ID", "Contig_Number", "Orf_Origin_ID");
   my @orf_table=("Gene_Finder", "Blast", "Orf", "Orf_Context", "Orf_Origin", "Contig", "Assembly");
   my @orf_condition=("Assembly_ID=FK_Assembly__ID", "Contig_Id=FK_Contig__ID", "FK_Orf_Context__ID=Orf_Context_ID", "Orf_ID=Orf_Context.FK_Orf__ID", "Orf_ID=Blast.FK_Orf__ID", "Gene_Finder_ID=FK_Gene_Finder__ID", "Assembly_ID=$assembly_id", "Gene_Finder_ID=$gene_finder_id");
   my $orf_instruction="ORDER BY Orf_ID";
   my $select_orf=SQLdb::GetRecord(\@orf_field, \@orf_table, \@orf_condition, $orf_instruction);
   my $tmp_orf=SQLdb::ExecuteMany($dbh, $select_orf);

   SQLdb::Disconnect($dbh);

   my ($tig_scroll, $contig_size)=processListInfo($tmp_tig);
   my ($orf_scroll, $orf_tig)=processOrfInfo($tmp_orf);

   return $tig_scroll, $orf_scroll, $contig_size, $orf_tig;
}

=for html <A NAME='getSpecificOrfInfo'>

=item getSpecificOrfInfo

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$tig_selection</B>():  [Default = <B>shift</B>]<BR>
- <B>$tig_size</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub getSpecificOrfInfo{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $tig_selection=shift;
   my $tig_size=shift;

   ####Connect to database
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});

   ####all orfs
   my @orf_field=("Orf_Origin_ID", "Orf_ID", "Orf_Origin_Start", "Orf_Origin_Stop", "Orf_Origin_Strand", "Blast_Protein_Name", "Blast_Organism", "Blast_Hit_Similarity");
   my @orf_table=("Gene_Finder", "Blast", "Orf", "Orf_Context", "Orf_Origin", "Contig", "Assembly");
   my @orf_condition=("Assembly_ID=FK_Assembly__ID", "Contig_Id=FK_Contig__ID", "FK_Orf_Context__ID=Orf_Context_ID", "Orf_ID=Orf_Context.FK_Orf__ID", "Orf_ID=Blast.FK_Orf__ID", "Gene_Finder_ID=FK_Gene_Finder__ID", "Assembly_ID=$assembly_id", "Gene_Finder_ID=$gene_finder_id", "Contig_Number='$tig_selection'");
   my $select_orf=SQLdb::GetRecord(\@orf_field, \@orf_table, \@orf_condition);
   my $tmp_orf=SQLdb::ExecuteMany($dbh, $select_orf);

   SQLdb::Disconnect($dbh);

   my ($leading, $lagging, $orf_hash, $orf_stat)=getSpecifics($tmp_orf, $tig_selection, $tig_size);

   return $leading, $lagging, $orf_hash, $orf_stat;
}

=for html <A NAME='processOrfInfo'>

=item processOrfInfo

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_element</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub processOrfInfo{

   my $tmp_element=shift;
   my @arr_reference=@$tmp_element;

   my %scroll_box;
   my %hash_relation;
   my %been_there;
   my $concat;

   foreach my $reference (@arr_reference){
      my @record=@$reference;

      if (! $been_there{$record[0]}){      
         $scroll_box{$record[2]}=$record[0];
         $been_there{$record[0]}++;
       }else{
         $concat=$record[0].".".$been_there{$record[0]};
         $scroll_box{$record[2]}=$concat;
         $been_there{$record[0]}++;
       }
       $hash_relation{$record[2]}=$record[1];
   }

   return \%scroll_box, \%hash_relation;
}

=for html <A NAME='processListInfo'>

=item processListInfo

=for html
simple routine to reorganize arrays into hash and produce list<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_element</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub processListInfo{

   ###simple routine to reorganize arrays into hash and produce list
   my $tmp_element=shift;
   my @arr_reference=@$tmp_element;

   my @list_array;
   my $hash_relation;
   
   foreach my $reference (@arr_reference){
      my @record=@$reference;
      push @list_array, $record[0];
      $hash_relation->{$record[0]}=$record[1];
   }

   return \@list_array, $hash_relation;
}

=for html <A NAME='getSpecifics'>

=item getSpecifics

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_orf</B>():  [Default = <B>shift</B>]<BR>
- <B>$tig_selection</B>():  [Default = <B>shift</B>]<BR>
- <B>$tig_size</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub getSpecifics{

   my $tmp_orf=shift;
   my @orf_reference=@$tmp_orf;
   my $tig_selection=shift;
   my $tig_size=shift;

   my (%leading, %lagging, %orf_hash, %orf_stat);
   my ($orf_ct, $lead_ct, $lagg_ct)=(0,0,0,0);

   foreach my $reference (@orf_reference){
      my @record=@$reference;
      $record[6]=$format->format_number($record[7],1,1);###format the similarity% 
      my @spec=($record[1], $record[2], $record[3], $record[4], $record[5], $record[6], $record[7]);
      $orf_hash{$record[0]}=\@spec;
      if ($record[4]>0){###leading
         $leading{$record[2]}=$record[3];###leading
         $lead_ct++;
      }elsif ($record[4]<0){
         $lagging{$record[3]}=$record[2];###lagging
         $lagg_ct++;
      }
      $orf_ct++;   
   }
   $orf_stat{'contig'}=$format->format_number($tig_selection);
   $orf_stat{'size'}=$format->format_number($tig_size);
   $orf_stat{'amount'}=$format->format_number($orf_ct);
   $orf_stat{'leading'}=$format->format_number($lead_ct);
   $orf_stat{'lagging'}=$format->format_number($lagg_ct);

   return \%leading, \%lagging, \%orf_hash, \%orf_stat;
}

=for html <A NAME='computeTigImage'>

=item computeTigImage

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tig_selection</B>():  [Default = <B>shift</B>]<BR>
- <B>$contig_size</B>():  [Default = <B>shift</B>]<BR>
- <B>$orf_hash</B>():  [Default = <B>shift</B>]<BR>
- <B>$zoom</B>():  [Default = <B>shift</B>]<BR>
- <B>$vertmove</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembler</B>():  [Default = <B>shift</B>]<BR>
- <B>$build</B>():  [Default = <B>shift</B>]<BR>
- <B>$featureorf</B>():  [Default = <B>shift</B>]<BR>
- <B>$leading</B>():  [Default = <B>shift</B>]<BR>
- <B>$lagging</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub computeTigImage{

   my $tig_selection=shift;
   my $contig_size=shift;
   my $orf_hash=shift;
   my %orf_hash=%$orf_hash;
   my $zoom=shift;
   my $vertmove=shift;
   my $assembler=shift;
   my $build=shift;
   my $featureorf=shift;
   my $leading=shift;
   my %leading=%$leading;
   my $lagging=shift;
   my %lagging=%$lagging;

   my $assemname="$assembler Build$build";

   my $orfcolor;

   my ($width, $length, $x1, $x2, $xladder, $xlegend, $y1, $y2, $spacepos, $spaceneg, $size, $gcbar, $xarrowleft, $xarrowright, $xarrowcenter, $ytoparrow, $ytopbase, $ytop2, $ybotarrow, $ybotbase, $ybot2, $mid, $topmid, $botmid, $intergenic)=&initializeTigViewerData($zoom, $tig_selection, $contig_size, $vertmove);

   my $image=&initializeDrawing($width, $length);      #pass the width and length
   my $color=&initializeColor($image);                 #get colors      

   # make the background transparent and interlaced
   $image->interlaced('true');

   #DRAW CONTIG:
   $image->filledRectangle($x1,$y1,$x2,$y2,$color->{navy});

   #DRAW AXIS
   $image->rectangle($xladder,$y1, $xladder,$y2, $color->{black});

   my $thick;

   if ($zoom==10000){
       $thick=10;
   }
   elsif($zoom<=1000){
       $thick=50;
   }

   for (my $ypos=$y1;$ypos<=$y2;$ypos+=$thick){
        my $thickvalue=($ypos-$y1)*$zoom/1000;
        my $thicklabel=$thickvalue.'k';
        $image->string(gdSmallFont,$xladder-40, $ypos-5,$thicklabel,$color->{black}); #axis label
        $image->rectangle($xladder+5, $ypos, $xladder, $ypos, $color->{black});     #axis thick
   }
   #last thick
   $image->rectangle($xladder+5, $y2, $xladder, $y2,  $color->{black});        #last thick
   my $tmplabel=$size/1000;
   my $lastlabel=$tmplabel."kb";
   $image->string(gdSmallFont, $xladder-40,  $y2+10, $lastlabel,$color->{black}); #last label
   #DRAW ARROWS
   # make top first triangle
   my $toptri = new GD::Polygon;
   $toptri->addPt($xarrowcenter,$ytoparrow);
   $toptri->addPt($xarrowleft,$ytopbase);
   $toptri->addPt($xarrowright,$ytopbase);
   # draw the polygon, filling it with a color
   $image->filledPolygon($toptri,$color->{grey});

   #make top second triangle
   my $sectoptri = new GD::Polygon;
   $sectoptri->addPt($xarrowcenter,$ytopbase);
   $sectoptri->addPt($xarrowleft,$ytop2);
   $sectoptri->addPt($xarrowright,$ytop2);
   # draw the polygon, filling it with a color
   $image->filledPolygon($sectoptri,$color->{grey});

   # make bottom first triangle
   my $bottri = new GD::Polygon;
   $bottri->addPt($xarrowcenter,$ybotarrow);
   $bottri->addPt($xarrowleft,$ybotbase);
   $bottri->addPt($xarrowright,$ybotbase);
   # draw the polygon, filling it with a color
   $image->filledPolygon($bottri,$color->{grey});

   #make bopttom second triangle
   my $secbottri = new GD::Polygon;
   $secbottri->addPt($xarrowcenter,$ybotbase);
   $secbottri->addPt($xarrowleft,$ybot2);
   $secbottri->addPt($xarrowright,$ybot2);
   # draw the polygon, filling it with a color
   $image->filledPolygon($secbottri,$color->{grey});
   #$image->filledRectangle($xarrowcenter, $ytop2, $xarrowcenter, $ybot2, $color->{black});

   #make center diamond
   my $diamond = new GD::Polygon;
   $diamond->addPt($xarrowleft,$mid);
   $diamond->addPt($xarrowcenter,$topmid);
   $diamond->addPt($xarrowright,$mid);
   $diamond->addPt($xarrowcenter,$botmid);
   # draw the polygon, filling it with a color
   $image->filledPolygon($diamond,$color->{grey});

   #DRAW LEGEND
   $image->filledRectangle($xlegend, 5, $xlegend+10,15, $color->{navy});
   $image->string(gdSmallFont, $xlegend+15, 5, "$assemname",$color->{black});

   $image->filledRectangle($xlegend+10, 18, $xlegend+10,28, $color->{forrest});
   $image->string(gdSmallFont, $xlegend+15, 18,"Gene Start",$color->{black});

   $image->filledRectangle($xlegend+10, 31, $xlegend+10,41, $color->{red});
   $image->string(gdSmallFont,$xlegend+15,31,"Gene Stop",$color->{black});

   $image->filledRectangle($xlegend, 44, $xlegend+10,54, $color->{lightblue});
   $image->string(gdSmallFont, $xlegend+15, 44,"Feature Gene",$color->{black});

   $image->filledRectangle($xlegend,61, $xlegend+10,65, $color->{forrest});
   $image->string(gdSmallFont,$xlegend+15,57,"Cluster (leading)",$color->{black});

   $image->filledRectangle($xlegend, 72, $xlegend+10, 76, $color->{dirtyred});
   $image->string(gdSmallFont, $xlegend+15, 70,"Cluster (lagging)",$color->{black});
   $image->string(gdSmallFont, $xlegend+15, 83,"Contig $tig_selection  Zoom 1:$zoom",$color->{black});

 #DRAW ORFS
   foreach my $gene (keys %orf_hash){

       my $tmp=$orf_hash{$gene};
       my @data=@$tmp;

       if ($data[3] > 0){                       #leading
          my $start=$y1+($data[1]/$zoom);
          my $stop=$y1+($data[2]/$zoom);

          $image->filledRectangle($spacepos, $start, $spacepos+10,$start, $color->{forrest});
          $image->filledRectangle($spacepos, $stop-1, $spacepos+10, $stop-1, $color->{red});

          if ($gene eq $featureorf){
              $image->filledRectangle($spacepos,$start+1,$spacepos+10, $stop-2, $color->{lightblue});
          }

          $image->string(gdSmallFont,$spacepos+15, $start-5, $data[0],$color->{black});   #put a name tag for all orfs

       }
       elsif($data[3] < 0){                     #lagging
          my $start=$y1+($data[1]/$zoom);
          my $stop=$y1+($data[2]/$zoom);

          $image->filledRectangle($spaceneg-10, $start, $spaceneg, $start, $color->{forrest});
          $image->filledRectangle($spaceneg-10, $stop-1, $spaceneg, $stop-1, $color->{red});

          if ($gene eq $featureorf){
              $image->filledRectangle($spaceneg-10, $stop, $spaceneg, $start-1, $color->{lightblue});
          }

          $image->string(gdSmallFont,$spaceneg-40,$start-5,$data[0],$color->{black});    #put a name tag for all orfs
          #$image->string(gdSmallFont,$spaceneg-100,$start-5,$stop,$color->{blue});

       }
   }

   #DRAW CLUSTER (LEADING)
   my $previousstop=0;
   my $clusterstart=7000000000;
   my $clusterstop=0;
   my $ct=0;
   my $yyy=100;

   LEAD:
   foreach my $start (sort {$a<=>$b} keys %leading){ #sort by ascending number of start ORF
      next LEAD if ($leading{$start}<$previousstop); #Crucial:take into account smaller overlap (inclusions)

      $clusterstart=$start if ($start<$clusterstart);

      if ($previousstop){

        my $difference=$start-$previousstop;
        if ($difference < $intergenic){
           $clusterstop=$leading{$start};
           $ct++;
        }
        else{

           if ($ct >= 1){ #describe the number of genes that define a gene cluster (in this case 1+1=2)
              my $clustery1=$y1+($clusterstart/$zoom);
              my $clustery2=$y1+($clusterstop/$zoom);
              $image->filledRectangle($x1+6, $clustery1,$x1+10,$clustery2,$color->{forrest});
           }
           $clusterstart=$start;
           $clusterstop=0;
           $previousstop=0;
           $ct=0;
        }
      }
      $previousstop=$leading{$start};
   }
   #make sure record the cluster if loop finished
   if ($ct >= 1){
      my $clustery1=$y1+($clusterstart/$zoom);
      my $clustery2=$y1+($clusterstop/$zoom);
      $image->filledRectangle($x1+6, $clustery1,$x1+10,$clustery2,$color->{forrest});
   }
   #DRAW CLUSTER (LAGGING)
   $previousstop=0;
   $clusterstart=7000000000;
   $clusterstop=0;
   $ct=0;

   LAGG:
   foreach my $start (sort {$a<=>$b} keys %lagging){ #sort by ascending number of start ORF

      next LAGG if ($lagging{$start}<$previousstop); #Crucial:take into account smaller overlap (inclusions)

      $clusterstart=$start if ($start<$clusterstart);

      if ($previousstop != 0){

        my $difference=$start-$previousstop;
        if ($difference < $intergenic){
           $clusterstop=$lagging{$start};
           $ct++;
        }
        else{

           if ($ct>=0){
              my $clustery1=$y1+($clusterstart/$zoom);
              my $clustery2=$y1+($clusterstop/$zoom);
              $image->filledRectangle($x1,$clustery1,$x1+4,$clustery2,$color->{dirtyred});
           }
           $clusterstart=$start;
           $clusterstop=0;
           $previousstop=0;
           $ct=0;
        }
      }
      $previousstop=$lagging{$start};
   }
   #make sure record the cluster if loop finished
   if ($ct >= 1){
      my $clustery1=$y1+($clusterstart/$zoom);
      my $clustery2=$y1+($clusterstop/$zoom);
      $image->filledRectangle($x1,$clustery1,$x1+4,$clustery2,$color->{dirtyred});
   }

   #DRAW FRAME
   $image->rectangle(0,0,$width-1,$length-1,$color->{black});

   # Output the GIF (to STDOUT) with the correct HTTP header:
   print "Content-type: image/gif\n\n";
   print $image->gif;
}

=for html <A NAME='initializeTigViewerData'>

=item initializeTigViewerData

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$zoom</B>():  [Default = <B>shift</B>]<BR>
- <B>$tig_selection</B>():  [Default = <B>shift</B>]<BR>
- <B>$contig_size</B>():  [Default = <B>shift</B>]<BR>
- <B>$vertmove</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub initializeTigViewerData{

   my $zoom=shift;
   my $tig_selection=shift;
   my $contig_size=shift;
   my %contig_size=%$contig_size;
   my $vertmove=shift;

   #--------------------------------------
   my $width=680;     #image size
   my $length=420;    #image size
   my $x1=300;        #coord for contig
   my $x2=310;        #coord for contig
   my $xladder=80;    #coord for ladder
   my $xlegend=480;   #coord for legend
   my $gcbar=100;

   my $xarrowleft=5;
   my $xarrowright=15;
   my $xarrowcenter=10;
   my $ytoparrow=2;
   my $ytopbase=12;
   my $ytop2=22;
   my $ybotarrow=($length-2);
   my $ybotbase=($length-12);
   my $ybot2=($length-22);
   my $mid=($length/2);
   my $topmid=($mid-5);
   my $botmid=($mid+5);

   my $intergenic=500;   #define the max length for intergenic regions
   #--------------------------------------

   my $size=$contig_size{$tig_selection};
   my $scaled=($size/$zoom);

   my $y1=(($length-$scaled)/2)+$vertmove; #takes into account any vertical movement
   my $y2=$y1+$scaled;

   my $spacepos=($x2+2);
   my $spaceneg=($x1-2);

   return $width, $length, $x1, $x2, $xladder, $xlegend, $y1, $y2, $spacepos, $spaceneg, $size, $gcbar, $xarrowleft, $xarrowright, $xarrowcenter, $ytoparrow, $ytopbase, $ytop2, $ybotarrow, $ybotbase, $ybot2, $mid, $topmid, $botmid, $intergenic;

}

=for html <A NAME='getOneOrfInfo'>

=item getOneOrfInfo

=for html
ORF #######################<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$orf_origin</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

################### ORF #######################
#-------------------------------------
sub getOneOrfInfo{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;
   my $orf_origin=shift;
   my $gene_finder_id=shift;

   my %all_orf;

   ####Connect to database
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});
   my @field=("Orf_ID", "Blast_Accession", "Blast_Protein_Name", "Blast_Organism", "Blast_Hit_Similarity", "Blast_Score", "Blast_EValue", "Blast_Hit_Start", "Blast_Hit_Stop", "Blast_Hit_Length", "Blast_Query_Start", "Blast_Query_Stop", "Blast_Positive_Residues", "Blast_Query_Sequence", "Blast_Hit_Sequence", "Orf_CDS_Sequence", "Orf_CDS_Length", "Orf_Protein_Sequence", "Orf_Protein_Length", "Orf_PercentA", "Orf_PercentT", "Orf_PercentC", "Orf_PercentG", "Orf_PercentGC", "Orf_Position_A1", "Orf_Position_A2", "Orf_Position_A3", "Orf_Position_T1", "Orf_Position_T2", "Orf_Position_T3", "Orf_Position_C1", "Orf_Position_C2", "Orf_Position_C3", "Orf_Position_G1", "Orf_Position_G2", "Orf_Position_G3", "Blast_Bits", "Blast_Match", "Contig_Number", "Orf_Origin_Strand", "Orf_Origin_Start", "Orf_Origin_Stop", "Blast_Hit_Protein_Length", "Blast_Hit_Identity");
   my @table=("Gene_Finder", "Blast", "Orf", "Orf_Context", "Orf_Origin", "Contig", "Assembly");
   my @condition=("Assembly_ID=FK_Assembly__ID", "Contig_Id=FK_Contig__ID", "FK_Orf_Context__ID=Orf_Context_ID", "Orf_ID=Orf_Context.FK_Orf__ID", "Orf_ID=Blast.FK_Orf__ID", "Gene_Finder_ID=FK_Gene_Finder__ID", "Assembly_ID=$assembly_id", "Gene_Finder_ID=$gene_finder_id", "Orf_Origin_ID=$orf_origin");
   my $select_orf=SQLdb::GetRecord(\@field, \@table, \@condition);
   #print "$select_orf";
   my $tmp_orf=SQLdb::ExecuteUnique($dbh, $select_orf);
   SQLdb::Disconnect($dbh);

   my @record=@$tmp_orf;

   ####will produce a list of amino acid shared between 2 sequences
   ####should be stored in SAMdb 
   my $shared=SequenceAnalysis::sharedAA($record[13], $record[14]); #call to sub to calculate similarity/match

   #MORE EXHAUSTIVE LIST FOR RECONSTRUCTION
   $all_orf{$orf_origin}{'orf_id'}=$record[0];
   $all_orf{$orf_origin}{'accession'}=$record[1];
   $all_orf{$orf_origin}{'name'}=$record[2];
   $all_orf{$orf_origin}{'organism'}=$record[3];
   $all_orf{$orf_origin}{'similarity'}=$format->format_number($record[4],1,1);
   $all_orf{$orf_origin}{'hit_protein_length'}=$format->format_number($record[42]);
   $all_orf{$orf_origin}{'score'}=$format->format_number($record[5],1,1);
   $all_orf{$orf_origin}{'evalue'}=$record[6];
   $all_orf{$orf_origin}{'hit_start'}=$record[7];
   $all_orf{$orf_origin}{'hit_stop'}=$record[8];
   $all_orf{$orf_origin}{'hit_length'}=$record[9];
   $all_orf{$orf_origin}{'query_length'}=length($record[13]);
   $all_orf{$orf_origin}{'query_start'}=$record[10];
   $all_orf{$orf_origin}{'query_stop'}=$record[11];
   $all_orf{$orf_origin}{'positive'}=$record[12];
   $all_orf{$orf_origin}{'query_sequence'}=$record[13];
   $all_orf{$orf_origin}{'hit_sequence'}=$record[14];
   $all_orf{$orf_origin}{'shared_sequence'}=$shared;
   $all_orf{$orf_origin}{'cds_sequence'}=$record[15];
   $all_orf{$orf_origin}{'cds_length'}=$format->format_number($record[16]);
   $all_orf{$orf_origin}{'protein_sequence'}=$record[17];
   $all_orf{$orf_origin}{'protein_length'}=$format->format_number($record[18]);
   $all_orf{$orf_origin}{'percentA'}=$format->format_number($record[19],1,1);
   $all_orf{$orf_origin}{'percentT'}=$format->format_number($record[20],1,1);
   $all_orf{$orf_origin}{'percentC'}=$format->format_number($record[21],1,1);
   $all_orf{$orf_origin}{'percentG'}=$format->format_number($record[22],1,1);
   $all_orf{$orf_origin}{'percentGC'}=$format->format_number($record[23],1,1);
   $all_orf{$orf_origin}{'A1'}=$format->format_number($record[24],1,1);
   $all_orf{$orf_origin}{'A2'}=$format->format_number($record[25],1,1);
   $all_orf{$orf_origin}{'A3'}=$format->format_number($record[26],1,1);
   $all_orf{$orf_origin}{'T1'}=$format->format_number($record[27],1,1);
   $all_orf{$orf_origin}{'T2'}=$format->format_number($record[28],1,1);
   $all_orf{$orf_origin}{'T3'}=$format->format_number($record[29],1,1);
   $all_orf{$orf_origin}{'C1'}=$format->format_number($record[30],1,1);
   $all_orf{$orf_origin}{'C2'}=$format->format_number($record[31],1,1);
   $all_orf{$orf_origin}{'C3'}=$format->format_number($record[32],1,1);
   $all_orf{$orf_origin}{'G1'}=$format->format_number($record[33],1,1);
   $all_orf{$orf_origin}{'G2'}=$format->format_number($record[34],1,1);
   $all_orf{$orf_origin}{'G3'}=$format->format_number($record[35],1,1);
   $all_orf{$orf_origin}{'bits'}=$format->format_number($record[36]);
   $all_orf{$orf_origin}{'match'}=$format->format_number($record[37]);
   $all_orf{$orf_origin}{'contig'}=$format->format_number($record[38]);
   $all_orf{$orf_origin}{'strand'}=$format->format_number($record[39]);
   $all_orf{$orf_origin}{'start_position'}=$format->format_number($record[40]);
   $all_orf{$orf_origin}{'stop_position'}=$format->format_number($record[41]);
   $all_orf{$orf_origin}{'hit_identity'}=$format->format_number($record[43],1,1);

   return \%all_orf;
}

=for html <A NAME='getOrfList'>

=item getOrfList

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$user_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$orf_name</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub getOrfList{

   my $user_info=shift;
   my %user_info=%$user_info;
   my $assembly_id=shift;
   my $orf_name=shift;
   my $gene_finder_id=shift;

   my (%orf_list);

   ####Connect to database
   my $dbh=SQLdb::Initialize($user_info{'password'}, $user_info{'username'}, $user_info{'assembly_database'}, $user_info{'assembly_host'});
   my @field=("Orf_Origin_ID", "Orf_ID", "Blast_Accession", "Blast_Protein_Name", "Blast_Organism", "Blast_Hit_Similarity");
   my @table=("Gene_Finder", "Blast", "Orf", "Orf_Context", "Orf_Origin", "Contig", "Assembly");
   my @condition=("Assembly_ID=FK_Assembly__ID", "Contig_Id=FK_Contig__ID", "FK_Orf_Context__ID=Orf_Context_ID", "Orf_ID=Orf_Context.FK_Orf__ID", "Orf_ID=Blast.FK_Orf__ID", "Assembly_ID=$assembly_id", "Gene_Finder_ID=FK_Gene_Finder__ID", "Gene_Finder_ID=$gene_finder_id");
   my $instruction=''; 
   if ($orf_name ne ''){
      $orf_name=~s/[^A-Z0-9\-]//gi;###remove any weird character globaly
      $instruction="AND (Blast_Organism like '%$orf_name%' OR Blast_Protein_Name like '%$orf_name%')";
   }
   my $select_orf=SQLdb::GetRecord(\@field, \@table, \@condition, $instruction);
   my $tmp_orf=SQLdb::ExecuteMany($dbh, $select_orf);
   SQLdb::Disconnect($dbh);

   my @orf_reference=@$tmp_orf;
   my $total_orf=0;
   my %been_there;
   my $concat;
   foreach my $reference (@orf_reference){
      my @record=@$reference;

      if (! defined $been_there{$record[1]}){
         $been_there{$record[1]}++;
         $orf_list{$record[0]}[0]=$record[1];
         $orf_list{$record[0]}[1]=$record[2];
         $orf_list{$record[0]}[2]=$record[3];
         $orf_list{$record[0]}[3]=$record[4];
         $orf_list{$record[0]}[4]=$format->format_number($record[5],1,1);
      }else{
         $concat=$record[1].".".$been_there{$record[1]};
         $orf_list{$record[0]}[0]=$concat;
         $orf_list{$record[0]}[1]=$record[2];
         $orf_list{$record[0]}[2]=$record[3];
         $orf_list{$record[0]}[3]=$record[4];
         $orf_list{$record[0]}[4]=$format->format_number($record[5],1,1);
         $been_there{$record[1]}++;
      }
      $total_orf++;
   }
   return \%orf_list, $total_orf;
}

=back

=cut

##############################
# private_methods            #
##############################
##############################
# private_functions          #
##############################
##############################
# main_footer                #
##############################
##############################
# perldoc_footer             #
##############################

=head1 KNOWN ISSUES <UPLINK>

<<KNOWN ISSUES>>

=head1 FUTURE IMPROVEMENTS <UPLINK>

<<FUTURE IMPROVEMENTS>>

=head1 AUTHORS <UPLINK>

<<AUTHORS>>

=head1 CREATED <UPLINK>

2004-08-18

=head1 REVISION <UPLINK>


=cut


return 1;
