#wgsHTML - A module for data display (produce HTML)
#wgsHTML produces the HTML from the data produced by wgsDATA             
#Rene Warren April 2003
package wgsHTML;

##############################
# perldoc_header             #
##############################

=head1 NAME <UPLINK>

wgsHTML.pm - wgsHTML - A module for data display (produce HTML)

=head1 SYNOPSIS <UPLINK>

	<<SYNOPSIS>>

=head1 DESCRIPTION <UPLINK>

=for html
wgsHTML - A module for data display (produce HTML)<BR>wgsHTML produces the HTML from the data produced by wgsDATA             <BR>Rene Warren April 2003<BR>

=cut

##############################
# superclasses               #
##############################

=head2 SUPERCLASSES <UPLINK>

=over

=back

=cut

##############################
# system_variables           #
##############################
##############################
# standard_modules_ref       #
##############################

=head2 STANDARD MODULES REFERENCE <UPLINK>

=over

=item lib "."

=item strict

=item wgsDATA

=item LWP::UserAgent

=back

=cut

use lib ".";
use strict;
use wgsDATA;
use LWP::UserAgent;

##############################
# custom_modules_ref         #
##############################

=head2 CUSTOM MODULES REFERENCE <UPLINK>

=over

=back

=cut

##############################
# global_vars                #
##############################

=head2 GLOBAL VARIABLES <UPLINK>

=over

=back

=cut

##############################
# modular_vars               #
##############################
##############################
# constants                  #
##############################
##############################
# main_header                #
##############################
######################## SAM #####################
#----------------------------------
1;

##############################
# constructor                #
##############################
##############################
# public_methods             #
##############################
##############################
# public_functions           #
##############################

=head2 PUBLIC FUNCTIONS <UPLINK>

=for html <font size='-1'><strong><A href='#SAMlogin'>SAMlogin; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#showLoginTable'>showLoginTable; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#SAMstarttable'>SAMstarttable; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#SAMendtable'>SAMendtable; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#SAMhome'>SAMhome; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#displayTasks'>displayTasks; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#displayAnnotateForm'>displayAnnotateForm; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#displayTieMapForm'>displayTieMapForm; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#filePrompt'>filePrompt; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#displayMessage'>displayMessage; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#displayAssembleForm'>displayAssembleForm; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#SAMwelcome'>SAMwelcome; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#setHTML'>setHTML; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#printTitle'>printTitle; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#printLink'>printLink; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#assemblerBox'>assemblerBox; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#simpleSelectionBox'>simpleSelectionBox; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#arraySelectionBox'>arraySelectionBox; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#printHomePage'>printHomePage; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#printAssemblyInfo'>printAssemblyInfo; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#printContigInfo'>printContigInfo; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#printOrfInfo'>printOrfInfo; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#showCompare'>showCompare; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#tableComparison'>tableComparison; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#assemblyComparisonSelection'>assemblyComparisonSelection; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#reportMenu'>reportMenu; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#progressMenu'>progressMenu; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#assemblyStatSelection'>assemblyStatSelection; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#assemblyAssemblerSelection'>assemblyAssemblerSelection; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#printProgressGraph'>printProgressGraph; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#assemblyProgressTable'>assemblyProgressTable; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#distributionMenu'>distributionMenu; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#distributionLibrary'>distributionLibrary; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#selectAssemblyStatic'>selectAssemblyStatic; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#printDistributionGraph'>printDistributionGraph; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#distributionTable'>distributionTable; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#errorDistribution'>errorDistribution; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#insertMenu'>insertMenu; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#printInsertGraph'>printInsertGraph; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#blastMenu'>blastMenu; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#blastSetParameter'>blastSetParameter; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#gapMenu'>gapMenu; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#showAllGapTable'>showAllGapTable; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#showSpecificGap'>showSpecificGap; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#showGapSummaryOnly'>showGapSummaryOnly; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#tableGapSpan'>tableGapSpan; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#overlapMenu'>overlapMenu; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#showAllOverlapTable'>showAllOverlapTable; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#showSpecificOverlap'>showSpecificOverlap; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#contigViewerMenu'>contigViewerMenu; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#contigViewerForm'>contigViewerForm; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#showZoomMenu'>showZoomMenu; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#contigViewerStats'>contigViewerStats; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#contigViewerDisplay'>contigViewerDisplay; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#mapViewerMenu'>mapViewerMenu; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#mapViewerForm'>mapViewerForm; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#mapViewerDisplay'>mapViewerDisplay; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#orfMenu'>orfMenu; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#displayOrfList'>displayOrfList; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#displayOrfSpecific'>displayOrfSpecific; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#displaySequence'>displaySequence; </A></strong></font><BR>

=for html <font size='-1'><strong><A href='#displayAlignment'>displayAlignment; </A></strong></font><BR>

=over

=for html <A NAME='SAMlogin'>

=item SAMlogin

=for html
SAM #####################<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$htdocpath</B>():  [Default = <B>shift</B>]<BR>
- <B>$sam_credential</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

######################## SAM #####################

#----------------------------------

sub SAMlogin{

   my $scriptname=shift;
   my $htdocpath=shift;
   my $sam_credential=shift;
   my $menu=shift;
   my $fuzzykey=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;

   print "<table border=1 bordercolor='D3D3D3' width=430 align=center>";
   print "<tr><td>";
   print "<table border=0 width=430 align=center background=\"$htdocpath/samlogin.png\">";
   &showLoginTable($scriptname, $sam_credential, $menu, $htdocpath, $fuzzykey, $assembly_id, $gene_finder_id);
   print "</table>";
   print "</td></tr>";
   print "</table>";

}

=for html <A NAME='showLoginTable'>

=item showLoginTable

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$sam_credential</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$htdocpath</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#----------------------------------
sub showLoginTable{

   my $scriptname=shift;
   my $sam_credential=shift;
   my %sam_credential=%$sam_credential;
   my $menu=shift;
   my $htdocpath=shift;
   my $fuzzykey=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;

   my ($comment, $color);

   if ($sam_credential{'pass'}==-1){
      $comment="*User not logged in";
      $color="FFFF00";
   }elsif(!$sam_credential{'pass'}){
      $comment="*Login failed";
      $color="FF0000";
   }
   print "<tr><td colspan=3 align=center>&nbsp;</td></tr>";
   print "<tr><td colspan=3 align=center>&nbsp;</td></tr>";
   print "<FORM ACTION=\"$scriptname\" METHOD='POST'>";
   print "<tr><td align=right><span class=small><b>Username&nbsp;</b></span></td><td align=center><INPUT TYPE=\"text\" NAME=\"username\" VALUE=\"\" SIZE=\"16\" MAXLENGTH=\"20\"></td><td>&nbsp;</td></tr>";
   print "<tr><td align=right><span class=small><b>Password&nbsp;</b></span></td><td align=center><INPUT TYPE=\"password\" NAME=\"access\" VALUE=\"\" SIZE=\"16\" MAXLENGTH=\"20\"></td><td>&nbsp;</td></tr>";
   print "<INPUT TYPE=\"hidden\" NAME=\"menu\" VALUE=\"$menu\">";
   print "<INPUT TYPE=\"hidden\" NAME=\"fuzzykey\" VALUE=\"$fuzzykey\">";
   print "<INPUT TYPE=\"hidden\" NAME=\"assembly_id\" VALUE=\"$assembly_id\">";
   print "<INPUT TYPE=\"hidden\" NAME=\"gene_finder_id\" VALUE=\"$gene_finder_id\">";

   print "<tr><td>&nbsp;</td><td align=center><font color=$color><span class=small><b>$comment</b></span></font></td><td align=right><INPUT TYPE=\"SUBMIT\" VALUE=\"Log In\"></td></tr>";
   print "</FORM>";

}

=for html <A NAME='SAMstarttable'>

=item SAMstarttable

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
- None<BR>
<BR>

=cut

#----------------------------------
sub SAMstarttable{

    print "<table border=1 bordercolor='D3D3D3' width=680 cellspacing=0 cellpadding=0>";
    print "<tr><td>";
    print "<table border=0 width=680 cellspacing=0 cellpadding=0>";

}

=for html <A NAME='SAMendtable'>

=item SAMendtable

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
- None<BR>
<BR>

=cut

#----------------------------------
sub SAMendtable{

   print "</table>";
   print "</td></tr></table>";

}

=for html <A NAME='SAMhome'>

=item SAMhome

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$htdocpath</B>():  [Default = <B>shift</B>]<BR>
- <B>$sam_credential</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
- <B>$sam_selection</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#----------------------------------

sub SAMhome{

   my $scriptname=shift;
   my $htdocpath=shift;
   my $sam_credential=shift;
   my %sam_credential=%$sam_credential;
   my $menu=shift;
   my $fuzzykey=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $compressed_userinfo=shift;
   my $sam_selection=shift;

   my ($link1,$link2,$link3,$link4, $link5, $link9);
   my ($tab1, $tab2, $tab3, $tab4, $tab5, $tab9, $main);

   $link1=$link2=$link3=$link4=$link5=$link9='0000FF';
   $main=$tab1=$tab2=$tab3=$tab4=$tab5=$tab9='D3D3D3';

   if($sam_selection==1){
      $link1='000000';
      $tab1='FFFFFF';
   }elsif($sam_selection==2){
      $link2='000000';
      $tab2='FFFFFF';
   }elsif($sam_selection==3){
      $link3='000000';
      $tab3='FFFFFF';
   }elsif($sam_selection==4){
      $link4='000000';
      $tab4='FFFFFF';
   }elsif($sam_selection==5){
      $link5='000000';
      $tab5='FFFFFF';
   }elsif($sam_selection==9){
      $link9='000000';
      $tab9='FFFFFF';
   }

   print "<tr><td><table border=0 width=680 cellspacing=0 cellpadding=0>";
   print "<tr><td align=left bgcolor=$main><IMG SRC=\"$htdocpath/samtitle.gif\" bgcolor=$main ALT=\"SAM\" TITLE=\"SAM\"></td><td colspan=2 align=left valign=bottom bgcolor=$main NOWRAP><font color='666666'><b><i>$sam_credential{'database'} Database</i></b></font></td></tr>";
   print "</table></td></tr>";

   print "<tr><td><table border=0 width=680 cellspacing=0 cellpadding=0>";
   print "<tr><td colspan=6 bgcolor=$main>&nbsp;</td></tr>";
   print "<tr><td align=center bgcolor=$tab1><A HREF=\"$scriptname?menu=8&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo&samselect=1\"><font color=$link1><span class=small>Import XML Trace</span></font></A></td>";
   print "<td align=center bgcolor=$tab2><A HREF=\"$scriptname?menu=8&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo&samselect=2\"><font color=$link2><span class=small>Assemble Sequences</span></font></A></td>";
   print "<td align=center bgcolor=$tab3><A HREF=\"$scriptname?menu=8&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo&samselect=3\"<font color=$link3><span class=small>Import Map</span></font></A></td>";
   print "<td align=center bgcolor=$tab4><A HREF=\"$scriptname?menu=8&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo&samselect=4\"<font color=$link4><span class=small>Tie Map</span></font></A></td>";
   print "<td align=center bgcolor=$tab5><A HREF=\"$scriptname?menu=8&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo&samselect=5\"<font color=$link5><span class=small>Annotate Genome</span></font></A></td>";
   print "<td align=center bgcolor=$tab9><A HREF=\"$scriptname?menu=8&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo&samselect=9\"><font color=$link9><span class=small>View Tasks</span></font></A></td></tr>";
   print "<tr><td colspan=6>&nbsp;</td></tr>";
   print "</table></td></tr>";
}

=for html <A NAME='displayTasks'>

=item displayTasks

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$task_reference</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$htdocpath</B>():  [Default = <B>shift</B>]<BR>
- <B>$sam_selection</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#----------------------------------
sub displayTasks{

   my $task_reference=shift;
   my @task=@$task_reference;
   my $scriptname=shift;
   my $htdocpath=shift;
   my $sam_selection=shift;
   my $menu=shift;
   my $fuzzykey=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $compressed_userinfo=shift;

   print "<FORM ACTION=\"$scriptname\" METHOD=\"POST\">";

   print "<tr><td colspan=6 align=center>";
   print "<table class=\"listing\" border=0 width=670>";
   print "<tr><th class=\"title\" align=left colspan=6>Task List</th></tr>";
   print "<tr>";
   print "<th><span class=small>ID</span></th><th><span class=small>Task</span></th><th><span class=small>Conditions</span></th>";
   print "<th><span class=small>User</span></th><th><span class=small>Date</span></th><th><span class=small>Status</span></th>";
   print "</tr>";

   my ($past, $value)=('even', '');
   my $ct_waiting=0;

   foreach my $ref (@task){

      my @record=@$ref;

      my @libraries=split(/,/, $record[6]);
      my $condition; 

      if ($record[10]==1 || $record[10]==3){
         $condition="Parse file $record[2] and populate database";
      }elsif($record[10]==2){
         $condition="Assemble all traces from @libraries libraries sequenced between $record[4] and $record[5] using $record[3] and gene finder ID=$record[11]";
      }elsif($record[10]==4){
         $condition="Tie Map ID=$record[13] to Assembly_ID=$record[12]";
      }elsif($record[10]==5){
         $condition="Annotate Assembly ID=$record[12] using gene finder ID=$record[11]";
      }#conditions being displayed on the page
    

      if ($past eq "even"){$value="odd"}else{$value="even";}

      print "<tr class=\"$value\">";
   
      if($record[9]=~/waiting/){
         print "<td style='text-align: center;'><span class=small>$record[0]</span><INPUT type=\"checkbox\" name=\"checkdeleted\" value=\"$record[0]\"></td>";
         $ct_waiting++;
      }else{#no checkbox (no delete option on initiated scripts)
         print "<td style='text-align: center;'><span class=small>$record[0]</span></td>";
      }
   
      print "<td><span class=small>$record[1]</span></td><td><span class=small>$condition</span></td>";
      print "<td><span class=small>$record[7]</span></td><td><span class=small>$record[8]</span></td><td><span class=small>$record[9]</span></td></tr>";
      $past=$value;
   }
   if($#task<0){
      print "<tr><td colspan=6 style='text-align: center;'><b>There are no tasks in the job queue</b></td></tr>";
   }

   if ($ct_waiting){###only allows deletion if there are tasks to delete
      print "<INPUT type=\"submit\" name=\"delete\" value=\"Delete Selected\" onClick=\"return checkDeleteTask(checkdeleted)\">";
      print "<input type=\"hidden\" NAME=\"assembly_id\" VALUE=\"$assembly_id\">";
      print "<input type=\"hidden\" NAME=\"fuzzykey\" VALUE=\"$fuzzykey\">";
      print "<input type=\"hidden\" NAME=\"menu\" VALUE=\"$menu\">";
      print "<input type=\"hidden\" NAME=\"samselect\" VALUE=\"$sam_selection\">";
      print "<input type=\"hidden\" NAME=\"data\" VALUE=\"$compressed_userinfo\">";
      print "<input type=\"hidden\" NAME=\"gene_finder_id\" VALUE=\"$gene_finder_id\">";
   }
   print "</table>";
   print "</td></tr>";
   print "</FORM>";
}

=for html <A NAME='displayAnnotateForm'>

=item displayAnnotateForm

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$htdocpath</B>():  [Default = <B>shift</B>]<BR>
- <B>$sam_selection</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_available</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_used</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_build</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub displayAnnotateForm{

   my $scriptname=shift;
   my $htdocpath=shift;
   my $sam_selection=shift;
   my $menu=shift;
   my $fuzzykey=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $compressed_userinfo=shift;
   my $gene_finder_available=shift;
   my @gene_finder_available=@$gene_finder_available;
   my $gene_finder_used=shift;
   my $tmp_build=shift;

   print "<FORM ACTION=\"$scriptname\" METHOD=\"POST\" ENCTYPE=\"multipart/form-data\">";

   print "<tr><td colspan=6><table border=0 width=670>";
   print "<tr><td valign=top><table border=0>";
   print "<tr><td align=left><i><b>Select An Assembly</b></i></td></tr>";
   print "<tr><td align=left><ul>";
   print "<SELECT NAME='assembly_id' onChange='top.location.href=\"$scriptname?fuzzykey=$fuzzykey&data=$compressed_userinfo&samselect=$sam_selection&menu=$menu&assembly_id=\"+this.options[selectedIndex].value;' Size='1'>";
   &assemblerBox($tmp_build, $assembly_id);
   print "</SELECT>";
   print "</td></tr>";
   print "</table></td><td valign=top><table>";
   print "<tr><td align=left><i><b>Select A Gene Finder</b></i></td></tr>";
 
   my $gene_finder_count=0;

   foreach my $reference(@gene_finder_available){
      my @record=@$reference;
      if (! defined $gene_finder_used->{$record[0]}){###only displays gene finders that have never been used for that assembly
         print "<tr><td><ul><INPUT TYPE=\"radio\" NAME=\"gene_finder_select\" VALUE=\"$record[0]\" CHECKED>$record[1]</td></tr>" if (! $gene_finder_count);
         print "<tr><td><ul><INPUT TYPE=\"radio\" NAME=\"gene_finder_select\" VALUE=\"$record[0]\">$record[1]</td></tr>" if ($gene_finder_count);
         $gene_finder_count++;
      }
   }
   print "<tr><td><ul>No More Gene Finder Available</td></tr>" if (! $gene_finder_count);

   print "</table></td></tr>";
   print "<tr><td colspan=2>&nbsp;</td></tr>";
   if ($gene_finder_count){
      print "<tr><td align=left colspan=2><i><b>E-mail</b></i></td></tr>";
      print "<tr><td align=left colspan=2><ul><INPUT TYPE=\"text\" NAME=\"email\" VALUE=\"\" SIZE=\"30\" MAXLENGTH=\"50\"></td></td>";
      print "<tr><td colspan=2 align=center><input type='submit' VALUE='Submit Request' NAME='annotate' onClick=\"return confirm('Annotate Contigs of Current Assembly?')\"></td></tr>";
   }
   print "</table></td></tr>";
   
   print "<input type=\"hidden\" NAME=\"assembly_id\" VALUE=\"$assembly_id\">";
   print "<input type=\"hidden\" NAME=\"fuzzykey\" VALUE=\"$fuzzykey\">";
   print "<input type=\"hidden\" NAME=\"menu\" VALUE=\"$menu\">";
   print "<input type=\"hidden\" NAME=\"samselect\" VALUE=\"$sam_selection\">";
   print "<input type=\"hidden\" NAME=\"data\" VALUE=\"$compressed_userinfo\">";
   print "<input type=\"hidden\" NAME=\"gene_finder_id\" VALUE=\"$gene_finder_id\">";

   print "</FORM>";

}

=for html <A NAME='displayTieMapForm'>

=item displayTieMapForm

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$htdocpath</B>():  [Default = <B>shift</B>]<BR>
- <B>$sam_selection</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_build</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_map</B>():  [Default = <B>shift</B>]<BR>
- <B>$map_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub displayTieMapForm{

   my $scriptname=shift;
   my $htdocpath=shift;
   my $sam_selection=shift;
   my $menu=shift;
   my $fuzzykey=shift;
   my $assembly_id=shift;
   my $compressed_userinfo=shift;
   my $tmp_build=shift;
   my $tmp_map=shift;
   my $map_id=shift;

   print "<FORM ACTION=\"$scriptname\" METHOD=\"POST\" ENCTYPE=\"multipart/form-data\">";

   print "<tr><td colspan=6><table border=0 width=670>";
   print "<tr><td valign=top><table border=0>";
   print "<tr><td align=left><i><b>Select An Assembly</b></i></td></tr>";
   print "<tr><td align=left><ul>";
   print "<SELECT NAME='assembly_id' onChange='top.location.href=\"$scriptname?fuzzykey=$fuzzykey&data=$compressed_userinfo&samselect=$sam_selection&menu=$menu&assembly_id=\"+this.options[selectedIndex].value;' Size='1'>";
   &assemblerBox($tmp_build, $assembly_id);
   print "</SELECT>";
   print "</td></tr>";
   print "</table></td><td valign=top><table>";
   print "<tr><td align=left><i><b>Select A Map</b></i></td></tr>";
   print "<tr><td align=left><ul>";
   print "<SELECT NAME=\"map_id\" Size=\"1\">";
   my $map_count=0;
   foreach my $ref (@$tmp_map){
      my @record=@$ref;
      if ($map_id!=$record[0]){#ensures that you don't tie a map on the same assembly twice
         $map_count++;
         print "<OPTION VALUE=$record[0]>v$record[1] ($record[2])</OPTION>";
      }
   }
   print "</SELECT>";
   print "</td></tr>";
   print "<tr><td><ul>No Maps Available for the Current Assembly</td></tr>" if (! $map_count);
   print "</table></td></tr>";
   print "<tr><td colspan=2>&nbsp;</td></tr>";

   if ($map_count){
      print "<tr><td align=left colspan=2><i><b>E-mail</b></i></td></tr>";
      print "<tr><td align=left colspan=2><ul><INPUT TYPE=\"text\" NAME=\"email\" VALUE=\"\" SIZE=\"30\" MAXLENGTH=\"50\"></td></td>";
      print "<tr><td colspan=2 align=center><input type='submit' VALUE='Submit Request' NAME='tiemap' onClick=\"return confirm('Tie Map with Current Assembly?')\"></td></tr>";
   }
   print "</table></td></tr>";

   print "<input type=\"hidden\" NAME=\"assembly_id\" VALUE=\"$assembly_id\">";
   print "<input type=\"hidden\" NAME=\"fuzzykey\" VALUE=\"$fuzzykey\">";
   print "<input type=\"hidden\" NAME=\"menu\" VALUE=\"$menu\">";
   print "<input type=\"hidden\" NAME=\"samselect\" VALUE=\"$sam_selection\">";
   print "<input type=\"hidden\" NAME=\"data\" VALUE=\"$compressed_userinfo\">";
   
   print "</FORM>";
}

=for html <A NAME='filePrompt'>

=item filePrompt

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$htdocpath</B>():  [Default = <B>shift</B>]<BR>
- <B>$sam_selection</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub filePrompt{

   my $scriptname=shift;
   my $htdocpath=shift;
   my $sam_selection=shift;
   my $menu=shift;
   my $fuzzykey=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $compressed_userinfo=shift;

   print "<FORM ACTION=\"$scriptname\" METHOD=\"POST\" ENCTYPE=\"multipart/form-data\">";
   
   print "<tr><td colspan=6><table border=0 width=670>";
   print "<tr><td colspan=2>&nbsp;</td></tr>";
   print "<tr><td align=right>File&nbsp;</td><td align=left><INPUT TYPE=\"text\" NAME=\"filename\" SIZE=\"55\" MAXLENGTH=\"100\"></td>";
   print "<tr><td align=right>E-mail&nbsp;</td><td align=left><INPUT TYPE=\"text\" NAME=\"email\" VALUE=\"\" SIZE=\"30\" MAXLENGTH=\"50\"></td>";
   print "<tr><td>&nbsp;</td><td align=left><INPUT TYPE=\"SUBMIT\" VALUE=\"Parse File\" onClick=\"return confirm('Parse '+filename.value+' & populate the database?')\"></td></tr>";
   print "</table></td></tr>";

   print "<input type=\"hidden\" NAME=\"assembly_id\" VALUE=\"$assembly_id\">";
   print "<input type=\"hidden\" NAME=\"fuzzykey\" VALUE=\"$fuzzykey\">";
   print "<input type=\"hidden\" NAME=\"menu\" VALUE=\"$menu\">";
   print "<input type=\"hidden\" NAME=\"samselect\" VALUE=\"$sam_selection\">";
   print "<input type=\"hidden\" NAME=\"data\" VALUE=\"$compressed_userinfo\">";
   print "<input type=\"hidden\" NAME=\"gene_finder_id\" VALUE=\"$gene_finder_id\">";

   print "</FORM>";
}

=for html <A NAME='displayMessage'>

=item displayMessage

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$comment</B>():  [Default = <B>shift</B>]<BR>
- <B>$color</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub displayMessage{

   my $comment=shift;
   my $color=shift;

   print "<table border=0>";
   print "<tr><td><font color=$color>$comment</font></td></tr>";
   print "</table>";

}

=for html <A NAME='displayAssembleForm'>

=item displayAssembleForm

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$htdocpath</B>():  [Default = <B>shift</B>]<BR>
- <B>$sam_selection</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_assembler_list</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_library_list</B>():  [Default = <B>shift</B>]<BR>
- <B>$sequence_date</B>():  [Default = <B>shift</B>]<BR>
- <B>$most_recent_date</B>():  [Default = <B>shift</B>]<BR>
- <B>$least_recent_date</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_used</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub displayAssembleForm{

   my $scriptname=shift;
   my $htdocpath=shift;
   my $sam_selection=shift;
   my $menu=shift;
   my $fuzzykey=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $compressed_userinfo=shift;
   my $tmp_assembler_list=shift;
   my @assembler_ref=@$tmp_assembler_list;   
   my $tmp_library_list=shift;
   my @library_ref=@$tmp_library_list;
   my $sequence_date=shift;
   my %sequence_date=%$sequence_date;
   my $most_recent_date=shift;
   my $least_recent_date=shift;
   my $gene_finder_used=shift;
   my @gene_finder_used=@$gene_finder_used;   

   ####Print Form
   print "<FORM ACTION=\"$scriptname\" METHOD=\"POST\">";

   print "<tr><td colspan=6 align=center>";
   print "<table border=0 width=680>";
   #---
   print "<tr><td valign=top><table border=0>";

   print "<tr><td><table border=0>";
   print "<tr><td align=left><i><b>Select An Assembler</b></i></td></tr>";
   my $assembler_count=0;
   foreach my $reference(@assembler_ref){
      my @assembler_arr=@$reference;
      print "<tr><td><ul><INPUT TYPE=\"radio\" NAME=\"assembler\" VALUE=\"$assembler_arr[0]\" CHECKED>$assembler_arr[0]</td></tr>" if (! $assembler_count);
      print "<tr><td><ul><INPUT TYPE=\"radio\" NAME=\"assembler\" VALUE=\"$assembler_arr[0]\">$assembler_arr[0]</td></tr>" if ($assembler_count);
      $assembler_count++;
   }
   print "</table>";
   print "<tr><td><table>";
   print "<tr><td align=left><i><b>Select An Assembly Type</b></i></td></tr>";
   print "<tr><td><ul><INPUT TYPE=\"radio\" NAME=\"assembly_type\" VALUE=\"1\" CHECKED>New Build</td></tr>";
   print "<tr><td><ul><INPUT TYPE=\"radio\" NAME=\"assembly_type\" VALUE=\"-1\">New Version</td></tr>";
   print "</table>";
   print "</td></tr>";

   print "<tr><td><table>";
   print "<tr><td align=left><i><b>Select A Gene Finder</b></i></td></tr>";

   print "<tr><td><ul><INPUT TYPE=\"radio\" NAME=\"gene_finder_select\" VALUE=\"-1\" CHECKED>None</td></tr>";
   foreach my $reference(@gene_finder_used){
      my @record=@$reference;
      print "<tr><td><ul><INPUT TYPE=\"radio\" NAME=\"gene_finder_select\" VALUE=\"$record[0]\">$record[1]</td></tr>";
   }

   print "</table>";
   print "</td></tr>";

   print "</table></td><td valign=top><table border=0>";
   #---
   print "<tr><td align=left><i><b>Select Libraries</b></i></td></tr>";
   print "<tr><td><ul><INPUT TYPE=\"checkbox\" NAME=\"checkall\" VALUE=\"1\" onClick=\"return checkAllBox(library, checkall)\"><font color='066828'>Select All</font></td></tr>";
    foreach my $reference(@library_ref){
      my @library_arr=@$reference;
      print "<tr><td><ul><INPUT TYPE=\"checkbox\" NAME=\"library\" VALUE=\"$library_arr[0]\">$library_arr[0]</td></tr>";
   }
   #---
   print "</table></td><td valign=top><table border=0>";
   print "<tr><td align=left colspan=2><i><b>Select Traces</b></i></td></tr>";
   print "<tr><td><ul>Starting</td></tr>";
   print "<tr><td><ul>";
   print "<SELECT NAME=\"startseq\" Size=7>";
   
   foreach my $date(sort {$a cmp $b} keys %sequence_date){
       print "<OPTION value=\"$date\">$date" if ($date ne $least_recent_date);
       print "<OPTION SELECTED value=\"$date\">$date" if ($date eq $least_recent_date);
   }
   print "</SELECT>";
   print "</td></tr>";
   
   print "<tr><td><ul>Ending</td></tr>";
   print "<tr><td><ul>";
   print "<SELECT NAME=\"endseq\" Size=7>";

   foreach my $date(sort {$b cmp $a} keys %sequence_date){
       print "<OPTION value=\"$date\">$date" if ($date ne $most_recent_date);
       print "<OPTION SELECTED value=\"$date\">$date" if ($date eq $most_recent_date);
   }
   print "</SELECT>";
   print "</td></tr>";
   print "</table></td></tr>";

   #---
   print "<tr><td align=left colspan=2><i><b>E-mail</b></i></td></tr>";
   print "<tr><td align=left colspan=2><ul><INPUT TYPE=\"text\" NAME=\"email\" VALUE=\"\" SIZE=\"30\" MAXLENGTH=\"50\"></td></td>";
   #---
   print "<input type=\"hidden\" NAME=\"assembly_id\" VALUE=\"$assembly_id\">";
   print "<input type=\"hidden\" NAME=\"fuzzykey\" VALUE=\"$fuzzykey\">";
   print "<input type=\"hidden\" NAME=\"menu\" VALUE=\"$menu\">";
   print "<input type=\"hidden\" NAME=\"samselect\" VALUE=\"$sam_selection\">";
   print "<input type=\"hidden\" NAME=\"data\" VALUE=\"$compressed_userinfo\">";
   print "<input type=\"hidden\" NAME=\"gene_finder_id\" VALUE=\"$gene_finder_id\">";
   #---
   print "<tr><td colspan=2 align=left><ul><INPUT TYPE=\"SUBMIT\" NAME=\"request\" VALUE=\"Send Request\" onClick=\"return checkAssemblyInput(assembler, library, startseq, endseq)\"></td></tr>";
   #---
   print "</td></tr>";
   print "</table>";
   print "</td></tr>";
   print "</FORM>";
}

=for html <A NAME='SAMwelcome'>

=item SAMwelcome

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
- None<BR>
<BR>

=cut

#------------------------------------------
sub SAMwelcome{

   print "<tr><td colspan=6>";
   print "<table width=680 border=0>";
   print "<tr><td align=center><i><b><font color='000000'>Welcome to SAM, the GSC Whole Genome Shotgun Sequence Assembly Manager.</font></b></i></td></tr>";
   print "</table>";
   print "</td></tr>";

}

=for html <A NAME='setHTML'>

=item setHTML

=for html
Common Code #####################<BR>print HTML from CGI script<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$page</B>():  [Default = <B>shift</B>]<BR>
- <B>$htdocpath</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

######################## Common Code #####################
#------------------------------------------
sub setHTML{
    # print HTML from CGI script

    my $page=shift;
    my $htdocpath=shift;

    my $JS1=$htdocpath."/integrityCheck.js";
    my $JS2=$htdocpath."/winpopup.js";
    

    print $page->header,    # create the HTTP header
          $page->start_html(-title=>'SAM Sequence Assembly Manager');

    print "<script language=\"JavaScript\" src=\"$JS1\"></script>";
    print "<script language=\"JavaScript\" src=\"$JS2\"></script>";

    print "<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"/site-style/common.css\">";
    print "<STYLE TYPE=\"text/css\">";
    print "span.small { font-size: small;}";
    print "span.large { font-size: medium;}";
    print "span.vlarge { font-size: large;}";

    print "</STYLE>";

    print "<center>";

}

=for html <A NAME='printTitle'>

=item printTitle

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$htdocpath</B>():  [Default = <B>shift</B>]<BR>
- <B>$project</B>():  [Default = <B>shift</B>]<BR>
- <B>$pass</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#------------------------------------------
sub printTitle{

    my $htdocpath=shift;
    my $project=shift;
    my @project=@$project;
    my $pass=shift;
    my $fuzzykey=shift;
    my $scriptname=shift;

    my $project_image_url="$htdocpath/$project[3]";
    my $ua = new LWP::UserAgent;
    my $request = new HTTP::Request('GET',$project_image_url);
    $ua->protocols_allowed( [ 'http', 'https'] );
    my $response = $ua->request($request);

    my $code=$response->code;
    print "<table width=680 border=0>";
    print "<tr>";
    print "<td valign=top><table border=0 cellspacing=0 cellpadding=0>";

    print "<tr><td valign=top><table border=0>";
    print "<tr><td><A HREF=\"$scriptname\"><IMG SRC=$project_image_url BORDER=0 ALT=\"$project[0] WGS home page\" TITLE=\"$project[0] WGS home page\"></A></td></tr>"; #if ($code);
    print "</table></td><td valign=top><table border=0 align=center>";
    print "<tr><td><span class=vlarge><font color='FF6666'><b>$project[0]</b></FONT></span></td></tr>";
    print "<tr><td><b><i>&nbsp;&nbsp;&nbsp;&nbsp;$project[1]</i></b><td></tr>";
    print "</table></td></tr>";

    print "</table></td>";
    print "<td valign=top align=right><table border=0>";
    if ($pass==1){
        print "<FORM ACTION=\"$scriptname\" METHOD='POST'>";
        print "<tr><td align=right><INPUT TYPE=\"image\" SRC=\"$htdocpath/samlogout.gif\" ALT=\"Logout from SAM\" TITLE=\"Logout from SAM\" NAME=\"\" VALUE=\"Log Out\"></td></tr>";
        print "<INPUT TYPE=\"hidden\" NAME=\"fuzzykey\" VALUE=\"$fuzzykey\">";
        print "</FORM>";
    }else{
        print "<tr><td>&nbsp;</td></tr>";
    }
 
    print "</table></td></tr>";
    print "<tr><td>&nbsp;</td></tr>" if ($pass !=1);
    print "</table>";

}

=for html <A NAME='printLink'>

=item printLink

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$htdocpath</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#------------------------------------------
sub printLink{

   my $scriptname=shift;
   my $assembly_id=shift; 
   my $gene_finder_id=shift;
   my $htdocpath=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;
   my $menu=shift;

   my ($link0,$link1,$link2,$link3,$link4,$link5,$link6,$link7, $link8); 
   $link0=$link1=$link2=$link3=$link4=$link5=$link6=$link7=$link8='0000FF';

   if($menu==0 || $menu==99){
      $link0='000000';
   }elsif($menu==1){
      $link1='000000';
   }elsif($menu==2){
      $link2='000000';
   }elsif($menu==3){
      $link3='000000';
   }elsif($menu==4){
      $link4='000000';
   }elsif($menu==5){
      $link5='000000';
   }elsif($menu==6){
      $link6='000000';
   }elsif($menu==7){
      $link7='000000';
   }elsif($menu==8){
      $link8='000000';
   }

   print "<table width=680 border=0>";
   print "<tr>";
   print "<td width=112 align=center><span class=small><A HREF=\"$scriptname?assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\"><font color=$link0>Home</font></A></span></td>";
   print "<td width=112 align=center><span class=small><A HREF=\"$scriptname?menu=1&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\"><font color=$link1>Assembly Details</font></A></span></td>";
   print "<td width=112 align=center><span class=small><A HREF=\"$scriptname?menu=2&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\"><font color=$link2>Compare</font></A></span></td>";
   print "<td width=112 align=center><span class=small><A HREF=\"$scriptname?menu=3&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\"><font color=$link3>Contig View</font></A></span></td>";
   print "<td width=112 align=center><span class=small><A HREF=\"$scriptname?menu=4&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\"><font color=$link4>Map View</font></A></span></td>";
   print "<td width=112 align=center><span class=small><A HREF=\"$scriptname?menu=5&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\"><font color=$link5>ORFs</font></A></span></td>";
   print "<td width=112 align=center><span class=small><A HREF=\"$scriptname?menu=6&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\"><font color=$link6>Blast</font></A></span></td>";
   print "<td width=112 align=center><span class=small><A HREF=\"$htdocpath/report/\"><font color=$link7>Reports</font></A></span></td>";
   print "<td width=112 align=center><span class=small><A HREF=\"$scriptname?menu=8&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\"><font color=$link8>SAM</A></font></span></td>";
   print "</tr>";
   print "<tr><td colspan=9><HR noshade=1></td></tr>";
   print "</table>";

}

=for html <A NAME='assemblerBox'>

=item assemblerBox

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_build</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#------------------------------------------
sub assemblerBox{

   my $tmp_build=shift;
   my $assembly_id=shift;
   
   my @build_ref=@$tmp_build;

   foreach my $reference(@build_ref){
      my @assembler_arr=@$reference;

      if ($assembly_id==$assembler_arr[2]){
         print "<OPTION VALUE=$assembler_arr[2] SELECTED>$assembler_arr[0] Build $assembler_arr[1]  $assembler_arr[3]</OPTION>";
      }else{
         print "<OPTION VALUE=$assembler_arr[2]>$assembler_arr[0] Build $assembler_arr[1]  $assembler_arr[3]</OPTION>";
      }
   }
}

=for html <A NAME='simpleSelectionBox'>

=item simpleSelectionBox

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$selection</B>():  [Default = <B>shift</B>]<BR>
- <B>$current_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#------------------------------------------
sub simpleSelectionBox{

   my $selection=shift;
   my %selection=%$selection;
   my $current_id=shift;
  
   foreach my $any_id (keys %selection){

      if ($current_id==$any_id){
         print "<OPTION VALUE=$any_id SELECTED>$selection{$any_id}</OPTION>";
      }else{
         print "<OPTION VALUE=$any_id>$selection{$any_id}</OPTION>";
      }
   }
}

=for html <A NAME='arraySelectionBox'>

=item arraySelectionBox

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$selection</B>():  [Default = <B>shift</B>]<BR>
- <B>$current_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#------------------------------------------
sub arraySelectionBox{

   my $selection=shift;
   my @selection=@$selection;
   my $current_id=shift;
 
   foreach my $element (@selection){

      if ($current_id==$element){
         print "<OPTION VALUE=$element SELECTED>$element</OPTION>";
      }else{
         print "<OPTION VALUE=$element>$element</OPTION>";
      }
   }
}

=for html <A NAME='printHomePage'>

=item printHomePage

=for html
Main Page #######################<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_list</B>():  [Default = <B>shift</B>]<BR>
- <B>$orf_info</B>():  [Default = <B>shift</B>]<BR>
- <B>$init_codon</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_build</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$download_config</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_available</B>():  [Default = <B>shift</B>]<BR>
- <B>$project</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

######################## Main Page #######################

#------------------------------------------
sub printHomePage{

   my $assembly_id=shift;
   my $assembly_list=shift;
   my $orf_info=shift;
   my $init_codon=shift;
   my $tmp_build=shift;
   my $scriptname=shift; 
   my $fuzzykey=shift;
   my $download_config=shift;
   my $compressed_userinfo=shift;
   my $gene_finder_id=shift;
   my $gene_finder_available=shift;
   my $project=shift;
   my @project=@$project;

   print "<table width=680 border=0>";
   print "<tr><td>";
   &printAssemblyInfo($assembly_list, $tmp_build, $assembly_id, $scriptname, $fuzzykey, $compressed_userinfo);
   print "</td></tr>";
   print "<tr><td align=center><table width=680 border=0>";
   print "<tr><td valign=top align=left>";
   &printContigInfo($assembly_list, $download_config);
   print "</td><td valign=top align=right>";
   &printOrfInfo($orf_info, $init_codon, $download_config, $gene_finder_id, $gene_finder_available, $scriptname, $assembly_id, $fuzzykey, $compressed_userinfo) if (defined $gene_finder_id);
   print "</td></tr></table>";
   print "</td></tr>";
   print "<tr><td>&nbsp;</td></tr>";
   print "<tr><td><A name='genome_size'></A><sup>1</sup><font color=000099>Estimated Genome Size=$project[2]bp</font></td></tr>";
   print "<tr><td><A name='genome_coverage'></A><sup>2</sup><font color=000099>Genome Coverage:&nbsp;X<sub>g</sub>=(N*L)/G</font></td></tr>";
   print "<tr><td><A name='poisson_genome'></A><sup>3</sup><font color=000099>Poisson Genome Size Estimate:&nbsp;G<sub>p</sub>=(L/ln(C/N))*(-1*N)</font></td></tr>";
   print "<tr><td><A name='poisson_contig'></A><sup>4</sup><font color=000099>Poisson Contig Number Estimate:&nbsp;C=N*e(-1*(NL/G<sub>p</sub>))</font></td></tr>";
   print "<tr><td><A name='poisson_coverage'></A><sup>5</sup><font color=000099>Poisson Genome Coverage:&nbsp;X<sub>p</sub>=(N*L)/G<sub>p</sub></font></td></tr>";
   print "<tr><td><A name='contig_coverage'></A><sup>6</sup><font color=000099>Contig Coverage:&nbsp;X<sub>c</sub>=(N*L)/T  where T>1kb AND no singleton</font></td></tr>";
   print "<tr><td><span class=small><font color=006600>N:Assembled Reads  L:Average Read Length  G:Genome Size  G<sub>p</sub>:Poisson Genome Size  C:Contig Number  T:Total Contig Size  X:Genome Coverage  X<sub>p</sub>:Poisson Genome Coverage  X<sub>c</sub>:Contig Coverage</font></span></td></tr>";
   print "<tr><td><A name='N50'></A><sup>7</sup><font color=000099>N50:&nbsp;Contig length L such that 50% of all bases are contained in contigs of length L or larger</font></td></tr>";
   print "</table>";
}

=for html <A NAME='printAssemblyInfo'>

=item printAssemblyInfo

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_assembly</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_build</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#------------------------------------------
sub printAssemblyInfo{

   my $tmp_assembly=shift;
   my %assembly=%$tmp_assembly;
   my $tmp_build=shift;
   my $assembly_id=shift;
   my $scriptname=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   print "<table class='listing' border=0 width=680>";
  
   print "<tr><th class='title' style='text-align: left;' colspan=2><span class=large><b>Assembly Information</b></span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
   print "<SELECT NAME='assembly_id' onChange='top.location.href=\"$scriptname?fuzzykey=$fuzzykey&data=$compressed_userinfo&assembly_id=\"+this.options[selectedIndex].value;' Size='1'>";
   &assemblerBox($tmp_build, $assembly_id); 
   print "</SELECT>";
   print "</th></tr>";
   print "<tr><th colspan=2 align=left><b>General Information</b></th></tr>";
   print "<tr class='odd'><td>Date Assembled</td><td style='text-align: right;'>$assembly{'date_assembled'}</td></tr>";

   print "<tr class='even'><td>Genome<sup><A href=#genome_coverage>1</A></sup> Coverage<sup><A href=#genome_size>2</A></sup></td><td style='text-align: right;'>$assembly{'genome_coverage'}</td></tr>";
   print "<tr class='odd'><td>Calculated Genome Size<sup><A href=#poisson_genome>3</A></sup></td><td style='text-align: right;'>$assembly{'poisson_size'}</td></tr>";
   print "<tr class='even'><td>Expected Contigs<sup><A href=#poisson_contig>4</A></sup></td><td style='text-align: right;'>$assembly{'poisson_contig'}</td></tr>";
   print "<tr class='odd'><td>Genome Coverage from Calculated Genome Size<sup><A href=#poisson_coverage>5</A></sup></td><td style='text-align: right;'>$assembly{'poisson_coverage'}</td></tr>";

   print "<tr><th colspan=2 align=left><b>Bases Information</b></th></tr>";
   print "<tr class='odd'><td>Total Bases</td><td style='text-align: right;'>$assembly{'base'}</td></tr>";
   print "<tr class='even'><td>Total Consensus</td><td style='text-align: right;'>$assembly{'consensus'}</td></tr>";
   print "<tr class='odd'><td>Number of Phred40 bases</td><td style='text-align: right;'>$assembly{'phred40'}</td></tr>";
   print "<tr class='even'><td>Average Error (per 10kb)</td><td style='text-align: right;'>$assembly{'error'}</td></tr>";

   print "<tr><td colspan=2><table class='listing' border=0>";
   print "<tr><th class='title' colspan=2><span class=large><b>Bases Composition</b></span></th></tr>";
   print "<tr><th><b>Base</b></td><th align=center><b>%</b></td></tr>";
   print "<tr class='odd'><td>A</td><td style='text-align: right;'>$assembly{'percentA'}</td></tr>"; 
   print "<tr class='even'><td>T</td><td style='text-align: right;'>$assembly{'percentT'}</td></tr>";
   print "<tr class='odd'><td>C</td><td style='text-align: right;'>$assembly{'percentC'}</td></tr>";
   print "<tr class='even'><td>G</td><td style='text-align: right;'>$assembly{'percentG'}</td></tr>";
   print "</table></td></tr>";

   print "<tr><th colspan=2 style='text-align: left;'><b>Read Information</b></th></tr>";
   print "<tr class='odd'><td>Reads Analyzed</td><td style='text-align: right;'>$assembly{'analyzed_read'}</td></tr>";
   print "<tr class='even'><td>Reads Assembled</td><td style='text-align: right;'>$assembly{'assembled_read'}</td></tr>";
   print "<tr class='odd'><td>Read as Singletons (<=5% masked bases)</td><td style='text-align: right;'>$assembly{'singleton_read'}</td></tr>";
   print "<tr class='even'><td>Bad Quality Reads (>20% low quality bases)</td><td style='text-align: right;'>$assembly{'bad_read'}</td></tr>";
   print "<tr class='odd'><td>Masqued Reads (>5% masked bases)</td><td style='text-align: right;'>$assembly{'masked_read'}</td></tr>";

   print "<tr class='odd'><th colspan=2 style='text-align: left;'><b>Contig Information</b></th></tr>";
   print "<tr class='even'><td>Number of Contigs</td><td style='text-align: right;'>$assembly{'contig'}</td></tr>";
   print "<tr class='odd'><td>Number of Assembled Singletons</td><td style='text-align: right;'>$assembly{'singleton_contig'}</td></tr>";
   print "<tr class='even'><td>Mean Contig Size</td><td style='text-align: right;'>$assembly{'mean_tig'}</td></tr>";
   print "<tr class='odd'><td>Largest Contig</td><td style='text-align: right;'>$assembly{'largest_contig'}</td></tr>";
   print "<tr class='even'><td>Smallest Contig</td><td style='text-align: right;'>$assembly{'smallest_contig'}</td></tr>";
   print "<tr class='odd'><td>Contig Coverage<sup><A href=#contig_coverage>6</A></sup></td><td style='text-align: right;'>$assembly{'tig_coverage'}</td></tr>";
   print "<tr class='even'><td>N50 length<sup><A href=#N50>7</A></sup></td><td style='text-align: right;'>$assembly{'N50'}</td></tr>";
   print "<tr class='odd'><th colspan=2 style='text-align: left;'><b>SuperContig Information</b></th></tr>";
   print "<tr class='even'><td>Number of Supercontigs</td><td style='text-align: right;'>$assembly{'supertig'}</td></tr>";
   print "<tr class='odd'><td>Total Supercontigs Size</td><td style='text-align: right;'>$assembly{'supertig_size'}</td></tr>";
   print "<tr class='even'><td>Mean Supercontig Size</td><td style='text-align: right;'>$assembly{'mean_super'}</td></tr>";

   print "</table>";

}

=for html <A NAME='printContigInfo'>

=item printContigInfo

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_assembly</B>():  [Default = <B>shift</B>]<BR>
- <B>$download_config</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#------------------------------------------
sub printContigInfo{

   my $tmp_assembly=shift;
   my %assembly=%$tmp_assembly;
   my $download_config=shift;
   my %download_config=%$download_config;

   print "<table class='listing' width=300 border=0 cellspacing=0 cellpadding=0>";
   print "<tr><th class='title' colspan=2 style='text-align: left;'><span class=large><b>Contig Composition</b></span></th></tr>";
   print "<tr><th><b>Reads per Contig</b></th><th><b>Number of Contigs</b></th></tr>";
   print "<tr class='odd'><td>1</td><td style='text-align: right;'>$assembly{'singleton_contig'}</td></tr>";
   print "<tr class='even'><td>2</td><td style='text-align: right;'>$assembly{'2read'}</td></tr>";
   print "<tr class='odd'><td>3</td><td style='text-align: right;'>$assembly{'3read'}</td></tr>";
   print "<tr class='even'><td>4</td><td style='text-align: right;'>$assembly{'4read'}</td></tr>";
   print "<tr class='odd'><td>5</td><td style='text-align: right;'>$assembly{'5read'}</td></tr>";
   print "<tr class='even'><td>6+</td><td style='text-align: right;'>$assembly{'6read'}</td></tr>";
   print "<tr class='odd'><td>10+</td><td style='text-align: right;'>$assembly{'10read'}</td></tr>";
   print "<tr class='even'><td>20+</td><td style='text-align: right;'>$assembly{'20read'}</td></tr>";
   print "<tr class='odd'><td colspan=2 style='text-align: center;'><b><A HREF=\"$download_config{'contig'}\" TARGET='blank'>Download Contig Sequences</A></b></td></tr>";
   print "</table>";

}

=for html <A NAME='printOrfInfo'>

=item printOrfInfo

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_orf</B>():  [Default = <B>shift</B>]<BR>
- <B>$init_codon</B>():  [Default = <B>shift</B>]<BR>
- <B>$download_config</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_available</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#------------------------------------------
sub printOrfInfo{

   my $tmp_orf=shift;
   my %orf=%$tmp_orf;
   my $init_codon=shift;
   my %init_codon=%$init_codon;
   my $download_config=shift;
   my %download_config=%$download_config;
   my $gene_finder_id=shift;
   my $gene_finder_available=shift;
   my $scriptname=shift;
   my $assembly_id=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   print "<table class='listing' width=300 border=0 cellspacing=0 cellpadding=0>";
   print "<tr><th class='title' colspan=2 style='text-align: left;'><A name='orf'></A><span class=large><b>ORF Info</b></span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
   print "<SELECT NAME='gene_finder_id' onChange='top.location.href=\"$scriptname?fuzzykey=$fuzzykey&data=$compressed_userinfo&assembly_id=$assembly_id&gene_finder_id=\"+this.options[selectedIndex].value+\"#orf\";' Size='1'>";
   &simpleSelectionBox($gene_finder_available, $gene_finder_id);
   print "</SELECT>";
   print "</th></tr>";
   print "<tr><th><b>General Stats</b></th><th><b>Value</b></th></tr>";
   print "<tr class='odd'><td>Number of putative genes</td><td style='text-align: right;'>$orf{'count'}</td></tr>";
   print "<tr class='even'><td>Biggest gene (bp)</td><td style='text-align: right;'>$orf{'max'}</td></tr>";
   print "<tr class='odd'><td>Smallest gene (bp)</td><td style='text-align: right;'>$orf{'min'}</td></tr>";
   print "<tr class='even'><td>Mean gene size (bp)</td><td style='text-align: right;'>$orf{'mean'}</td></tr>";
   if ($orf{'count'}){
      print "<tr class='odd'><td colspan=2 style='text-align: center;'><b><A HREF=\"$download_config{'orf'}\" TARGET='blank'>Download ORF Protein Sequences</A></b></td></tr>";
      print "<tr class='odd'><td colspan=2 style='text-align: center;'><b><A HREF=\"$download_config{'orf_cds'}\" TARGET='blank'>Download ORF DNA Sequences</A></b></td></tr>";
   }
   print "<tr><th><b>Start Codon Usage</b></th><th><b>%</b></th></tr>";

   my ($past, $value)=("even", "");
   foreach my $type (sort {$init_codon{$b}<=>$init_codon{$a}} keys %init_codon){
     if ($past eq "even"){$value="odd"}else{$value="even";}
     print "<tr class=\"$value\"><td>$type</td><td style='text-align: right;'>$init_codon{$type}</td></tr>";
     $past=$value;
   }
   print "</table>";

}

=for html <A NAME='showCompare'>

=item showCompare

=for html
Compare Assemblies #######################<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_build</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$compare_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$compare_list</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
- <B>$project</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

######################## Compare Assemblies #######################

#------------------------------------------
sub showCompare{

   my $tmp_build=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $compare_id=shift;
   my $compare_list=shift;
   my $scriptname=shift;
   my $menu=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;
   my $project=shift; 

   print "<H1>Compare Assemblies</H1>";

   my $assembly_desc=&assemblyComparisonSelection($tmp_build, $assembly_id, $gene_finder_id, $compare_id, $scriptname, $menu, $fuzzykey, $compressed_userinfo);
   &tableComparison($compare_list, $assembly_id, $compare_id, $assembly_desc, $project);

}

=for html <A NAME='tableComparison'>

=item tableComparison

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$compare_list</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$compare_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_desc</B>():  [Default = <B>shift</B>]<BR>
- <B>$project</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#------------------------------------------
sub tableComparison{

   my $compare_list=shift;
   my %compare=%$compare_list;
   my $assembly_id=shift;
   my $compare_id=shift;
   my $assembly_desc=shift;
   my %assembly_desc=%$assembly_desc;
   my $project=shift;

   print "<table border=3 width=680 align=center>";
   print "<tr><td>";   
   print "<table border=0 width=680 cellspacing=0 cellpadding=0>";

   #print "<tr><th class='title' style='text-align: left;' colspan=4 >Assembly Comparison</th></tr>";
   print "<tr><th colspan=4 align=left bgcolor='99CCFF'>Assembly Comparison</th></tr>";
   print "<tr bgcolor='D8BFD8'><th align=left>Assembly</th><th align=center>$assembly_desc{'one'}{'assembler'}&nbsp;Build&nbsp;$assembly_desc{'one'}{'build'} $assembly_desc{'one'}{'type'}</th><th align=center>$assembly_desc{'two'}{'assembler'}&nbsp;Build&nbsp;$assembly_desc{'two'}{'build'} $assembly_desc{'two'}{'type'}</th><th align=right>Change</th></tr>";

   ###allow to customize the way data is displayed (order) 
#   my @intro_list=('Date Assembled','Genome Coverage','Poisson Genome Size','Poisson Genome Coverage', 'Analyzed Read','Assembled Read', 'Singleton Read', 'Contig Number', 'Mean Tig', 'N50', 'Contig Coverage', 'Poisson Contig', 'Largest Tig', 'Smallest Tig', 'Singleton Contig', 'Supertig Number', 'Mean Super', 'Supertig Size');

#   my @spec_list=('Total Bases','Consensus','Phred40', 'Error', 'Percent A','Percent T','Percent G','Percent C', 'Masked Read', 'Bad Quality Read', '2Read Contig', '3Read Contig','4Read Contig','5Read Contig','6Read Contig','10Read Contig', '20Read Contig');

   print "<tr><td colspan=4 align=left><b>Genome Coverage</b></td></tr>";
   print "<tr bgcolor='F6F6F6'><td>Date Assembled</td><td align=right>$compare{'Date Assembled'}{'one'}</td><td align=right>$compare{'Date Assembled'}{'two'}</td><td align=right>$compare{'Date Assembled'}{'delta'}</td><tr>";
   print "<tr><td>Genome Coverage<sup><A href=#genome>1</A></sup></td><td align=right>$compare{'Genome Coverage'}{'one'}</td><td align=right>$compare{'Genome Coverage'}{'two'}</td><td align=right>$compare{'Genome Coverage'}{'delta'}</td><tr>";
   print "<tr bgcolor='F6F6F6'><td>Genome Size (Poisson Distribution)</td><td align=right>$compare{'Poisson Genome Size'}{'one'}</td><td align=right>$compare{'Poisson Genome Size'}{'two'}</td><td align=right >$compare{'Poisson Genome Size'}{'delta'}</td><tr>";
   print "<tr><td>Genome Coverage from Poisson Genome Size</td><td align=right>$compare{'Poisson Genome Coverage'}{'one'}</td><td align=right>$compare{'Poisson Genome Coverage'}{'two'}</td><td align=right>$compare{'Poisson Genome Coverage'}{'delta'}</td><tr>";
   print "<tr><td colspan=4>&nbsp;</td></tr>";

   print "<tr><td colspan=4 align=left><b>Reads</b></td></tr>";
   print "<tr bgcolor='F6F6F6'><td>Analyzed Reads</td><td align=right>$compare{'Analyzed Read'}{'one'}</td><td align=right>$compare{'Analyzed Read'}{'two'}</td><td align=right>$compare{'Analyzed Read'}{'delta'}</td><tr>";
   print "<tr><td>Assembled Reads</td><td align=right>$compare{'Assembled Read'}{'one'}</td><td align=right>$compare{'Assembled Read'}{'two'}</td><td align=right>$compare{'Assembled Read'}{'delta'}</td><tr>";
   print "<tr bgcolor='F6F6F6'><td>Singleton Reads</td><td align=right>$compare{'Singleton Read'}{'one'}</td><td align=right>$compare{'Singleton Read'}{'two'}</td><td align=right>$compare{'Singleton Read'}{'delta'}</td><tr>";
   print "<tr><td>Masked Reads</td><td align=right>$compare{'Masked Read'}{'one'}</td><td align=right>$compare{'Masked Read'}{'two'}</td><td align=right>$compare{'Masked Read'}{'delta'}</td><tr>";
   print "<tr bgcolor='F6F6F6'><td>Bad Quality Reads</td><td align=right>$compare{'Bad Quality Read'}{'one'}</td><td align=right>$compare{'Bad Quality Read'}{'two'}</td><td align=right>$compare{'Bad Quality Read'}{'delta'}</td><tr>";

   print "<tr><td colspan=4>&nbsp;</td></tr>";

   print "<tr><td colspan=4 align=left><b>Contigs</b></td></tr>";
   print "<tr bgcolor='F6F6F6'><td>Number of Contigs</td><td align=right>$compare{'Contig Number'}{'one'}</td><td align=right>$compare{'Contig Number'}{'two'}</td><td align=right>$compare{'Contig Number'}{'delta'}</td><tr>";
   print "<tr><td>Mean Contig Size (bp)</td><td align=right>$compare{'Mean Tig'}{'one'}</td><td align=right>$compare{'Mean Tig'}{'two'}</td><td align=right>$compare{'Mean Tig'}{'delta'}</td><tr>";
   print "<tr bgcolor='F6F6F6'><td>Contig N50 (bp)</td><td align=right>$compare{'N50'}{'one'}</td><td align=right>$compare{'N50'}{'two'}</td><td align=right>$compare{'N50'}{'delta'}</td><tr>";
   print "<tr><td>Contig Coverage</td><td align=right>$compare{'Contig Coverage'}{'one'}</td><td align=right>$compare{'Contig Coverage'}{'two'}</td><td align=right>$compare{'Contig Coverage'}{'delta'}</td><tr>";
   print "<tr bgcolor='F6F6F6'><td>Poisson Contig</td><td align=right>$compare{'Poisson Contig'}{'one'}</td><td align=right>$compare{'Poisson Contig'}{'two'}</td><td align=right>$compare{'Poisson Contig'}{'delta'}</td><tr>";
   print "<tr><td>Largest Contig (bp)</td><td align=right>$compare{'Largest Tig'}{'one'}</td><td align=right>$compare{'Largest Tig'}{'two'}</td><td align=right>$compare{'Largest Tig'}{'delta'}</td><tr>";
   print "<tr bgcolor='F6F6F6'><td>Smallest Contig (bp)</td><td align=right>$compare{'Smallest Tig'}{'one'}</td><td align=right>$compare{'Smallest Tig'}{'two'}</td><td align=right>$compare{'Smallest Tig'}{'delta'}</td><tr>";
   print "<tr><td>Contig Singletons</td><td align=right>$compare{'Singleton Contig'}{'one'}</td><td align=right>$compare{'Singleton Contig'}{'two'}</td><td align=right>$compare{'Singleton Contig'}{'delta'}</td><tr>";
   print "<tr><td colspan=4>&nbsp;</td></tr>";

   print "<tr><td colspan=4 align=left><b>Supercontigs</b></td></tr>";
   print "<tr bgcolor='F6F6F6'><td>Number of SuperContigs</td><td align=right>$compare{'Supertig Number'}{'one'}</td><td align=right>$compare{'Supertig Number'}{'two'}</td><td align=right>$compare{'Supertig Number'}{'delta'}</td><tr>";
   print "<tr><td>Mean Supercontig Size (bp)</td><td align=right>$compare{'Mean Super'}{'one'}</td><td align=right>$compare{'Mean Super'}{'two'}</td><td align=right>$compare{'Mean Super'}{'delta'}</td><tr>";
   print "<tr bgcolor='F6F6F6'><td>Total Supercontig Size (bp)</td><td align=right>$compare{'Supertig Size'}{'one'}</td><td align=right>$compare{'Supertig Size'}{'two'}</td><td align=right>$compare{'Supertig Size'}{'delta'}</td><tr>";
   print "<tr><td colspan=4>&nbsp;</td></tr>";

   print "<tr><td colspan=4 align=left><b>Bases</b></td></tr>";
   print "<tr bgcolor='F6F6F6'><td>Total Bases</td><td align=right>$compare{'Total Bases'}{'one'}</td><td align=right>$compare{'Total Bases'}{'two'}</td><td align=right>$compare{'Total Bases'}{'delta'}</td><tr>";
   print "<tr><td>Consensus Bases</td><td align=right>$compare{'Consensus'}{'one'}</td><td align=right>$compare{'Consensus'}{'two'}</td><td align=right>$compare{'Consensus'}{'delta'}</td><tr>";
   print "<tr bgcolor='F6F6F6'><td>Phred40 Bases (1:10,000 error)</td><td align=right>$compare{'Phred40'}{'one'}</td><td align=right>$compare{'Phred40'}{'two'}</td><td align=right>$compare{'Phred40'}{'delta'}</td><tr>";
   print "<tr><td>Average Error (per 10kb)</td><td align=right>$compare{'Error'}{'one'}</td><td align=right>$compare{'Error'}{'two'}</td><td align=right>$compare{'Error'}{'delta'}</td><tr>";
   print "<tr bgcolor='F6F6F6'><td>A%</td><td align=right>$compare{'Percent A'}{'one'}</td><td align=right>$compare{'Percent A'}{'two'}</td><td align=right>$compare{'Percent A'}{'delta'}</td><tr>";
   print "<tr><td>T%</td><td align=right>$compare{'Percent T'}{'one'}</td><td align=right>$compare{'Percent T'}{'two'}</td><td align=right>$compare{'Percent T'}{'delta'}</td><tr>";
   print "<tr bgcolor='F6F6F6'><td>G%</td><td align=right>$compare{'Percent G'}{'one'}</td><td align=right>$compare{'Percent G'}{'two'}</td><td align=right>$compare{'Percent G'}{'delta'}</td><tr>";
   print "<tr><td>C%</td><td align=right>$compare{'Percent C'}{'one'}</td><td align=right>$compare{'Percent C'}{'two'}</td><td align=right>$compare{'Percent C'}{'delta'}</td><tr>";

   print "</table>";
   print "</td></tr></table>";
   print "<font color='000099'><sup><A name='genome'>1</A></sup><i> Using an estimated Genome Size of $project->[2]bp</i></font><BR>";
}

=for html <A NAME='assemblyComparisonSelection'>

=item assemblyComparisonSelection

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_build</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$compare_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#------------------------------------------
sub assemblyComparisonSelection{

   my $tmp_build=shift;
   my @assembly_list=@$tmp_build;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $compare_id=shift;
   my $scriptname=shift;
   my $menu=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   my %assembly_desc;

   print "<FORM ACTION=\"$scriptname\" METHOD=\"POST\">";

   print "<table border=0>";
   print "<tr><td>Compare</td>";
   print "<td>";
   print "<SELECT NAME=\"assembly_id\" Size=\"1\">";
   #my @reverse_assembly=reverse(@assembly_list);
   foreach my $reference(@assembly_list){
      my @assembler_arr=@$reference;
      if ($assembly_id == $assembler_arr[2]){
         $assembly_desc{'one'}{'assembler'}=$assembler_arr[0];
         $assembly_desc{'one'}{'build'}=$assembler_arr[1];
         $assembly_desc{'one'}{'type'}=$assembler_arr[3];
         print "<OPTION VALUE=$assembler_arr[2] SELECTED>$assembler_arr[0] Build $assembler_arr[1]  $assembler_arr[3]</OPTION>";
      }else{
         print "<OPTION VALUE=$assembler_arr[2]>$assembler_arr[0] Build $assembler_arr[1]  $assembler_arr[3]</OPTION>";
      }
   }
   print "</SELECT>";

   print "</td>";
   print "<td>against assembly</td>";
   print "<td>";
   print "<SELECT NAME=\"compare_id\" Size=\"1\">";
   foreach my $reference(@assembly_list){
      my @assembler_arr=@$reference;
      if ($compare_id ==$assembler_arr[2]){
         $assembly_desc{'two'}{'assembler'}=$assembler_arr[0];
         $assembly_desc{'two'}{'build'}=$assembler_arr[1];
         $assembly_desc{'two'}{'type'}=$assembler_arr[3];
         print "<OPTION VALUE=$assembler_arr[2] SELECTED>$assembler_arr[0] Build $assembler_arr[1]  $assembler_arr[3]</OPTION>";
      }else{
         print "<OPTION VALUE=$assembler_arr[2]>$assembler_arr[0] Build $assembler_arr[1]  $assembler_arr[3]</OPTION>";
      }
   }
   print "</SELECT>";
   print "</td><td valign=center>";
   print "<input type=\"hidden\" NAME=\"menu\" VALUE=\"$menu\">";
   print "<input type=\"hidden\" NAME=\"fuzzykey\" VALUE=\"$fuzzykey\">";
   print "<input type=\"hidden\" NAME=\"data\" VALUE=\"$compressed_userinfo\">";
   print "<INPUT TYPE='submit' NAME='compare' VALUE='Go!'>";
   print "</FORM>";

   print "</table>";

   return \%assembly_desc;
}

=for html <A NAME='reportMenu'>

=item reportMenu

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

##########################################

#-------------------------------------
sub reportMenu{

   my $scriptname=shift;
   my $menu=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   print "<table border=0 width=680>";
   print "<tr><td align=left valign=center><a href=\"$scriptname?menu=$menu&reportmenu=1&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\">View Assembly Progress</a></td></tr>";
   print "<tr><td align=left valign=center><a href=\"$scriptname?menu=$menu&reportmenu=2&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\">Read Distribution</a></td></tr>";
   print "<tr><td align=left valign=center><a href=\"$scriptname?menu=$menu&reportmenu=3&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\">Insert Size Distribution</a></td></tr>";
   print "<tr><td align=left valign=center><a href=\"$scriptname?menu=$menu&reportmenu=4&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\">Gap-Spanning Clones</a></td></tr>";
   print "<tr><td align=left valign=center><a href=\"$scriptname?menu=$menu&reportmenu=5&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\">Overlapping Clones</a></td></tr>";
   print "<tr><td align=left valign=center><a href=\"$scriptname?menu=$menu&reportmenu=6&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\">Contig Size Distribution</a></td></tr>";
   print "<tr><td align=left valign=center><a href=\"$scriptname?menu=$menu&reportmenu=7&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\">Supercontig Size Distribution</a></td></tr>";
   print "</table>";
}

=for html <A NAME='progressMenu'>

=item progressMenu

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_assembler</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembler_name</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$report_menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub progressMenu{

   my $tmp_assembler=shift;
   my $assembler_name=shift;
   my $scriptname=shift;
   my $menu=shift;
   my $report_menu=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   print "<H1>Assembly Progress Tracker</H1>";

   print "<FORM ACTION=\"$scriptname\" METHOD=\"POST\">";
   print "<table width=680 border=0>";
   print "<tr><td valign=top>";
   &assemblyAssemblerSelection($tmp_assembler, $assembler_name, $scriptname, $menu, $report_menu);
   print "</td><td valign=top>";
   &assemblyStatSelection();
   print "</td></tr>";
   print "<input type=\"hidden\" NAME=\"menu\" VALUE=\"$menu\">";
   print "<input type=\"hidden\" NAME=\"reportmenu\" VALUE=\"$report_menu\">";
   print "<input type=\"hidden\" NAME=\"fuzzykey\" VALUE=\"$fuzzykey\">";
   print "<input type=\"hidden\" NAME=\"data\" VALUE=\"$compressed_userinfo\">";
   print "<tr><td>&nbsp;</td><td><INPUT TYPE='submit' NAME='progress' VALUE='View Progress' onClick=\"return checkProgress(summary)\"></td></tr>";
   print "</table>";
   print "</FORM>";
}

=for html <A NAME='assemblyStatSelection'>

=item assemblyStatSelection

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
- None<BR>
<BR>

=cut

#------------------------------------------
sub assemblyStatSelection{

   print "<table border=0 width=580>";
   print "<tr><td align=left colspan=3><i><b>What to show?</b></i></td></tr>";
   print "<tr><td><INPUT TYPE=\"checkbox\" NAME=\"summary\" VALUE=\"Summary_Consensus\">Consensus Bases</td><td><INPUT TYPE=\"checkbox\" NAME=\"summary\" VALUE=\"Summary_Analyzed_Read\">Analyzed Reads</td><td><INPUT TYPE=\"checkbox\" NAME=\"summary\" VALUE=\"Summary_Assembled_Read\">Assembled Reads</td></tr>";

   print "<tr><td><INPUT TYPE=\"checkbox\" NAME=\"summary\" VALUE=\"Summary_Singleton_Contig\">Contig Singletons</td><td><INPUT TYPE=\"checkbox\" NAME=\"summary\" VALUE=\"Summary_Supertig_Number\">Supercontigs</td><td><INPUT TYPE=\"checkbox\" NAME=\"summary\" VALUE=\"Summary_Mean_Super\">Mean Supercontig Size</td></tr>";

   print "<tr><td><INPUT TYPE=\"checkbox\" NAME=\"summary\" VALUE=\"Summary_Contig_Number\">Contigs</td><td><INPUT TYPE=\"checkbox\" NAME=\"summary\" VALUE=\"Summary_Mean_Tig\">Mean Contig Size</td><td><INPUT TYPE=\"checkbox\" NAME=\"summary\" VALUE=\"Summary_Singleton_Read\">Read as Singleton</td></tr>";

   print "<tr><td><INPUT TYPE=\"checkbox\" NAME=\"summary\" VALUE=\"Summary_N50\">N50 length</td><td><INPUT TYPE=\"checkbox\" NAME=\"summary\" VALUE=\"Summary_Contig_Coverage\">Contig Coverage</td><td><INPUT TYPE=\"checkbox\" NAME=\"summary\" VALUE=\"Summary_Genome_Coverage\">Genome Coverage</td></tr>";
   print "</table>";
}

=for html <A NAME='assemblyAssemblerSelection'>

=item assemblyAssemblerSelection

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_assembler</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembler_name</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#------------------------------------------
sub assemblyAssemblerSelection{
   
   my $tmp_assembler=shift;
   my @assembler_list=@$tmp_assembler;
   my $assembler_name=shift;

   print "<table border=0 width=100>";
   print "<tr><td align=left colspan=1><i><b>Select an Assembler</b></i></td></tr>";
   print "<tr><td>";
   
   print "<SELECT NAME=\"assembler\" Size=\"1\">";

   foreach my $reference(@assembler_list){
      my @assembler_arr=@$reference;
      if ($assembler_name eq $assembler_arr[0]){
         print "<OPTION VALUE=$assembler_arr[0] SELECTED>$assembler_arr[0]</OPTION>";
      }else{
         print "<OPTION VALUE=$assembler_arr[0]>$assembler_arr[0]</OPTION>";
      }
   }
   print "</SELECT>";
   print "</td></tr>";
   print "</table>";
}

=for html <A NAME='printProgressGraph'>

=item printProgressGraph

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$report_menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_summary</B>():  [Default = <B>shift</B>]<BR>
- <B>$progress_title</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembler_name</B>():  [Default = <B>shift</B>]<BR>
- <B>$max_option</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#------------------------------------------
sub printProgressGraph{

   my $scriptname=shift;
   my $menu=shift;
   my $report_menu=shift;
   my $tmp_summary=shift;
   my $progress_title=shift;
   my $assembler_name=shift;
   my $max_option=shift;  
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   print "<H1><A HREF=\"$scriptname?menu=$menu&reportmenu=$report_menu&fuzzykey=$fuzzykey&data=$compressed_userinfo\">Assembly Progress Tracker</A></H1>";

   print "<table border=0 width=680>";
   print "<tr><td align=center><IMG SRC=\"$scriptname?progressgraph=1&fuzzykey=$fuzzykey&data=$compressed_userinfo\"></td></tr>";
   print "</table>";
   &assemblyProgressTable($tmp_summary, $progress_title, $assembler_name, $max_option);
}

=for html <A NAME='assemblyProgressTable'>

=item assemblyProgressTable

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_summary</B>():  [Default = <B>shift</B>]<BR>
- <B>$progress_title</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembler_name</B>():  [Default = <B>shift</B>]<BR>
- <B>$max_option</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub assemblyProgressTable{

   my $tmp_summary=shift;
   my @build_summary=@$tmp_summary; 
   my $progress_title=shift;
   my @progress_title=@$progress_title;
   my $assembler_name=shift; 
   my $max_option=shift;

   print "<table class='listing' border=0 width=680>";
   print "<tr><th class='title' colspan=$max_option style='text-align: left;'>$assembler_name Assembly Progress</th></tr>";
   print "<tr>";
   for (my $element=0;$element<($max_option-1);$element++){
      print "<th><span class=small>$progress_title[$element]</span></th>";
   }
   print "<tr>";
   my ($past, $value)=("even", "");
   foreach my $reference (@build_summary){
      if ($past eq "even"){$value="odd"}else{$value="even";}
      my @record=@$reference;
      my $max_record=$#record;
      print "<tr class=\"$value\">";
      for (my $element=0;$element<=$max_record;$element++){
         print "<td style='text-align: right;'><span class=small>$record[$element]</span></td>";
      }
      print "</tr>";
      $past=$value;
   }
   print "</table>";
}

=for html <A NAME='distributionMenu'>

=item distributionMenu

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_build</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_library</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$report_menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub distributionMenu{

   my $tmp_build=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $tmp_library=shift;
   my $scriptname=shift;
   my $menu=shift;
   my $report_menu=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   print "<H1>Read Distribution</H1>";

   print "<table width=680 border=0>";
   print "<FORM ACTION=\"$scriptname\" METHOD=\"POST\">";
   print "<tr><td valign=top>";
   &selectAssemblyStatic($tmp_build, $assembly_id);
   print "</td><td valign=top>";
   &distributionLibrary($tmp_library); 
   print "</td></tr>";
   print "<input type=\"hidden\" NAME=\"menu\" VALUE=\"$menu\">";
   print "<input type=\"hidden\" NAME=\"reportmenu\" VALUE=\"$report_menu\">";
   print "<input type=\"hidden\" NAME=\"fuzzykey\" VALUE=\"$fuzzykey\">"; 
   print "<input type=\"hidden\" NAME=\"data\" VALUE=\"$compressed_userinfo\">"; 
   print "<input type=\"hidden\" NAME=\"gene_finder_id\" VALUE=\"$gene_finder_id\">";
   print "<tr><td>&nbsp;</td><td align=left><INPUT TYPE='submit' NAME='distribution' VALUE='View Distribution' onClick=\"return checkDistribution(library)\"></td></tr>";
   print "</FORM>";
   print "</table>";
   
}

=for html <A NAME='distributionLibrary'>

=item distributionLibrary

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_library</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub distributionLibrary{

   my $tmp_library=shift;
   my @library_ref=@$tmp_library;

   my $ct=0;

   print "<table border=0>";
   print "<tr><td align=left colspan=3><i><b>Select Libraries</b></i></td></tr>";
   print "<tr>";
   foreach my $reference(@library_ref){
      my @library_arr=@$reference;
      print "<td><INPUT TYPE=\"checkbox\" NAME=\"library\" VALUE=\"$library_arr[0]\">$library_arr[0]</td>";
      if ($ct>3){print "</tr><tr>";$ct=0;}
      $ct++
   }
   print "</tr>";
   print "</table>";

}

=for html <A NAME='selectAssemblyStatic'>

=item selectAssemblyStatic

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_build</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub selectAssemblyStatic{

   my $tmp_build=shift;
   my @assembly_list=@$tmp_build;
   my $assembly_id=shift;

   print "<table border=0>";
   print "<tr><td align=left><i><b>Select an Assembly</b></i></td></tr>";
   print "<tr><td>";
   print "<SELECT NAME='assembly_id' Size='1'>";
   #my @reverse_assembly=reverse(@assembly_list);
   foreach my $reference(@assembly_list){
      my @assembler_arr=@$reference;
      if ($assembly_id == $assembler_arr[2]){
         print "<OPTION VALUE=$assembler_arr[2] SELECTED>$assembler_arr[0] Build $assembler_arr[1]  $assembler_arr[3]</OPTION>";
      }else{
         print "<OPTION VALUE=$assembler_arr[2]>$assembler_arr[0] Build $assembler_arr[1]  $assembler_arr[3]</OPTION>";
      }
   }
   print "</SELECT>";
   print "</td></tr>";
   print "</table>";
}

=for html <A NAME='printDistributionGraph'>

=item printDistributionGraph

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$report_menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$all_account</B>():  [Default = <B>shift</B>]<BR>
- <B>$missing_lib</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub printDistributionGraph{

   my $scriptname=shift;
   my $menu=shift;
   my $report_menu=shift;
   my $all_account=shift;
   my $missing_lib=shift;
   my $fuzzykey=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $compressed_userinfo=shift;

   print "<H1><A HREF=\"$scriptname?menu=$menu&reportmenu=$report_menu&fuzzykey=$fuzzykey&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&data=$compressed_userinfo\">Read Distribution</A></H1>";

   print "<table border=0 width=680>";
   print "<tr><td align=center><IMG SRC=\"$scriptname?distributiongraph=1&fuzzykey=$fuzzykey&data=$compressed_userinfo\"></td></tr>";
   print "<tr><td align=center><span class=small><font color=\"FF0000\">*The following libraries were not found in the chosen assembly:$missing_lib</font></span></td></tr>" if ($missing_lib); 
   print "</table>";
   &distributionTable($all_account);
}

=for html <A NAME='distributionTable'>

=item distributionTable

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$all_account</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub distributionTable{

   my $all_account=shift;
   my %all_account=%$all_account;

   print "<table border=0 class=\"listing\" width=680>";
   print "<tr><th colspan=3 class=\"title\" style='text-align: left;'><span class=large>Top Ten Contigs with most Reads</span></th></td>";
   print "<tr><th>Contig</th><th>Library</th><th>Number of Reads</th></tr>";

   my ($past, $value)=("even", "");
   my $row_count=0;
   RECORD:
   foreach my $read_count (sort {$b<=>$a} keys %all_account){
      my $tmp_contig=$all_account{$read_count};
      my %contig_list=%$tmp_contig;
      foreach my $contig (sort {$a <=> $b} keys %contig_list){
         my $library=$contig_list{$contig};
         if ($past eq "even"){$value="odd"}else{$value="even";}
         print "<tr class=\"$value\"><td style='text-align: center;'>$contig</td><td align=center style='text-align: center;'>$library</td><td align=right style='text-align: right;'>$read_count</td></tr>";
         $row_count++;
         last RECORD if ($row_count>=10);
         $past=$value;
      }
   }
   print "</table>";
}

=for html <A NAME='errorDistribution'>

=item errorDistribution

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$report_menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$missing_lib</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub errorDistribution{

   my $scriptname=shift;
   my $menu=shift;
   my $report_menu=shift;
   my $missing_lib=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   print "<H1><A HREF=\"$scriptname?menu=$menu&reportmenu=$report_menu&fuzzykey=$fuzzykey&data=$compressed_userinfo\">Read Distribution</A></H1>";

   print "<table border=0 width=680>";
   if ($missing_lib){
      print "<tr><td align=center><span class=small><font color=\"FF0000\">*The following libraries were not found in the chosen assembly:$missing_lib</font></span></td></tr>";
   }else{
      print "<tr><td align=center><span class=small><font color=\"FF0000\">Error: Library Not found.</font></span></td></tr>";
   }
   print "</table>";
}

=for html <A NAME='insertMenu'>

=item insertMenu

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_build</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$report_menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub insertMenu{

   my $tmp_build=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $scriptname=shift;
   my $menu=shift;
   my $report_menu=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;
   my $title=shift;

   print "<H1>$title</H1>";
   print "<table border=0>";
   print "<tr><td>Distribution for&nbsp;</td><td>";
   print "<SELECT NAME='assembly_id' onChange='top.location.href=\"$scriptname?fuzzykey=$fuzzykey&menu=$menu&reportmenu=$report_menu&data=$compressed_userinfo&assembly_id=\"+this.options[selectedIndex].value;' Size='1'>";
   &assemblerBox($tmp_build, $assembly_id);
   print "</SELECT>";
   print "</td></tr>";
   print "</table>";
}

=for html <A NAME='printInsertGraph'>

=item printInsertGraph

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$insert_list</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub  printInsertGraph{

   my $scriptname=shift;
   my $insert_list=shift;
   my %insert_list=%$insert_list;
   my $fuzzykey=shift;  
   my $compressed_userinfo=shift;

   print "<table class='listing' border=0 width=680>";
   print "<tr><th class='title' style='text-align: left;' colspan=6><span class=large>Insert Statistics</span></th></tr>";
   print "<tr><th>Library</th><th>Whole Clones</th><th>Mean</th><th>Std Deviation</th><th>Max</th><th>Min</th></tr>";
   my ($past, $value)=("even", "");

   foreach my $lib (sort keys %insert_list){
      if ($past eq "even"){$value="odd"}else{$value="even";}
      my $tmp_data=$insert_list{$lib};
      my @data=@$tmp_data;
      print "<tr class=\"$value\"><td>$lib</td>";
      foreach my $element(@data){
         print "<td style='text-align: right;'>$element</td>";
      }
      print "</tr>";
      $past=$value;
   }
   print "</table>";
 
   print "<table border=0 width=680>";
   foreach my $lib (sort keys %insert_list){
      print "<tr><td align=center><IMG SRC=\"$scriptname?insertgraph=1&insertlibrary=$lib&fuzzykey=$fuzzykey&data=$compressed_userinfo\"></td></tr>";
   }
   print "</table>";
}

###Start Additions

#-------------------------------------
sub printContigDistributionGraph{

   my $scriptname=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;
   my $size_range=shift;
   my $element=shift;

   my $elements=$element."s";

   print "<table class='listing' border=0 width=680>";
   print "<tr><th class='title' style='text-align: left;' colspan=6><span class=large>Distribution Statistics</span></th></tr>";
   print "<tr><th>Size Range</th><th>Number of $elements</th><th>Total Number of Bases</th>";
   my ($past, $value)=("even", "");
   my $el=0;

   foreach my $reference (@$size_range){

      my @data=@$reference;
      if ($past eq "even"){$value="odd"}else{$value="even";}

      print "<tr class=\"$value\">";
      foreach my $array_element(@data){
         print "<td style='text-align: right;'>$array_element</td>";
      }
      print "</tr>";
      $past=$value;
   }
   print "</table>";
   print "<tr><td align=center><IMG SRC=\"$scriptname?contig_distribution_graph=1&sequence_type=$element&fuzzykey=$fuzzykey&data=$compressed_userinfo\"></td></tr>";
   print "</table>";
}




#### End Additions

=for html <A NAME='blastMenu'>

=item blastMenu

=for html
Blast ###################################<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_build</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_available</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

##################### Blast ###################################

#-------------------------------------
sub blastMenu{

   my $tmp_build=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $gene_finder_available=shift;
   my $scriptname=shift;
   my $menu=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   print "<H1>Blast the Genome & ORF list</H1>";
   print "<table border=0 cellspacing=0 cellpadding=0>";
   print "<tr><td>Select an Assembly&nbsp;</td><td>";
   print "<SELECT NAME='assembly_id' onChange='top.location.href=\"$scriptname?fuzzykey=$fuzzykey&menu=$menu&data=$compressed_userinfo&assembly_id=\"+this.options[selectedIndex].value;' Size='1'>";
   &assemblerBox($tmp_build, $assembly_id);
   print "</SELECT>";
   print "</td>";

   if (defined $gene_finder_id){
      print "<td>&nbsp;Gene Finder&nbsp;</td><td>";
      print "<SELECT NAME='gene_finder_id' onChange='top.location.href=\"$scriptname?fuzzykey=$fuzzykey&menu=$menu&data=$compressed_userinfo&assembly_id=$assembly_id&gene_finder_id=\"+this.options[selectedIndex].value;' Size='1'>";
      &simpleSelectionBox($gene_finder_available, $gene_finder_id);
      print "</SELECT>";
      print "</td>";
   }
   print "</tr>";

   print "</table>";
}

=for html <A NAME='blastSetParameter'>

=item blastSetParameter

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$blast_config</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembler</B>():  [Default = <B>shift</B>]<BR>
- <B>$build</B>():  [Default = <B>shift</B>]<BR>
- <B>$cgipath</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub blastSetParameter{

   my $blast_config=shift;
   my %blast_config=%$blast_config;
   my $assembler=shift;
   my $build=shift;
   my $cgipath=shift;
   my $gene_finder_id=shift;

   print "<FORM METHOD=POST  enctype='multipart/form-data'  TARGET=\"blank\" ACTION=\"$cgipath/nph-Blast_Server.html\">";
   print "<BR>";
    
   print "<table width=680 border=0 cellspacing=0 cellpadding=0 align=center>";
   print "<tr><td>Cut and Paste your sequence here<P><TEXTAREA NAME=\"sequence\" ROWS=20 COLS=50> </TEXTAREA><P></TD></TR>";

   print "<tr><td><p><INPUT TYPE='radio' checked NAME='blast_selection' VALUE='tblastn:$blast_config{'contig'}' ><B>TBLASTN</B><I>&nbsp;Searching through contigs with a protein sequence</I>";
   print "<BR><INPUT TYPE='radio' NAME='blast_selection' VALUE='blastn:$blast_config{'contig'}'><B>BLASTN</B><I>&nbsp;Searching through contigs with a DNA sequence</I>";

   if (defined $gene_finder_id){
      print "<BR><INPUT TYPE='radio' NAME='blast_selection' VALUE='blastn:$blast_config{'orf_cds'}'><B>BLASTN</B><I>&nbsp;Searching through ORF CDS with a DNA sequence (Chosen Build)</I>";
      print "<BR><INPUT TYPE='radio' NAME='blast_selection' VALUE='blastn:$blast_config{'everygene'}'><B>BLASTN</B><I>&nbsp;Searching through ORF CDS with a DNA sequence (All Builds)</I>";
      print "<BR><INPUT TYPE='radio' NAME='blast_selection' VALUE='blastp:$blast_config{'orf'}'><B>BLASTP</B><I>&nbsp;Searching through ORF Protein list with a protein sequence</I>";
      print "<BR><INPUT TYPE='radio' NAME='blast_selection' VALUE='blastx:$blast_config{'orf'}'><B>BLASTX</B><I>&nbsp;Searching through ORF Protein list with a DNA sequence</I>";
   }

   print "<BR>";
   print "</td></tr>";
   print "<tr><td>";
   print "<INPUT TYPE='submit'>";
   print "<INPUT TYPE='reset'>";
   print "<INPUT TYPE='hidden' NAME='return' VALUE='HTML'>";
   print "</FORM>";
   print "</td></tr>";
   print "</table>";

}

=for html <A NAME='gapMenu'>

=item gapMenu

=for html
Gap ###################################<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_build</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$report_menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

##################### Gap ###################################
#-------------------------------------
sub gapMenu{

   my $tmp_build=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $scriptname=shift;
   my $menu=shift;
   my $report_menu=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   print "<H1>Gap-Spanning Clones</H1>";
   print "<table border=0>";
   print "<tr><td>Select an Assembly&nbsp;</td><td>";
   print "<SELECT NAME='assembly_id' onChange='top.location.href=\"$scriptname?fuzzykey=$fuzzykey&menu=$menu&reportmenu=$report_menu&data=$compressed_userinfo&assembly_id=\"+this.options[selectedIndex].value;' Size='1'>";
   &assemblerBox($tmp_build, $assembly_id);
   print "</SELECT>";
   print "</td></tr>";
   print "</table>";
}

=for html <A NAME='showAllGapTable'>

=item showAllGapTable

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$classify_count</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$report_menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub showAllGapTable{

   my $classify_count=shift;
   my %classify_count=%$classify_count;
   my $scriptname=shift;
   my $menu=shift;
   my $report_menu=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   my ($subtotal_gap, $subtotal_clone)=(0,0);

   print "<table border=0 width=680>";
   print "<tr><td><A HREF=\"$scriptname?menu=$menu&reportmenu=$report_menu&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&gap_stats=1&fuzzykey=$fuzzykey&data=$compressed_userinfo\">View Sequence Gap/Overlap Stats</td></tr>";
   print "</table>";
   print "<table class='listing' border=0 width=680>";
   print "<tr><th style='text-align: left;' class='title' colspan=3>Sequence Gaps & Gap-Spanning Clones</th></tr>";
   print "<tr><th>Clones per Gap</th><th>Sequence Gaps</th><th>Total Clones</th></tr>";
   my ($past, $value)=("even", "");

   foreach my $count (sort {$b<=>$a} keys %classify_count){
      my $clones=$count*$classify_count{$count};
      if ($past eq "even"){$value="odd"}else{$value="even";}

      if ($count>1){
         print "<tr class=\"$value\"><td><A HREF=\"$scriptname?countgap=$count&menu=$menu&reportmenu=$report_menu&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\">$count</A></td><td style='text-align: right;'>$classify_count{$count}</td><td style='text-align: right;'>$clones</td></tr>";
         $subtotal_clone+=$clones;
         $subtotal_gap+=$classify_count{$count};
      }elsif ($count==1){
         print "<tr bgcolor='99CCFF'><td><A HREF=\"$scriptname?countgap=-1&menu=$menu&reportmenu=$report_menu&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\">Sub Total</A></td><td style='text-align: right;'>$subtotal_gap</td><td style='text-align: right;'>$subtotal_clone</td></tr>" if ($subtotal_clone && $subtotal_gap);
         print "<tr class=\"$value\"><td><A HREF=\"$scriptname?countgap=$count&menu=$menu&reportmenu=$report_menu&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\">$count</A></td><td style='text-align: right;'>$classify_count{$count}</td><td style='text-align: right;'>$clones</td></tr>";
         my $total_clone=$clones+$subtotal_clone;
         my $total_gap=$classify_count{$count}+$subtotal_gap;
         print "<tr bgcolor='99CCFF'><td>Total</td><td style='text-align: right;'>$total_gap</td><td style='text-align: right;'>$total_clone</td></tr>" if ($total_clone && $total_gap);
      }
      $past=$value;
   }
   print "</table>";
}

=for html <A NAME='showSpecificGap'>

=item showSpecificGap

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$count_clone</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$report_menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$htdocpath</B>():  [Default = <B>shift</B>]<BR>
- <B>$ref_gap_list</B>():  [Default = <B>shift</B>]<BR>
- <B>$ref_gap_stat</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub showSpecificGap{

   my $count_clone=shift;
   my $scriptname=shift;
   my $menu=shift;
   my $report_menu=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $htdocpath=shift;
   my $ref_gap_list=shift;
   my %gap_list=%$ref_gap_list;
   my $ref_gap_stat=shift;
   my %gap_stat=%$ref_gap_stat;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   ####Provide Way to get back to table;
   print "<BR><A HREF=\"$scriptname?menu=$menu&reportmenu=$report_menu&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\">Back to Sequence Gap & Gap-Spanning Clone Table</A>";
   print "<BR><i><font color='FF0000'>Possible mate pair violations are highlighted in yellow.</font></i>";
   print "<table class='listing' border=0 width=680>";
   foreach my $clone_amount (sort {$b<=>$a} keys %gap_list){
      my $tmp_gap_list=$gap_list{$clone_amount};
      my $tmp_gap_stat=$gap_stat{$clone_amount};
      if ($count_clone>0 && $clone_amount==$count_clone){###definition of a gap
          &tableGapSpan($tmp_gap_list, $tmp_gap_stat, $clone_amount, $htdocpath);
       }elsif ($count_clone<0){
          if ($clone_amount != 1){
             &tableGapSpan($tmp_gap_list, $tmp_gap_stat, $clone_amount, $htdocpath);
          }
       }#elsif ($count_clone==0){
       #   &tableGapSpan($tmp_gap_list, $clone_amount, $htdocpath);
       #}
   }
   print "</table>";

}

=for html <A NAME='showGapSummaryOnly'>

=item showGapSummaryOnly

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembler</B>():  [Default = <B>shift</B>]<BR>
- <B>$build</B>():  [Default = <B>shift</B>]<BR>
- <B>$report_menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$ref_gap_list</B>():  [Default = <B>shift</B>]<BR>
- <B>$ref_gap_stat</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub showGapSummaryOnly{

   my $scriptname=shift;
   my $menu=shift;
   my $assembler=shift;
   my $build=shift;
   my $report_menu=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $ref_gap_list=shift;
   my %gap_category=%$ref_gap_list;
   my $ref_gap_stat=shift;
   my %gap_stat=%$ref_gap_stat;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   print "<H1>Gap-Spanning Clones</H1>";
 
   ####Provide Way to get back to table;
   print "<BR><A HREF=\"$scriptname?menu=$menu&reportmenu=$report_menu&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\">Back to Sequence Gap & Gap-Spanning Clone Table</A>";

   print "<table border=0 width=680>";
   print "<tr><td align=center><IMG SRC=\"$scriptname?gapgraph=1&fuzzykey=$fuzzykey&data=$compressed_userinfo\"></td></tr>";
   print "</table>";

   print "<table class='listing' border=0 width=680>";
   print "<tr><th class='title' style='text-align: left;' colspan=8>Sequence Gap/Overlap Stats&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$assembler Build $build</th></tr>";
   print "<tr><th><span class=small>Contig Gap/Overlap</span></th><th><span class=small>Type</span></th><th><span class=small>Mean Gap Size (bp)</span></th><th><span class=small>Std Dev.</span></th><th><span class=small>Max (bp)</span></th><th><span class=small>Min (bp)</span></th><th><span class=small>Violations</span></th</tr>";

   my ($past, $value)=("even", "");

   foreach my $clone_amount (sort {$b<=>$a} keys %gap_category){
      my $tmp_gap_stat=$gap_stat{$clone_amount};   
      my %pergap_stat=%$tmp_gap_stat;

      foreach my $gap (keys %pergap_stat){
         if ($past eq "even"){$value="odd"}else{$value="even";}
         my $violation=$clone_amount-$pergap_stat{$gap}{'count'};
         print "<tr class='$value'><td style='text-align: center;'><span class=small><A HREF=\"$scriptname?countgap=$clone_amount&menu=$menu&reportmenu=$report_menu&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo#$gap\">$gap<A></span></td><td style='text-align: center;'><span class=small>$pergap_stat{$gap}{'type'}</span></td><td style='text-align: right;'><span class=small>$pergap_stat{$gap}{'mean'}</span></td><td style='text-align: right;'><span class=small>$pergap_stat{$gap}{'stdev'}</span></td><td style='text-align: right;'><span class=small>$pergap_stat{$gap}{'max'}</span></td><td style='text-align: right;'><span class=small>$pergap_stat{$gap}{'min'}</span></td><td style='text-align: right;'><span class=small>$violation out of $clone_amount</span></td></tr>";
         $past=$value;
      }
   }
   print "</table>";
}

=for html <A NAME='tableGapSpan'>

=item tableGapSpan

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_gap_list</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_gap_stat</B>():  [Default = <B>shift</B>]<BR>
- <B>$clone_amount</B>():  [Default = <B>shift</B>]<BR>
- <B>$htdocpath</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub tableGapSpan{

   my $tmp_gap_list=shift;
   my %gap_list=%$tmp_gap_list;
   my $tmp_gap_stat=shift;
   my %gap_stat=%$tmp_gap_stat;
   my $clone_amount=shift;
   my $htdocpath=shift;

   foreach my $gap(keys %gap_list){
      print "<tr><th class='title' style='text-align: left;' colspan=4><A name='$gap'></A>Gap Contig $gap ($clone_amount members)</th></tr>";
      print "<tr><th><span class=small>Clone</span></th><th><span class=small>Gap Size (bp)</span></th><th><span class=small>Comment</span></th><th><span class=small>Likely Tig Orientation</span></th></tr>";
      my $ref_clone=$gap_list{$gap};
      my %clone_list=%$ref_clone;
      
      foreach my $clone(sort keys %clone_list){
         if ($clone_list{$clone}{'misassembly'} eq '-'){
            print "<tr><td><span class=small>$clone</span></td><td style='text-align: right;'><span class=small>$clone_list{$clone}{'size'}</span></td><td style='text-align: center;'><span class=small>$clone_list{$clone}{'misassembly'}</span></td><td style='text-align: center;'><IMG SRC=\"$htdocpath/$clone_list{$clone}{'image'}\"></td></tr>";
         }else{
            print "<tr bgcolor='FFFFD0'><td><span class=small>$clone</span></td><td style='text-align: right;'><span class=small>$clone_list{$clone}{'size'}</span></td><td style='text-align: center;'><span class=small>$clone_list{$clone}{'misassembly'}</span></td><td style='text-align: center;' bgcolor='FFFFD0'><IMG SRC=\"$htdocpath/$clone_list{$clone}{'image'}\"></td></tr>";
         }
      }      
      my $violations=$clone_amount-$gap_stat{$gap}{'count'};
      print "<tr bgcolor='99CCFF'><td><span class=small><b>$gap_stat{$gap}{'type'} Summary</b></span></td><td colspan=3 style='text-align: center;'><span class=small><b>Mean: $gap_stat{$gap}{'mean'}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Std Dev.: $gap_stat{$gap}{'stdev'}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Max: $gap_stat{$gap}{'max'}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Min: $gap_stat{$gap}{'min'}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Violations: $violations out of $clone_amount</b></span></td></tr>";
   }

}

=for html <A NAME='overlapMenu'>

=item overlapMenu

=for html
Overlap ###################################<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_build</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$report_menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

##################### Overlap ###################################
#-------------------------------------
sub overlapMenu{

   my $tmp_build=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $scriptname=shift;
   my $menu=shift;
   my $report_menu=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   print "<H1>Clones with Overlapping Paired End Reads</H1>";
   print "<table border=0>";
   print "<tr><td>Select an Assembly&nbsp;</td><td>";
   print "<SELECT NAME='assembly_id' onChange='top.location.href=\"$scriptname?fuzzykey=$fuzzykey&menu=$menu&reportmenu=$report_menu&data=$compressed_userinfo&assembly_id=\"+this.options[selectedIndex].value;' Size='1'>";
   &assemblerBox($tmp_build, $assembly_id);
   print "</SELECT>";
   print "</td></tr>";
   print "</table>";
}

=for html <A NAME='showAllOverlapTable'>

=item showAllOverlapTable

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$overlap_count</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$report_menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub showAllOverlapTable{

   my $overlap_count=shift;
   my %overlap_count=%$overlap_count;
   my $scriptname=shift;
   my $menu=shift;
   my $report_menu=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   my $total_clone=0;

   print "<table class='listing' width=680>";
   print "<tr><th colspan=2 class='title' style='text-align: left;'>Overlapping paired-end reads</th></tr>";
   print "<tr><th>Contig Number</th><th>Number of Clones</th></tr>";

   my ($past, $value)=("even", "");

   foreach my $overlap (sort {$overlap_count{$b}<=>$overlap_count{$a} || $b<=>$a} keys %overlap_count){###sort by value, then by key
      if ($past eq "even"){$value="odd"}else{$value="even";}

      print "<tr class=\"$value\"><td><A HREF=\"$scriptname?fuzzykey=$fuzzykey&countoverlap=$overlap&menu=$menu&reportmenu=$report_menu&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&data=$compressed_userinfo\">$overlap</A></td><td style='text-align: right;'>$overlap_count{$overlap}</td></tr>";
      $total_clone+=$overlap_count{$overlap};
      $past=$value;
   }
   print "<tr bgcolor='99CCFF'><td>Total</td><td style='text-align: right;'>$total_clone</td></tr>" if ($total_clone);
   print "</table>";
}

=for html <A NAME='showSpecificOverlap'>

=item showSpecificOverlap

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$count_overlap</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$report_menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_overlap_list</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub showSpecificOverlap{

   my $count_overlap=shift;
   my $scriptname=shift;
   my $menu=shift;
   my $report_menu=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $tmp_overlap_list=shift;
   my %overlap_list=%$tmp_overlap_list;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   ####Provide Way to get back to table;
   print "<BR><A HREF=\"$scriptname?menu=$menu&reportmenu=$report_menu&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\">Back to Overlapping End Reads Table</A>";

   my $tmp_clone_list=$overlap_list{$count_overlap};
   my %clone_list=%$tmp_clone_list;

   print "<table class='listing' border=0 width=680>";
   print "<tr><th colspan=2 class='title' style='text-align: left;'>Overlapping paired-end reads for Contig $count_overlap</th></tr>";
   print "<tr><th>Clone</th><th>Overlap Size</th></tr>";

   my ($past, $value)=("even", "");

   foreach my $clone (sort {$clone_list{$b}{'size'}<=>$clone_list{$a}{'size'}} keys %clone_list){
      if ($past eq "even"){$value="odd"}else{$value="even";}
      print "<tr class=\"$value\"><td>$clone</td><td style='text-align: right;'>$clone_list{$clone}{'size'}</td></tr>";
      $past=$value;
   }
   print "</table>";
}

=for html <A NAME='contigViewerMenu'>

=item contigViewerMenu

=for html
TIG Viewer ###################################<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_build</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_available</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

##################### TIG Viewer ###################################
#-------------------------------------
sub contigViewerMenu{

   my $tmp_build=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $gene_finder_available=shift;
   my $scriptname=shift;
   my $menu=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   print "<H1>Contig View</H1>";
   print "<table border=0 cellpadding=0 cellspacing=0>";
   print "<tr><td>Select an Assembly&nbsp;</td><td>";
   print "<SELECT NAME='assembly_id' onChange='top.location.href=\"$scriptname?fuzzykey=$fuzzykey&menu=$menu&data=$compressed_userinfo&assembly_id=\"+this.options[selectedIndex].value;' Size='1'>";
   &assemblerBox($tmp_build, $assembly_id);
   print "</SELECT>";
   print "</td>";

   if (defined $gene_finder_id){
      print "<td>&nbsp;Gene Finder&nbsp;</td><td>";
      print "<SELECT NAME='gene_finder_id' onChange='top.location.href=\"$scriptname?fuzzykey=$fuzzykey&menu=$menu&data=$compressed_userinfo&assembly_id=$assembly_id&gene_finder_id=\"+this.options[selectedIndex].value;' Size='1'>";
      &simpleSelectionBox($gene_finder_available, $gene_finder_id);
      print "</SELECT>";
      print "</td>";
   }
   print "</tr>";

   print "</table>";

}

=for html <A NAME='contigViewerForm'>

=item contigViewerForm

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tig_scroll</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$tig_selection</B>():  [Default = <B>shift</B>]<BR>
- <B>$featureorf</B>():  [Default = <B>shift</B>]<BR>
- <B>$orf_scroll</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$zoom</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub contigViewerForm{

    my $tig_scroll=shift;
    my @tig_scroll=@$tig_scroll;
    my $scriptname=shift;
    my $tig_selection=shift;
    my $featureorf=shift;
    my $orf_scroll=shift;
    my %orf_scroll=%$orf_scroll;
    my $assembly_id=shift;
    my $gene_finder_id=shift;
    my $fuzzykey=shift;
    my $menu=shift;
    my $zoom=shift;
    my $compressed_userinfo=shift;

    my $choice;
    my $orfchoice;
    my $menucolor="0000FF";

    print "<table width=675 colspan=3 border=1>";
    print "<tr>";
    print "<td valign=top><table border=0>";

    #----------------------------------
    print "<FORM ACTION=\"$scriptname?showcontig=1\" METHOD=\"POST\">";

    print "<tr><td align=center><span class=large><font color=$menucolor><b>Zoom</b></font></span></td></tr>";
    print "<tr>";
    print "<td align=left><span class=small>";

    my @zoom_value=(10,50,100,500,1000);
    &showZoomMenu($zoom, \@zoom_value);

    print "</span></td></tr>";
    print "<input type=\"hidden\" NAME='orf' VALUE=$featureorf>";                         #hidden field passes info on feature orf
    print "<input type=\"hidden\" NAME='contig' VALUE=$tig_selection>";
    print "<input type=\"hidden\" NAME='assembly_id' VALUE=$assembly_id>";
    print "<input type=\"hidden\" NAME='menu' VALUE=\"$menu\">";
    print "<input type=\"hidden\" NAME='fuzzykey' VALUE=\"$fuzzykey\">";
    print "<input type=\"hidden\" NAME='data' VALUE=\"$compressed_userinfo\">";
    print "<input type=\"hidden\" NAME='gene_finder_id' VALUE=\"$gene_finder_id\">";

    print "<tr><td align=center><INPUT TYPE=submit VALUE=\"Refresh\"></td></tr>";

    print "</form>";
    #----------------------------------

    print "</table></td>";
    print "<td valign=top align=center><table border=0 colspan=1 valign=top>";

    #----------------------------------
    print "<FORM ACTION=\"$scriptname?showcontig=1\" METHOD=\"POST\">";

    print "<tr><td align=center><span class=large><font color=$menucolor><b>Contig Search</b></font></span></td></tr>";
    print "<tr><td align=center>";
    print "<BR>";

#    print "<SELECT NAME='contig' onChange='top.location.href=\"$scriptname?showcontig=1&menu=$menu&contig=\"+this.options[selectedIndex].value;' Size='1'>";
#   &arraySelectionBox($tig_scroll, $tig_selection);
  

    print "<SELECT NAME=\"contig\" SIZE=1>";

    foreach my $tig (@tig_scroll){
       print "<OPTION>$tig" if ($tig_selection != $tig);
       print "<OPTION SELECTED>$tig" if ($tig_selection == $tig);
    }

    print "</SELECT>";
    print "</td></tr>";

    print "<input type=\"hidden\" NAME='zoom' VALUE=$zoom>";
    print "<input type=\"hidden\" NAME='assembly_id' VALUE=$assembly_id>";
    print "<input type=\"hidden\" NAME='menu' VALUE=\"$menu\">";
    print "<input type=\"hidden\" NAME='fuzzykey' VALUE=\"$fuzzykey\">";
    print "<input type=\"hidden\" NAME='data' VALUE=\"$compressed_userinfo\">";
    print "<input type=\"hidden\" NAME='gene_finder_id' VALUE=\"$gene_finder_id\">";
    print "<tr><td>&nbsp;</td></tr>";
    print "<tr><td colspan=1 align=center><INPUT TYPE=submit VALUE=\"Search\"></td></tr>";

#    print "</SELECT>";

    print "</FORM>";
    #----------------------------------

    print "</table></td>";
    print "<td valign=top align=center>";
    print "<table border=0 colspan=1>";

    #----------------------------------
    print "<FORM ACTION=\"$scriptname?showcontig=1\" METHOD=\"POST\">";

    print "<tr><td align=center><span class=large><font color=$menucolor><b>Gene Search</b></font></span></td></tr>";
    print "<tr><td align=center>";
    print "<BR>";
    print "<SELECT NAME=\"orf\" SIZE=1>";

    foreach my $orf_num (sort {$orf_scroll{$a}<=>$orf_scroll{$b}} keys %orf_scroll){
       print "<OPTION value=$orf_num>$orf_scroll{$orf_num}" if ($orf_num != $featureorf);
       print "<OPTION value=$orf_num SELECTED>$orf_scroll{$orf_num}" if ($orf_num == $featureorf);
    }
    print "</SELECT>";
    print "</td></tr>";

    print "<input type=\"hidden\" NAME='zoom' VALUE=$zoom>";
    print "<input type=\"hidden\" NAME='assembly_id' VALUE=$assembly_id>";
    print "<input type=\"hidden\" NAME='menu' VALUE=\"$menu\">";
    print "<input type=\"hidden\" NAME='fuzzykey' VALUE=\"$fuzzykey\">";
    print "<input type=\"hidden\" NAME='data' VALUE=\"$compressed_userinfo\">";
    print "<input type=\"hidden\" NAME='gene_finder_id' VALUE=\"$gene_finder_id\">";
    print "<tr><td>&nbsp;</td></tr>";
    print "<tr><td colspan=1 align=center><INPUT TYPE=submit VALUE=\"Search\"></td></tr>";
    print "</FORM>";
    #----------------------------------

    print "</table></td></tr>";
    print "</table>";
}

=for html <A NAME='showZoomMenu'>

=item showZoomMenu

=for html
Will display some zoom option<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
- None<BR>
<BR>

=cut

#-------------------------------------
sub showZoomMenu{

   #Will display some zoom option
   my ($zoom, $zoom_value)=@_;

   print "<INPUT TYPE=radio NAME=zoom VALUE=$zoom_value->[0] ";
   print "CHECKED" if ($zoom==$zoom_value->[0]);
   print ">1:$zoom_value->[0]<BR>";

   print "<INPUT TYPE=radio NAME=zoom VALUE=$zoom_value->[1] ";
   print "CHECKED" if ($zoom==$zoom_value->[1]);
   print ">1:$zoom_value->[1]<BR>";

   print "<INPUT TYPE=radio NAME=zoom VALUE=$zoom_value->[2] ";
   print "CHECKED" if ($zoom==$zoom_value->[2]);
   print ">1:$zoom_value->[2]<BR>";

   print "<INPUT TYPE=radio NAME=zoom VALUE=$zoom_value->[3] ";
   print "CHECKED" if ($zoom==$zoom_value->[3]);
   print ">1:$zoom_value->[3]<BR>";

   print "<INPUT TYPE=radio NAME=zoom VALUE=$zoom_value->[4] ";
   print "CHECKED" if ($zoom==$zoom_value->[4]);
   print ">1:$zoom_value->[4]<BR>";
}

=for html <A NAME='contigViewerStats'>

=item contigViewerStats

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$orf_stat</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub contigViewerStats{

   my $orf_stat=shift;
   my %orf_stat=%$orf_stat;

   my $statscolor="FF0000";

   print "<table border=0 width=680>";
   print "<tr><td align=center><span class=small><b>Contig ID</b></span></td><td align=center><span class=small><b>Size (bp)</b></span></td><td align=center><span class=small><b>Number of ORFs</b></span></td><td align=center><span class=small><b>Genes on Leading</b></span></td><td align=center><span class=small><b>Genes on lagging</b></span></td></tr>";
   print "<tr><td align=center><span class=small><font color=$statscolor><b>$orf_stat{'contig'}</b></font></span></td><td align=center><span class=small><font color=$statscolor><b>$orf_stat{'size'}</b></font></span></td><td align=center><span class=small><font color=$statscolor><b>$orf_stat{'amount'}</b></font></span></td><td align=center><span class=small><font color=$statscolor><b>$orf_stat{'leading'}</b></font></span></td><td align=center><span class=small><font color=$statscolor><b>$orf_stat{'lagging'}</b></font></span></td></tr>";
   print "</table>";
}

=for html <A NAME='contigViewerDisplay'>

=item contigViewerDisplay

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$tig_selection</B>():  [Default = <B>shift</B>]<BR>
- <B>$zoom</B>():  [Default = <B>shift</B>]<BR>
- <B>$contig</B>():  [Default = <B>shift</B>]<BR>
- <B>$orf_hash</B>():  [Default = <B>shift</B>]<BR>
- <B>$vertmove</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$featureorf</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub contigViewerDisplay{

   my $scriptname=shift;
   my $tig_selection=shift;
   my $zoom=shift;
   my $contig=shift;
   my $orf_hash=shift;
   my %orf_hash=%$orf_hash;
   my $vertmove=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $featureorf=shift;
   my $fuzzykey=shift;
   my $menu=shift;
   my $compressed_userinfo=shift;

   my ($width, $length, $x1, $x2, $xladder, $xlegend, $y1, $y2, $spacepos, $spaceneg, $size, $gcbar, $xarrowleft, $xarrowright, $xarrowcenter, $ytoparrow, $ytopbase, $ytop2, $ybotarrow, $ybotbase, $ybot2, $mid, $topmid, $botmid, $intergenic)=wgsDATA::initializeTigViewerData($zoom, $tig_selection, $contig, $vertmove);

   print "<table width=680 border=0>";

   print "<tr><td align=left colspan=2><IMG SRC=\"$scriptname?showcontig=1&contig=$tig_selection&menu=$menu&zoom=$zoom&vertmove=$vertmove&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&orf=$featureorf&fuzzykey=$fuzzykey&data=$compressed_userinfo\" BORDER=0 USEMAP=#contig></td></tr>";
  
   print "<MAP NAME=\"contig\">";
  
   foreach my $gene (keys %orf_hash){

       my $tmp=$orf_hash{$gene};
       my @data=@$tmp;
    
       my ($xx1,$xx2,$yy1,$yy2,$ftx1,$ftx2,$fty1,$fty2);

       #^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
       if ($data[3] > 0){                       #leading
          my $start=$y1+($data[1]/$zoom);
          my $stop=$y1+($data[2]/$zoom);

          $xx1=$spacepos;
          $xx2=$spacepos+10;
          $yy1=$start;
          $yy2=$stop;

          $ftx1=$spacepos+15;
          $ftx2=$spacepos+40;
          $fty1=$start-5;
          $fty2=$start+5;

       }
       #^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
       elsif($data[3] < 0 ){                     #lagging
          my $start=$y1+($data[2]/$zoom);
          my $stop=$y1+($data[1]/$zoom);

          $xx1=$spaceneg-10;
          $xx2=$spaceneg;
          $yy1=$start;
          $yy2=$stop;

          $ftx1=$spaceneg-40;
          $ftx2=$spaceneg-15;
          $fty1=$stop-5;
          $fty2=$stop+5;

       }
       print "<area href=\"$scriptname?menu=5&orf_id=$gene&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\" COORDS=\"$xx1,$yy1,$xx2,$yy2\" ALT=\"ORF$gene $data[4] $data[5] $data[1]-$data[2] (Similarity=$data[6]%)\" TITLE=\"ORF$gene $data[4] $data[5] $data[1]-$data[2] (Similarity=$data[6]%)\">";
       print "<area href=\"$scriptname?menu=5&orf_id=$gene&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\" COORDS=\"$ftx1,$fty1,$ftx2,$fty2\" ALT=\"ORF$gene $data[4] $data[5] $data[1]-$data[2] (Similarity=$data[6]\" TITLE=\"ORF$gene $data[4] $data[5] $data[1]-$data[2] (Similarity=$data[6]\">";
   }

   #move vertical up
   print "<area href=\"$scriptname?contig=$tig_selection&zoom=$zoom&move=u&vertmove=$vertmove&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&orf=$featureorf&fuzzykey=$fuzzykey&menu=$menu&data=$compressed_userinfo\" COORDS=\"$xarrowleft,$ytoparrow,$xarrowright,$ytop2\" ALT=\"Towards Contig Start\" TITLE=\"Towards Contig Start\">";
   #move vertical down
   print "<area href=\"$scriptname?contig=$tig_selection&zoom=$zoom&move=d&vertmove=$vertmove&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&orf=$featureorf&fuzzykey=$fuzzykey&menu=$menu&data=$compressed_userinfo\" COORDS=\"$xarrowleft,$ybot2,$xarrowright,$ybotarrow\" ALT=\"Towards Contig End\" TITLE=\"Towards Contig End\">";
   #Re-establish center
   print "<area href=\"$scriptname?contig=$tig_selection&zoom=$zoom&vertmove=0&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&orf=$featureorf&fuzzykey=$fuzzykey&menu=$menu&data=$compressed_userinfo\" COORDS=\"$xarrowleft,$topmid,$xarrowright,$botmid\" ALT=\"Back to Center\" TITLE=\"Back to Center\">";

   print "</MAP>";
   print "</table>";
}

=for html <A NAME='mapViewerMenu'>

=item mapViewerMenu

=for html
MAP Viewer ###################################<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_build</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$map_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$map_version_used</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

##################### MAP Viewer ###################################
#-------------------------------------
sub mapViewerMenu{

   my $tmp_build=shift;
   my $assembly_id=shift;
   my $map_id=shift;
   my $map_version_used=shift;
   my $scriptname=shift;
   my $menu=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   print "<H1>Map View</H1>";
   print "<table border=0 cellpadding=0 cellspacing=0>";
   print "<tr><td>Select an Assembly&nbsp;</td><td>";
   print "<SELECT NAME='assembly_id' onChange='top.location.href=\"$scriptname?fuzzykey=$fuzzykey&menu=$menu&data=$compressed_userinfo&assembly_id=\"+this.options[selectedIndex].value;' Size='1'>";
   &assemblerBox($tmp_build, $assembly_id);
   print "</SELECT>";
   print "</td>";

  if (defined $map_id){
      print "<td>&nbsp;Fingerprint Map Version&nbsp;</td><td>";
      print "<SELECT NAME='map_id' onChange='top.location.href=\"$scriptname?fuzzykey=$fuzzykey&menu=$menu&data=$compressed_userinfo&assembly_id=$assembly_id&map_id=\"+this.options[selectedIndex].value;' Size='1'>";
      &simpleSelectionBox($map_version_used, $map_id);
      print "</SELECT>";
      print "</td></tr></table>";
   }else{
      print "</tr></table>";
      print "<BR><font color='0000FF'>There are currently no fingerprint maps tied to the sequence assembly selected</font><BR>";
   }
}

=for html <A NAME='mapViewerForm'>

=item mapViewerForm

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$maptig_scroll</B>():  [Default = <B>shift</B>]<BR>
- <B>$map_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$clone_name</B>():  [Default = <B>shift</B>]<BR>
- <B>$maptig_selection</B>():  [Default = <B>shift</B>]<BR>
- <B>$buried</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$zoom</B>():  [Default = <B>shift</B>]<BR>
- <B>$horizmove</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub mapViewerForm{

   my $maptig_scroll=shift;
   my $map_id=shift;
   my $clone_name=shift;
   my $maptig_selection=shift;
   my $buried=shift;
   my $menu=shift;
   my $zoom=shift;
   my $horizmove=shift;
   my $assembly_id=shift;
   my $scriptname=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   my $menucolor="0000FF";

   print "<table width=675 border=1>";
   print "<tr><td valign=top>";
   print "<table border=0>";             #left most table
   print "<tr><td valign=top><table border=0 width=150>";

   #----------------------------------
   print "<FORM ACTION=\"$scriptname?showmap=1\" METHOD=\"POST\">";

   print "<tr><td align=left><span class=large><font color=$menucolor><b>Zoom</b></font></span></td></tr>";

   print "<tr><td align=left><span class=small>";
   my @zoom_value=(250,500,1000,2500,8000);
   &showZoomMenu($zoom, \@zoom_value);
   print "</td></tr>";

   print "</table></td><td valign=top><table border=0 width=150>";

   print "<tr><td align=left><span class=large><font color=$menucolor><b>Clone Name</b></font></span></td></tr>";
   print "<tr><td align=left><span class=small>";
   print "<INPUT TYPE=radio NAME=clone_name VALUE=1 ";
   print "CHECKED" if ($clone_name==1);
   print ">Map<BR>";

   print "<INPUT TYPE=radio NAME=clone_name VALUE=0 ";
   print "CHECKED" if ($clone_name==0);
   print ">Sequence<BR>";

   print "</table></td><td valign=top><table border=0 width=150>";

   print "<tr><td align=left><span class=large><font color=$menucolor><b>Buried Clones</b></font></span></td></tr>";

   print "<tr><td valign=top align=left><span class=small>";

   print "<INPUT TYPE=radio NAME=buried VALUE=1 ";
   print "CHECKED" if ($buried==1);
   print ">Add<BR>";

   print "<INPUT TYPE=radio NAME=buried VALUE=0 ";
   print "CHECKED" if ($buried==0);
   print ">Remove<BR><BR>";

   print "</span></td></tr>";
   print "</table></td></tr>";
   print "<tr><td colspan=3 align=center><INPUT TYPE=submit VALUE=\"Refresh\"></td></tr>";
   print "</td></tr>";
   print "</table></td>";
#  print "<input type=\"hidden\" NAME='horizmove' VALUE=$horizmove>";
   print "<input type=\"hidden\" NAME='maptig' VALUE=$maptig_selection>";
   print "<input type=\"hidden\" NAME='assembly_id' VALUE=$assembly_id>";
   print "<input type=\"hidden\" NAME='menu' VALUE=\"$menu\">";
   print "<input type=\"hidden\" NAME='fuzzykey' VALUE=\"$fuzzykey\">";
   print "<input type=\"hidden\" NAME='data' VALUE=\"$compressed_userinfo\">";
   print "<input type=\"hidden\" NAME='map_id' VALUE=\"$map_id\">";
   print "</FORM>";
 
   print "<FORM ACTION=\"$scriptname?showmap=1\" METHOD=\"POST\">";
   print "<td valign=top><table border=0>";

   print "<tr><td align=center><span class=large><font color=$menucolor><b>Select a Map Contig</b></font></span></td></tr>";
   print "<tr><td>&nbsp;</td></tr>";
   print "<tr><td align=center>";

   #print "<SELECT NAME='maptig' onChange='top.location.href=\"$scriptname?showmap=1&menu=$menu&fuzzykey=$fuzzykey&data=$compressed_userinfo&assembly_id=$assembly_id&map_id=$map_id&maptig=\"+this.options[selectedIndex].value;' Size='1'>";
   #&arraySelectionBox($maptig_scroll, $maptig_selection);
   #print "</SELECT>";

   print "<SELECT NAME=\"maptig\" SIZE=1>";

   my @maptig_scroll=@$maptig_scroll;
   foreach my $maptig (@maptig_scroll){
       print "<OPTION>$maptig" if ($maptig_selection != $maptig);
       print "<OPTION SELECTED>$maptig" if ($maptig_selection == $maptig);
   }

   print "</SELECT>";

   print "</td></tr>";
   print "<input type=\"hidden\" NAME='zoom' VALUE=$zoom>";
   print "<input type=\"hidden\" NAME='clone_name' VALUE=$clone_name>";
   print "<input type=\"hidden\" NAME='buried' VALUE=$buried>";
   print "<input type=\"hidden\" NAME='assembly_id' VALUE=$assembly_id>";
   print "<input type=\"hidden\" NAME='menu' VALUE=\"$menu\">";
   print "<input type=\"hidden\" NAME='fuzzykey' VALUE=\"$fuzzykey\">";
   print "<input type=\"hidden\" NAME='data' VALUE=\"$compressed_userinfo\">";
   print "<input type=\"hidden\" NAME='map_id' VALUE=\"$map_id\">";
   print "<tr><td>&nbsp;</td></tr>";
   print "<tr><td>&nbsp;</td></tr>";
   print "<tr><td align=center><INPUT type='submit' name='submit_maptig' value='Search'></td></tr>";
   print "</FORM>";

   print "</table></td></tr>";
   print "</table>";
}

=for html <A NAME='mapViewerDisplay'>

=item mapViewerDisplay

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
- None<BR>
<BR>

=cut

#-------------------------------------
sub mapViewerDisplay{
   
   my ($scriptname, $maptig_selection, $zoom, $horizmove, $map_id, $clone_name, $buried, $read_coord, $htdocpath, $graph_value, $assembly_id, $fuzzykey, $menu, $compressed_userinfo)=@_;

   print "<table width=680 border=0>";
   print "<tr><td align=left colspan=2><IMG SRC=\"$scriptname?showmap=1&maptig=$maptig_selection&menu=$menu&zoom=$zoom&horizmove=$horizmove&assembly_id=$assembly_id&map_id=$map_id&clone_name=$clone_name&buried=$buried&fuzzykey=$fuzzykey&data=$compressed_userinfo\" BORDER=0 USEMAP=#map></td></tr>";

   print "<MAP NAME=\"map\">";

   #####Read Hyperlink
   my $graph_value=wgsDATA::initializeMapViewerData();
   my $x_pos=$graph_value->[14]+$horizmove;
   my $rdypos=$graph_value->[17];
   
   foreach my $order (sort {$a<=>$b} keys %$read_coord){
      my $clone_hash=$read_coord->{$order};
      foreach my $clone(keys %$clone_hash){

         my $image_file=$clone.".gif";
         my $full_image_path="$htdocpath/$assembly_id/$map_id/$maptig_selection/$image_file";###this is new, will store all images in map tig sub dir
         
         ####both pairs represented for a clone
         if(defined $clone_hash->{$clone}{'F'} && defined $clone_hash->{$clone}{'R'}){

            ####Determine the identity of the 1st read
            my $forward=$read_coord->{$order}{$clone}{'F'}{'start'};
            my $reverse=$read_coord->{$order}{$clone}{'R'}{'start'};
            my ($left_start, $left_stop, $right_start, $right_stop, $layout);

            if($forward<$reverse){
               $left_start=$read_coord->{$order}{$clone}{'F'}{'start'};
               $left_stop=$read_coord->{$order}{$clone}{'F'}{'stop'};
               $right_start=$read_coord->{$order}{$clone}{'R'}{'start'};
               $right_stop=$read_coord->{$order}{$clone}{'R'}{'stop'};
            }else{
               $left_start=$read_coord->{$order}{$clone}{'R'}{'start'};
               $left_stop=$read_coord->{$order}{$clone}{'R'}{'stop'};
               $right_start=$read_coord->{$order}{$clone}{'F'}{'start'};
               $right_stop=$read_coord->{$order}{$clone}{'F'}{'stop'};
            }

            my $scaled_lstart=($left_start/$zoom)+$x_pos;
            my $scaled_rstop=($right_stop/$zoom)+$x_pos+60;

            my ($up, $down)=($rdypos-3,$rdypos+3);
            print "<area href=\"Javascript:openPopWin('$full_image_path',400,900,'resizable,toolbar',800,100)\" COORDS=\"$scaled_lstart,$up,$scaled_rstop,$down\" ALT=\"$clone\" TITLE=\"$clone\">";

         }else{#only one pair present
            my ($start, $stop, $scaled_start, $scaled_stop);

            if(defined $clone_hash->{$clone}{'F'}){
               $start=$read_coord->{$order}{$clone}{'F'}{'start'};
               $stop=$read_coord->{$order}{$clone}{'F'}{'stop'};
               $scaled_start=($start/$zoom)+$x_pos;
               $scaled_stop=($stop/$zoom)+$x_pos+60;
            }else{
               $start=$read_coord->{$order}{$clone}{'R'}{'start'};
               $stop=$read_coord->{$order}{$clone}{'R'}{'stop'};
               $scaled_start=($start/$zoom)+$x_pos;
               $scaled_stop=($stop/$zoom)+$x_pos+60;
            }   

            my ($up, $down)=($rdypos-3,$rdypos+3);
            print "<area href=\"Javascript:openPopWin('$full_image_path',400,900,'resizable,toolbar',800,100)\" COORDS=\"$scaled_start,$up,$scaled_stop,$down\" ALT=\"$clone\" TITLE=\"$clone\">";

         }
         $rdypos+=6
      }
   }

   #####Image Control
   #move left
   print "<area href=\"$scriptname?maptig=$maptig_selection&zoom=$zoom&move=l&horizmove=$horizmove&assembly_id=$assembly_id&map_id=$map_id&clone_name=$clone_name&buried=$buried&menu=$menu&fuzzykey=$fuzzykey&data=$compressed_userinfo\" COORDS=\"$graph_value->[3],$graph_value->[1],$graph_value->[5],$graph_value->[2]\" ALT=\"Towards Map Contig Start\" TITLE=\"Towards Map Contig Start\">";
   #move right
   print "<area href=\"$scriptname?maptig=$maptig_selection&zoom=$zoom&move=r&horizmove=$horizmove&assembly_id=$assembly_id&map_id=$map_id&clone_name=$clone_name&buried=$buried&menu=$menu&fuzzykey=$fuzzykey&data=$compressed_userinfo\" COORDS=\"$graph_value->[8],$graph_value->[1],$graph_value->[10],$graph_value->[2]\" ALT=\"Towards Map Contig End\" TITLE=\"Towards Map Contig End\">";
   #Re-establish center
   print "<area href=\"$scriptname?maptig=$maptig_selection&zoom=$zoom&horizmove=0&assembly_id=$assembly_id&map_id=$map_id&clone_name=$clone_name&buried=$buried&menu=$menu&fuzzykey=$fuzzykey&data=$compressed_userinfo\" COORDS=\"$graph_value->[6],$graph_value->[1],$graph_value->[7],$graph_value->[2]\" ALT=\"Back to Center\" TITLE=\"Back to Center\">";

   print "</MAP>";  

   print "</table>";
}

=for html <A NAME='orfMenu'>

=item orfMenu

=for html
ORF List ###################################<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$tmp_build</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_available</B>():  [Default = <B>shift</B>]<BR>
- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

##################### ORF List ###################################
#-------------------------------------
sub orfMenu{

   my $tmp_build=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $gene_finder_available=shift;
   my $scriptname=shift;
   my $menu=shift;
   my $fuzzykey=shift;
   my $compressed_userinfo=shift;

   print "<H1>ORF List</H1>";
   print "<table border=0 cellspacing=0 cellpadding=0>";
   print "<tr><td>Select an Assembly&nbsp;</td><td>";
   print "<SELECT NAME='assembly_id' onChange='top.location.href=\"$scriptname?fuzzykey=$fuzzykey&menu=$menu&data=$compressed_userinfo&assembly_id=\"+this.options[selectedIndex].value;' Size='1'>";
   &assemblerBox($tmp_build, $assembly_id);
   print "</SELECT>";
   print "</td>";

   if (defined $gene_finder_id){
      print "<td>&nbsp;Gene Finder&nbsp;</td><td>";
      print "<SELECT NAME='gene_finder_id' onChange='top.location.href=\"$scriptname?fuzzykey=$fuzzykey&menu=$menu&data=$compressed_userinfo&assembly_id=$assembly_id&gene_finder_id=\"+this.options[selectedIndex].value;' Size='1'>";
      &simpleSelectionBox($gene_finder_available, $gene_finder_id);
      print "</SELECT>";
      print "</td>";
   }
   print "</tr>";

   print "</table>";
   print "<BR><BR>";
   print "<table border=0 cellspacing=0 cellpadding=0>";
   print "<FORM ACTION=\"$scriptname\" METHOD=\"POST\">";
   print "<tr><td>Search the ORF List for:&nbsp;</td><td><INPUT TYPE='textbox' name='orf_name'><span class=small>(case insensitive)</span></td></tr>";
   print "<input type=\"hidden\" NAME=\"menu\" VALUE=\"$menu\">";
   print "<input type=\"hidden\" NAME=\"fuzzykey\" VALUE=\"$fuzzykey\">";
   print "<input type=\"hidden\" NAME=\"assembly_id\" VALUE=\"$assembly_id\">";
   print "<input type=\"hidden\" NAME=\"data\" VALUE=\"$compressed_userinfo\">";
   print "<input type=\"hidden\" NAME=\"gene_finder_id\" VALUE=\"$gene_finder_id\">";

   print "<tr><td><INPUT type='submit' name='submit_orf' value='Submit Query'></td></tr>";
   print "</FORM>";
   print "</table>";
}

=for html <A NAME='displayOrfList'>

=item displayOrfList

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$orf_name</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_orf</B>():  [Default = <B>shift</B>]<BR>
- <B>$total_orf</B>():  [Default = <B>shift</B>]<BR>
- <B>$element</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub displayOrfList{
   
   my $scriptname=shift;
   my $menu=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $orf_name=shift;
   my $fuzzykey=shift;
   my $tmp_orf=shift;
   my %orf_list=%$tmp_orf;
   my $total_orf=shift;  
   my $element=shift; 
   my $compressed_userinfo=shift;

   if ($orf_name ne ''){###displays search
      print "<BR>Search Results for <font color='FF9966'><b>$orf_name</b></font>: $total_orf orfs found.<BR>";
   }else{
      print "<BR>All ORFs in the selected assembly: $total_orf ORFs found.<BR>";
   }

   print "<table class='listing' width=680 border=0>";
   print "<tr><th class='title' colspan=5  style='text-align: left;'><span class=large>Putative Genes</span></th></tr>";
   print "<tr>";
   print "<th><span class=small><A HREF=\"$scriptname?menu=$menu&orf_name=$orf_name&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&sort=0&data=$compressed_userinfo\">ORF ID</A></span></th>";
   print "<th><span class=small><A HREF=\"$scriptname?menu=$menu&orf_name=$orf_name&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&sort=1&data=$compressed_userinfo\">SPTR Accession</A></span></th>";
   print "<th><span class=small><A HREF=\"$scriptname?menu=$menu&orf_name=$orf_name&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&sort=2&data=$compressed_userinfo\">Name</A></span></th>";
   print "<th><span class=small><A HREF=\"$scriptname?menu=$menu&orf_name=$orf_name&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&sort=3&data=$compressed_userinfo\">Organism</A></span></th>";
   print "<th><span class=small><A HREF=\"$scriptname?menu=$menu&orf_name=$orf_name&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&sort=4&data=$compressed_userinfo\">Similarity (%)</A></span></th>";
   print "</tr>";

   my ($past, $value)=("even", "");

   ####Display ORFs
   my $count_record=0;

   if ($element==0){###id smaller->bigger
      foreach my $orf_id (sort {$orf_list{$a}->[$element]<=>$orf_list{$b}->[$element]}  keys %orf_list){
         if ($past eq "even"){$value="odd"}else{$value="even";}
         print "<tr class=\"$value\"><td><span class=small><A HREF=\"$scriptname?menu=$menu&orf_id=$orf_id&orf_name=$orf_name&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\">$orf_list{$orf_id}->[0]</A></span></td><td><span class=small>$orf_list{$orf_id}->[1]</span></td><td><span class=small>$orf_list{$orf_id}->[2]</span></td><td><span class=small>$orf_list{$orf_id}->[3]</span></td><td style='text-align: right;'><span class=small>$orf_list{$orf_id}->[4]</span></td></tr>";
         $past=$value;
         $count_record++;
      }
   }elsif ($element==4){###similarity/identity best on top
      foreach my $orf_id (sort {$orf_list{$b}->[$element]<=>$orf_list{$a}->[$element]}  keys %orf_list){
         if ($past eq "even"){$value="odd"}else{$value="even";}
         print "<tr class=\"$value\"><td><span class=small><A HREF=\"$scriptname?menu=$menu&orf_id=$orf_id&orf_name=$orf_name&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\">$orf_list{$orf_id}->[0]</A></span></td><td><span class=small>$orf_list{$orf_id}->[1]</span></td><td><span class=small>$orf_list{$orf_id}->[2]</span></td><td><span class=small>$orf_list{$orf_id}->[3]</span></td><td style='text-align: right;'><span class=small>$orf_list{$orf_id}->[4]</span></td></tr>";
         $past=$value;
         $count_record++;
      }
   }else{###all the rest (non-numeric)
      foreach my $orf_id (sort {$orf_list{$a}->[$element] cmp $orf_list{$b}->[$element] || $orf_list{$a}->[$element]<=>$orf_list{$b}->[$element]} keys %orf_list){
         if ($past eq "even"){$value="odd"}else{$value="even";}
         print "<tr class=\"$value\"><td><span class=small><A HREF=\"$scriptname?menu=$menu&orf_id=$orf_id&orf_name=$orf_name&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&data=$compressed_userinfo\">$orf_list{$orf_id}->[0]</A></span></td><td><span class=small>$orf_list{$orf_id}->[1]</span></td><td><span class=small>$orf_list{$orf_id}->[2]</span></td><td><span class=small>$orf_list{$orf_id}->[3]</span></td><td style='text-align: right;'><span class=small>$orf_list{$orf_id}->[4]</span></td></tr>";
         $past=$value;
         $count_record++;
      }
   }

   print "<tr><td colspan=5 style='text-align: center;'><font color='FF0000'><b>No ORFs Match your Query</b></font></td></tr>" if (! $count_record);
   print "</table>";
}

=for html <A NAME='displayOrfSpecific'>

=item displayOrfSpecific

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$scriptname</B>():  [Default = <B>shift</B>]<BR>
- <B>$menu</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembly_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_id</B>():  [Default = <B>shift</B>]<BR>
- <B>$gene_finder_available</B>():  [Default = <B>shift</B>]<BR>
- <B>$orf_name</B>():  [Default = <B>shift</B>]<BR>
- <B>$fuzzykey</B>():  [Default = <B>shift</B>]<BR>
- <B>$orf_origin</B>():  [Default = <B>shift</B>]<BR>
- <B>$tmp_orf</B>():  [Default = <B>shift</B>]<BR>
- <B>$assembler</B>():  [Default = <B>shift</B>]<BR>
- <B>$build</B>():  [Default = <B>shift</B>]<BR>
- <B>$compressed_userinfo</B>():  [Default = <B>shift</B>]<BR>
<FONT color=red>## parameters are also passed on to <A Href=#displayAlignment>displayAlignment</A> ##</Font><BR>
</Font><BR>

=cut

#-------------------------------------
sub displayOrfSpecific{

   my $scriptname=shift;
   my $menu=shift;
   my $assembly_id=shift;
   my $gene_finder_id=shift;
   my $gene_finder_available=shift;
   my %gene_finder_available=%$gene_finder_available;
   my $orf_name=shift;
   my $fuzzykey=shift;
   my $orf_origin=shift;
   my $tmp_orf=shift;
   my %all_orf=%$tmp_orf;
   my $assembler=shift;
   my $build=shift;
   my $compressed_userinfo=shift;

   my $tmp_record=$all_orf{$orf_origin};
   my %orf_spec=%$tmp_record;

   print "<H1>Specific ORF Information</H1>";

   ####Provide Way to get back to table;
   print "<BR><A HREF=\"$scriptname?menu=$menu&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&fuzzykey=$fuzzykey&orf_name=$orf_name&data=$compressed_userinfo\">Back to ORF Table</A>";

   ####General Info
   print "<table class='listing' width=680>";
   print "<tr><th class='title' colspan=2 style='text-align: left;'><span class=large>ORF $orf_spec{'orf_id'}&nbsp;&nbsp;$assembler Build $build</span></th></tr>";
   print "<tr class='even'><td>ORF Database ID</td><td style='text-align: right;'><A HREF=\"$scriptname?menu=3&zoom=100&orf=$orf_origin&assembly_id=$assembly_id&gene_finder_id=$gene_finder_id&contig=$orf_spec{'contig'}&data=$compressed_userinfo\">$orf_spec{'orf_id'}</A></td></tr>";
   print "<tr class='even'><td>Location in Assembly</td><td style='text-align: right;'>$assembler Build $build Contig $orf_spec{'contig'}<BR>Strand: $orf_spec{'strand'} Position: $orf_spec{'start_position'}-$orf_spec{'stop_position'}</td></tr>";

   if ($orf_spec{'accession'} ne "NA"){
      print "<tr class='odd'><td>Best Hit in SPTREMBL</td><td style='text-align: right;'><A HREF=\"http://www.ebi.ac.uk/cgi-bin/swissfetch?db=SWALL&id='$orf_spec{'accession'}'&style=html\" target=\"blank\">$orf_spec{'accession'}</A></td></tr>";
   }else{
      print "<tr class='odd'><td>Best Hit in SPTREMBL</td><td style='text-align: right;'>$orf_spec{'accession'}</td></tr>";
   }

  
   print "<tr class='even'><td>Gene Finder Used</td><td style='text-align: right;'>$gene_finder_available{$gene_finder_id}</td></tr>";
   print "<tr class='odd'><td>Protein Description</td><td style='text-align: right;'>$orf_spec{'name'}</td></tr>";
   print "<tr class='even'><td>Homologue Species</td><td style='text-align: right;'>$orf_spec{'organism'}</td></tr>";
   print "<tr class='even'><td>Best Hit Protein Length</td><td style='text-align: right;'>$orf_spec{'hit_protein_length'}</td></tr>";
   print "<tr class='odd'><td>Blastp Score (bits)</td><td style='text-align: right;'>$orf_spec{'score'}&nbsp;($orf_spec{'bits'})</td></tr>";
   print "<tr class='even'><td>Blastp E-Value</td><td style='text-align: right;'>$orf_spec{'evalue'}</td></tr>";
   print "<tr class='odd'><td>Similarity<span class=small>(Number of positive Amino Acids/Best Hit Protein length)</span></td><td style='text-align: right;'>$orf_spec{'similarity'}%</td></tr>";
   print "<tr class='even'><td>Identity<span class=small>(Number of identical match/Best Hit Protein length)</span></td><td style='text-align: right;'>$orf_spec{'hit_identity'}%</td></tr>";
   print "<tr class='odd'><td colspan=2><A HREF=\"http://www.ebi.ac.uk/ego/GSearch?query=$orf_spec{'accession'}&mode=protein&ontology=all_ont\" target=\"blank\"><b><i>View Gene Ontology</i></b></A></td></tr>" if ($orf_spec{'accession'} ne "NA");

   print "</table>";

   ####Base Composition
   print "<table border=0 width=680>";
   print "<tr><td valign=top align=left>";
   print "<table class='listing' border=0 width=260>";
   print "<tr><th class='title' colspan=2 style='text-align: center;'><span class=large><b>Base Composition</b></span></th></tr>";
   print "<tr><th><b>Base</b></th><th><b>Proportion<b></th></tr>";
   print "<tr class='odd'><td>%A</td><td style='text-align: right;'>$orf_spec{'percentA'}</td></tr>";
   print "<tr class='even'><td>%T</td><td style='text-align: right;'>$orf_spec{'percentT'}</td></tr>";
   print "<tr class='odd'><td>%C</td><td style='text-align: right;'>$orf_spec{'percentC'}</td></tr>";
   print "<tr class='even'><td>%G</td><td style='text-align: right;'>$orf_spec{'percentG'}</td></tr>";
   print "<tr class='odd'><td><font color='330099'><b>%G+C</b></font></td><td style='text-align: right;'><font color='330099'><b>$orf_spec{'percentGC'}</b></font></td></tr>";
   print "</table>";
   print "</td><td valign=top align=right>";
   print "<table class='listing' border=0 width=400>";
   print "<tr><th class='title' colspan=4 style='text-align: center;'><span class=large><b>% Base Composition for Every Codon</b></span></th></tr>";
   print "<tr><th><b>Base</b></th><th><b>+1</b></th><th><b>+2</b></th><th><b>+3</b></th></tr>";
   print "<tr class='odd'><td>%A</td><td style='text-align: right;'>&nbsp;$orf_spec{'A1'}</td><td style='text-align: right;'>&nbsp;$orf_spec{'A2'}</td><td style='text-align: right;'>&nbsp;$orf_spec{'A3'}</td></tr>";
   print "<tr class='even'><td>%T</td><td style='text-align: right;'>&nbsp;$orf_spec{'T1'}</td><td style='text-align: right;'>&nbsp;$orf_spec{'T2'}</td><td style='text-align: right;'>&nbsp;$orf_spec{'T3'}</td></tr>";
   print "<tr class='odd'><td>%C</td><td style='text-align: right;'>&nbsp;$orf_spec{'C1'}</td><td style='text-align: right;'>&nbsp;$orf_spec{'C2'}</td><td style='text-align: right;'>&nbsp;$orf_spec{'C3'}</td></tr>";
   print "<tr class='even'><td>%G</td><td style='text-align: right;'>&nbsp;$orf_spec{'G1'}</td><td style='text-align: right;'>&nbsp;$orf_spec{'G2'}</td><td style='text-align: right;'>&nbsp;$orf_spec{'G3'}</td></tr>";
   print "</table>";
   print "</td></tr>";
   print "</table>";

   ####Sequences
   print "<table width=680 border=1 cellpadding=1 cellspacing=0>";
   print "<tr><td class=mediumprodblue><span class=large><b>Nucleic Acid Sequence (Fasta)</b></span></td><td class=mediumprodblue><span class=large><b>Amino Acid Sequence (Fasta)</b></span></td></tr>";

   #DNA
   print "<tr><td valign=top align=left>&nbsp;";
   &displaySequence($orf_spec{'cds_sequence'}, $orf_spec{'orf_id'});

   #AMINO ACID
   print "</td><td valign=top align=left>&nbsp;";
   &displaySequence($orf_spec{'protein_sequence'}, $orf_spec{'orf_id'});
   print "</td></tr>";
   print "</table>";

   print "<tr><td colspan=2 valign=top><table width=680 border=1 colspan=6>";
   print "<tr><td colspan=6 class=mediumprodblue><span class=large><b>Blastp Sequence Alignment & Statistics</b></span></td></tr>";

   ####Reconstruct Blast Alignment
   if ($orf_spec{'accession'} ne 'NA'){

        my $pmatch=int($orf_spec{'match'}/$orf_spec{'query_length'}*100) if ($orf_spec{'query_length'} ne '0');     #percentage of match
        my $positive=int($orf_spec{'positive'}/$orf_spec{'query_length'}*100) if ($orf_spec{'query_length'} ne '0');     

        print "<tr><td align=left><span class=medium>ORF AA Length:</span></td><td align=left><span class=medium>Score:</span></td><td align=left><span class=medium>E-value:</span></td><td align=left><span class=medium>Positive:</span></td><td align=left><span class=medium>Match:</span></td><td align=left><span class=medium>Similarity:</span></td></tr>";
        print "<tr><td><b>&nbsp;$orf_spec{'protein_length'}</b></td><td><b>&nbsp;$orf_spec{'score'}&nbsp;($orf_spec{'bits'})</b></td><td><b>&nbsp;$orf_spec{'evalue'}</b></td><td><b>&nbsp;$orf_spec{'positive'}\/$orf_spec{'query_length'} ($positive%)</b></td><td><b>&nbsp;$orf_spec{'match'}\/$orf_spec{'query_length'} ($pmatch%)</b></td><td><b>&nbsp;$orf_spec{'positive'}/$orf_spec{'hit_protein_length'} ($orf_spec{'similarity'}%)</b></td></tr>";
        print "<BR>";
        print "<tr><td colspan=6>";
        #BLAST
        &displayAlignment(\%orf_spec);
        print "</td></tr>";
  }
  else{
     print "<tr><td colspan=2 align=center><span class=medium>THIS ORF DOES NOT HAVE HOMOLOGUES IN SPTREMBL -- NO ALIGNMENTS AVAILABLE</span></td></tr>";
  }
  print "</table>";

}

=for html <A NAME='displaySequence'>

=item displaySequence

=for html

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$sequence</B>():  [Default = <B>shift</B>]<BR>
- <B>$id</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
sub displaySequence{

   my $sequence=shift;
   my $id=shift;

   my $count=0;
   my @arraylength;

   @arraylength=split(//,$sequence);

   print "<pre>";                #formats sequence

   print ">ORF$id";
   print "<BR>";
   for (my $x=0;$x<=$#arraylength;$x++){

       $count++;

       if ($count<40){           #display sequence by stretch of 40 characters
            print $arraylength[$x];
       }
       else{
           print $arraylength[$x]; #still want to display current bit of sequence
           print "<BR>";
           $count=0;
       }
   }
   print "</pre>";
}

=for html <A NAME='displayAlignment'>

=item displayAlignment

=for html
Displays Blast Alignment<BR>

=for html
<B>Arguments:</B><BR>
********************<BR>
<Font size =-2>- <B>$orf_spec</B>():  [Default = <B>shift</B>]<BR>
</Font><BR>

=cut

#-------------------------------------
#Displays Blast Alignment
sub displayAlignment{

   my $orf_spec=shift;
   my %orf_spec=%$orf_spec;

   my $count=1;
   my $flag=1;
   my $buffer=15;

   my $hitcount=1;

   my $len1=length($orf_spec{'query_start'});        #determine length of numbers
   my $len2=length($orf_spec{'hit_start'});

   my $space1=$buffer-$len1-5;                     #5 is length of ORF: /HIT:
   my $space2=$buffer-$len2-5;

   my @query=split(//, $orf_spec{'query_sequence'});  #put sequences in arrays
   my @hit=split(//, $orf_spec{'hit_sequence'});
   my @shared=split(//, $orf_spec{'shared_sequence'});

   print "<pre>";                #formats sequence

   my $loopval=int($#query/60);  #calculate amount of pass (section of 60aa)
   my $init=0;
   my $index;

   print "<BR> <BR>";            #space before starting display

  #DISPLAY
   for (my $pass=1;$pass<=$loopval;$pass++){       #go thru each sets of 60
        $index=59*$pass;                           #starts at 0-->59(60)
        $index+=$pass-1 if ($pass>1);              #equalize display
        #QUERY--------------------------------
        if ($init==0){                             #first row
            print "ORF: $orf_spec{'query_start'}";
            print " " x $space1;
        }
        else{
            #print " " x $buffer;
            my $number=$orf_spec{'query_start'}+$init;
            my $lennum=length($number);
            my $spc=$buffer-$lennum-5;
            print "ORF: $number";
            print " " x $spc;
        }

        #PRINTS AA CONTENTS
        for (my $x=$init;$x<=$index;$x++){
             print $query[$x];
             #print $x;
        }
        my $end=$orf_spec{'query_start'}+$index;
        print "    $end";

        print "<BR>";

        #SHARED--------------------------------
        print " "x $buffer;
        for (my $x=$init;$x<=$index;$x++){
             print $shared[$x];
        }
        print "<BR>";

   #HIT-----------------------------------
        if ($init==0){
            print "HIT: $orf_spec{'hit_start'}";
            print " " x $space2;
        }
        else{
            #print " " x $buffer;
            my $number=$orf_spec{'hit_start'}+$init;
            my $lennum=length($number);
            my $spc=$buffer-$lennum-5;
            print "HIT: $number";
            print " " x $spc;
        }

        #PRINTS ALL AA
        for (my $x=$init;$x<=$index;$x++){
             print $hit[$x];
             #print $x;
        }
        my $end=$orf_spec{'hit_start'}+$index;
        print "    $end";

        print "<BR>  <BR>";                #prints empty line

        $init=$index+1;
   }
   #finalizing(last row, trailing sequence<60)

 #QUERY
   if ($init==0){
       print "ORF: $orf_spec{'query_start'}";
       print " " x $space1;
   }
   else{
        #print " " x $buffer;
        my $number=$orf_spec{'query_start'}+$init;
        my $lennum=length($number);
        my $spc=$buffer-$lennum-5;
        print "ORF: $number";
        print " " x $spc;
   }
   for (my $x=$init;$x<=$#query;$x++){
       print $query[$x];
#       print $x;
   }
   my $end=$orf_spec{'query_stop'};
   print "    $end";
   print "<BR>";

   #SHARED
   print " "x $buffer;
   for (my $x=$init;$x<=$#query;$x++){
        print $shared[$x];
   }
   print "<BR>";

 #HIT
  if ($init==0){                           #case of very short sequences
       print "HIT: $orf_spec{'hit_start'}";
       print " " x $space2;
   }
   else{
       #print " " x $buffer;
       my $number=$orf_spec{'hit_start'}+$init;
       my $lennum=length($number);
       my $spc=$buffer-$lennum-5;
       print "HIT: $number";
       print " " x $spc;
   }
   for (my $x=$init;$x<=$#query;$x++){
       print $hit[$x];
#       print $x;
  }
   my $end=$orf_spec{'hit_stop'};
   print "    $end";
   print "<BR> <BR>";                         #include a space line

   print "</pre>";
}

=back

=cut

##############################
# private_methods            #
##############################
##############################
# private_functions          #
##############################
##############################
# main_footer                #
##############################
##############################
# perldoc_footer             #
##############################

=head1 KNOWN ISSUES <UPLINK>

<<KNOWN ISSUES>>

=head1 FUTURE IMPROVEMENTS <UPLINK>

<<FUTURE IMPROVEMENTS>>

=head1 AUTHORS <UPLINK>

<<AUTHORS>>

=head1 CREATED <UPLINK>

2004-08-18

=head1 REVISION <UPLINK>


=cut


return 1;
